///////////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2024, ООО 1С-Софт
// Все права защищены. Эта программа и сопроводительные материалы предоставляются 
// в соответствии с условиями лицензии Attribution 4.0 International (CC BY 4.0)
// Текст лицензии доступен по ссылке:
// https://creativecommons.org/licenses/by/4.0/legalcode
///////////////////////////////////////////////////////////////////////////////////////////////////////

#Область ОбработчикиСобытийФормы

&НаСервере
Процедура ПриСозданииНаСервере(Отказ, СтандартнаяОбработка)

	Если Параметры.Владелец.Пустая() Тогда
		ТекстСообщения = НСтр("ru = 'Данная форма предназначена для открытия только из вопросов для анкетирования.'");
		ОбщегоНазначения.СообщитьПользователю(ТекстСообщения);
		Отказ = Истина;
		Возврат;
	КонецЕсли;

	Объект.Владелец = Параметры.Владелец;
	Если Не Параметры.ТипОтвета.Пустая() Тогда
		Элементы.ТребуетОткрытогоОтвета.Видимость = (Параметры.ТипОтвета = Перечисления.ТипыОтветовНаВопрос.НесколькоВариантовИз);
	Иначе
		ТипОтвета = ОбщегоНазначения.ЗначениеРеквизитаОбъекта(Объект.Владелец, "ТипОтвета");
		Элементы.ТребуетОткрытогоОтвета.Видимость = (ТипОтвета = Перечисления.ТипыОтветовНаВопрос.НесколькоВариантовИз);
	КонецЕсли;

	Если Не ПустаяСтрока(Параметры.Наименование) Тогда
		Объект.Наименование = Параметры.Наименование;
	КонецЕсли;

КонецПроцедуры

#КонецОбласти