///////////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2024, ООО 1С-Софт
// Все права защищены. Эта программа и сопроводительные материалы предоставляются 
// в соответствии с условиями лицензии Attribution 4.0 International (CC BY 4.0)
// Текст лицензии доступен по ссылке:
// https://creativecommons.org/licenses/by/4.0/legalcode
///////////////////////////////////////////////////////////////////////////////////////////////////////

#Область ОбработчикиСобытийФормы

&НаСервере
Процедура ПриСозданииНаСервере(Отказ, СтандартнаяОбработка)
	
	Элементы.ДобавитьЗаявлениеНаВыпускСертификата.Видимость = 
		ЭлектроннаяПодпись.ОбщиеНастройки().ЗаявлениеНаВыпускСертификатаДоступно И Не Параметры.СкрытьЗаявление;
		
	Если ЭлектроннаяПодпись.ДобавлениеИзменениеЭлектронныхПодписей()
		И Не ЭлектроннаяПодпись.ИспользоватьШифрование()
		И Не Элементы.ДобавитьЗаявлениеНаВыпускСертификата.Видимость Тогда
		
		Отказ = Истина;
		Возврат;
		
	КонецЕсли;
	
	СвойстваКомандыДобавленияСертификатов = ЭлектроннаяПодписьСлужебный.СвойстваКомандыДобавленияСертификатов();
	Элементы.ДобавитьДляПодписанияИШифрования.Заголовок = СтрЗаменить(
		СвойстваКомандыДобавленияСертификатов.Заголовок, "Для", НСтр("ru = 'Добавить для'"));
	НазначениеДляПодписанияИШифрования = СвойстваКомандыДобавленияСертификатов.Назначение;
	
	СвойстваКомандыДобавленияСертификатов = ЭлектроннаяПодписьСлужебный.СвойстваКомандыДобавленияСертификатов(Истина);
	Элементы.ДобавитьДляПодписанияИШифрованияИзФайлов.Заголовок = СтрЗаменить(
		СвойстваКомандыДобавленияСертификатов.Заголовок, "Для", НСтр("ru = 'Добавить для'"));
	
КонецПроцедуры

#КонецОбласти

#Область ОбработчикиКомандФормы

&НаКлиенте
Процедура ДобавитьДляПодписанияИШифрования(Команда)
	
	Закрыть(НазначениеДляПодписанияИШифрования);
	
КонецПроцедуры

&НаКлиенте
Процедура ДобавитьДляПодписанияИШифрованияИзФайлов(Команда)
	
	Закрыть("ДляПодписанияШифрованияИРасшифровкиИзФайлов");
	
КонецПроцедуры

&НаКлиенте
Процедура ДобавитьИзФайлов(Команда)
	
	Закрыть("ТолькоДляШифрованияИзФайлов");
	
КонецПроцедуры

&НаКлиенте
Процедура ДобавитьИзКаталога(Команда)
	
	Закрыть("ТолькоДляШифрованияИзКаталога");
	
КонецПроцедуры

&НаКлиенте
Процедура ДобавитьЗаявлениеНаВыпускСертификата(Команда)
	
	Закрыть("ЗаявлениеНаВыпускСертификата");
	
КонецПроцедуры

&НаКлиенте
Процедура ДобавитьТолькоДляШифрования(Команда)
	
	Закрыть("ТолькоДляШифрования");
	
КонецПроцедуры

#КонецОбласти
