#Если Сервер Или ТолстыйКлиентОбычноеПриложение Или ВнешнееСоединение Тогда
 
#Область ПрограммныйИнтерфейс

Процедура ПередЗаписью(Отказ)
	
	Если ОбменДанными.Загрузка Тогда
		Возврат;
	КонецЕсли;
	
	Имя = СокрЛП(Имя);
	Имя = СтрЗаменить(Имя, " ", "");
	
	НаименованиеВладельца = ОбщегоНазначения.ЗначениеРеквизитаОбъекта(Владелец, "Наименование", Истина);
	
	Наименование = СтрШаблон("%1.%2.%3", НаименованиеВладельца, Тип, Имя);
	
	Если Не ЗначениеЗаполнено(Синоним) Тогда
		Синоним = УДК_СтроковыеФункцииКлиентСервер.ТекстИзCamelCaseСтроки(Имя);
	КонецЕсли;
	
	ПроверитьНаличиеДубликатовПередЗаписью(Отказ);
	
КонецПроцедуры

Процедура ОбработкаПроверкиЗаполнения(Отказ, ПроверяемыеРеквизиты)
	УДК_РаботаСОбъектамиМетаданных.ПроверитьИмяОбъектаНаКорректность(ЭтотОбъект, Отказ);
КонецПроцедуры

#КонецОбласти
 
#Область ОбработчикиСобытий
 
#КонецОбласти
 
#Область СлужебныйПрограммныйИнтерфейс
 
#КонецОбласти
 
#Область СлужебныеПроцедурыИФункции

Процедура ПроверитьНаличиеДубликатовПередЗаписью(Отказ)
	
	Запрос = Новый Запрос;
	Запрос.Текст = 
	"ВЫБРАТЬ ПЕРВЫЕ 1
	|	ИСТИНА КАК Ссылка
	|ИЗ
	|	Справочник.УДК_ФормыКомандыМакеты КАК СправочникУДК_ФормыКомандыМакеты
	|ГДЕ
	|	СправочникУДК_ФормыКомандыМакеты.Владелец = &Владелец
	|	И СправочникУДК_ФормыКомандыМакеты.Наименование = &Наименование
	|	И СправочникУДК_ФормыКомандыМакеты.Ссылка <> &Ссылка";
	Запрос.УстановитьПараметр("Владелец", Владелец);
	Запрос.УстановитьПараметр("Наименование", Наименование);
	Запрос.УстановитьПараметр("Ссылка", Ссылка);
	
	Результат = Запрос.Выполнить();
	
	Отказ = Не Результат.Пустой();
	
	Если Отказ Тогда
		ТекстСообщения = СтрШаблон("Объект ""%1"" уже есть в ""%2""", Имя, Владелец);
		ОбщегоНазначения.СообщитьПользователю(ТекстСообщения);
	КонецЕсли;
	
КонецПроцедуры

#КонецОбласти
 
#Область Инициализация
 
#КонецОбласти
 
#КонецЕсли
