///////////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2024, ООО 1С-Софт
// Все права защищены. Эта программа и сопроводительные материалы предоставляются 
// в соответствии с условиями лицензии Attribution 4.0 International (CC BY 4.0)
// Текст лицензии доступен по ссылке:
// https://creativecommons.org/licenses/by/4.0/legalcode
///////////////////////////////////////////////////////////////////////////////////////////////////////

#Область ПрограммныйИнтерфейс

// Вызывается для открытия формы поиска внешних компонент в Интернете.
//
// Параметры:
//  Оповещение - ОписаниеОповещения
//  Контекст - Структура:
//      * ТекстПояснения - Строка
//      * Идентификатор - Строка
//      * Версия        - Строка
//      * ОбновлятьАвтоматически - Булево
//
Процедура ПриПоискеКомпонентНаПортале(Оповещение, Контекст) Экспорт
	
	// Локализация
	ПараметрыФормы = Новый Структура;
	ПараметрыФормы.Вставить("ТекстПояснения", Контекст.ТекстПояснения);
	ПараметрыФормы.Вставить("Идентификатор", Контекст.Идентификатор);
	ПараметрыФормы.Вставить("Версия", Контекст.Версия);
	ПараметрыФормы.Вставить("ОбновлятьАвтоматически", Контекст.ОбновлятьАвтоматически);
	
	ОткрытьФорму("Справочник.ВнешниеКомпоненты.Форма.ПоискКомпонентыНаПортале1СИТС", 
		ПараметрыФормы,,,,, Оповещение)
	// Конец Локализация
	
КонецПроцедуры

// Вызывается для открытия формы обновление внешних компонент через Интернет.
//
// Параметры:
//  Оповещение - ОписаниеОповещения
//  ОбновляемыеКомпоненты - Массив из СправочникСсылка.ВнешниеКомпоненты
//
Процедура ПриОбновленииКомпонентСПортала(Оповещение, ОбновляемыеКомпоненты) Экспорт
	
	// Локализация
	ПараметрыФормы = Новый Структура;
	ПараметрыФормы.Вставить("ОбновляемыеКомпоненты", ОбновляемыеКомпоненты);
	ОткрытьФорму("Справочник.ВнешниеКомпоненты.Форма.ОбновлениеКомпонентСПортала1СИТС",
		ПараметрыФормы,,,,, Оповещение);
	// Конец Локализация
	
КонецПроцедуры

#КонецОбласти
