///////////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2024, ООО 1С-Софт
// Все права защищены. Эта программа и сопроводительные материалы предоставляются 
// в соответствии с условиями лицензии Attribution 4.0 International (CC BY 4.0)
// Текст лицензии доступен по ссылке:
// https://creativecommons.org/licenses/by/4.0/legalcode
///////////////////////////////////////////////////////////////////////////////////////////////////////

#Область СлужебныйПрограммныйИнтерфейс

// Запускает изменение настроек уничтожения персональных данных субъектов в соответствии с измененными
// настройками системы.
//
// Параметры:
//  ИдентификаторФормы - УникальныйИдентификатор - уникальный идентификатор формы.
//  ПараметрыМетода - см. НастройкиУничтоженияПерсональныхДанныхСистемы
//
// Возвращаемое значение:
//   см. ДлительныеОперации.ВыполнитьВФоне.
//
Функция ЗапуститьДлительнуюОперациюИзменениеНастроекУничтоженияПДн(Знач ИдентификаторФормы, Знач ПараметрыМетода) Экспорт
	
	ПараметрыВыполнения = ДлительныеОперации.ПараметрыВыполненияВФоне(ИдентификаторФормы);
	ПараметрыВыполнения.НаименованиеФоновогоЗадания = НСтр("ru = 'Изменение настроек уничтожения персональных данных'");
	ПараметрыВыполнения.ОжидатьЗавершение = 0;
	ПараметрыВыполнения.УточнениеОшибки =
		НСтр("ru = 'Не удалось изменить настройки уничтожения персональных данных по причине:'");
	
	Возврат ДлительныеОперации.ВыполнитьПроцедуру(ПараметрыВыполнения, 
		"ЗащитаПерсональныхДанных.ИзменитьНастройкиУничтоженияПерсональныхДанных", ПараметрыМетода);
	
КонецФункции

// Возвращает настройки скрытия персональных данных системы.
// 
// Возвращаемое значение:
//   Структура:
//      * ИспользоватьУничтожениеПерсональныхДанных - Булево - признак использования уничтожения персональных данных
//        субъектов.
//
Функция НастройкиУничтоженияПерсональныхДанныхСистемы() Экспорт
	
	НастройкиУничтожения = Новый Структура;
	НастройкиУничтожения.Вставить("ИспользоватьУничтожениеПерсональныхДанных",
		Константы.ИспользоватьСкрытиеПерсональныхДанныхСубъектов.Получить());
	
	Возврат НастройкиУничтожения;
	
КонецФункции

#КонецОбласти

#Область СлужебныеПроцедурыИФункции

Процедура СохранитьПоложениеОтбораПоказыватьСоСкрытымиПДн(ИмяФормы, ПоложениеОтбора) Экспорт
	
	ОбщегоНазначения.ХранилищеОбщихНастроекСохранить(ИмяФормы, "ПоказыватьСоСкрытымиПДн", ПоложениеОтбора);
	
КонецПроцедуры

// См. ЗащитаПерсональныхДанныхПовтИсп.ТипыСубъектов
Функция ТипыСубъектов() Экспорт
	
	Возврат ЗащитаПерсональныхДанных.ТипыСубъектов();
	
КонецФункции

#КонецОбласти