///////////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2024, ООО 1С-Софт
// Все права защищены. Эта программа и сопроводительные материалы предоставляются 
// в соответствии с условиями лицензии Attribution 4.0 International (CC BY 4.0)
// Текст лицензии доступен по ссылке:
// https://creativecommons.org/licenses/by/4.0/legalcode
///////////////////////////////////////////////////////////////////////////////////////////////////////

#Область СлужебныйПрограммныйИнтерфейс

Функция Подключены() Экспорт
	
	Возврат ОбсужденияСлужебный.Подключены();
	
КонецФункции

Процедура Разблокировать() Экспорт 
	
	ОбсужденияСлужебный.Разблокировать();
	
КонецПроцедуры

#КонецОбласти

#Область СлужебныеПроцедурыИФункции

Функция ПодключитьВнешнююОбработку(АдресВоВременномХранилище) Экспорт
	
	// АПК:552-выкл подключение выполняется при наличии права интерактивного открытия внешних отчетов и обработок.
	// АПК:556-выкл
	// АПК:553-выкл
	ВыполнитьПроверкуПравДоступа("ИнтерактивноеОткрытиеВнешнихОбработок", Метаданные);
	Возврат ВнешниеОбработки.Подключить(АдресВоВременномХранилище, , Ложь);
	// АПК:553-вкл
	// АПК:556-вкл
	// АПК:552-вкл
	
КонецФункции

Функция ПодключитьВнешнийОтчет(АдресВоВременномХранилище) Экспорт
	
	// АПК:552-выкл подключение выполняется при наличии права интерактивного открытия внешних отчетов и обработок.
	// АПК:556-выкл
	// АПК:553-выкл
	ВыполнитьПроверкуПравДоступа("ИнтерактивноеОткрытиеВнешнихОбработок", Метаданные);
	Возврат ВнешниеОтчеты.Подключить(АдресВоВременномХранилище, , Ложь);
	// АПК:553-вкл
	// АПК:556-вкл
	// АПК:552-вкл
	
КонецФункции

Функция ДоступноОткрытиеВнешнихОтчетовИОбработок() Экспорт

	Возврат ПравоДоступа("ИнтерактивноеОткрытиеВнешнихОбработок", Метаданные);

КонецФункции

#КонецОбласти