///////////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2024, ООО 1С-Софт
// Все права защищены. Эта программа и сопроводительные материалы предоставляются 
// в соответствии с условиями лицензии Attribution 4.0 International (CC BY 4.0)
// Текст лицензии доступен по ссылке:
// https://creativecommons.org/licenses/by/4.0/legalcode
///////////////////////////////////////////////////////////////////////////////////////////////////////

#Область ПрограммныйИнтерфейс

// Позволяет внести изменения в дерево с разделами полнотекстового поиска, отображаемое при выборе области поиска.
// По умолчанию дерево разделов формируется на основании состава подсистем конфигурации.
//
// Перед добавлением объекта метаданных убедитесь, что его свойство ПолнотекстовыйПоиск
// установлено в значение Метаданные.СвойстваОбъектов.ИспользованиеПолнотекстовогоПоиска.Использовать.
//
// Параметры:
//   РазделыПоиска - ДеревоЗначений - области поиска. Содержит колонки:
//     * Раздел   - Строка   - представление раздела, например, название подсистемы или объекта метаданных.
//     * Картинка - Картинка - картинка раздела, рекомендуется только для корневых разделов.
//     * ОбъектМД - СправочникСсылка.ИдентификаторыОбъектовМетаданных,
//                  СправочникСсылка.ИдентификаторыОбъектовРасширений - задается только для объектов метаданных, для
//                                                                      разделов остается пустым.
// Пример:
//
//	РазделГлавное = РазделыПоиска.Строки.Добавить();
//	РазделГлавное.Раздел = "Главное";
//	РазделГлавное.Картинка = БиблиотекаКартинок.РазделГлавное;
//	
//	СчетНаОплату = Метаданные.Документы.СчетНаОплатуПокупателю;
//	Если ПравоДоступа("Просмотр", СчетНаОплату)
//		И ОбщегоНазначения.ОбъектМетаданныхДоступенПоФункциональнымОпциям(СчетНаОплату) Тогда 
//		
//		ОбъектРаздела = РазделГлавное.Строки.Добавить();
//		ОбъектРаздела.Раздел = СчетНаОплату.ПредставлениеСписка;
//		ОбъектРаздела.ОбъектМД = ОбщегоНазначения.ИдентификаторОбъектаМетаданных(СчетНаОплату);
//	КонецЕсли;
//
Процедура ПриПолученииРазделовПолнотекстовогоПоиска(РазделыПоиска) Экспорт
	
	
	
КонецПроцедуры

#КонецОбласти