///////////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2024, ООО 1С-Софт
// Все права защищены. Эта программа и сопроводительные материалы предоставляются 
// в соответствии с условиями лицензии Attribution 4.0 International (CC BY 4.0)
// Текст лицензии доступен по ссылке:
// https://creativecommons.org/licenses/by/4.0/legalcode
///////////////////////////////////////////////////////////////////////////////////////////////////////

#Область ПрограммныйИнтерфейс

// Вызывается при проверке доступности Интернета и позволяет указать контрольный адрес.
//
// Параметры:
//  АдресаСервера - Строка - установить адрес сервера для контрольной проверки подключения. 
//                           По умолчанию, "google.co)m".
//
Процедура ПриПолученииАдресаСервераКонтрольнойПроверки(АдресаСервера) Экспорт
	
	// Локализация	
	АдресаСервера = "ya.ru";
	// Конец Локализация
	
КонецПроцедуры

// Вызывается при проверке доступности Интернета и позволяет дополнить подробную информацию об известной проблеме.
//
// Параметры:
//  Описание - Массив из Строка - краткое описание ошибки при проверке доступности Интернета.
//  ТекстОшибки - см. ПолучениеФайловИзИнтернета.ДиагностикаСоединения
//
Процедура ПриФормированииСообщенияОбИзвестнойПроблеме(Описание, ТекстОшибки) Экспорт
	
	Если СтрНайти(ВРег(ТекстОшибки), ВРег("Удаленный узел не прошел проверку")) > 0 Тогда // АПК:1297 Нелокализуемый фрагмент информации об ошибке в исключении.
		// Локализация
		Описание.Добавить(НСтр("ru = 'Подробнее см. на ИТС: https://its.1c.ru/db/metod8dev/content/5941/hdoc'"));
		// Конец Локализация
	КонецЕсли;
	
КонецПроцедуры


#КонецОбласти
