///////////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2024, ООО 1С-Софт
// Все права защищены. Эта программа и сопроводительные материалы предоставляются 
// в соответствии с условиями лицензии Attribution 4.0 International (CC BY 4.0)
// Текст лицензии доступен по ссылке:
// https://creativecommons.org/licenses/by/4.0/legalcode
///////////////////////////////////////////////////////////////////////////////////////////////////////

#Область ПрограммныйИнтерфейс

// Включает/отключает показ предупреждений о необходимости обновления классификатора банков.
//
// Параметры:
//  ПоказыватьПредупреждение - Булево - при установке значения Ложь предупреждения показываться не будут.
//
Процедура ПриОпределенииНеобходимостиПоказаПредупрежденияОбУстаревшемКлассификатореБанков(ПоказыватьПредупреждение) Экспорт
	
КонецПроцедуры

// Определяет настройки загрузки классификатора банков.
//
// Параметры:
//  Настройки - Структура:
//   * ОбрабатыватьОбластиДанных - Булево - включает выполнение процедуры ПриОбработкеОбластиДанных при обновлении
//                                          классификатора.
//
Процедура ПриОпределенииНастроекЗагрузкиКлассификатораБанков(Настройки) Экспорт
	
КонецПроцедуры

// Используется только в разделенном режиме. Вызывается после загрузки классификатора для выполнения дополнительных
// действий в областях данных. Выполнение процедуры необходимо включить в ПриОпределенииНастроек, по умолчанию выключена.
//
Процедура ПриОбработкеОбластиДанных() Экспорт
	
КонецПроцедуры

#КонецОбласти
