///////////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2024, ООО 1С-Софт
// Все права защищены. Эта программа и сопроводительные материалы предоставляются 
// в соответствии с условиями лицензии Attribution 4.0 International (CC BY 4.0)
// Текст лицензии доступен по ссылке:
// https://creativecommons.org/licenses/by/4.0/legalcode
///////////////////////////////////////////////////////////////////////////////////////////////////////

#Область ПрограммныйИнтерфейс

// Устанавливает IP-адреса серверов DNS, которые могут использоваться для чтения MX-записей доменов.
//
// Параметры:
//  АдресаСерверовDNS - Массив из Строка - IP-адреса;
//  СтандартнаяОбработка - Булево - установить в Ложь, если в список не требуется добавлять стандартные
//
Процедура ПриПолученииАдресовСерверовDNS(АдресаСерверовDNS, СтандартнаяОбработка) Экспорт
	
	// Локализация
	АдресаСерверовDNS.Добавить("78.88.8.8"); // dns.yandex
	АдресаСерверовDNS.Добавить("78.8.8.1"); // dns.yandex
	СтандартнаяОбработка = Ложь;
	// Конец Локализация
	
КонецПроцедуры

// Определяет адрес файла с настройками подключения к почтовым серверам.
//
// Параметры:
//  АдресФайла - Строка - URL файла с настройками подключения к почтовым серверам.
//
Процедура ПриПолученииАдресаФайлаСНастройками(АдресФайла) Экспорт
	
	// Локализация
	АдресФайла = "https://downloads.v8.1c.ru/content/common/settings/mailservers.json";
	// Конец Локализация
	
КонецПроцедуры

// Определяет адрес файла с описанием ошибок подключения к почтовым серверам.
//
// Параметры:
//  АдресФайла - Строка - URL файла с описанием ошибок подключения к почтовым серверам.
//
Процедура ПриПолученииАдресаФайлаСОписаниемОшибок(АдресФайла) Экспорт
	
	// Локализация
	АдресФайла = "https://downloads.v8.1c.ru/content/common/settings/v2/mailerrors.json";
	// Конец Локализация
	
КонецПроцедуры

// Определяет адрес внешнего ресурса для механизма профилей безопасности.
// См. РаботаВБезопасномРежимеПереопределяемый.ПриЗаполненииРазрешенийНаДоступКВнешнимРесурсам.
//
// Параметры:
//  АдресВнешнегоРесурса - Строка - адрес внешнего ресурса.
//
Процедура ПриПолученииАдресаВнешнегоРесурса(АдресВнешнегоРесурса) Экспорт
	
	// Локализация
	АдресВнешнегоРесурса = "downloads.v8.1c.ru";
	// Конец Локализация
	
КонецПроцедуры

#КонецОбласти