///////////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2024, ООО 1С-Софт
// Все права защищены. Эта программа и сопроводительные материалы предоставляются 
// в соответствии с условиями лицензии Attribution 4.0 International (CC BY 4.0)
// Текст лицензии доступен по ссылке:
// https://creativecommons.org/licenses/by/4.0/legalcode
///////////////////////////////////////////////////////////////////////////////////////////////////////

#Область ПрограммныйИнтерфейс

// Вызывается для определения адреса объекта в облачном сервисе файлов.
// 
// Параметры:
//  Сервис - Строка - адрес облачного сервиса файлов, например, "https://dav.dropdav.com".
//  Href - Строка - относительный URL объекта.
//  АдресОбъекта - Строка - возвращаемое значение. 
//
Процедура ПриОпределенииАдресаВОблачномСервисе(Знач Сервис, Знач Href, АдресОбъекта) Экспорт
	
	// Локализация
	Если Сервис = "https://webdav.yandex.com" Тогда
		АдресОбъекта = СтрЗаменить(Href, "https://webdav.yandex.com", "https://disk.yandex.com/client/disk");
	ИначеЕсли Сервис = "https://webdav.yandex.ru" Тогда
		АдресОбъекта = СтрЗаменить(Href, "https://webdav.yandex.ru", "https://disk.yandex.ru/client/disk");
	КонецЕсли;
	// Конец Локализация
	
КонецПроцедуры

// Вызывается для определения списка облачных сервисов файлов.
// 
// Параметры:
//  Сервисы - СписокЗначений:
//   * Значение - адрес облачного сервиса файлов.
//   * Представление - название облачного сервиса файлов.
//
Процедура ПриОпределенииОблачныхСервисов(Сервисы) Экспорт
	
	// Локализация
	Сервисы.Добавить("https://webdav.yandex.com", "Яндекс.Диск");
	// Конец Локализация
	
КонецПроцедуры


#КонецОбласти