///////////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2024, ООО 1С-Софт
// Все права защищены. Эта программа и сопроводительные материалы предоставляются 
// в соответствии с условиями лицензии Attribution 4.0 International (CC BY 4.0)
// Текст лицензии доступен по ссылке:
// https://creativecommons.org/licenses/by/4.0/legalcode
///////////////////////////////////////////////////////////////////////////////////////////////////////

#Область ПрограммныйИнтерфейс

// Определяет символы национального алфавита
//
// Параметры:
//   СимволыНациональногоАлфавита - Строка
//   ДополнительныеДопустимыеСимволы - Строка
//
Процедура ПриОпределенииСимволовНациональногоАлфавита(СимволыНациональногоАлфавита, ДополнительныеДопустимыеСимволы) Экспорт
	// Локализация
	СимволыНациональногоАлфавита = "абвгдеёжзийклмнопрстуфхцчшщъыьэюя"; // АПК:163 буква ё разрешена в данном контексте.
	// Конец Локализация
КонецПроцедуры

// Определяет коды символов, которые не считаются разделителем.
// Если явно не указан разделитель слов.
//
// Параметры:
//   Диапазоны - Массив из Структура:
//    * Мин - Число - код символа, с которого начинается диапазон.
//    * Макс - Число - код символа, на котором заканчивается диапазон.
//
Процедура ПриОпределенииСимволовСлов(Диапазоны) Экспорт
	// Локализация
	Диапазоны.Добавить(Новый Структура("Мин,Макс", 1040, 1103));  // кириллица
	// АПК:163-выкл
	Диапазоны.Добавить(Новый Структура("Мин,Макс", 1025, 1025));  // символ "Ё"
	Диапазоны.Добавить(Новый Структура("Мин,Макс", 1105, 1105));  // символ "ё"
	// АПК:163-вкл
	
	// Конец Локализация
КонецПроцедуры

#КонецОбласти



















