///////////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2024, ООО 1С-Софт
// Все права защищены. Эта программа и сопроводительные материалы предоставляются 
// в соответствии с условиями лицензии Attribution 4.0 International (CC BY 4.0)
// Текст лицензии доступен по ссылке:
// https://creativecommons.org/licenses/by/4.0/legalcode
///////////////////////////////////////////////////////////////////////////////////////////////////////

#Область СлужебныйПрограммныйИнтерфейс

Функция СтруктураНастроекПодключения() Экспорт

	Настройки = Новый Структура;
	
	Настройки.Вставить("КодУзла", "");
	Настройки.Вставить("КодУзлаКорреспондента", "");
	Настройки.Вставить("ИдентификаторНастройки", "");
	Настройки.Вставить("ИмяПланаОбмена", "");
	Настройки.Вставить("ИмяПланаОбменаКорреспондента", "");
	Настройки.Вставить("ВариантНастройкиОбмена", "");
	Настройки.Вставить("ФорматОбмена", Неопределено);
	Настройки.Вставить("УзелИнформационнойБазы", Неопределено);
	Настройки.Вставить("ВариантРаботыМастера", "");
	Настройки.Вставить("СсылкаНового", Неопределено);
	Настройки.Вставить("КодПредопределенногоУзла", "");
	Настройки.Вставить("КодНовогоУзлаВторойБазы", "");
	Настройки.Вставить("НаименованиеЭтойБазы", "");
	Настройки.Вставить("НаименованиеВторойБазы", "");
	Настройки.Вставить("ПрефиксИнформационнойБазыИсточника", "");
	Настройки.Вставить("ПрефиксИнформационнойБазыПриемника", "");
	Настройки.Вставить("УзелИнформационнойБазы", Неопределено);
	Настройки.Вставить("ИспользоватьПрефиксыДляНастройкиОбмена", Ложь);
	Настройки.Вставить("ИспользоватьПрефиксыДляНастройкиОбменаКорреспондента", Ложь);
	Настройки.Вставить("ИдентификаторИнформационнойБазыИсточника", "");
	Настройки.Вставить("ИдентификаторИнформационнойБазыПриемника", "");
	Настройки.Вставить("ВерсияФорматаФайлаНастроекОбменаДанными", "");
	Настройки.Вставить("ВерсияФорматаОбмена", "");
	Настройки.Вставить("ВерсииФорматаОбмена", Новый Массив);
	Настройки.Вставить("ПоддерживаемыеОбъектыФормата", Неопределено);
	Настройки.Вставить("ПоддерживаемыеОбъектыФорматаКорреспондента", Неопределено);
	Настройки.Вставить("ИдентификаторТранспорта", "");
	Настройки.Вставить("НастройкиТранспорта", Новый Структура);
	Настройки.Вставить("ДанныеАутентификации", Новый Структура);
	Настройки.Вставить("WSКонечнаяТочкаКорреспондента", "");
	Настройки.Вставить("WSОбластьДанныхКорреспондента", 0);
	Настройки.Вставить("ВосстановлениеНастроекОбмена", "");
	Настройки.Вставить("НомерОтправленного", 0);
	Настройки.Вставить("НомерПринятого", 0);
	Настройки.Вставить("ИсправитьДублированиеНастроекСинхронизации");
	Настройки.Вставить("УзелКорреспондентаЕстьВЭтойБазе");
	Настройки.Вставить("ЭтотУзелЕстьВКорреспонденте");
	
	Возврат Настройки;
	
КонецФункции

Функция НастройкиПодключенияПоОбработке(ПомощникСозданияОбмена) Экспорт

	Настройки = СтруктураНастроекПодключения();
	
	ЗаполнитьЗначенияСвойств(Настройки, ПомощникСозданияОбмена);
	
	Если Настройки.ИспользоватьПрефиксыДляНастройкиОбмена
		Или Настройки.ИспользоватьПрефиксыДляНастройкиОбменаКорреспондента Тогда
		
		Настройки.КодУзла = Настройки.ПрефиксИнформационнойБазыИсточника;
			
	Иначе
		
		Настройки.КодУзла = Настройки.ИдентификаторИнформационнойБазыИсточника;
		
	КонецЕсли;
	
	Если Настройки.ИспользоватьПрефиксыДляНастройкиОбмена
		Или Настройки.ИспользоватьПрефиксыДляНастройкиОбменаКорреспондента Тогда
		
		Настройки.КодУзлаКорреспондента = Настройки.ПрефиксИнформационнойБазыПриемника;
			
	Иначе
		
		Настройки.КодУзлаКорреспондента = Настройки.ИдентификаторИнформационнойБазыПриемника;
		
	КонецЕсли;
	
	Настройки.ПоддерживаемыеОбъектыФормата = ПомощникСозданияОбмена.ПоддерживаемыеОбъектыФорматаКорреспондента;
	Настройки.ВариантНастройкиОбмена = ПомощникСозданияОбмена.ИдентификаторНастройки;
		
	Возврат Настройки;
	
КонецФункции

#КонецОбласти



