///////////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2024, ООО 1С-Софт
// Все права защищены. Эта программа и сопроводительные материалы предоставляются 
// в соответствии с условиями лицензии Attribution 4.0 International (CC BY 4.0)
// Текст лицензии доступен по ссылке:
// https://creativecommons.org/licenses/by/4.0/legalcode
///////////////////////////////////////////////////////////////////////////////////////////////////////

#Область ПрограммныйИнтерфейс

// Вызывается из ТранспортСообщенийОбмена.ВсеТипыТранспорта
// Возвращает все доступные типы транспорта.
// 
// Параметры:
//  ТипыТранспорта - Массив из ОбработкаОбъект.ТранспортСообщенийОбмена*
//
Процедура ПриОпределенииТиповТранспорта(ТипыТранспорта) Экспорт

	//
	
КонецПроцедуры

// Вызывается в ТранспортСообщенийОбмена.ДоступныеТипыТранспорта
// Определяет доступные типы транспорта для узла плана обмена
// 
// Параметры:
//  ДоступныеТипыТранспорта - Массив из ОбработкаОбъект.ТранспортСообщенийОбмена*
//  Корреспондент - ПланОбменаСсылка - узел, для котороно определяются доступные типы транспорта
//  ВариантНастройки - Строка - вариант настройки
//
Процедура ПриОпределенииДоступныхТиповТранспорта(ДоступныеТипыТранспорта, Корреспондент, ВариантНастройки = "") Экспорт

	//
	
КонецПроцедуры

// Вызывается в ОбменДаннымиОперацииВебСервисов.СобратьФайлИзЧастей, 
// при помещении файла в хранилище сообщений обмена (регистр сведений СообщенияОбменаДанными).
// 
// Параметры:
//  ИмяФайла - Строка
//  ИдентификаторФайла - Строка 
//
Процедура ПриПомещенииФайлаВХранилище(ИмяФайла, ИдентификаторФайла) Экспорт
	
	//
	
КонецПроцедуры

// Вызывается в ОбменДаннымиОперацииВебСервисов.ПодготовитьФайлДляПолучения,
// перед получерием файла их хранилища сообщений обмена (регистр сведений СообщенияОбменаДанными).
// 
// Параметры:
//  ИдентификаторФайла - Строка
//
Процедура ПередПолучениемФайлаИзХранилища(ИдентификаторФайла) Экспорт

	//
	
КонецПроцедуры

#КонецОбласти
