///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// <Заголовок модуля: краткое описание и условия применения модуля.>
// 
// 
// 
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#Область ПрограммныйИнтерфейс

// Проверяет корректность имени объекта.
// 
// Параметры:
//  Объект - СправочникОбъект, ДокументОбъект - Проверяемый объект.
//  Отказ  - Булево - Признак ошибки проверки. Устанавливается в Истина, если имя некорректно.
//
// Процедура проверяет, соответствует ли имя объекта правилам: 
// должно начинаться с буквы или подчеркивания, содержать только буквы, цифры и подчеркивания.
// При некорректном имени устанавливает Отказ в Истина и выводит сообщение пользователю.
//
Процедура ПроверитьИмяОбъектаНаКорректность(Объект, Отказ) Экспорт
	
	Отказ = Не УДК_СтроковыеФункции.ИмяОбъектаКорректно(Объект.Имя);
	
	Если Отказ Тогда
		ТекстСообщения = "Имя недопустимо. Имя должно начинаться с буквы или подчёркивания,"
						+ " содержать только буквы, цифры и подчёркивания";
		ОбщегоНазначения.СообщитьПользователю(ТекстСообщения, , , "Объект.Имя", Отказ);
	КонецЕсли;
	
КонецПроцедуры


// Функция - Таблица вид объекта индекс картинки
// 
// Возвращаемое значение:
//  ТаблицаЗначений - Таблица с колонками: 
//	* ИндексКартинки - Число - Индекс картинки в коллекции "ОбщаяКартинка.ОбъектыМетаданных"
//	* ВидОбъекта - СправочникСсылка.УДК_ВидыОбъектовМетаданных - Вид объекта метаданных
//
Функция ТаблицаВидОбъектаИндексКартинки() Экспорт
	
	Таблица = Новый ТаблицаЗначений;
	Таблица.Колонки.Добавить("ИндексКартинки", 
		ОбщегоНазначения.ОписаниеТипаЧисло(5, 0, ДопустимыйЗнак.Неотрицательный));
	Таблица.Колонки.Добавить("ВидОбъекта", 
		Новый ОписаниеТипов("СправочникСсылка.УДК_ВидыОбъектовМетаданных"));
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.Общие;
	НоваяСтрока.ИндексКартинки = 2;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.Константа;
	НоваяСтрока.ИндексКартинки = 31;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.Справочник;
	НоваяСтрока.ИндексКартинки = 32;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.Документ;
	НоваяСтрока.ИндексКартинки = 93;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.ЖурналДокументов;
	НоваяСтрока.ИндексКартинки = 34;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.Перечисление;
	НоваяСтрока.ИндексКартинки = 35;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.Отчет;
	НоваяСтрока.ИндексКартинки = 36;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.Обработка;
	НоваяСтрока.ИндексКартинки = 37;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.ПланВидовХарактеристик;
	НоваяСтрока.ИндексКартинки = 38;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.ПланСчетов;
	НоваяСтрока.ИндексКартинки = 39;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.ПланВидовРасчета;
	НоваяСтрока.ИндексКартинки = 40;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.Подсистема;
	НоваяСтрока.ИндексКартинки = 41;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.РегистрСведений;
	НоваяСтрока.ИндексКартинки = 75;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.РегистрНакопления;
	НоваяСтрока.ИндексКартинки = 76;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.РегистрБухгалтерии;
	НоваяСтрока.ИндексКартинки = 77;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.РегистрРасчета;
	НоваяСтрока.ИндексКартинки = 78;

	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.БизнесПроцесс;
	НоваяСтрока.ИндексКартинки = 17;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.Задача;
	НоваяСтрока.ИндексКартинки = 80;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.ПланОбмена;
	НоваяСтрока.ИндексКартинки = 45;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.Роль;
	НоваяСтрока.ИндексКартинки = 44;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.ФункциональнаяОпция;
	НоваяСтрока.ИндексКартинки = 84;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.ОбщийМодуль;
	НоваяСтрока.ИндексКартинки = 81;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.ПодпискаНаСобытие;
	НоваяСтрока.ИндексКартинки = 82;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.РегламентноеЗадание;
	НоваяСтрока.ИндексКартинки = 83;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.ПакетXDTO;
	НоваяСтрока.ИндексКартинки = 85;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.КритерийОтбора;
	НоваяСтрока.ИндексКартинки = 86;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.ХранилищеНастроек;
	НоваяСтрока.ИндексКартинки = 87;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.ОбщаяКоманда;
	НоваяСтрока.ИндексКартинки = 88;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.WebСервис;
	НоваяСтрока.ИндексКартинки = 89;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.WSСсылка;
	НоваяСтрока.ИндексКартинки = 92;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.ГруппаКоманд;
	НоваяСтрока.ИндексКартинки = 90;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.ОбщаяФорма;
	НоваяСтрока.ИндексКартинки = 47;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.ПараметрСеанса;
	НоваяСтрока.ИндексКартинки = 43;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.Последовательность;
	НоваяСтрока.ИндексКартинки = 33;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.Нумератор;
	НоваяСтрока.ИндексКартинки = 94;	
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.ОбщийРеквизит;
	НоваяСтрока.ИндексКартинки = 95;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.ОбщийМакет;
	НоваяСтрока.ИндексКартинки = 96;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.ОбщаяКартинка;
	НоваяСтрока.ИндексКартинки = 97;

	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.HTTPСервис;
	НоваяСтрока.ИндексКартинки = 98;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.ПараметрФункциональнойОпции;
	НоваяСтрока.ИндексКартинки = 99;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.ОпределяемыйТип;
	НоваяСтрока.ИндексКартинки = 100;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.ВнешнийИсточникДанных;
	НоваяСтрока.ИндексКартинки = 102;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.Стиль;
	НоваяСтрока.ИндексКартинки = 103;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.ЭлементСтиля;
	НоваяСтрока.ИндексКартинки = 104;
	
	НоваяСтрока = Таблица.Добавить();
	НоваяСтрока.ВидОбъекта = Справочники.УДК_ВидыОбъектовМетаданных.Язык;
	НоваяСтрока.ИндексКартинки = 105;
	
	Возврат Таблица;
	
КонецФункции

// Процедура - Создает временную таблицу
//		* ИндексКартинки - Число - Индекс картинки в коллекции "ОбщаяКартинка.ОбъектыМетаданных"
//		* ВидОбъекта - СправочникСсылка.УДК_ВидыОбъектовМетаданных - Вид объекта метаданных
//
// Параметры:
//  МенеджерВТ	 - МенеджерВременныхТаблиц - Менеджер, куда будет помещена ВТ
//  ИмяТаблицы	 - Строка  - Желаемое имя ВТ. По умолчанию "ВТИндексыКартинок"
// 
Процедура СоздатьВТВидОбъектаИндексКартинки(МенеджерВТ, ИмяТаблицы = "ВТИндексыКартинок") Экспорт
	
	Запрос = Новый Запрос;
	Запрос.МенеджерВременныхТаблиц = МенеджерВТ;
	Запрос.Текст = 
	"ВЫБРАТЬ
	|	*
	|ПОМЕСТИТЬ [ИмяТаблицы]
	|ИЗ 
	|	[ТаблицаВидОбъектаИндексКартинки]";
	
	СтруктураПараметров = Новый Структура;
	СтруктураПараметров.Вставить("ИмяТаблицы", ИмяТаблицы);
	СтруктураПараметров.Вставить("ТаблицаВидОбъектаИндексКартинки", ТаблицаВидОбъектаИндексКартинки());
	
	Запрос.Текст = СтроковыеФункцииКлиентСервер.ВставитьПараметрыВСтроку(Запрос.Текст, СтруктураПараметров);
	
	Запрос.Выполнить();
	
КонецПроцедуры

// Функция - Текст запроса вид объекта индекс картинки
// 
// Возвращаемое значение:
//  Строка - Текст запроса, содержащий поля
//		* ИндексКартинки - Число - Индекс картинки в коллекции "ОбщаяКартинка.ОбъектыМетаданных"
//		* ВидОбъекта - СправочникСсылка.УДК_ВидыОбъектовМетаданных - Вид объекта метаданных
//
Функция ТекстЗапросаВидОбъектаИндексКартинки() Экспорт

	Текст = 
	"ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.Общие) КАК ВидОбъекта,
	|	2 КАК ИндексКартинки
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.Константа),
	|	31
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.Справочник),
	|	32
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.Документ),
	|	93
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.ЖурналДокументов),
	|	34
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.Перечисление),
	|	35
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.Отчет),
	|	36
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.Обработка),
	|	37
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.ПланВидовХарактеристик),
	|	38
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.ПланСчетов),
	|	39
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.ПланВидовРасчета),
	|	40
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.Подсистема),
	|	41
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.РегистрСведений),
	|	75
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.РегистрНакопления),
	|	76
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.РегистрБухгалтерии),
	|	77
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.РегистрРасчета),
	|	78
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.БизнесПроцесс),
	|	17
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.Задача),
	|	80
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.ПланОбмена),
	|	45
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.Роль),
	|	44
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.ФункциональнаяОпция),
	|	84
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.ОбщийМодуль),
	|	81
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.ПодпискаНаСобытие),
	|	82
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.РегламентноеЗадание),
	|	83
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.ПакетXDTO),
	|	85
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.КритерийОтбора),
	|	86
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.ХранилищеНастроек),
	|	87
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.ОбщаяКоманда),
	|	88
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.WebСервис),
	|	89
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.WSСсылка),
	|	92
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.ГруппаКоманд),
	|	90
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.ОбщаяФорма),
	|	47
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.ПараметрСеанса),
	|	43
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.Последовательность),
	|	33
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.Нумератор),
	|	94
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.ОбщийРеквизит),
	|	95
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.ОбщийМакет),
	|	96
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.ОбщаяКартинка),
	|	97
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.HTTPСервис),
	|	98
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.ПараметрФункциональнойОпции),
	|	99
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.ОпределяемыйТип),
	|	100
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.ВнешнийИсточникДанных),
	|	102
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.Стиль),
	|	103
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.ЭлементСтиля),
	|	104
	|
	|ОБЪЕДИНИТЬ ВСЕ
	|
	|ВЫБРАТЬ
	|	ЗНАЧЕНИЕ(Справочник.УДК_ВидыОбъектовМетаданных.Язык),
	|	105";
	
	Возврат Текст;
	
КонецФункции

// Функция - Индекс картинки по виду объекта
//
// Параметры:
//  ВидОбъектаМетаданных - СправочникСсылка.УДК_ВидыОбъектовМетаданных	 - 
// 
// Возвращаемое значение:
//  Число - Индекс картинки в коллекции "ОбщаяКартинка.ОбъектыМетаданных"
//
Функция ИндексКартинкиПоВидуОбъекта(ВидОбъектаМетаданных) Экспорт
	СписокИндексов = ИндексыКартинокПоВидамОбъектов();
	Результат = СписокИндексов.Получить(ВидОбъектаМетаданных);
	Возврат ?(Результат = Неопределено, 1, Результат);
КонецФункции

#КонецОбласти
 
#Область СлужебныйПрограммныйИнтерфейс
 
#КонецОбласти
 
#Область СлужебныеПроцедурыИФункции

Функция ИндексыКартинокПоВидамОбъектов()

    СписокИндексов = Новый Соответствие;

    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.Общие, 2);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.Константа, 31);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.Справочник, 32);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.Документ, 93);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.ЖурналДокументов, 34);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.Перечисление, 35);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.Отчет, 36);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.Обработка, 37);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.ПланВидовХарактеристик, 38);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.ПланСчетов, 39);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.ПланВидовРасчета, 40);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.Подсистема, 41);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.РегистрСведений, 75);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.РегистрНакопления, 76);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.РегистрБухгалтерии, 77);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.РегистрРасчета, 78);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.БизнесПроцесс, 17);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.Задача, 80);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.ПланОбмена, 45);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.Роль, 44);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.ФункциональнаяОпция, 84);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.ОбщийМодуль, 81);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.ПодпискаНаСобытие, 82);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.РегламентноеЗадание, 83);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.ПакетXDTO, 85);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.КритерийОтбора, 86);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.ХранилищеНастроек, 87);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.ОбщаяКоманда, 88);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.WebСервис, 89);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.WSСсылка, 92);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.ГруппаКоманд, 90);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.ОбщаяФорма, 47);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.ПараметрСеанса, 43);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.Последовательность, 33);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.Нумератор, 94);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.ОбщийРеквизит, 95);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.ОбщийМакет, 96);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.ОбщаяКартинка, 97);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.HTTPСервис, 98);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.ПараметрФункциональнойОпции, 99);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.ОпределяемыйТип, 100);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.ВнешнийИсточникДанных, 102);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.Стиль, 103);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.ЭлементСтиля, 104);
    СписокИндексов.Вставить(Справочники.УДК_ВидыОбъектовМетаданных.Язык, 105);

    Возврат СписокИндексов;

КонецФункции

#КонецОбласти