///////////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2024, ООО 1С-Софт
// Все права защищены. Эта программа и сопроводительные материалы предоставляются 
// в соответствии с условиями лицензии Attribution 4.0 International (CC BY 4.0)
// Текст лицензии доступен по ссылке:
// https://creativecommons.org/licenses/by/4.0/legalcode
///////////////////////////////////////////////////////////////////////////////////////////////////////

#Область СлужебныйПрограммныйИнтерфейс

Функция ИсключенияПоискаСсылокРазрешающихУдаление() Экспорт
	Возврат УдалениеПомеченныхОбъектовСлужебный.ИсключенияПоискаСсылокРазрешающихУдалениеСлужебный();
КонецФункции

Функция ПроверятьИспользованиеУдаляемыхОбъектов() Экспорт
	Результат = Новый Структура("Значение, МеткаВремени");
	Результат.Значение = Константы.ПроверятьИспользованиеУдаляемыхОбъектов.Получить();
	Результат.МеткаВремени = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Возврат Результат;
КонецФункции

#КонецОбласти

#Область СлужебныеПроцедурыИФункции

// Возвращаемое значение:
//   Строка
//
Функция ВедущиеИзмеренияРегистра(Знач ПолноеИмяРегистра) Экспорт
	
	МетаданныеРегистра = ОбщегоНазначения.ОбъектМетаданныхПоПолномуИмени(ПолноеИмяРегистра);
	Результат = Новый Массив;
	Контейнер = Новый Структура("Измерения", Новый Массив);
	ЗаполнитьЗначенияСвойств(Контейнер, МетаданныеРегистра);
	Измерения = Контейнер.Измерения; // КоллекцияОбъектовМетаданных
	Для каждого Измерение Из Измерения Цикл
		Контейнер = Новый Структура("Ведущее", Ложь);
		ЗаполнитьЗначенияСвойств(Контейнер, Измерение);
		Если Контейнер.Ведущее Тогда
			Результат.Добавить(Измерение.Имя);
		КонецЕсли;
	КонецЦикла;
	Возврат СтрСоединить(Результат, ",");
	
КонецФункции

#КонецОбласти