///////////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2024, ООО 1С-Софт
// Все права защищены. Эта программа и сопроводительные материалы предоставляются 
// в соответствии с условиями лицензии Attribution 4.0 International (CC BY 4.0)
// Текст лицензии доступен по ссылке:
// https://creativecommons.org/licenses/by/4.0/legalcode
///////////////////////////////////////////////////////////////////////////////////////////////////////

#Если Сервер Или ТолстыйКлиентОбычноеПриложение Или ВнешнееСоединение Тогда

#Область СлужебныйПрограммныйИнтерфейс

////////////////////////////////////////////////////////////////////////////////
// Обработчики событий подсистем конфигурации.

// См. ОбщегоНазначенияПереопределяемый.ПриДобавленииПереименованийОбъектовМетаданных.
Процедура ПриДобавленииПереименованийОбъектовМетаданных(Переименования) Экспорт
	
	ОбщегоНазначения.ДобавитьПереименование(Переименования, "2.2.1.12",
		"Подсистема.НастройкаИАдминистрирование", "Подсистема.Администрирование", "СтандартныеПодсистемы");
	
КонецПроцедуры

// Определяет разделы, в которых доступна панель отчетов.
//   Подробнее - см. описание процедуры ИспользуемыеРазделы
//   общего модуля ВариантыОтчетов.
//
// Параметры:
//   Разделы - СписокЗначений
//
Процедура ПриОпределенииРазделовСВариантамиОтчетов(Разделы) Экспорт
	
	Подсистема = Метаданные.Подсистемы.Найти("Администрирование");
	
	Если Подсистема <> Неопределено Тогда
		Разделы.Добавить(Подсистема, НСтр("ru = 'Отчеты администратора'"));
	КонецЕсли;
	
КонецПроцедуры

// Параметры:
//  Разделы - см. ДополнительныеОтчетыИОбработкиПереопределяемый.ОпределитьРазделыСДополнительнымиОтчетами.Разделы
//
Процедура ПриОпределенииРазделовСДополнительнымиОтчетами(Разделы) Экспорт
	
	Подсистема = Метаданные.Подсистемы.Найти("Администрирование");
	
	Если Подсистема <> Неопределено Тогда
		Разделы.Добавить(Подсистема);
	КонецЕсли;
	
КонецПроцедуры

// Параметры:
//  Разделы - см. ДополнительныеОтчетыИОбработкиПереопределяемый.ОпределитьРазделыСДополнительнымиОтчетами.Разделы
//
Процедура ПриОпределенииРазделовСДополнительнымиОбработками(Разделы) Экспорт
	
	Подсистема = Метаданные.Подсистемы.Найти("Администрирование");
	
	Если Подсистема <> Неопределено Тогда
		Разделы.Добавить(Подсистема);
	КонецЕсли;
	
КонецПроцедуры

#КонецОбласти

#КонецЕсли
