///////////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2024, ООО 1С-Софт
// Все права защищены. Эта программа и сопроводительные материалы предоставляются 
// в соответствии с условиями лицензии Attribution 4.0 International (CC BY 4.0)
// Текст лицензии доступен по ссылке:
// https://creativecommons.org/licenses/by/4.0/legalcode
///////////////////////////////////////////////////////////////////////////////////////////////////////

#Если Сервер Или ТолстыйКлиентОбычноеПриложение Или ВнешнееСоединение Тогда

#Область ПрограммныйИнтерфейс

// См. ОбработкаМенеджер.ТранспортСообщенийОбменаFILE.ПараметрыТранспорта
Функция ПараметрыТранспорта() Экспорт
	
	Описание = НСтр("ru = 'Данный вариант подключения рекомендуется в том случае, если другая программа находится на том же компьютере,
		|что и эта программа, или обе программы расположены в одной локальной сети (в одном офисе).'");
	
	Параметры = ТранспортСообщенийОбмена.СтруктураПараметровТранспорта();
	
	Параметры.Псевдоним = НСтр("ru = 'Прямое подключение (com-соединение)'");
	Параметры.ИдентификаторТранспорта = "COM";
	Параметры.Описание = Описание;
	Параметры.ИмяФормыАутентификации = "ФормаАутентификации";
	Параметры.РеквизитыДляБезопасногоХранилища.Добавить("ПарольПользователя");
	Параметры.ПрямоеПодключение = Истина;
	Параметры.РежимРаботыПриложения = 0;
	Параметры.ИспользоватьПрогресс = Ложь;
	Параметры.СохранитьПараметрыПодключенияВФайл = Ложь;
	Параметры.Картинка = БиблиотекаКартинок.ТранспортCOM;
	
	Возврат Параметры;
	
КонецФункции

#КонецОбласти

#Область СлужебныеПроцедурыИФункции

Функция НастройкиПодключенияВXML(НастройкиПодключения) Экспорт
	
	Возврат ТранспортСообщенийОбмена.НастройкиПодключенияВXML_1_2(НастройкиПодключения);
	
КонецФункции

Функция НастройкиПодключенияИзXML(ТекстXML) Экспорт
	
	Возврат ТранспортСообщенийОбмена.НастройкиПодключенияИзXML_1_2(ТекстXML, "COM");
	
КонецФункции

Функция НастройкиТранспортаВJSON(НастройкиТранспорта) Экспорт
	
	Возврат "";
	
КонецФункции

Функция НастройкиТранспортаИзJSON(НастройкиТранспортаJSON) Экспорт
	
	Возврат "";
	
КонецФункции

Функция ИмяКаталогаСохраненияНастроек(НастройкиПодключения) Экспорт
	
	Возврат "";
	
КонецФункции

#КонецОбласти
	
#КонецЕсли