///////////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2024, ООО 1С-Софт
// Все права защищены. Эта программа и сопроводительные материалы предоставляются 
// в соответствии с условиями лицензии Attribution 4.0 International (CC BY 4.0)
// Текст лицензии доступен по ссылке:
// https://creativecommons.org/licenses/by/4.0/legalcode
///////////////////////////////////////////////////////////////////////////////////////////////////////

#Область ОбработчикиСобытий

&НаКлиенте
Процедура ОбработкаКоманды(ПараметрКоманды, ПараметрыВыполненияКоманды)
	
	Если ПараметрКоманды = Неопределено Тогда
		ПоказатьПредупреждение(,НСтр("ru = 'Не выбраны задачи.'"));
		Возврат;
	КонецЕсли;
		
	ОчиститьСообщения();
	Результат = ВыполнитьЗадачи(ПараметрКоманды);
	ПоказатьОповещениеПользователя(Результат.ТекстСообщения, Результат.НавигационнаяСсылка, Результат.Пояснение);
	Оповестить("Запись_ЗадачаИсполнителя", Новый Структура("Выполнена", Истина), ПараметрКоманды);
	
КонецПроцедуры

&НаСервере
Функция ВыполнитьЗадачи(Знач Задачи)
	
	Результат = Новый Структура;
	Результат.Вставить("ТекстСообщения", НСтр("ru = 'Задачи выполнены'"));
	Результат.Вставить("НавигационнаяСсылка", Неопределено);
	Результат.Вставить("Пояснение", "");
	Для Каждого Задача Из Задачи Цикл
		БизнесПроцессыИЗадачиСервер.ВыполнитьЗадачу(Задача, Истина);
		Если Результат.НавигационнаяСсылка = Неопределено Тогда
			Результат.ТекстСообщения = НСтр("ru = 'Задача выполнена'");
			Результат.НавигационнаяСсылка = ПолучитьНавигационнуюСсылку(Задача);
			Результат.Пояснение = Строка(Задача);
		КонецЕсли;
	КонецЦикла;
	Возврат Результат;
	
КонецФункции

#КонецОбласти