///////////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2024, ООО 1С-Софт
// Все права защищены. Эта программа и сопроводительные материалы предоставляются 
// в соответствии с условиями лицензии Attribution 4.0 International (CC BY 4.0)
// Текст лицензии доступен по ссылке:
// https://creativecommons.org/licenses/by/4.0/legalcode
///////////////////////////////////////////////////////////////////////////////////////////////////////

#Область СлужебныеПроцедурыИФункции

////////////////////////////////////////////////////////////////////////////////
// Обработчики операций

// Соответствует операции Upload.
Функция ВыполнитьВыгрузку(ИмяПланаОбмена, КодУзлаИнформационнойБазы, ХранилищеСообщенияОбмена)
	
	Возврат ОбменДаннымиОперацииВебСервисов.ВыполнитьВыгрузку(ИмяПланаОбмена, КодУзлаИнформационнойБазы, ХранилищеСообщенияОбмена)
	
КонецФункции

// Соответствует операции UploadData.
Функция ВыполнитьВыгрузкуДанных(ИмяПланаОбмена, КодУзлаИнформационнойБазы, ИдентификаторФайлаСтрокой, ДлительнаяОперация,
	ИдентификаторОперации, ДлительнаяОперацияРазрешена)
	
	Возврат ОбменДаннымиОперацииВебСервисов.ВыполнитьВыгрузкуДанных(ИмяПланаОбмена, КодУзлаИнформационнойБазы, 
		ИдентификаторФайлаСтрокой, ДлительнаяОперация, ИдентификаторОперации, ДлительнаяОперацияРазрешена)

КонецФункции

// Соответствует операции Download.
Функция ВыполнитьЗагрузку(ИмяПланаОбмена, КодУзлаИнформационнойБазы, ХранилищеСообщенияОбмена)
	
	Возврат ОбменДаннымиОперацииВебСервисов.ВыполнитьЗагрузку(
		ИмяПланаОбмена, КодУзлаИнформационнойБазы, ХранилищеСообщенияОбмена);
	
КонецФункции

// Соответствует операции DownloadData.
Функция ВыполнитьЗагрузкуДанных(ИмяПланаОбмена, КодУзлаИнформационнойБазы, ИдентификаторФайлаСтрокой, ДлительнаяОперация,
	ИдентификаторОперации, ДлительнаяОперацияРазрешена)
	
	Возврат ОбменДаннымиОперацииВебСервисов.ВыполнитьЗагрузкуДанных(ИмяПланаОбмена, КодУзлаИнформационнойБазы, 
		ИдентификаторФайлаСтрокой, ДлительнаяОперация, ИдентификаторОперации, ДлительнаяОперацияРазрешена);
	
КонецФункции

// Соответствует операции GetIBParameters.
Функция ПолучитьПараметрыИнформационнойБазы(ИмяПланаОбмена, КодУзла, СообщениеОбОшибке) 
	
	Возврат ОбменДаннымиОперацииВебСервисов.ПолучитьПараметрыИнформационнойБазы(
		ИмяПланаОбмена, КодУзла, СообщениеОбОшибке)
	
КонецФункции

// Соответствует операции CreateExchangeNode.
Функция СоздатьУзелОбменаДанными(ПараметрыXDTO)
	
	Возврат ОбменДаннымиОперацииВебСервисов.СоздатьУзелОбменаДанными(ПараметрыXDTO);
	
КонецФункции

// Соответствует операции RemoveExchangeNode.
Функция УдалитьУзелОбменаДанными(ИмяПланаОбмена, ИдентификаторУзла)
	
	Возврат ОбменДаннымиОперацииВебСервисов.УдалитьУзелОбменаДанными(ИмяПланаОбмена, ИдентификаторУзла);
	
КонецФункции

// Соответствует операции GetContinuousOperationStatus.
Функция ПолучитьСостояниеДлительнойОперации(ИдентификаторОперации, СтрокаСообщенияОбОшибке)
	
	Возврат ОбменДаннымиОперацииВебСервисов.ПолучитьСостояниеДлительнойОперации(
		ИдентификаторОперации, СтрокаСообщенияОбОшибке);
	
КонецФункции

// Соответствует операции PrepareGetFile.
Функция PrepareGetFile(FileId, BlockSize, TransferId, PartQuantity)
	
	Возврат ОбменДаннымиОперацииВебСервисов.ПодготовитьФайлДляПолучения(FileId, BlockSize, TransferId, PartQuantity);
	
КонецФункции

// Соответствует операции GetFilePart.
Функция GetFilePart(TransferId, PartNumber, PartData)
	
	Возврат ОбменДаннымиОперацииВебСервисов.ПолучитьЧастьФайла(TransferId, PartNumber, PartData);
	
КонецФункции

// Соответствует операции ReleaseFile.
Функция ReleaseFile(TransferId)
	
	Возврат ОбменДаннымиОперацииВебСервисов.УдалитьСообщениеОбмена(TransferId);
	
КонецФункции

// Соответствует операции PutFilePart.
//
// Параметры:
//   TransferId - УникальныйИдентификатор - уникальный идентификатор сессии передачи данных.
//   PartNumber - Число - номер части файла.
//   PartData - ДвоичныеДанные - данные части файла.
//
Функция PutFilePart(TransferId, PartNumber, PartData)
	
	Возврат ОбменДаннымиОперацииВебСервисов.ПоместитьЧастьФайла(TransferId, PartNumber, PartData);
	
КонецФункции

// Соответствует операции SaveFileFromParts.
Функция SaveFileFromParts(TransferId, PartQuantity, FileId)
	
	Возврат ОбменДаннымиОперацииВебСервисов.СобратьФайлИзЧастей(TransferId, PartQuantity, FileId);
	
КонецФункции

// Соответствует операции PutMessageForDataMatching.
Функция PutMessageForDataMatching(ИмяПланаОбмена, ИдентификаторУзла, ИдентификаторФайла)
	
	Возврат ОбменДаннымиОперацииВебСервисов.ПоместитьСообщениеДляСопоставленияДанных(
		ИмяПланаОбмена, ИдентификаторУзла, ИдентификаторФайла);
	
КонецФункции

// Соответствует операции Ping.
Функция Ping()
	// Проверка связи.
	Возврат "";
КонецФункции

// Соответствует операции TestConnection.
Функция TestConnection(ИмяПланаОбмена, КодУзла, Результат)
	
	Возврат ОбменДаннымиОперацииВебСервисов.ТестовоеПодключение(ИмяПланаОбмена, КодУзла, Результат);
	
КонецФункции

#КонецОбласти
