///////////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2024, ООО 1С-Софт
// Все права защищены. Эта программа и сопроводительные материалы предоставляются 
// в соответствии с условиями лицензии Attribution 4.0 International (CC BY 4.0)
// Текст лицензии доступен по ссылке:
// https://creativecommons.org/licenses/by/4.0/legalcode
///////////////////////////////////////////////////////////////////////////////////////////////////////

#Область ПрограммныйИнтерфейс

#Область ДляВызоваИзДругихПодсистем

// Определяет события, на которые могут подписаться другие библиотеки.
//
// Возвращаемое значение:
//   Структура - ключами свойств структуры являются имена событий, на которые
//               могут быть подписаны библиотеки.
//
Функция СобытияБСП() Экспорт

	События = Новый Структура;
	
	// БазоваяФункциональность
	События.Вставить("ПриДобавленииПодсистем", Ложь);
	События.Вставить("ПриУстановкеПараметровСеанса", Ложь);
	События.Вставить("ПриДобавленииОбработчиковУстановкиПараметровСеанса", Ложь);
	События.Вставить("ПриДобавленииИсключенийПоискаСсылок", Ложь);
	События.Вставить("ПриДобавленииПереименованийОбъектовМетаданных", Ложь);
	События.Вставить("ПриЗаполненииВсехПараметровРаботыРасширений", Ложь);
	События.Вставить("ПриОчисткеВсехПараметровРаботыРасширений", Ложь);
	События.Вставить("ПриОтправкеДанныхГлавному", Ложь);
	События.Вставить("ПриОтправкеДанныхПодчиненному", Ложь);
	События.Вставить("ПриПолученииДанныхОтГлавного", Ложь);
	События.Вставить("ПриПолученииДанныхОтПодчиненного", Ложь);
	События.Вставить("ПослеПолученияДанных", Ложь);
	События.Вставить("ПриВключенииРазделенияПоОбластямДанных", Ложь);
	События.Вставить("ПриОпределенииПоддерживаемыхВерсийПрограммныхИнтерфейсов", Ложь);
	События.Вставить("ПриДобавленииПараметровРаботыКлиентаПриЗапуске", Ложь);
	События.Вставить("ПриДобавленииПараметровРаботыКлиента", Ложь);
	События.Вставить("ПередЗапускомПрограммы", Ложь);
	События.Вставить("ПриДобавленииСерверныхОповещений", Ложь);
	События.Вставить("ПриПериодическомПолученииДанныхКлиентаНаСервере", Ложь);
	
	// Банки
	События.Вставить("ПриОпределенииНастроекЗагрузкиКлассификатораБанков");
	
	// ВариантыОтчетов
	События.Вставить("ПриОпределенииНастроекВариантовОтчетов", Ложь);
	События.Вставить("ПриОпределенииРазделовСВариантамиОтчетов", Ложь);
	События.Вставить("ПриНастройкеВариантовОтчетов", Ложь);
	События.Вставить("ПриИзмененииКлючейВариантовОтчетов", Ложь);
	События.Вставить("ПриОпределенииОбъектовСКомандамиОтчетов", Ложь);
	События.Вставить("ПередДобавлениемКомандОтчетов", Ложь);
	События.Вставить("ПриОпределенииПараметровВыбораВариантыОтчетов", Ложь);
	События.Вставить("ПриСозданииНаСервереВариантыОтчетов", Ложь);
	События.Вставить("ПередЗагрузкойВариантаНаСервере", Ложь);
	
	// ВнешниеКомпоненты
	События.Вставить("ПриОпределенииИспользуемыхВнешнихКомпонент", Ложь);
	
	// ГрупповоеИзменениеОбъектов
	События.Вставить("ПриОпределенииОбъектовСРедактируемымиРеквизитами", Ложь);
	События.Вставить("ПриОпределенииРедактируемыхРеквизитовОбъекта", Ложь);
	
	// ДатыЗапретаИзменений
	События.Вставить("ПриЗаполненииРазделовДатЗапретаИзменения", Ложь);
	События.Вставить("ПриЗаполненииИсточниковДанныхДляПроверкиЗапретаИзменения", Ложь);
	
	// ДополнительныеОтчетыИОбработки
	События.Вставить("ПриУстановкеРежимаПодключенияДополнительногоОтчетаИлиОбработкиВОбластиДанных", Ложь);
	
	// ЗагрузкаДанныхИзФайла
	События.Вставить("ПриОпределенииСправочниковДляЗагрузкиДанных", Ложь);
	
	// ЗапретРедактированияРеквизитовОбъектов
	События.Вставить("ПриОпределенииОбъектовСЗаблокированнымиРеквизитами", Ложь);
	
	// ИнтерфейсOData
	События.Вставить("ПриЗаполненииТиповИсключаемыхИзВыгрузкиЗагрузкиOData", Ложь);
	События.Вставить("ПриЗаполненииЗависимыхТаблицДляВыгрузкиЗагрузкиOData", Ложь);
	
	// КонтрольВеденияУчета
	События.Вставить("ПриОпределенииПроверок", Ложь);
	
	// НапоминанияПользователя
	События.Вставить("ПриЗаполненииСпискаРеквизитовИсточникаСДатамиДляНапоминания", Ложь);
	
	// ОбменДанными
	События.Вставить("ПриНастройкеПодчиненногоУзлаРИБ", Ложь);
	
	// ОбновлениеВерсииИБ
	События.Вставить("ПриДобавленииОбработчиковОбновления", Ложь); // Для совместимости с БТС 1.2.2.
	События.Вставить("ПослеОбновленияИнформационнойБазы", Ложь);
	События.Вставить("ПриПолученииПриоритетаОбновления", Ложь);
	События.Вставить("ПриЗаполненииОбъектовПланируемыхКУдалению", Ложь);
	
	// Печать
	События.Вставить("ПриОпределенииНастроекПечати", Ложь);
	События.Вставить("ПриПодготовкеСпискаМакетовВФорматеОфисныхДокументовФормируемыхНаСервере", Ложь);
	События.Вставить("ПриОпределенииОбъектовСКомандамиПечати", Ложь); // Устарела. Следует использовать ПриОпределенииНастроекПечати. 
	События.Вставить("ПередДобавлениемКомандПечати", Ложь);
	События.Вставить("ПриПолученииНастроекСпискаКомандПечати", Ложь);
	События.Вставить("ПриПечати", Ложь);
	События.Вставить("ПередОтправкойПоПочте", Ложь);
	События.Вставить("ПриПолученииПодписейИПечатей", Ложь);
	События.Вставить("ПечатьДокументовПриСозданииНаСервере", Ложь);
	События.Вставить("ПечатьДокументовПриЗагрузкеДанныхИзНастроекНаСервере", Ложь);
	События.Вставить("ПечатьДокументовПриСохраненииДанныхВНастройкахНаСервере", Ложь);
	События.Вставить("ПечатьДокументовПриВыполненииКоманды", Ложь);
	События.Вставить("ПриОпределенииИсточниковДанныхПечати", Ложь);
	События.Вставить("ПриПодготовкеДанныхПечати", Ложь);
	
	// ПодключаемыеКоманды
	События.Вставить("ПриОпределенииВидовПодключаемыхКоманд", Ложь);
	События.Вставить("ПриОпределенииСоставаНастроекПодключаемыхОбъектов", Ложь);
	События.Вставить("ПриОпределенииКомандПодключенныхКОбъекту", Ложь);
	События.Вставить("ПриОпределенииОбъектовСКомандамиСозданияНаОсновании", Ложь);
	События.Вставить("ПередДобавлениемКомандСозданияНаОсновании", Ложь);
	События.Вставить("ПриДобавленииКомандСозданияНаОсновании", Ложь);
	
	// Пользователи
	События.Вставить("ПриОпределенииНастроек", Ложь);
	События.Вставить("ПриОпределенииНазначенияРолей", Ложь);
	События.Вставить("ПриОпределенииДействийВФорме", Ложь);
	События.Вставить("ПриПолученииПрочихНастроек", Ложь);
	События.Вставить("ПриСохраненииПрочихНастроек", Ложь);
	События.Вставить("ПриУдаленииПрочихНастроек", Ложь);
	События.Вставить("ПриЗавершенииОбработкиПользователяИБ", Ложь);
	События.Вставить("ПриОпределенииНастроекРегистрацииСобытийДоступаКДанным", Ложь);
	
	// ПрофилиБезопасности
	События.Вставить("ПриПроверкеВозможностиНастройкиПрофилейБезопасности", Ложь);
	События.Вставить("ПриЗапросеРазрешенийНаИспользованиеВнешнихРесурсов", Ложь);
	События.Вставить("ПриЗапросеСозданияПрофиляБезопасности", Ложь);
	События.Вставить("ПриЗапросеУдаленияПрофиляБезопасности", Ложь);
	События.Вставить("ПриПодключенииВнешнегоМодуля", Ложь);
	События.Вставить("ПриВключенииИспользованияПрофилейБезопасности", Ложь);
	События.Вставить("ПриЗаполненииРазрешенийНаДоступКВнешнимРесурсам", Ложь);
	
	// РаботаСПочтовымиСообщениями  
	События.Вставить("ПередПолучениемСтатусовПисем", Ложь); 
	События.Вставить("ПослеПолученияСтатусовПисем", Ложь);	
	
	// РаботаСФайлами
	События.Вставить("ПриСозданииФормыСпискаФайлов", Ложь);
	События.Вставить("ПриСозданииФормыЭлементаФайлов", Ложь);
	События.Вставить("ПриОпределенииОбъектовИсключенияСинхронизацииФайлов", Ложь);
	События.Вставить("ПриОтправкеФайловПочтой", Ложь);
	
	// РегламентныеЗадания
	События.Вставить("ПриОпределенииНастроекРегламентныхЗаданий", Ложь);
	События.Вставить("ПриЗапретеРаботыСВнешнимиРесурсами", Ложь);
	События.Вставить("ПриРазрешенииРаботыСВнешнимиРесурсами", Ложь);
	
	// Свойства
	События.Вставить("ПриПолученииПредопределенныхНаборовСвойств", Ложь);
	
	// ТекущиеДела
	События.Вставить("ПриОпределенииОбработчиковТекущихДел", Ложь);
	События.Вставить("ПриЗаполненииСпискаТекущихДел", Ложь);
	События.Вставить("ПриОпределенииПорядкаРазделовКомандногоИнтерфейса", Ложь);
	События.Вставить("ПриОтключенииТекущихДел", Ложь);
	События.Вставить("ПриОпределенииНастроекТекущихДел", Ложь);
	События.Вставить("ПриУстановкеОбщихПараметровЗапросов", Ложь);
	
	// УправлениеДоступом
	События.Вставить("ПриЗаполненииВидовДоступа", Ложь);
	События.Вставить("ПриЗаполненииСписковСОграничениемДоступа", Ложь);
	События.Вставить("ПриЗаполненииПоставляемыхПрофилейГруппДоступа", Ложь);
	События.Вставить("ПриЗаполненииЗависимостейПравДоступа", Ложь);
	События.Вставить("ПриЗаполненииВозможныхПравДляНастройкиПравОбъектов", Ложь);
	События.Вставить("ПриЗаполненииИспользованияВидаДоступа", Ложь);
	События.Вставить("ПриЗаполненииВидовОграниченийПравОбъектовМетаданных", Ложь);
	
	// УчетОригиналовПервичныхДокументов
	События.Вставить("ПриОпределенииНастроекУчетаОригиналов", Ложь);
	События.Вставить("ПриИзмененииОбщегоСостоянияОригинала", Ложь);
	События.Вставить("ПередЗаписьюСостоянийОригиналовПослеПечати", Ложь);
	События.Вставить("ПриОпределенииОбъектовСКомандамиУчетаОригиналов", Ложь);
	События.Вставить("ПриОпределенииМногосотрудниковыхДокументов", Ложь);
	События.Вставить("ПриЗаполненииТаблицыУчетаОригиналов", Ложь);

	// ЦентрМониторинга
	События.Вставить("ПриСбореПоказателейСтатистикиКонфигурации", Ложь);

	Возврат События;

КонецФункции

#Область ОбработчикиСобытийБТС

// Обработка программных событий, возникающих в подсистемах БТС.
// Только для вызовов из библиотеки БТС в БСП.

// Определяет события, на которые подписана эта библиотека.
//
// Параметры:
//  Подписки - см. ИнтеграцияПодсистемБТС.СобытияБТС.
//
Процедура ПриОпределенииПодписокНаСобытияБТС(Подписки) Экспорт
	
	// БазоваяФункциональность
	Подписки.ПриДобавленииОбработчиковОбновленияБТС = Истина;
	
	// ВыгрузкаЗагрузкаДанных
	Подписки.ПриЗаполненииТиповТребующихАннотациюСсылокПриВыгрузке = Истина;
	Подписки.ПриЗаполненииТиповОбщихДанныхПоддерживающихСопоставлениеСсылокПриЗагрузке = Истина;
	Подписки.ПриЗаполненииТиповОбщихДанныхНеТребующихСопоставлениеСсылокПриЗагрузке = Истина;
	Подписки.ПриЗаполненииТиповИсключаемыхИзВыгрузкиЗагрузки = Истина;
	Подписки.ПриРегистрацииОбработчиковВыгрузкиДанных = Истина;
	Подписки.ПриРегистрацииОбработчиковЗагрузкиДанных = Истина;
	Подписки.ПослеЗагрузкиДанных = Истина;
	Подписки.ПередВыгрузкойДанных = Истина;
	Подписки.ПередЗагрузкойДанных = Истина;
	Подписки.ПриЗагрузкеПользователяИнформационнойБазы = Истина;
	Подписки.ПослеЗагрузкиПользователяИнформационнойБазы = Истина;
	Подписки.ПослеЗагрузкиПользователейИнформационнойБазы = Истина;
	
	// РаботаВМоделиСервиса_БазоваяФункциональностьВМоделиСервиса
	Подписки.ПриЗаполненииТаблицыПараметровИБ = Истина;
	Подписки.ПриОпределенииИсключенийНеразделенныхДанных = Истина;
	Подписки.ПриОпределенииПсевдонимаПользователя = Истина;

	// РаботаВМоделиСервиса_ОбменСообщениями
	Подписки.ПриОпределенииОбработчиковКаналовСообщений  = Истина;
	Подписки.РегистрацияИнтерфейсовПринимаемыхСообщений  = Истина;
	Подписки.РегистрацияИнтерфейсовОтправляемыхСообщений = Истина;
	
	// РаботаВМоделиСервиса_ОчередьЗаданий
	Подписки.ПриПолученииСпискаШаблонов = Истина;
	Подписки.ПриОпределенииПсевдонимовОбработчиков = Истина;
	Подписки.ПриОпределенииИспользованияРегламентныхЗаданий = Истина;
	
	// РаботаВМоделиСервиса_ПоставляемыеДанные
	Подписки.ПриОпределенииОбработчиковПоставляемыхДанных = Истина;

КонецПроцедуры

#Область БазоваяФункциональность

// См. ОбновлениеИнформационнойБазыБТС.ПриДобавленииОбработчиковОбновления.
Процедура ПриДобавленииОбработчиковОбновленияБТС(Обработчики) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.ДополнительныеОтчетыИОбработкиВМоделиСервиса") Тогда
		МодульДополнительныеОтчетыИОбработкиВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль(
			"ДополнительныеОтчетыИОбработкиВМоделиСервиса");
		МодульДополнительныеОтчетыИОбработкиВМоделиСервиса.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;

КонецПроцедуры

#КонецОбласти

#Область ВыгрузкаЗагрузкаДанных

// См. ВыгрузкаЗагрузкаДанныхПереопределяемый.ПриЗаполненииТиповТребующихАннотациюСсылокПриВыгрузке.
Процедура ПриЗаполненииТиповТребующихАннотациюСсылокПриВыгрузке(Типы) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаВМоделиСервиса.ПользователиВМоделиСервиса") Тогда
		МодульПользователиСлужебныйВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("ПользователиСлужебныйВМоделиСервиса");
		МодульПользователиСлужебныйВМоделиСервиса.ПриЗаполненииТиповТребующихАннотациюСсылокПриВыгрузке(Типы);
	КонецЕсли;

КонецПроцедуры

// См. ВыгрузкаЗагрузкаДанныхПереопределяемый.ПриЗаполненииТиповОбщихДанныхПоддерживающихСопоставлениеСсылокПриЗагрузке.
Процедура ПриЗаполненииТиповОбщихДанныхПоддерживающихСопоставлениеСсылокПриЗагрузке(Типы) Экспорт

	СтандартныеПодсистемыСервер.ПриЗаполненииТиповОбщихДанныхПоддерживающихСопоставлениеСсылокПриЗагрузке(Типы);

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Банки") Тогда
		МодульРаботаСБанками = ОбщегоНазначения.ОбщийМодуль("РаботаСБанками");
		МодульРаботаСБанками.ПриЗаполненииТиповОбщихДанныхПоддерживающихСопоставлениеСсылокПриЗагрузке(Типы);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВариантыОтчетов") Тогда
		МодульВариантыОтчетов = ОбщегоНазначения.ОбщийМодуль("ВариантыОтчетов");
		МодульВариантыОтчетов.ПриЗаполненииТиповОбщихДанныхПоддерживающихСопоставлениеСсылокПриЗагрузке(Типы);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ДатыЗапретаИзменения") Тогда
		МодульДатыЗапретаИзмененияСлужебный = ОбщегоНазначения.ОбщийМодуль("ДатыЗапретаИзмененияСлужебный");
		МодульДатыЗапретаИзмененияСлужебный.ПриЗаполненииТиповОбщихДанныхПоддерживающихСопоставлениеСсылокПриЗагрузке(
			Типы);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КалендарныеГрафики") Тогда
		МодульКалендарныеГрафики = ОбщегоНазначения.ОбщийМодуль("КалендарныеГрафики");
		МодульКалендарныеГрафики.ПриЗаполненииТиповОбщихДанныхПоддерживающихСопоставлениеСсылокПриЗагрузке(Типы);
	КонецЕсли;

КонецПроцедуры

// См. ВыгрузкаЗагрузкаДанныхПереопределяемый.ПриЗаполненииТиповОбщихДанныхНеТребующихСопоставлениеСсылокПриЗагрузке.
Процедура ПриЗаполненииТиповОбщихДанныхНеТребующихСопоставлениеСсылокПриЗагрузке(Типы) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСФайлами") Тогда
		МодульРаботаСФайламиСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебный");
		МодульРаботаСФайламиСлужебный.ПриЗаполненииТиповОбщихДанныхНеТребующихСопоставлениеСсылокПриЗагрузке(Типы);
	КонецЕсли;

КонецПроцедуры

// См. ВыгрузкаЗагрузкаДанныхПереопределяемый.ПриЗаполненииТиповИсключаемыхИзВыгрузкиЗагрузки.
Процедура ПриЗаполненииТиповИсключаемыхИзВыгрузкиЗагрузки(Типы) Экспорт

	Если Не ОбщегоНазначения.ПодсистемаСуществует("ТехнологияСервиса.ВыгрузкаЗагрузкаДанных") Тогда
		Возврат;
	КонецЕсли;
	
	СтандартныеПодсистемыСервер.ПриЗаполненииТиповИсключаемыхИзВыгрузкиЗагрузки(Типы);
	СерверныеОповещения.ПриЗаполненииТиповИсключаемыхИзВыгрузкиЗагрузки(Типы);
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.АдресныйКлассификатор") Тогда
		МодульАдресныйКлассификаторСлужебный = ОбщегоНазначения.ОбщийМодуль("АдресныйКлассификаторСлужебный");
		МодульАдресныйКлассификаторСлужебный.ПриЗаполненииТиповИсключаемыхИзВыгрузкиЗагрузки(Типы);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВариантыОтчетов") Тогда
		МодульВариантыОтчетов = ОбщегоНазначения.ОбщийМодуль("ВариантыОтчетов");
		МодульВариантыОтчетов.ПриЗаполненииТиповИсключаемыхИзВыгрузкиЗагрузки(Типы);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Взаимодействия") Тогда
		МодульВзаимодействия = ОбщегоНазначения.ОбщийМодуль("Взаимодействия");
		МодульВзаимодействия.ПриЗаполненииТиповИсключаемыхИзВыгрузкиЗагрузки(Типы);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВнешниеКомпоненты") Тогда
		МодульВнешниеКомпонентыСлужебный = ОбщегоНазначения.ОбщийМодуль("ВнешниеКомпонентыСлужебный");
		МодульВнешниеКомпонентыСлужебный.ПриЗаполненииТиповИсключаемыхИзВыгрузкиЗагрузки(Типы);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.ВнешниеКомпонентыВМоделиСервиса") Тогда
		МодульВнешниеКомпонентыВМоделиСервисаСлужебный = ОбщегоНазначения.ОбщийМодуль(
			"ВнешниеКомпонентыВМоделиСервисаСлужебный");
		МодульВнешниеКомпонентыВМоделиСервисаСлужебный.ПриЗаполненииТиповИсключаемыхИзВыгрузкиЗагрузки(Типы);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.ДополнительныеОтчетыИОбработкиВМоделиСервиса") Тогда
		МодульДополнительныеОтчетыИОбработкиВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль(
			"ДополнительныеОтчетыИОбработкиВМоделиСервиса");
		МодульДополнительныеОтчетыИОбработкиВМоделиСервиса.ПриЗаполненииТиповИсключаемыхИзВыгрузкиЗагрузки(Типы);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЗавершениеРаботыПользователей") Тогда
		МодульСоединенияИБ = ОбщегоНазначения.ОбщийМодуль("СоединенияИБ");
		МодульСоединенияИБ.ПриЗаполненииТиповИсключаемыхИзВыгрузкиЗагрузки(Типы);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КонтрольВеденияУчета") Тогда
		МодульКонтрольВеденияУчетаСлужебный = ОбщегоНазначения.ОбщийМодуль("КонтрольВеденияУчетаСлужебный");
		МодульКонтрольВеденияУчетаСлужебный.ПриЗаполненииТиповИсключаемыхИзВыгрузкиЗагрузки(Типы);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.ОбновлениеВерсииИБВМоделиСервиса") Тогда
		МодульОбновлениеИнформационнойБазыСлужебныйВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль(
			"ОбновлениеИнформационнойБазыСлужебныйВМоделиСервиса");
		МодульОбновлениеИнформационнойБазыСлужебныйВМоделиСервиса.ПриЗаполненииТиповИсключаемыхИзВыгрузкиЗагрузки(Типы);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСПочтовымиСообщениями") Тогда
		МодульРаботаСПочтовымиСообщениямиСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСПочтовымиСообщениямиСлужебный");
		МодульРаботаСПочтовымиСообщениямиСлужебный.ПриЗаполненииТиповИсключаемыхИзВыгрузкиЗагрузки(Типы);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.РаботаСФайламиВМоделиСервиса") Тогда
		МодульРаботаСФайламиСлужебныйВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебныйВМоделиСервиса");
		МодульРаботаСФайламиСлужебныйВМоделиСервиса.ПриЗаполненииТиповИсключаемыхИзВыгрузкиЗагрузки(Типы);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаВМоделиСервиса.ОбменДаннымиВМоделиСервиса") Тогда
		МодульОбменДаннымиВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("ОбменДаннымиВМоделиСервиса");
		МодульОбменДаннымиВМоделиСервиса.ПриЗаполненииТиповИсключаемыхИзВыгрузкиЗагрузки(Типы);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УдалениеПомеченныхОбъектов") Тогда
		МодульУдалениеПомеченныхОбъектовСлужебный = ОбщегоНазначения.ОбщийМодуль("УдалениеПомеченныхОбъектовСлужебный");
		МодульУдалениеПомеченныхОбъектовСлужебный.ПриЗаполненииТиповИсключаемыхИзВыгрузкиЗагрузки(Типы);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЭлектроннаяПодписьСервисаDSS") Тогда
		МодульСервисКриптографииDSSСлужебный = ОбщегоНазначения.ОбщийМодуль("СервисКриптографииDSSСлужебный");
		МодульСервисКриптографииDSSСлужебный.ПриЗаполненииТиповИсключаемыхИзВыгрузкиЗагрузки(Типы);
	КонецЕсли;
	
КонецПроцедуры

// См. ВыгрузкаЗагрузкаДанныхПереопределяемый.ПриРегистрацииОбработчиковВыгрузкиДанных.
Процедура ПриРегистрацииОбработчиковВыгрузкиДанных(ТаблицаОбработчиков) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВерсионированиеОбъектов") Тогда
		МодульВерсионированиеОбъектов = ОбщегоНазначения.ОбщийМодуль("ВерсионированиеОбъектов");
		МодульВерсионированиеОбъектов.ПриРегистрацииОбработчиковВыгрузкиДанных(ТаблицаОбработчиков);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.РаботаСФайламиВМоделиСервиса") Тогда
		МодульРаботаСФайламиСлужебныйВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебныйВМоделиСервиса");
		МодульРаботаСФайламиСлужебныйВМоделиСервиса.ПриРегистрацииОбработчиковВыгрузкиДанных(ТаблицаОбработчиков);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаВМоделиСервиса.ПользователиВМоделиСервиса") Тогда
		МодульПользователиСлужебныйВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("ПользователиСлужебныйВМоделиСервиса");
		МодульПользователиСлужебныйВМоделиСервиса.ПриРегистрацииОбработчиковВыгрузкиДанных(ТаблицаОбработчиков);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УправлениеДоступом") Тогда
		МодульУправлениеДоступомСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеДоступомСлужебный");
		МодульУправлениеДоступомСлужебный.ПриРегистрацииОбработчиковВыгрузкиДанных(ТаблицаОбработчиков);
	КонецЕсли;

КонецПроцедуры

// См. ВыгрузкаЗагрузкаДанныхПереопределяемый.ПриРегистрацииОбработчиковЗагрузкиДанных.
Процедура ПриРегистрацииОбработчиковЗагрузкиДанных(ТаблицаОбработчиков) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.РаботаСФайламиВМоделиСервиса") Тогда
		МодульРаботаСФайламиСлужебныйВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль(
			"РаботаСФайламиСлужебныйВМоделиСервиса");
		МодульРаботаСФайламиСлужебныйВМоделиСервиса.ПриРегистрацииОбработчиковЗагрузкиДанных(ТаблицаОбработчиков);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаВМоделиСервиса.ПользователиВМоделиСервиса") Тогда
		МодульПользователиСлужебныйВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("ПользователиСлужебныйВМоделиСервиса");
		МодульПользователиСлужебныйВМоделиСервиса.ПриРегистрацииОбработчиковЗагрузкиДанных(ТаблицаОбработчиков);
	КонецЕсли;

КонецПроцедуры

// См. ВыгрузкаЗагрузкаДанныхПереопределяемый.ПередВыгрузкойДанных
Процедура ПередВыгрузкойДанных(Контейнер) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.ОбновлениеВерсииИБВМоделиСервиса") Тогда
		МодульОбновлениеИнформационнойБазыСлужебныйВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль(
			"ОбновлениеИнформационнойБазыСлужебныйВМоделиСервиса");
		МодульОбновлениеИнформационнойБазыСлужебныйВМоделиСервиса.ПередВыгрузкойДанных(Контейнер);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ИнтерфейсOData") Тогда
		МодульИнтерфейсODataСлужебный = ОбщегоНазначения.ОбщийМодуль("ИнтерфейсODataСлужебный");
		МодульИнтерфейсODataСлужебный.ПередВыгрузкойДанных(Контейнер);
	КонецЕсли;

КонецПроцедуры

// См. ВыгрузкаЗагрузкаДанныхПереопределяемый.ПередЗагрузкойДанных
Процедура ПередЗагрузкойДанных(Контейнер) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.ОбновлениеВерсииИБВМоделиСервиса") Тогда
		МодульОбновлениеИнформационнойБазыСлужебныйВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль(
			"ОбновлениеИнформационнойБазыСлужебныйВМоделиСервиса");
		МодульОбновлениеИнформационнойБазыСлужебныйВМоделиСервиса.ПередЗагрузкойДанных(Контейнер);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ИнтерфейсOData") Тогда
		МодульИнтерфейсODataСлужебный = ОбщегоНазначения.ОбщийМодуль("ИнтерфейсODataСлужебный");
		МодульИнтерфейсODataСлужебный.ПередЗагрузкойДанных(Контейнер);
	КонецЕсли;

КонецПроцедуры

// См. ВыгрузкаЗагрузкаДанныхПереопределяемый.ПослеЗагрузкиДанных.
Процедура ПослеЗагрузкиДанных(Контейнер) Экспорт

	ПользователиСлужебный.ПослеЗагрузкиДанных(Контейнер);

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РегламентныеЗадания") Тогда
		МодульРегламентныеЗаданияСлужебный = ОбщегоНазначения.ОбщийМодуль("РегламентныеЗаданияСлужебный");
		МодульРегламентныеЗаданияСлужебный.ПослеЗагрузкиДанных(Контейнер);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Валюты") Тогда
		МодульРаботаСКурсамиВалютСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСКурсамиВалютСлужебный");
		МодульРаботаСКурсамиВалютСлужебный.ПослеЗагрузкиДанных(Контейнер);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.ОбновлениеВерсииИБВМоделиСервиса") Тогда
		МодульОбновлениеИнформационнойБазыСлужебныйВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль(
			"ОбновлениеИнформационнойБазыСлужебныйВМоделиСервиса");
		МодульОбновлениеИнформационнойБазыСлужебныйВМоделиСервиса.ПослеЗагрузкиДанных(Контейнер);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.УправлениеДоступомВМоделиСервиса") Тогда
		МодульУправлениеДоступомСлужебныйВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль(
			"УправлениеДоступомСлужебныйВМоделиСервиса");
		МодульУправлениеДоступомСлужебныйВМоделиСервиса.ПослеЗагрузкиДанных(Контейнер);
	КонецЕсли;

	ОбновлениеИнформационнойБазыСлужебный.ПослеЗагрузкиДанных(Контейнер);
	
	СтандартныеПодсистемыСервер.ПослеЗагрузкиДанных(Контейнер);
	
КонецПроцедуры

// См. ВыгрузкаЗагрузкаДанныхПереопределяемый.ПриЗагрузкеПользователяИнформационнойБазы.
Процедура ПриЗагрузкеПользователяИнформационнойБазы(Контейнер, Сериализация, ПользовательИБ, Отказ) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаВМоделиСервиса.ПользователиВМоделиСервиса") Тогда
		МодульПользователиСлужебныйВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("ПользователиСлужебныйВМоделиСервиса");
		МодульПользователиСлужебныйВМоделиСервиса.ПриЗагрузкеПользователяИнформационнойБазы(Контейнер, Сериализация,
			ПользовательИБ, Отказ);
	КонецЕсли;

КонецПроцедуры

// См. ВыгрузкаЗагрузкаДанныхПереопределяемый.ПослеЗагрузкиПользователяИнформационнойБазы.
Процедура ПослеЗагрузкиПользователяИнформационнойБазы(Контейнер, Сериализация, ПользовательИБ) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаВМоделиСервиса.ПользователиВМоделиСервиса") Тогда
		МодульПользователиСлужебныйВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("ПользователиСлужебныйВМоделиСервиса");
		МодульПользователиСлужебныйВМоделиСервиса.ПослеЗагрузкиПользователяИнформационнойБазы(Контейнер, Сериализация,
			ПользовательИБ);
	КонецЕсли;

КонецПроцедуры

// См. ВыгрузкаЗагрузкаДанныхПереопределяемый.ПослеЗагрузкиПользователейИнформационнойБазы.
Процедура ПослеЗагрузкиПользователейИнформационнойБазы(Контейнер) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаВМоделиСервиса.ПользователиВМоделиСервиса") Тогда
		МодульПользователиСлужебныйВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("ПользователиСлужебныйВМоделиСервиса");
		МодульПользователиСлужебныйВМоделиСервиса.ПослеЗагрузкиПользователейИнформационнойБазы(Контейнер);
	КонецЕсли;

КонецПроцедуры

#КонецОбласти

#Область РаботаВМоделиСервиса_БазоваяФункциональностьВМоделиСервиса

// См. РаботаВМоделиСервисаПереопределяемый.ПриЗаполненииТаблицыПараметровИБ.
Процедура ПриЗаполненииТаблицыПараметровИБ(Знач ТаблицаПараметров) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаВМоделиСервиса.ОбменДаннымиВМоделиСервиса") Тогда
		МодульОбменДаннымиВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("ОбменДаннымиВМоделиСервиса");
		МодульОбменДаннымиВМоделиСервиса.ПриЗаполненииТаблицыПараметровИБ(ТаблицаПараметров);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РегламентныеЗадания") Тогда
		МодульРегламентныеЗаданияСлужебный = ОбщегоНазначения.ОбщийМодуль("РегламентныеЗаданияСлужебный");
		МодульРегламентныеЗаданияСлужебный.ПриЗаполненииТаблицыПараметровИБ(ТаблицаПараметров);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЗавершениеРаботыПользователей") Тогда
		МодульСоединенияИБ = ОбщегоНазначения.ОбщийМодуль("СоединенияИБ");
		МодульСоединенияИБ.ПриЗаполненииТаблицыПараметровИБ(ТаблицаПараметров);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЭлектроннаяПодписьСервисаDSS") Тогда
		МодульСервисКриптографииDSSСлужебный = ОбщегоНазначения.ОбщийМодуль("СервисКриптографииDSSСлужебный");
		МодульСервисКриптографииDSSСлужебный.ПриЗаполненииТаблицыПараметровИБ(ТаблицаПараметров);
	КонецЕсли;
	
КонецПроцедуры

// Переопределяет исключения неразделенных данных для подсистемы ТехнологияСервиса 
// 
// Параметры:
//  Исключения - Массив из ОбъектМетаданных - исключения.
//
Процедура ПриОпределенииИсключенийНеразделенныхДанных(Исключения) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЭлектроннаяПодпись") Тогда
		МодульЭлектроннаяПодписьСлужебный = ОбщегоНазначения.ОбщийМодуль("ЭлектроннаяПодписьСлужебный");
		МодульЭлектроннаяПодписьСлужебный.ПриОпределенииИсключенийНеразделенныхДанных(Исключения);
	КонецЕсли;

КонецПроцедуры

// Позволяет переопределить результат функции РаботаВМоделиСервиса.ПсевдонимПользователяИнформационнойБазы.
//
// Параметры:
//   ИдентификаторПользователя - УникальныйИдентификатор - идентификатор пользователя.
//   Псевдоним - Строка - псевдоним пользователя информационной базы для отображения в интерфейсе.
//
Процедура ПриОпределенииПсевдонимаПользователя(ИдентификаторПользователя, Псевдоним) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаВМоделиСервиса.ПользователиВМоделиСервиса") Тогда
		МодульПользователиСлужебныйВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("ПользователиСлужебныйВМоделиСервиса");
		МодульПользователиСлужебныйВМоделиСервиса.ПриОпределенииПсевдонимаПользователя(ИдентификаторПользователя,
			Псевдоним);
	КонецЕсли;

КонецПроцедуры

#КонецОбласти

#Область РаботаВМоделиСервиса_ОбменСообщениями

// См. ОбменСообщениямиПереопределяемый.ПолучитьОбработчикиКаналовСообщений.
Процедура ПриОпределенииОбработчиковКаналовСообщений(Обработчики) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаВМоделиСервиса.ОбменДаннымиВМоделиСервиса") Тогда
		МодульОбменДаннымиВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("ОбменДаннымиВМоделиСервиса");
		МодульОбменДаннымиВМоделиСервиса.ПриОпределенииОбработчиковКаналовСообщений(Обработчики);
	КонецЕсли;

КонецПроцедуры

// См. ИнтерфейсыСообщенийВМоделиСервисаПереопределяемый.ЗаполнитьОбработчикиОтправляемыхСообщений.
Процедура РегистрацияИнтерфейсовОтправляемыхСообщений(МассивОбработчиков) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаВМоделиСервиса.ОбменДаннымиВМоделиСервиса") Тогда
		МодульОбменДаннымиВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("ОбменДаннымиВМоделиСервиса");
		МодульОбменДаннымиВМоделиСервиса.РегистрацияИнтерфейсовОтправляемыхСообщений(МассивОбработчиков);
	КонецЕсли;

КонецПроцедуры

// См. ИнтерфейсыСообщенийВМоделиСервисаПереопределяемый.ЗаполнитьОбработчикиПринимаемыхСообщений.
Процедура РегистрацияИнтерфейсовПринимаемыхСообщений(МассивОбработчиков) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаВМоделиСервиса.ОбменДаннымиВМоделиСервиса") Тогда
		МодульОбменДаннымиВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("ОбменДаннымиВМоделиСервиса");
		МодульОбменДаннымиВМоделиСервиса.РегистрацияИнтерфейсовПринимаемыхСообщений(МассивОбработчиков);
	КонецЕсли;

КонецПроцедуры

#КонецОбласти

#Область РаботаВМоделиСервиса_ОчередьЗаданий

// См. ОчередьЗаданийПереопределяемый.ПриПолученииСпискаШаблонов.
Процедура ПриПолученииСпискаШаблонов(ШаблоныЗаданий) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.БизнесПроцессыИЗадачи") Тогда
		МодульБизнесПроцессыИЗадачиСервер = ОбщегоНазначения.ОбщийМодуль("БизнесПроцессыИЗадачиСервер");
		МодульБизнесПроцессыИЗадачиСервер.ПриПолученииСпискаШаблонов(ШаблоныЗаданий);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВерсионированиеОбъектов") Тогда
		МодульВерсионированиеОбъектов = ОбщегоНазначения.ОбщийМодуль("ВерсионированиеОбъектов");
		МодульВерсионированиеОбъектов.ПриПолученииСпискаШаблонов(ШаблоныЗаданий);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Взаимодействия") Тогда
		МодульВзаимодействия = ОбщегоНазначения.ОбщийМодуль("Взаимодействия");
		МодульВзаимодействия.ПриПолученииСпискаШаблонов(ШаблоныЗаданий);
		МодульУправлениеЭлектроннойПочтой = ОбщегоНазначения.ОбщийМодуль("УправлениеЭлектроннойПочтой");
		МодульУправлениеЭлектроннойПочтой.ПриПолученииСпискаШаблонов(ШаблоныЗаданий);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЗащитаПерсональныхДанных") Тогда
		МодульЗащитаПерсональныхДанных = ОбщегоНазначения.ОбщийМодуль("ЗащитаПерсональныхДанных");
		МодульЗащитаПерсональныхДанных.ПриПолученииСпискаШаблонов(ШаблоныЗаданий);
	КонецЕсли;

	ОбновлениеИнформационнойБазыСлужебный.ПриПолученииСпискаШаблонов(ШаблоныЗаданий);

	СтандартныеПодсистемыСервер.ПриПолученииСпискаШаблонов(ШаблоныЗаданий);

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УдалениеПомеченныхОбъектов") Тогда
		МодульУдалениеПомеченныхОбъектовСлужебный = ОбщегоНазначения.ОбщийМодуль("УдалениеПомеченныхОбъектовСлужебный");
		МодульУдалениеПомеченныхОбъектовСлужебный.ПриПолученииСпискаШаблонов(ШаблоныЗаданий);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.УправлениеДоступомВМоделиСервиса") Тогда
		МодульУправлениеДоступомСлужебныйВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль(
			"УправлениеДоступомСлужебныйВМоделиСервиса");
		МодульУправлениеДоступомСлужебныйВМоделиСервиса.ПриПолученииСпискаШаблонов(ШаблоныЗаданий);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УправлениеИтогамиИАгрегатами") Тогда
		МодульУправлениеИтогамиИАгрегатамиСлужебный = ОбщегоНазначения.ОбщийМодуль(
			"УправлениеИтогамиИАгрегатамиСлужебный");
		МодульУправлениеИтогамиИАгрегатамиСлужебный.ПриПолученииСпискаШаблонов(ШаблоныЗаданий);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.РаботаСФайламиВМоделиСервиса") Тогда
		МодульРаботаСФайламиСлужебныйВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебныйВМоделиСервиса");
		МодульРаботаСФайламиСлужебныйВМоделиСервиса.ПриПолученииСпискаШаблонов(ШаблоныЗаданий);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КонтактнаяИнформация") Тогда
		МодульУправлениеКонтактнойИнформациейСлужебный = ОбщегоНазначения.ОбщийМодуль(
			"УправлениеКонтактнойИнформациейСлужебный");
		МодульУправлениеКонтактнойИнформациейСлужебный.ПриПолученииСпискаШаблонов(ШаблоныЗаданий);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КонтрольВеденияУчета") Тогда
		МодульКонтрольВеденияУчетаСлужебный = ОбщегоНазначения.ОбщийМодуль("КонтрольВеденияУчетаСлужебный");
		МодульКонтрольВеденияУчетаСлужебный.ПриПолученииСпискаШаблонов(ШаблоныЗаданий);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЭлектроннаяПодпись") Тогда
		МодульЭлектроннаяПодписьСлужебный = ОбщегоНазначения.ОбщийМодуль("ЭлектроннаяПодписьСлужебный");
		МодульЭлектроннаяПодписьСлужебный.ПриПолученииСпискаШаблонов(ШаблоныЗаданий);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.МашиночитаемыеДоверенности") Тогда
		МодульМашиночитаемыеДоверенностиФНССлужебный = ОбщегоНазначения.ОбщийМодуль("МашиночитаемыеДоверенностиФНССлужебный");
		МодульМашиночитаемыеДоверенностиФНССлужебный.ПриПолученииСпискаШаблонов(ШаблоныЗаданий);
	КонецЕсли;

	
КонецПроцедуры

// См. ОчередьЗаданийПереопределяемый.ПриОпределенииПсевдонимовОбработчиков.
Процедура ПриОпределенииПсевдонимовОбработчиков(СоответствиеИменПсевдонимам) Экспорт
	
	СерверныеОповещения.ПриОпределенииПсевдонимовОбработчиков(СоответствиеИменПсевдонимам);
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.БизнесПроцессыИЗадачи") Тогда
		МодульБизнесПроцессыИЗадачиСервер = ОбщегоНазначения.ОбщийМодуль("БизнесПроцессыИЗадачиСервер");
		МодульБизнесПроцессыИЗадачиСервер.ПриОпределенииПсевдонимовОбработчиков(СоответствиеИменПсевдонимам);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ОбменДанными") Тогда
		МодульОбменДаннымиСервер = ОбщегоНазначения.ОбщийМодуль("ОбменДаннымиСервер");
		МодульОбменДаннымиСервер.ПриОпределенииПсевдонимовОбработчиков(СоответствиеИменПсевдонимам);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаВМоделиСервиса.ОбменДаннымиВМоделиСервиса") Тогда
		МодульОбменДаннымиВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("ОбменДаннымиВМоделиСервиса");
		МодульОбменДаннымиВМоделиСервиса.ПриОпределенииПсевдонимовОбработчиков(СоответствиеИменПсевдонимам);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Валюты") Тогда
		МодульРаботаСКурсамиВалютСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСКурсамиВалютСлужебный");
		МодульРаботаСКурсамиВалютСлужебный.ПриОпределенииПсевдонимовОбработчиков(СоответствиеИменПсевдонимам);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КонтактнаяИнформация") Тогда
		МодульУправлениеКонтактнойИнформациейСлужебный = ОбщегоНазначения.ОбщийМодуль(
			"УправлениеКонтактнойИнформациейСлужебный");
		МодульУправлениеКонтактнойИнформациейСлужебный.ПриОпределенииПсевдонимовОбработчиков(
			СоответствиеИменПсевдонимам);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КалендарныеГрафики") Тогда
		МодульКалендарныеГрафикиСлужебный = ОбщегоНазначения.ОбщийМодуль("КалендарныеГрафикиСлужебный");
		МодульКалендарныеГрафикиСлужебный.ПриОпределенииПсевдонимовОбработчиков(СоответствиеИменПсевдонимам);
	КонецЕсли;

	ОбновлениеИнформационнойБазыСлужебный.ПриОпределенииПсевдонимовОбработчиков(СоответствиеИменПсевдонимам);
	
	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.ОбновлениеВерсииИБВМоделиСервиса") Тогда
		МодульОбновлениеИнформационнойБазыСлужебныйВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль(
			"ОбновлениеИнформационнойБазыСлужебныйВМоделиСервиса");
		МодульОбновлениеИнформационнойБазыСлужебныйВМоделиСервиса.ПриОпределенииПсевдонимовОбработчиков(
			СоответствиеИменПсевдонимам);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.РаботаСФайламиВМоделиСервиса") Тогда
		МодульРаботаСФайламиСлужебныйВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебныйВМоделиСервиса");
		МодульРаботаСФайламиСлужебныйВМоделиСервиса.ПриОпределенииПсевдонимовОбработчиков(СоответствиеИменПсевдонимам);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УдалениеПомеченныхОбъектов") Тогда
		МодульУдалениеПомеченныхОбъектовСлужебный = ОбщегоНазначения.ОбщийМодуль("УдалениеПомеченныхОбъектовСлужебный");
		МодульУдалениеПомеченныхОбъектовСлужебный.ПриОпределенииПсевдонимовОбработчиков(СоответствиеИменПсевдонимам);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЭлектроннаяПодпись") Тогда
		МодульЭлектроннаяПодписьСлужебный = ОбщегоНазначения.ОбщийМодуль("ЭлектроннаяПодписьСлужебный");
		МодульЭлектроннаяПодписьСлужебный.ПриОпределенииПсевдонимовОбработчиков(СоответствиеИменПсевдонимам);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РассылкаОтчетов") Тогда
		МодульРассылкаОтчетов = ОбщегоНазначения.ОбщийМодуль("РассылкаОтчетов");
		МодульРассылкаОтчетов.ПриОпределенииПсевдонимовОбработчиков(СоответствиеИменПсевдонимам);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСПочтовымиСообщениями") Тогда
		МодульРаботаСПочтовымиСообщениямиСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСПочтовымиСообщениямиСлужебный");
		МодульРаботаСПочтовымиСообщениямиСлужебный.ПриОпределенииПсевдонимовОбработчиков(СоответствиеИменПсевдонимам);
	КонецЕсли;
	
КонецПроцедуры

// См. ОчередьЗаданийПереопределяемый.ПриОпределенииИспользованияРегламентныхЗаданий.
Процедура ПриОпределенииИспользованияРегламентныхЗаданий(ТаблицаИспользования) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.ОбновлениеВерсииИБВМоделиСервиса") Тогда
		МодульОбновлениеИнформационнойБазыСлужебныйВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль(
			"ОбновлениеИнформационнойБазыСлужебныйВМоделиСервиса");
		МодульОбновлениеИнформационнойБазыСлужебныйВМоделиСервиса.ПриОпределенииИспользованияРегламентныхЗаданий(
			ТаблицаИспользования);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.РаботаСФайламиВМоделиСервиса") Тогда
		МодульРаботаСФайламиСлужебныйВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебныйВМоделиСервиса");
		МодульРаботаСФайламиСлужебныйВМоделиСервиса.ПриОпределенииИспользованияРегламентныхЗаданий(ТаблицаИспользования);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РегламентныеЗадания") Тогда
		МодульРегламентныеЗаданияСлужебный = ОбщегоНазначения.ОбщийМодуль("РегламентныеЗаданияСлужебный");
		МодульРегламентныеЗаданияСлужебный.ПриОпределенииИспользованияРегламентныхЗаданий(ТаблицаИспользования);
	КонецЕсли;
	
КонецПроцедуры

#КонецОбласти

#Область РаботаВМоделиСервиса_ПоставляемыеДанные

// См. ПоставляемыеДанныеПереопределяемый.ПолучитьОбработчикиПоставляемыхДанных.
Процедура ПриОпределенииОбработчиковПоставляемыхДанных(Обработчики) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.АдресныйКлассификатор") Тогда
		МодульАдресныйКлассификаторСлужебный = ОбщегоНазначения.ОбщийМодуль("АдресныйКлассификаторСлужебный");
		МодульАдресныйКлассификаторСлужебный.ПриОпределенииОбработчиковПоставляемыхДанных(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Валюты") Тогда
		МодульРаботаСКурсамиВалютСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСКурсамиВалютСлужебный");
		МодульРаботаСКурсамиВалютСлужебный.ПриОпределенииОбработчиковПоставляемыхДанных(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаВМоделиСервиса.ОбменДаннымиВМоделиСервиса") Тогда
		МодульОбменДаннымиВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("ОбменДаннымиВМоделиСервиса");
		МодульОбменДаннымиВМоделиСервиса.ПриОпределенииОбработчиковПоставляемыхДанных(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.ДополнительныеОтчетыИОбработкиВМоделиСервиса") Тогда
		МодульДополнительныеОтчетыИОбработкиВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль(
			"ДополнительныеОтчетыИОбработкиВМоделиСервиса");
		МодульДополнительныеОтчетыИОбработкиВМоделиСервиса.ПриОпределенииОбработчиковПоставляемыхДанных(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЭлектроннаяПодпись") Тогда
		МодульЭлектроннаяПодписьСлужебный = ОбщегоНазначения.ОбщийМодуль("ЭлектроннаяПодписьСлужебный");
		МодульЭлектроннаяПодписьСлужебный.ПриОпределенииОбработчиковПоставляемыхДанных(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЭлектроннаяПодписьСервисаDSS") Тогда
		МодульСервисКриптографииDSSСлужебный = ОбщегоНазначения.ОбщийМодуль("СервисКриптографииDSSСлужебный");
		МодульСервисКриптографииDSSСлужебный.ПриОпределенииОбработчиковПоставляемыхДанных(Обработчики);
	КонецЕсли;

КонецПроцедуры

#КонецОбласти

#КонецОбласти

// ИнтернетПоддержкаПользователей

#Область ОбработчикиСобытийБИП

// Обработка программных событий, возникающих в подсистемах ИПП.
// Только для вызовов из библиотеки ИПП в БСП.

// Определяет события, на которые подписана эта библиотека.
//
// Параметры:
//  Подписки - Структура - ключами свойств структуры являются имена событий, на которые
//           подписана эта библиотека.
//
Процедура ПриОпределенииПодписокНаСобытияБИП(Подписки) Экспорт
	
	// БазоваяФункциональность
	Подписки.ПриИзмененииДанныхАутентификацииИнтернетПоддержки = Истина;
	
	// РаботаСКлассификаторами
	Подписки.ПриДобавленииКлассификаторов = Истина;
	Подписки.ПриЗагрузкеКлассификатора = Истина;
	Подписки.ПриОбработкеОбластиДанных = Истина;
	
	// ЭлектроннаяПодпись
	Подписки.ПриОпределенииИспользуемыхВерсийВнешнихКомпонент = Истина;
	
КонецПроцедуры

#Область БазоваяФункциональность

// См. ИнтернетПоддержкаПользователейПереопределяемый.ПриИзмененииДанныхАутентификацииИнтернетПоддержки.
Процедура ПриИзмененииДанныхАутентификацииИнтернетПоддержки(ДанныеПользователя) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Валюты") Тогда
		МодульРаботаСКурсамиВалют = ОбщегоНазначения.ОбщийМодуль("РаботаСКурсамиВалют");
		МодульРаботаСКурсамиВалют.ПриИзмененииДанныхАутентификацииИнтернетПоддержки(ДанныеПользователя);
	КонецЕсли;

КонецПроцедуры

#КонецОбласти

#Область ВнешниеКомпонентыВМоделиСервиса

// См. ПолучениеВнешнихКомпонентВМоделиСервисаПереопределяемый.ПриОпределенииИспользуемыхВерсийВнешнихКомпонент.
Процедура ПриОпределенииИспользуемыхВерсийВнешнихКомпонент(Идентификаторы) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВнешниеКомпоненты") Тогда
		МодульВнешниеКомпонентыСлужебный = ОбщегоНазначения.ОбщийМодуль("ВнешниеКомпонентыСлужебный");
		ОбщегоНазначенияКлиентСервер.ДополнитьМассив(
			Идентификаторы, МодульВнешниеКомпонентыСлужебный.ПоставляемыеКомпоненты(), Истина);
	КонецЕсли;

КонецПроцедуры

#КонецОбласти

#Область РаботаСКлассификаторами

// См. РаботаСКлассификаторамиПереопределяемый.ПриДобавленииКлассификаторов.
Процедура ПриДобавленииКлассификаторов(Классификаторы) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Банки") И Метаданные.Обработки.Найти(
		"ЗагрузкаКлассификатораБанков") <> Неопределено Тогда
		МодульЗагрузкаКлассификатораБанков = ОбщегоНазначения.ОбщийМодуль("Обработки.ЗагрузкаКлассификатораБанков");
		МодульЗагрузкаКлассификатораБанков.ПриДобавленииКлассификаторов(Классификаторы);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Валюты") И Метаданные.Обработки.Найти(
		"ЗагрузкаКурсовВалют") <> Неопределено Тогда
		МодульЗагрузкаКурсовВалют = ОбщегоНазначения.ОбщийМодуль("Обработки.ЗагрузкаКурсовВалют");
		МодульЗагрузкаКурсовВалют.ПриДобавленииКлассификаторов(Классификаторы);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КалендарныеГрафики") Тогда
		МодульКалендарныеГрафики = ОбщегоНазначения.ОбщийМодуль("КалендарныеГрафики");
		МодульКалендарныеГрафики.ПриДобавленииКлассификаторов(Классификаторы);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КонтактнаяИнформация") Тогда
		МодульУправлениеКонтактнойИнформациейСлужебныйПовтИсп = ОбщегоНазначения.ОбщийМодуль("УправлениеКонтактнойИнформациейСлужебныйПовтИсп");
		Если МодульУправлениеКонтактнойИнформациейСлужебныйПовтИсп.ДоступныМодулиРаботаСАдресами() Тогда
			МодульРаботаСАдресами = ОбщегоНазначения.ОбщийМодуль("РаботаСАдресами");
			МодульРаботаСАдресами.ПриДобавленииКлассификаторов(Классификаторы);
		КонецЕсли;
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЭлектроннаяПодпись") Тогда
		МодульЭлектроннаяПодписьСлужебный = ОбщегоНазначения.ОбщийМодуль("ЭлектроннаяПодписьСлужебный");
		МодульЭлектроннаяПодписьСлужебный.ПриДобавленииКлассификаторов(Классификаторы);
	КонецЕсли;
	
КонецПроцедуры

// См. РаботаСКлассификаторамиПереопределяемый.ПриЗагрузкеКлассификатора.
Процедура ПриЗагрузкеКлассификатора(Идентификатор, Версия, Адрес, Обработан, ДополнительныеПараметры) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Банки")
		И Метаданные.Обработки.Найти("ЗагрузкаКлассификатораБанков") <> Неопределено Тогда
		МодульЗагрузкаКлассификатораБанков = ОбщегоНазначения.ОбщийМодуль("Обработки.ЗагрузкаКлассификатораБанков");
		МодульЗагрузкаКлассификатораБанков.ПриЗагрузкеКлассификатора(Идентификатор, Версия, Адрес, Обработан,
			ДополнительныеПараметры);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Валюты") Тогда
		МодульРаботаСКурсамиВалютЛокализация = ОбщегоНазначения.ОбщийМодуль("РаботаСКурсамиВалютЛокализация");
		МодульРаботаСКурсамиВалютЛокализация.ПриЗагрузкеКлассификатора(Идентификатор, Версия, Адрес, Обработан,
			ДополнительныеПараметры);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КалендарныеГрафики") Тогда
		МодульКалендарныеГрафики = ОбщегоНазначения.ОбщийМодуль("КалендарныеГрафики");
		МодульКалендарныеГрафики.ПриЗагрузкеКлассификатора(Идентификатор, Версия, Адрес, Обработан,
			ДополнительныеПараметры);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КонтактнаяИнформация") Тогда
		МодульУправлениеКонтактнойИнформациейСлужебныйПовтИсп = ОбщегоНазначения.ОбщийМодуль("УправлениеКонтактнойИнформациейСлужебныйПовтИсп");
		Если МодульУправлениеКонтактнойИнформациейСлужебныйПовтИсп.ДоступныМодулиРаботаСАдресами() Тогда
			МодульРаботаСАдресами = ОбщегоНазначения.ОбщийМодуль("РаботаСАдресами");
			МодульРаботаСАдресами.ПриЗагрузкеКлассификатора(Идентификатор, Версия, Адрес, Обработан,
				ДополнительныеПараметры);
		КонецЕсли;
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЭлектроннаяПодпись") Тогда
		МодульЭлектроннаяПодписьСлужебный = ОбщегоНазначения.ОбщийМодуль("ЭлектроннаяПодписьСлужебный");
		МодульЭлектроннаяПодписьСлужебный.ПриЗагрузкеКлассификатора(Идентификатор, Версия, Адрес, Обработан,
			ДополнительныеПараметры);
	КонецЕсли;

КонецПроцедуры

// См. РаботаСКлассификаторамиВМоделиСервисаПереопределяемый.ПриОбработкеОбластиДанных.
Процедура ПриОбработкеОбластиДанных(Идентификатор, Версия, ДополнительныеПараметры) Экспорт

	Если Не ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КалендарныеГрафики") Тогда
		Возврат;
	КонецЕсли;

	МодульКалендарныеГрафики = ОбщегоНазначения.ОбщийМодуль("КалендарныеГрафики");
	Если Идентификатор <> МодульКалендарныеГрафики.ИдентификаторКлассификатора() Тогда
		Возврат;
	КонецЕсли;

	Если Не ДополнительныеПараметры.Свойство(Идентификатор) Тогда
		Возврат;
	КонецЕсли;

	ПараметрыОбновления = ДополнительныеПараметры[Идентификатор];
	МодульКалендарныеГрафики.ЗаполнитьДанныеЗависимыеОтПроизводственныхКалендарей(ПараметрыОбновления.ТаблицаИзменений);

КонецПроцедуры

#КонецОбласти

#КонецОбласти

// Конец ИнтернетПоддержкаПользователей

#КонецОбласти

#КонецОбласти

#Область СлужебныйПрограммныйИнтерфейс

#Область БазоваяФункциональность

// См. ПодсистемыКонфигурацииПереопределяемый.ПриДобавленииПодсистем.
Процедура ПриДобавленииПодсистем(МодулиПодсистем) Экспорт

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриДобавленииПодсистем Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриДобавленииПодсистем(МодулиПодсистем);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриДобавленииПодсистем Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриДобавленииПодсистем(МодулиПодсистем);
	КонецЕсли;
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриДобавленииПодсистем Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриДобавленииПодсистем(МодулиПодсистем);
	КонецЕсли;

КонецПроцедуры

// Параметры:
//   Параметры - см. СтандартныеПодсистемыСервер.УстановкаПараметровСеанса.ИменаПараметровСеанса.
//
Процедура ПриУстановкеПараметровСеанса(Параметры) Экспорт

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриУстановкеПараметровСеанса Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриУстановкеПараметровСеанса(Параметры);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриУстановкеПараметровСеанса Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриУстановкеПараметровСеанса(Параметры);
	КонецЕсли;
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриУстановкеПараметровСеанса Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриУстановкеПараметровСеанса(Параметры);
	КонецЕсли;

КонецПроцедуры

// См. ОбщегоНазначенияПереопределяемый.ПриДобавленииОбработчиковУстановкиПараметровСеанса.
Процедура ПриДобавленииОбработчиковУстановкиПараметровСеанса(Обработчики) Экспорт

	ОбновлениеИнформационнойБазыСлужебный.ПриДобавленииОбработчиковУстановкиПараметровСеанса(Обработчики);
	ПользователиСлужебный.ПриДобавленииОбработчиковУстановкиПараметровСеанса(Обработчики);

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВерсионированиеОбъектов") Тогда
		МодульВерсионированиеОбъектов = ОбщегоНазначения.ОбщийМодуль("ВерсионированиеОбъектов");
		МодульВерсионированиеОбъектов.ПриДобавленииОбработчиковУстановкиПараметровСеанса(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ДатыЗапретаИзменения") Тогда
		МодульДатыЗапретаИзмененияСлужебный = ОбщегоНазначения.ОбщийМодуль("ДатыЗапретаИзмененияСлужебный");
		МодульДатыЗапретаИзмененияСлужебный.ПриДобавленииОбработчиковУстановкиПараметровСеанса(Обработчики);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ДополнительныеОтчетыИОбработки") Тогда
		МодульДополнительныеОтчетыИОбработки = ОбщегоНазначения.ОбщийМодуль("ДополнительныеОтчетыИОбработки");
		МодульДополнительныеОтчетыИОбработки.ПриДобавленииОбработчиковУстановкиПараметровСеанса(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КонтактнаяИнформация") Тогда
		МодульУправлениеКонтактнойИнформациейСлужебный = ОбщегоНазначения.ОбщийМодуль(
			"УправлениеКонтактнойИнформациейСлужебный");
		МодульУправлениеКонтактнойИнформациейСлужебный.ПриДобавленииОбработчиковУстановкиПараметровСеанса(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ОценкаПроизводительности") Тогда
		МодульОценкаПроизводительностиСлужебный = ОбщегоНазначения.ОбщийМодуль("ОценкаПроизводительностиСлужебный");
		МодульОценкаПроизводительностиСлужебный.ПриДобавленииОбработчиковУстановкиПараметровСеанса(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ОбменДанными") Тогда
		МодульОбменДаннымиСервер = ОбщегоНазначения.ОбщийМодуль("ОбменДаннымиСервер");
		МодульОбменДаннымиСервер.ПриДобавленииОбработчиковУстановкиПараметровСеанса(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РегламентныеЗадания") Тогда
		МодульБлокировкаРаботыСВнешнимиРесурсами = ОбщегоНазначения.ОбщийМодуль("БлокировкаРаботыСВнешнимиРесурсами");
		МодульБлокировкаРаботыСВнешнимиРесурсами.ПриДобавленииОбработчиковУстановкиПараметровСеанса(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Свойства") Тогда
		МодульУправлениеСвойствамиСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеСвойствамиСлужебный");
		МодульУправлениеСвойствамиСлужебный.ПриДобавленииОбработчиковУстановкиПараметровСеанса(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УправлениеДоступом") Тогда
		МодульУправлениеДоступомСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеДоступомСлужебный");
		МодульУправлениеДоступомСлужебный.ПриДобавленииОбработчиковУстановкиПараметровСеанса(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УдалениеПомеченныхОбъектов") Тогда
		МодульУдалениеПомеченныхОбъектовСлужебный = ОбщегоНазначения.ОбщийМодуль("УдалениеПомеченныхОбъектовСлужебный");
		МодульУдалениеПомеченныхОбъектовСлужебный.ПриДобавленииОбработчиковУстановкиПараметровСеанса(Обработчики);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриДобавленииОбработчиковУстановкиПараметровСеанса Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриДобавленииОбработчиковУстановкиПараметровСеанса(Обработчики);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриДобавленииОбработчиковУстановкиПараметровСеанса Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриДобавленииОбработчиковУстановкиПараметровСеанса(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЭлектроннаяПодписьСервисаDSS") Тогда
		МодульСервисКриптографииDSSСлужебный = ОбщегоНазначения.ОбщийМодуль("СервисКриптографииDSSСлужебный");
		МодульСервисКриптографииDSSСлужебный.ПриДобавленииОбработчиковУстановкиПараметровСеанса(Обработчики);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.МашиночитаемыеДоверенности") Тогда
		МодульМашиночитаемыеДоверенностиФНССлужебный = ОбщегоНазначения.ОбщийМодуль("МашиночитаемыеДоверенностиФНССлужебный");
		МодульМашиночитаемыеДоверенностиФНССлужебный.ПриДобавленииОбработчиковУстановкиПараметровСеанса(Обработчики);
	КонецЕсли;
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриДобавленииОбработчиковУстановкиПараметровСеанса Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриДобавленииОбработчиковУстановкиПараметровСеанса(Обработчики);
	КонецЕсли;
	
КонецПроцедуры

// См. ОбщегоНазначенияПереопределяемый.ПриДобавленииИсключенийПоискаСсылок.
Процедура ПриДобавленииИсключенийПоискаСсылок(ИсключенияПоискаСсылок) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.БизнесПроцессыИЗадачи") Тогда
		МодульБизнесПроцессыИЗадачиСервер = ОбщегоНазначения.ОбщийМодуль("БизнесПроцессыИЗадачиСервер");
		МодульБизнесПроцессыИЗадачиСервер.ПриДобавленииИсключенийПоискаСсылок(ИсключенияПоискаСсылок);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Валюты") Тогда
		МодульРаботаСКурсамиВалют = ОбщегоНазначения.ОбщийМодуль("РаботаСКурсамиВалют");
		МодульРаботаСКурсамиВалют.ПриДобавленииИсключенийПоискаСсылок(ИсключенияПоискаСсылок);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВариантыОтчетов") Тогда
		МодульВариантыОтчетов = ОбщегоНазначения.ОбщийМодуль("ВариантыОтчетов");
		МодульВариантыОтчетов.ПриДобавленииИсключенийПоискаСсылок(ИсключенияПоискаСсылок);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВерсионированиеОбъектов") Тогда
		МодульВерсионированиеОбъектов = ОбщегоНазначения.ОбщийМодуль("ВерсионированиеОбъектов");
		МодульВерсионированиеОбъектов.ПриДобавленииИсключенийПоискаСсылок(ИсключенияПоискаСсылок);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ДополнительныеОтчетыИОбработки") Тогда
		МодульДополнительныеОтчетыИОбработки = ОбщегоНазначения.ОбщийМодуль("ДополнительныеОтчетыИОбработки");
		МодульДополнительныеОтчетыИОбработки.ПриДобавленииИсключенийПоискаСсылок(ИсключенияПоискаСсылок);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ОбменДанными") Тогда
		МодульОбменДаннымиСервер = ОбщегоНазначения.ОбщийМодуль("ОбменДаннымиСервер");
		МодульОбменДаннымиСервер.ПриДобавленииИсключенийПоискаСсылок(ИсключенияПоискаСсылок);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСФайлами") Тогда
		МодульРаботаСФайламиСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебный");
		МодульРаботаСФайламиСлужебный.ПриДобавленииИсключенийПоискаСсылок(ИсключенияПоискаСсылок);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РассылкаОтчетов") Тогда
		МодульРассылкаОтчетов = ОбщегоНазначения.ОбщийМодуль("РассылкаОтчетов");
		МодульРассылкаОтчетов.ПриДобавленииИсключенийПоискаСсылок(ИсключенияПоискаСсылок);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Свойства") Тогда
		МодульУправлениеСвойствамиСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеСвойствамиСлужебный");
		МодульУправлениеСвойствамиСлужебный.ПриДобавленииИсключенийПоискаСсылок(ИсключенияПоискаСсылок);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УправлениеДоступом") Тогда
		МодульУправлениеДоступомСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеДоступомСлужебный");
		МодульУправлениеДоступомСлужебный.ПриДобавленииИсключенийПоискаСсылок(ИсключенияПоискаСсылок);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УдалениеПомеченныхОбъектов") Тогда
		МодульУдалениеПомеченныхОбъектовСлужебный = ОбщегоНазначения.ОбщийМодуль("УдалениеПомеченныхОбъектовСлужебный");
		МодульУдалениеПомеченныхОбъектовСлужебный.ПриДобавленииИсключенийПоискаСсылок(ИсключенияПоискаСсылок);
	КонецЕсли;

	ПользователиСлужебный.ПриДобавленииИсключенийПоискаСсылок(ИсключенияПоискаСсылок);
	ОбновлениеИнформационнойБазыСлужебный.ПриДобавленииИсключенийПоискаСсылок(ИсключенияПоискаСсылок);
	СтандартныеПодсистемыСервер.ПриДобавленииИсключенийПоискаСсылок(ИсключенияПоискаСсылок);

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриДобавленииИсключенийПоискаСсылок Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриДобавленииИсключенийПоискаСсылок(ИсключенияПоискаСсылок);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриДобавленииИсключенийПоискаСсылок Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриДобавленииИсключенийПоискаСсылок(ИсключенияПоискаСсылок);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриДобавленииИсключенийПоискаСсылок Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриДобавленииИсключенийПоискаСсылок(ИсключенияПоискаСсылок);
	КонецЕсли;
	
КонецПроцедуры

// См. ОбщегоНазначенияПереопределяемый.ПриОпределенииПодчиненныхОбъектов
Процедура ПриОпределенииПодчиненныхОбъектов(ПодчиненныеОбъекты) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Взаимодействия") Тогда
		МодульВзаимодействия = ОбщегоНазначения.ОбщийМодуль("Взаимодействия");
		МодульВзаимодействия.ПриОпределенииПодчиненныхОбъектов(ПодчиненныеОбъекты);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Свойства") Тогда
		МодульУправлениеСвойствамиСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеСвойствамиСлужебный");
		МодульУправлениеСвойствамиСлужебный.ПриОпределенииПодчиненныхОбъектов(ПодчиненныеОбъекты);
	КонецЕсли;

КонецПроцедуры

// Добавляет к коллекции дублей связанные подчиненные объекты.
//
// Параметры:
//  ПарыЗамен		 - см. ОбщегоНазначения.ЗаменитьСсылки.ПарыЗамен
//  ПараметрыЗамены	 - см. ОбщегоНазначения.ПараметрыЗаменыСсылок
//
Процедура ПередПоискомМестИспользования(ПарыЗамен, ПараметрыВыполнения) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ПоискИУдалениеДублей") Тогда
		МодульПоискИУдалениеДублей = ОбщегоНазначения.ОбщийМодуль("ПоискИУдалениеДублей");
		МодульПоискИУдалениеДублей.ДополнитьДублиСвязаннымиПодчиненнымиОбъектами(ПарыЗамен, ПараметрыВыполнения);
	КонецЕсли;

КонецПроцедуры

// См. ОбщегоНазначенияПереопределяемый.ПриДобавленииПереименованийОбъектовМетаданных.
Процедура ПриДобавленииПереименованийОбъектовМетаданных(Переименования) Экспорт

	СтандартныеПодсистемыСервер.ПриДобавленииПереименованийОбъектовМетаданных(Переименования);

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КонтрольРаботыПользователей") Тогда
		МодульКонтрольРаботыПользователейСлужебный = ОбщегоНазначения.ОбщийМодуль("КонтрольРаботыПользователейСлужебный");
		МодульКонтрольРаботыПользователейСлужебный.ПриДобавленииПереименованийОбъектовМетаданных(Переименования);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВариантыОтчетов") Тогда
		МодульВариантыОтчетов = ОбщегоНазначения.ОбщийМодуль("ВариантыОтчетов");
		МодульВариантыОтчетов.ПриДобавленииПереименованийОбъектовМетаданных(Переименования);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ДополнительныеОтчетыИОбработки") Тогда
		МодульДополнительныеОтчетыИОбработки = ОбщегоНазначения.ОбщийМодуль("ДополнительныеОтчетыИОбработки");
		МодульДополнительныеОтчетыИОбработки.ПриДобавленииПереименованийОбъектовМетаданных(Переименования);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЗаметкиПользователя") Тогда
		МодульЗаметкиПользователяСлужебный = ОбщегоНазначения.ОбщийМодуль("ЗаметкиПользователяСлужебный");
		МодульЗаметкиПользователяСлужебный.ПриДобавленииПереименованийОбъектовМетаданных(Переименования);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.НапоминанияПользователя") Тогда
		МодульНапоминанияПользователяСлужебный = ОбщегоНазначения.ОбщийМодуль("НапоминанияПользователяСлужебный");
		МодульНапоминанияПользователяСлужебный.ПриДобавленииПереименованийОбъектовМетаданных(Переименования);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.НастройкиПрограммы") Тогда
		МодульПанельАдминистрированияБСП = ОбщегоНазначения.ОбщийМодуль("Обработки.ПанельАдминистрированияБСП");
		МодульПанельАдминистрированияБСП.ПриДобавленииПереименованийОбъектовМетаданных(Переименования);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ОбменДанными") Тогда
		МодульОбменДаннымиСервер = ОбщегоНазначения.ОбщийМодуль("ОбменДаннымиСервер");
		МодульОбменДаннымиСервер.ПриДобавленииПереименованийОбъектовМетаданных(Переименования);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСПочтовымиСообщениями") Тогда
		МодульРаботаСПочтовымиСообщениямиСлужебный = ОбщегоНазначения.ОбщийМодуль(
			"РаботаСПочтовымиСообщениямиСлужебный");
		МодульРаботаСПочтовымиСообщениямиСлужебный.ПриДобавленииПереименованийОбъектовМетаданных(Переименования);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСФайлами") Тогда
		МодульРаботаСФайламиСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебный");
		МодульРаботаСФайламиСлужебный.ПриДобавленииПереименованийОбъектовМетаданных(Переименования);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.СтруктураПодчиненности") Тогда
		МодульСтруктураПодчиненностиСлужебный = ОбщегоНазначения.ОбщийМодуль("СтруктураПодчиненностиСлужебный");
		МодульСтруктураПодчиненностиСлужебный.ПриДобавленииПереименованийОбъектовМетаданных(Переименования);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ТекущиеДела") Тогда
		МодульТекущиеДелаСлужебный = ОбщегоНазначения.ОбщийМодуль("ТекущиеДелаСлужебный");
		МодульТекущиеДелаСлужебный.ПриДобавленииПереименованийОбъектовМетаданных(Переименования);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЭлектроннаяПодпись") Тогда
		МодульЭлектроннаяПодписьСлужебный = ОбщегоНазначения.ОбщийМодуль("ЭлектроннаяПодписьСлужебный");
		МодульЭлектроннаяПодписьСлужебный.ПриДобавленииПереименованийОбъектовМетаданных(Переименования);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриДобавленииПереименованийОбъектовМетаданных Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриДобавленииПереименованийОбъектовМетаданных(Переименования);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриДобавленииПереименованийОбъектовМетаданных Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриДобавленииПереименованийОбъектовМетаданных(Переименования);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриДобавленииПереименованийОбъектовМетаданных Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриДобавленииПереименованийОбъектовМетаданных(Переименования);
	КонецЕсли;
	
КонецПроцедуры

// См. РегистрСведений.ПараметрыРаботыВерсийРасширений.ЗаполнитьВсеПараметрыРаботыРасширений.
Процедура ПриЗаполненииВсехПараметровРаботыРасширений() Экспорт

	ПользователиСлужебный.ПриЗаполненииВсехПараметровРаботыРасширений();
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УправлениеДоступом") Тогда
		МодульУправлениеДоступомСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеДоступомСлужебный");
		МодульУправлениеДоступомСлужебный.ПриЗаполненииВсехПараметровРаботыРасширений();
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ПодключаемыеКоманды") Тогда
		МодульПодключаемыеКоманды = ОбщегоНазначения.ОбщийМодуль("ПодключаемыеКоманды");
		МодульПодключаемыеКоманды.ПриЗаполненииВсехПараметровРаботыРасширений();
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.БизнесПроцессыИЗадачи") Тогда
		МодульБизнесПроцессыИЗадачиСервер = ОбщегоНазначения.ОбщийМодуль("БизнесПроцессыИЗадачиСервер");
		МодульБизнесПроцессыИЗадачиСервер.ПриЗаполненииВсехПараметровРаботыРасширений();
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВариантыОтчетов") Тогда
		МодульВариантыОтчетов = ОбщегоНазначения.ОбщийМодуль("ВариантыОтчетов");
		МодульВариантыОтчетов.ПриЗаполненииВсехПараметровРаботыРасширений();
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриЗаполненииВсехПараметровРаботыРасширений Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриЗаполненииВсехПараметровРаботыРасширений();
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриЗаполненииВсехПараметровРаботыРасширений Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриЗаполненииВсехПараметровРаботыРасширений();
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриЗаполненииВсехПараметровРаботыРасширений Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриЗаполненииВсехПараметровРаботыРасширений();
	КонецЕсли;
	
КонецПроцедуры

// См. РегистрСведений.ПараметрыРаботыВерсийРасширений.ОчиститьВсеПараметрыРаботыРасширений.
Процедура ПриОчисткеВсехПараметровРаботыРасширений() Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВариантыОтчетов") Тогда
		МодульВариантыОтчетов = ОбщегоНазначения.ОбщийМодуль("ВариантыОтчетов");
		МодульВариантыОтчетов.ПриОчисткеВсехПараметровРаботыРасширений();
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриОчисткеВсехПараметровРаботыРасширений Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриОчисткеВсехПараметровРаботыРасширений();
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриОчисткеВсехПараметровРаботыРасширений Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриОчисткеВсехПараметровРаботыРасширений();
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриОчисткеВсехПараметровРаботыРасширений Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриОчисткеВсехПараметровРаботыРасширений();
	КонецЕсли;
	
КонецПроцедуры

// См. СтандартныеПодсистемыСервер.ПриОтправкеДанныхГлавному.
Процедура ПриОтправкеДанныхГлавному(ЭлементДанных, ОтправкаЭлемента, Получатель) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВерсионированиеОбъектов") Тогда
		МодульВерсионированиеОбъектов = ОбщегоНазначения.ОбщийМодуль("ВерсионированиеОбъектов");
		МодульВерсионированиеОбъектов.ПриОтправкеДанныхГлавному(ЭлементДанных, ОтправкаЭлемента, Получатель);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВнешниеКомпоненты") Тогда
		МодульВнешниеКомпонентыСлужебный = ОбщегоНазначения.ОбщийМодуль("ВнешниеКомпонентыСлужебный");
		МодульВнешниеКомпонентыСлужебный.ПриОтправкеДанныхГлавному(ЭлементДанных, ОтправкаЭлемента, Получатель);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.ВнешниеКомпонентыВМоделиСервиса") Тогда
		МодульВнешниеКомпонентыВМоделиСервисаСлужебный = ОбщегоНазначения.ОбщийМодуль(
			"ВнешниеКомпонентыВМоделиСервисаСлужебный");
		МодульВнешниеКомпонентыВМоделиСервисаСлужебный.ПриОтправкеДанныхГлавному(ЭлементДанных,
			ОтправкаЭлемента, Получатель);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаВМоделиСервиса.ОбменДаннымиВМоделиСервиса") Тогда
		МодульОбменДаннымиВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("ОбменДаннымиВМоделиСервиса");
		МодульОбменДаннымиВМоделиСервиса.ПриОтправкеДанныхГлавному(ЭлементДанных, ОтправкаЭлемента, Получатель);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ДатыЗапретаИзменения") Тогда
		МодульДатыЗапретаИзмененияСлужебный = ОбщегоНазначения.ОбщийМодуль("ДатыЗапретаИзмененияСлужебный");
		МодульДатыЗапретаИзмененияСлужебный.ПриОтправкеДанныхГлавному(ЭлементДанных, ОтправкаЭлемента, Получатель);
	КонецЕсли;

	ОбновлениеИнформационнойБазыСлужебный.ПриОтправкеДанныхГлавному(ЭлементДанных, ОтправкаЭлемента, Получатель);
	ПользователиСлужебный.ПриОтправкеДанныхГлавному(ЭлементДанных, ОтправкаЭлемента, Получатель);

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСФайлами") Тогда
		МодульРаботаСФайламиСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебный");
		МодульРаботаСФайламиСлужебный.ПриОтправкеДанныхГлавному(ЭлементДанных, ОтправкаЭлемента, Получатель);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УправлениеДоступом") Тогда
		МодульУправлениеДоступомСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеДоступомСлужебный");
		МодульУправлениеДоступомСлужебный.ПриОтправкеДанныхГлавному(ЭлементДанных, ОтправкаЭлемента, Получатель);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЭлектроннаяПодпись") Тогда
		МодульЭлектроннаяПодписьСлужебный = ОбщегоНазначения.ОбщийМодуль("ЭлектроннаяПодписьСлужебный");
		МодульЭлектроннаяПодписьСлужебный.ПриОтправкеДанныхГлавному(ЭлементДанных, ОтправкаЭлемента, Получатель);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриОтправкеДанныхГлавному Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриОтправкеДанныхГлавному(ЭлементДанных, ОтправкаЭлемента, Получатель);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриОтправкеДанныхГлавному Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриОтправкеДанныхГлавному(ЭлементДанных, ОтправкаЭлемента, Получатель);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриОтправкеДанныхГлавному Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриОтправкеДанныхГлавному(ЭлементДанных, ОтправкаЭлемента, Получатель);
	КонецЕсли;
	
КонецПроцедуры

// См. СтандартныеПодсистемыСервер.ПриОтправкеДанныхПодчиненному.
Процедура ПриОтправкеДанныхПодчиненному(ЭлементДанных, ОтправкаЭлемента, СозданиеНачальногоОбраза, Получатель) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВерсионированиеОбъектов") Тогда
		МодульВерсионированиеОбъектов = ОбщегоНазначения.ОбщийМодуль("ВерсионированиеОбъектов");
		МодульВерсионированиеОбъектов.ПриОтправкеДанныхПодчиненному(ЭлементДанных,
			ОтправкаЭлемента, СозданиеНачальногоОбраза, Получатель);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВнешниеКомпоненты") Тогда
		МодульВнешниеКомпонентыСлужебный = ОбщегоНазначения.ОбщийМодуль("ВнешниеКомпонентыСлужебный");
		МодульВнешниеКомпонентыСлужебный.ПриОтправкеДанныхПодчиненному(ЭлементДанных,
			ОтправкаЭлемента, СозданиеНачальногоОбраза, Получатель);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.ВнешниеКомпонентыВМоделиСервиса") Тогда
		МодульВнешниеКомпонентыВМоделиСервисаСлужебный = ОбщегоНазначения.ОбщийМодуль(
			"ВнешниеКомпонентыВМоделиСервисаСлужебный");
		МодульВнешниеКомпонентыВМоделиСервисаСлужебный.ПриОтправкеДанныхПодчиненному(ЭлементДанных,
			ОтправкаЭлемента, СозданиеНачальногоОбраза, Получатель);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ДатыЗапретаИзменения") Тогда
		МодульДатыЗапретаИзмененияСлужебный = ОбщегоНазначения.ОбщийМодуль("ДатыЗапретаИзмененияСлужебный");
		МодульДатыЗапретаИзмененияСлужебный.ПриОтправкеДанныхПодчиненному(ЭлементДанных,
			ОтправкаЭлемента, СозданиеНачальногоОбраза, Получатель);
	КонецЕсли;

	ОбновлениеИнформационнойБазыСлужебный.ПриОтправкеДанныхПодчиненному(ЭлементДанных,
			ОтправкаЭлемента, СозданиеНачальногоОбраза, Получатель);

	ПользователиСлужебный.ПриОтправкеДанныхПодчиненному(ЭлементДанных,
			ОтправкаЭлемента, СозданиеНачальногоОбраза, Получатель);

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСФайлами") Тогда
		МодульРаботаСФайламиСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебный");
		МодульРаботаСФайламиСлужебный.ПриОтправкеДанныхПодчиненному(ЭлементДанных,
			ОтправкаЭлемента, СозданиеНачальногоОбраза, Получатель);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УправлениеДоступом") Тогда
		МодульУправлениеДоступомСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеДоступомСлужебный");
		МодульУправлениеДоступомСлужебный.ПриОтправкеДанныхПодчиненному(ЭлементДанных,
			ОтправкаЭлемента, СозданиеНачальногоОбраза, Получатель);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЭлектроннаяПодпись") Тогда
		МодульЭлектроннаяПодписьСлужебный = ОбщегоНазначения.ОбщийМодуль("ЭлектроннаяПодписьСлужебный");
		МодульЭлектроннаяПодписьСлужебный.ПриОтправкеДанныхПодчиненному(ЭлементДанных,
			ОтправкаЭлемента, СозданиеНачальногоОбраза, Получатель);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриОтправкеДанныхПодчиненному Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриОтправкеДанныхПодчиненному(ЭлементДанных,
			ОтправкаЭлемента, СозданиеНачальногоОбраза, Получатель);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриОтправкеДанныхПодчиненному Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриОтправкеДанныхПодчиненному(ЭлементДанных,
			ОтправкаЭлемента, СозданиеНачальногоОбраза, Получатель);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриОтправкеДанныхПодчиненному Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриОтправкеДанныхПодчиненному(ЭлементДанных,
			ОтправкаЭлемента, СозданиеНачальногоОбраза, Получатель);
	КонецЕсли;
	
КонецПроцедуры

// См. СтандартныеПодсистемыСервер.ПриПолученииДанныхОтГлавного.
Процедура ПриПолученииДанныхОтГлавного(ЭлементДанных, ПолучениеЭлемента, ОтправкаНазад, Отправитель) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.БизнесПроцессыИЗадачи") Тогда
		МодульБизнесПроцессыИЗадачиСервер = ОбщегоНазначения.ОбщийМодуль("БизнесПроцессыИЗадачиСервер");
		МодульБизнесПроцессыИЗадачиСервер.ПриПолученииДанныхОтГлавного(ЭлементДанных,
			ПолучениеЭлемента, ОтправкаНазад, Отправитель);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВерсионированиеОбъектов") Тогда
		МодульВерсионированиеОбъектов = ОбщегоНазначения.ОбщийМодуль("ВерсионированиеОбъектов");
		МодульВерсионированиеОбъектов.ПриПолученииДанныхОтГлавного(ЭлементДанных,
			ПолучениеЭлемента, ОтправкаНазад, Отправитель);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВнешниеКомпоненты") Тогда
		МодульВнешниеКомпонентыСлужебный = ОбщегоНазначения.ОбщийМодуль("ВнешниеКомпонентыСлужебный");
		МодульВнешниеКомпонентыСлужебный.ПриПолученииДанныхОтГлавного(ЭлементДанных,
			ПолучениеЭлемента, ОтправкаНазад, Отправитель);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.ВнешниеКомпонентыВМоделиСервиса") Тогда
		МодульВнешниеКомпонентыВМоделиСервисаСлужебный = ОбщегоНазначения.ОбщийМодуль(
			"ВнешниеКомпонентыВМоделиСервисаСлужебный");
		МодульВнешниеКомпонентыВМоделиСервисаСлужебный.ПриПолученииДанныхОтГлавного(ЭлементДанных,
			ПолучениеЭлемента, ОтправкаНазад, Отправитель);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ДатыЗапретаИзменения") Тогда
		МодульДатыЗапретаИзмененияСлужебный = ОбщегоНазначения.ОбщийМодуль("ДатыЗапретаИзмененияСлужебный");
		МодульДатыЗапретаИзмененияСлужебный.ПриПолученииДанныхОтГлавного(ЭлементДанных,
			ПолучениеЭлемента, ОтправкаНазад, Отправитель);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ДополнительныеОтчетыИОбработки") Тогда
		МодульДополнительныеОтчетыИОбработки = ОбщегоНазначения.ОбщийМодуль("ДополнительныеОтчетыИОбработки");
		МодульДополнительныеОтчетыИОбработки.ПриПолученииДанныхОтГлавного(ЭлементДанных,
			ПолучениеЭлемента, ОтправкаНазад, Отправитель);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЗащитаПерсональныхДанных") Тогда
		МодульЗащитаПерсональныхДанных = ОбщегоНазначения.ОбщийМодуль("ЗащитаПерсональныхДанных");
		МодульЗащитаПерсональныхДанных.ПриПолученииДанныхОтГлавного(ЭлементДанных,
			ПолучениеЭлемента, ОтправкаНазад, Отправитель);
	КонецЕсли;

	ПользователиСлужебный.ПриПолученииДанныхОтГлавного(ЭлементДанных,
		ПолучениеЭлемента, ОтправкаНазад, Отправитель);

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСПочтовымиСообщениями") Тогда
		МодульРаботаСПочтовымиСообщениямиСлужебный = ОбщегоНазначения.ОбщийМодуль(
			"РаботаСПочтовымиСообщениямиСлужебный");
		МодульРаботаСПочтовымиСообщениямиСлужебный.ПриПолученииДанныхОтГлавного(ЭлементДанных,
			ПолучениеЭлемента, ОтправкаНазад, Отправитель);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСФайлами") Тогда
		МодульРаботаСФайламиСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебный");
		МодульРаботаСФайламиСлужебный.ПриПолученииДанныхОтГлавного(ЭлементДанных,
			ПолучениеЭлемента, ОтправкаНазад, Отправитель);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УправлениеДоступом") Тогда
		МодульУправлениеДоступомСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеДоступомСлужебный");
		МодульУправлениеДоступомСлужебный.ПриПолученииДанныхОтГлавного(ЭлементДанных,
			ПолучениеЭлемента, ОтправкаНазад, Отправитель);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриПолученииДанныхОтГлавного Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриПолученииДанныхОтГлавного(ЭлементДанных,
			ПолучениеЭлемента, ОтправкаНазад, Отправитель);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриПолученииДанныхОтГлавного Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриПолученииДанныхОтГлавного(ЭлементДанных,
			ПолучениеЭлемента, ОтправкаНазад, Отправитель);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриПолученииДанныхОтГлавного Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриПолученииДанныхОтГлавного(ЭлементДанных,
			ПолучениеЭлемента, ОтправкаНазад, Отправитель);
	КонецЕсли;
	
КонецПроцедуры

// См. СтандартныеПодсистемыСервер.ПриПолученииДанныхОтПодчиненного.
Процедура ПриПолученииДанныхОтПодчиненного(ЭлементДанных, ПолучениеЭлемента, ОтправкаНазад, Отправитель) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.БизнесПроцессыИЗадачи") Тогда
		МодульБизнесПроцессыИЗадачиСервер = ОбщегоНазначения.ОбщийМодуль("БизнесПроцессыИЗадачиСервер");
		МодульБизнесПроцессыИЗадачиСервер.ПриПолученииДанныхОтГлавного(ЭлементДанных,
			ПолучениеЭлемента, ОтправкаНазад, Отправитель);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВерсионированиеОбъектов") Тогда
		МодульВерсионированиеОбъектов = ОбщегоНазначения.ОбщийМодуль("ВерсионированиеОбъектов");
		МодульВерсионированиеОбъектов.ПриПолученииДанныхОтПодчиненного(ЭлементДанных,
			ПолучениеЭлемента, ОтправкаНазад, Отправитель);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВнешниеКомпоненты") Тогда
		МодульВнешниеКомпонентыСлужебный = ОбщегоНазначения.ОбщийМодуль("ВнешниеКомпонентыСлужебный");
		МодульВнешниеКомпонентыСлужебный.ПриПолученииДанныхОтПодчиненного(ЭлементДанных,
			ПолучениеЭлемента, ОтправкаНазад, Отправитель);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.ВнешниеКомпонентыВМоделиСервиса") Тогда
		МодульВнешниеКомпонентыВМоделиСервисаСлужебный = ОбщегоНазначения.ОбщийМодуль(
			"ВнешниеКомпонентыВМоделиСервисаСлужебный");
		МодульВнешниеКомпонентыВМоделиСервисаСлужебный.ПриПолученииДанныхОтПодчиненного(ЭлементДанных,
			ПолучениеЭлемента, ОтправкаНазад, Отправитель);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаВМоделиСервиса.ОбменДаннымиВМоделиСервиса") Тогда
		МодульОбменДаннымиВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("ОбменДаннымиВМоделиСервиса");
		МодульОбменДаннымиВМоделиСервиса.ПриПолученииДанныхОтПодчиненного(ЭлементДанных,
			ПолучениеЭлемента, ОтправкаНазад, Отправитель);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ДатыЗапретаИзменения") Тогда
		МодульДатыЗапретаИзмененияСлужебный = ОбщегоНазначения.ОбщийМодуль("ДатыЗапретаИзмененияСлужебный");
		МодульДатыЗапретаИзмененияСлужебный.ПриПолученииДанныхОтПодчиненного(ЭлементДанных,
			ПолучениеЭлемента, ОтправкаНазад, Отправитель);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ДополнительныеОтчетыИОбработки") Тогда
		МодульДополнительныеОтчетыИОбработки = ОбщегоНазначения.ОбщийМодуль("ДополнительныеОтчетыИОбработки");
		МодульДополнительныеОтчетыИОбработки.ПриПолученииДанныхОтПодчиненного(ЭлементДанных,
			ПолучениеЭлемента, ОтправкаНазад, Отправитель);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЗащитаПерсональныхДанных") Тогда
		МодульЗащитаПерсональныхДанных = ОбщегоНазначения.ОбщийМодуль("ЗащитаПерсональныхДанных");
		МодульЗащитаПерсональныхДанных.ПриПолученииДанныхОтПодчиненного(ЭлементДанных,
			ПолучениеЭлемента, ОтправкаНазад, Отправитель);
	КонецЕсли;

	ПользователиСлужебный.ПриПолученииДанныхОтПодчиненного(ЭлементДанных, ПолучениеЭлемента, ОтправкаНазад, Отправитель);

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСФайлами") Тогда
		МодульРаботаСФайламиСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебный");
		МодульРаботаСФайламиСлужебный.ПриПолученииДанныхОтПодчиненного(ЭлементДанных,
			ПолучениеЭлемента, ОтправкаНазад, Отправитель);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСПочтовымиСообщениями") Тогда
		МодульРаботаСПочтовымиСообщениямиСлужебный = ОбщегоНазначения.ОбщийМодуль(
			"РаботаСПочтовымиСообщениямиСлужебный");
		МодульРаботаСПочтовымиСообщениямиСлужебный.ПриПолученииДанныхОтПодчиненного(ЭлементДанных,
			ПолучениеЭлемента, ОтправкаНазад, Отправитель);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УправлениеДоступом") Тогда
		МодульУправлениеДоступомСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеДоступомСлужебный");
		МодульУправлениеДоступомСлужебный.ПриПолученииДанныхОтПодчиненного(ЭлементДанных,
			ПолучениеЭлемента, ОтправкаНазад, Отправитель);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриПолученииДанныхОтПодчиненного Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриПолученииДанныхОтПодчиненного(ЭлементДанных,
			ПолучениеЭлемента, ОтправкаНазад, Отправитель);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриПолученииДанныхОтПодчиненного Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриПолученииДанныхОтПодчиненного(ЭлементДанных,
			ПолучениеЭлемента, ОтправкаНазад, Отправитель);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриПолученииДанныхОтПодчиненного Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриПолученииДанныхОтПодчиненного(ЭлементДанных,
			ПолучениеЭлемента, ОтправкаНазад, Отправитель);
	КонецЕсли;
	
КонецПроцедуры

// См. СтандартныеПодсистемыСервер.ПослеПолученияДанных.
Процедура ПослеПолученияДанных(Отправитель, Отказ, ПолучениеИзГлавногоУзла) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.БизнесПроцессыИЗадачи") Тогда
		МодульБизнесПроцессыИЗадачиСервер = ОбщегоНазначения.ОбщийМодуль("БизнесПроцессыИЗадачиСервер");
		МодульБизнесПроцессыИЗадачиСервер.ПослеПолученияДанных(Отправитель, Отказ, ПолучениеИзГлавногоУзла);
	КонецЕсли;

	ПользователиСлужебный.ПослеПолученияДанных(Отправитель, Отказ, ПолучениеИзГлавногоУзла);

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УправлениеДоступом") Тогда
		МодульУправлениеДоступомСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеДоступомСлужебный");
		МодульУправлениеДоступомСлужебный.ПослеПолученияДанных(Отправитель, Отказ, ПолучениеИзГлавногоУзла);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПослеПолученияДанных Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПослеПолученияДанных(Отправитель, Отказ, ПолучениеИзГлавногоУзла);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПослеПолученияДанных Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПослеПолученияДанных(Отправитель, Отказ, ПолучениеИзГлавногоУзла);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПослеПолученияДанных Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПослеПолученияДанных(Отправитель, Отказ, ПолучениеИзГлавногоУзла);
	КонецЕсли;
	
КонецПроцедуры

// См. РаботаВМоделиСервисаПереопределяемый.ПриВключенииРазделенияПоОбластямДанных.
Процедура ПриВключенииРазделенияПоОбластямДанных() Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КалендарныеГрафики") Тогда
		МодульКалендарныеГрафики = ОбщегоНазначения.ОбщийМодуль("КалендарныеГрафики");
		МодульКалендарныеГрафики.ПриВключенииРазделенияПоОбластямДанных();
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ОбменДанными") Тогда
		МодульОбменДаннымиСервер = ОбщегоНазначения.ОбщийМодуль("ОбменДаннымиСервер");
		МодульОбменДаннымиСервер.ПриВключенииРазделенияПоОбластямДанных();
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриВключенииРазделенияПоОбластямДанных Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриВключенииРазделенияПоОбластямДанных();
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриВключенииРазделенияПоОбластямДанных Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриВключенииРазделенияПоОбластямДанных();
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриВключенииРазделенияПоОбластямДанных Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриВключенииРазделенияПоОбластямДанных();
	КонецЕсли;
	
КонецПроцедуры

// См. ОбщегоНазначенияПереопределяемый.ПриОпределенииПоддерживаемыхВерсийПрограммныхИнтерфейсов.
Процедура ПриОпределенииПоддерживаемыхВерсийПрограммныхИнтерфейсов(ПоддерживаемыеВерсии) Экспорт

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриОпределенииПоддерживаемыхВерсийПрограммныхИнтерфейсов Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриОпределенииПоддерживаемыхВерсийПрограммныхИнтерфейсов(ПоддерживаемыеВерсии);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ОбменДанными") Тогда
		МодульОбменДаннымиСервер = ОбщегоНазначения.ОбщийМодуль("ОбменДаннымиСервер");
		МодульОбменДаннымиСервер.ПриОпределенииПоддерживаемыхВерсийПрограммныхИнтерфейсов(ПоддерживаемыеВерсии);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаВМоделиСервиса.ОбменДаннымиВМоделиСервиса") Тогда
		МодульОбменДаннымиВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("ОбменДаннымиВМоделиСервиса");
		МодульОбменДаннымиВМоделиСервиса.ПриОпределенииПоддерживаемыхВерсийПрограммныхИнтерфейсов(ПоддерживаемыеВерсии);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриОпределенииПоддерживаемыхВерсийПрограммныхИнтерфейсов Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриОпределенииПоддерживаемыхВерсийПрограммныхИнтерфейсов(ПоддерживаемыеВерсии);
	КонецЕсли;

	ПользователиСлужебный.ПриОпределенииПоддерживаемыхВерсийПрограммныхИнтерфейсов(ПоддерживаемыеВерсии);
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЭлектроннаяПодписьСервисаDSS") Тогда
		МодульСервисКриптографииDSSСлужебный = ОбщегоНазначения.ОбщийМодуль("СервисКриптографииDSSСлужебный");
		МодульСервисКриптографииDSSСлужебный.ПриОпределенииПоддерживаемыхВерсийПрограммныхИнтерфейсов(ПоддерживаемыеВерсии);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриОпределенииПоддерживаемыхВерсийПрограммныхИнтерфейсов Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриОпределенииПоддерживаемыхВерсийПрограммныхИнтерфейсов(ПоддерживаемыеВерсии);
	КонецЕсли;
		
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаВМоделиСервиса.УправлениеДоступомВМоделиСервиса") Тогда
		МодульУправлениеДоступомСлужебныйВМоделиСервиса = 
			ОбщегоНазначения.ОбщийМодуль("УправлениеДоступомСлужебныйВМоделиСервиса");
		МодульУправлениеДоступомСлужебныйВМоделиСервиса.ПриОпределенииПоддерживаемыхВерсийПрограммныхИнтерфейсов(ПоддерживаемыеВерсии);
	КонецЕсли;
	
КонецПроцедуры

// См. ОбщегоНазначенияПереопределяемый.ПриДобавленииПараметровРаботыКлиентаПриЗапуске.
Процедура ПриДобавленииПараметровРаботыКлиентаПриЗапуске(Параметры) Экспорт

	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриДобавленииПараметровРаботыКлиентаПриЗапуске Тогда
		МодульТехнологияСервиса = ОбщегоНазначения.ОбщийМодуль("ТехнологияСервиса");
		ВерсияБТС = МодульТехнологияСервиса.ВерсияБиблиотеки();
		Если Параметры.ДоступноИспользованиеРазделенныхДанных
		 Или ОбщегоНазначенияКлиентСервер.СравнитьВерсии(ВерсияБТС, "2.0.11.0") >= 0 Тогда
			МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
			МодульИнтеграцияПодсистемБТС.ПриДобавленииПараметровРаботыКлиентаПриЗапуске(Параметры);
		КонецЕсли;
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"ИнтеграцияПодсистемБТС.ПриДобавленииПараметровРаботыКлиентаПриЗапуске");

	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ИнформацияПриЗапуске") Тогда
		МодульИнформацияПриЗапуске = ОбщегоНазначения.ОбщийМодуль("ИнформацияПриЗапуске");
		МодульИнформацияПриЗапуске.ПриДобавленииПараметровРаботыКлиентаПриЗапуске(Параметры);
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"ИнформацияПриЗапуске.ПриДобавленииПараметровРаботыКлиентаПриЗапуске");

	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КонтрольВеденияУчета") Тогда
		МодульКонтрольВеденияУчетаСлужебный = ОбщегоНазначения.ОбщийМодуль("КонтрольВеденияУчетаСлужебный");
		МодульКонтрольВеденияУчетаСлужебный.ПриДобавленииПараметровРаботыКлиентаПриЗапуске(Параметры);
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"КонтрольВеденияУчетаСлужебный.ПриДобавленииПараметровРаботыКлиентаПриЗапуске");

	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.НапоминанияПользователя") Тогда
		МодульНапоминанияПользователяСлужебный = ОбщегоНазначения.ОбщийМодуль("НапоминанияПользователяСлужебный");
		МодульНапоминанияПользователяСлужебный.ПриДобавленииПараметровРаботыКлиентаПриЗапуске(Параметры);
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"НапоминанияПользователяСлужебный.ПриДобавленииПараметровРаботыКлиентаПриЗапуске");

	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ОбменДанными") Тогда
		МодульОбменДаннымиСервер = ОбщегоНазначения.ОбщийМодуль("ОбменДаннымиСервер");
		МодульОбменДаннымиСервер.ПриДобавленииПараметровРаботыКлиентаПриЗапуске(Параметры);
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"ОбменДаннымиСервер.ПриДобавленииПараметровРаботыКлиентаПриЗапуске");

	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаВМоделиСервиса.ОбменДаннымиВМоделиСервиса") Тогда
		МодульОбменДаннымиВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("ОбменДаннымиВМоделиСервиса");
		МодульОбменДаннымиВМоделиСервиса.ПриДобавленииПараметровРаботыКлиентаПриЗапуске(Параметры);
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"ОбменДаннымиВМоделиСервиса.ПриДобавленииПараметровРаботыКлиентаПриЗапуске");

	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	ОбновлениеИнформационнойБазыСлужебный.ПриДобавленииПараметровРаботыКлиентаПриЗапуске(Параметры);
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"ОбновлениеИнформационнойБазыСлужебный.ПриДобавленииПараметровРаботыКлиентаПриЗапуске");

	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ОбновлениеКонфигурации") Тогда
		МодульОбновлениеКонфигурации = ОбщегоНазначения.ОбщийМодуль("ОбновлениеКонфигурации");
		МодульОбновлениеКонфигурации.ПриДобавленииПараметровРаботыКлиентаПриЗапуске(Параметры);
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"ОбновлениеКонфигурации.ПриДобавленииПараметровРаботыКлиентаПриЗапуске");

	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ОценкаПроизводительности") Тогда
		МодульОценкаПроизводительностиСлужебный = ОбщегоНазначения.ОбщийМодуль("ОценкаПроизводительностиСлужебный");
		МодульОценкаПроизводительностиСлужебный.ПриДобавленииПараметровРаботыКлиентаПриЗапуске(Параметры);
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"ОценкаПроизводительностиСлужебный.ПриДобавленииПараметровРаботыКлиентаПриЗапуске");

	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Банки") Тогда
		МодульРаботаСБанками = ОбщегоНазначения.ОбщийМодуль("РаботаСБанками");
		МодульРаботаСБанками.ПриДобавленииПараметровРаботыКлиентаПриЗапуске(Параметры);
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"РаботаСБанками.ПриДобавленииПараметровРаботыКлиентаПриЗапуске");

	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Валюты") Тогда
		МодульРаботаСКурсамиВалют = ОбщегоНазначения.ОбщийМодуль("РаботаСКурсамиВалют");
		МодульРаботаСКурсамиВалют.ПриДобавленииПараметровРаботыКлиентаПриЗапуске(Параметры);
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"РаботаСКурсамиВалют.ПриДобавленииПараметровРаботыКлиентаПриЗапуске");

	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСФайлами") Тогда
		МодульРаботаСФайламиСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебный");
		МодульРаботаСФайламиСлужебный.ПриДобавленииПараметровРаботыКлиентаПриЗапуске(Параметры);
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"РаботаСФайламиСлужебный.ПриДобавленииПараметровРаботыКлиентаПриЗапуске");

	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РезервноеКопированиеИБ") Тогда
		МодульРезервноеКопированиеИБСервер = ОбщегоНазначения.ОбщийМодуль("РезервноеКопированиеИБСервер");
		МодульРезервноеКопированиеИБСервер.ПриДобавленииПараметровРаботыКлиентаПриЗапуске(Параметры);
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"РезервноеКопированиеИБСервер.ПриДобавленииПараметровРаботыКлиентаПриЗапуске");

	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЗавершениеРаботыПользователей") Тогда
		МодульСоединенияИБ = ОбщегоНазначения.ОбщийМодуль("СоединенияИБ");
		МодульСоединенияИБ.ПриДобавленииПараметровРаботыКлиентаПриЗапуске(Параметры);
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"СоединенияИБ.ПриДобавленииПараметровРаботыКлиентаПриЗапуске");

	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЦентрМониторинга") Тогда
		МодульЦентрМониторингаСлужебный = ОбщегоНазначения.ОбщийМодуль("ЦентрМониторингаСлужебный");
		МодульЦентрМониторингаСлужебный.ПриДобавленииПараметровРаботыКлиентаПриЗапуске(Параметры);
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"ЦентрМониторингаСлужебный.ПриДобавленииПараметровРаботыКлиентаПриЗапуске");

	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриДобавленииПараметровРаботыКлиентаПриЗапуске Тогда
		МодульИнтернетПоддержкаПользователейКлиентСервер = ОбщегоНазначения.ОбщийМодуль("ИнтернетПоддержкаПользователейКлиентСервер");
		ВерсияБИП = МодульИнтернетПоддержкаПользователейКлиентСервер.ВерсияБиблиотеки();
		Если Параметры.ДоступноИспользованиеРазделенныхДанных
		 Или ОбщегоНазначенияКлиентСервер.СравнитьВерсии(ВерсияБИП, "2.6.5.0") >= 0 Тогда
			МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
			МодульИнтеграцияПодсистемБИП.ПриДобавленииПараметровРаботыКлиентаПриЗапуске(Параметры);
		КонецЕсли;
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"ИнтеграцияПодсистемБИП.ПриДобавленииПараметровРаботыКлиентаПриЗапуске");
	
	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриДобавленииПараметровРаботыКлиентаПриЗапуске Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриДобавленииПараметровРаботыКлиентаПриЗапуске(Параметры);
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"ИнтеграцияПодсистемПлюс.ПриДобавленииПараметровРаботыКлиентаПриЗапуске");

КонецПроцедуры

// См. ОбщегоНазначенияПереопределяемый.ПриДобавленииПараметровРаботыКлиента.
Процедура ПриДобавленииПараметровРаботыКлиента(Параметры) Экспорт

	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриДобавленииПараметровРаботыКлиента Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриДобавленииПараметровРаботыКлиента(Параметры);
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"ИнтеграцияПодсистемБТС.ПриДобавленииПараметровРаботыКлиента");

	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.АдресныйКлассификатор") Тогда
		МодульАдресныйКлассификаторСлужебный = ОбщегоНазначения.ОбщийМодуль("АдресныйКлассификаторСлужебный");
		МодульАдресныйКлассификаторСлужебный.ПриДобавленииПараметровРаботыКлиента(Параметры);
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"АдресныйКлассификаторСлужебный.ПриДобавленииПараметровРаботыКлиента");

	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Взаимодействия") Тогда
		МодульВзаимодействия = ОбщегоНазначения.ОбщийМодуль("Взаимодействия");
		МодульВзаимодействия.ПриДобавленииПараметровРаботыКлиента(Параметры);
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"Взаимодействия.ПриДобавленииПараметровРаботыКлиента");

	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ОбменДанными") Тогда
		МодульОбменДаннымиСервер = ОбщегоНазначения.ОбщийМодуль("ОбменДаннымиСервер");
		МодульОбменДаннымиСервер.ПриДобавленииПараметровРаботыКлиента(Параметры);
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"ОбменДаннымиСервер.ПриДобавленииПараметровРаботыКлиента");

	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаВМоделиСервиса.ОбменДаннымиВМоделиСервиса") Тогда
		МодульОбменДаннымиВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("ОбменДаннымиВМоделиСервиса");
		МодульОбменДаннымиВМоделиСервиса.ПриДобавленииПараметровРаботыКлиента(Параметры);
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"ОбменДаннымиВМоделиСервиса.ПриДобавленииПараметровРаботыКлиента");

	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ОбновлениеКонфигурации") Тогда
		МодульОбновлениеКонфигурации = ОбщегоНазначения.ОбщийМодуль("ОбновлениеКонфигурации");
		МодульОбновлениеКонфигурации.ПриДобавленииПараметровРаботыКлиента(Параметры);
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"ОбновлениеКонфигурации.ПриДобавленииПараметровРаботыКлиента");

	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ОтправкаSMS") Тогда
		МодульОтправкаSMS = ОбщегоНазначения.ОбщийМодуль("ОтправкаSMS");
		МодульОтправкаSMS.ПриДобавленииПараметровРаботыКлиента(Параметры);
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"ОтправкаSMS.ПриДобавленииПараметровРаботыКлиента");

	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ПолучениеФайловИзИнтернета") Тогда
		МодульПолучениеФайловИзИнтернетаСлужебный = ОбщегоНазначения.ОбщийМодуль("ПолучениеФайловИзИнтернетаСлужебный");
		МодульПолучениеФайловИзИнтернетаСлужебный.ПриДобавленииПараметровРаботыКлиента(Параметры);
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"ПолучениеФайловИзИнтернетаСлужебный.ПриДобавленииПараметровРаботыКлиента");
	
	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ПрофилиБезопасности") Тогда
		МодульРаботаВБезопасномРежимеСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаВБезопасномРежимеСлужебный");
		МодульРаботаВБезопасномРежимеСлужебный.ПриДобавленииПараметровРаботыКлиента(Параметры);
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"РаботаВБезопасномРежимеСлужебный.ПриДобавленииПараметровРаботыКлиента");
	
	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	ПользователиСлужебный.ПриДобавленииПараметровРаботыКлиента(Параметры);
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"ПользователиСлужебный.ПриДобавленииПараметровРаботыКлиента");

	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСФайлами") Тогда
		МодульРаботаСФайламиСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебный");
		МодульРаботаСФайламиСлужебный.ПриДобавленииПараметровРаботыКлиента(Параметры);
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"РаботаСФайламиСлужебный.ПриДобавленииПараметровРаботыКлиента");

	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РезервноеКопированиеИБ") Тогда
		МодульРезервноеКопированиеИБСервер = ОбщегоНазначения.ОбщийМодуль("РезервноеКопированиеИБСервер");
		МодульРезервноеКопированиеИБСервер.ПриДобавленииПараметровРаботыКлиента(Параметры);
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"РезервноеКопированиеИБСервер.ПриДобавленииПараметровРаботыКлиента");

	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЗавершениеРаботыПользователей") Тогда
		МодульСоединенияИБ = ОбщегоНазначения.ОбщийМодуль("СоединенияИБ");
		МодульСоединенияИБ.ПриДобавленииПараметровРаботыКлиента(Параметры);
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"СоединенияИБ.ПриДобавленииПараметровРаботыКлиента");

	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	СтандартныеПодсистемыСервер.ПриДобавленииПараметровРаботыКлиента(Параметры);
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"СтандартныеПодсистемыСервер.ПриДобавленииПараметровРаботыКлиента");

	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УправлениеДоступом") Тогда
		МодульУправлениеДоступомСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеДоступомСлужебный");
		МодульУправлениеДоступомСлужебный.ПриДобавленииПараметровРаботыКлиента(Параметры);
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"УправлениеДоступомСлужебный.ПриДобавленииПараметровРаботыКлиента");

	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЭлектроннаяПодпись") Тогда
		МодульЭлектроннаяПодписьСлужебный = ОбщегоНазначения.ОбщийМодуль("ЭлектроннаяПодписьСлужебный");
		МодульЭлектроннаяПодписьСлужебный.ПриДобавленииПараметровРаботыКлиента(Параметры);
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"ЭлектроннаяПодписьСлужебный.ПриДобавленииПараметровРаботыКлиента");

	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриДобавленииПараметровРаботыКлиента Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриДобавленииПараметровРаботыКлиента(Параметры);
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"ИнтеграцияПодсистемБИП.ПриДобавленииПараметровРаботыКлиента");

	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЭлектроннаяПодписьСервисаDSS") Тогда
		МодульСервисКриптографииDSSСлужебный = ОбщегоНазначения.ОбщийМодуль("СервисКриптографииDSSСлужебный");
		МодульСервисКриптографииDSSСлужебный.ПриДобавленииПараметровРаботыКлиента(Параметры);
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"СервисКриптографииDSSСлужебный.ПриДобавленииПараметровРаботыКлиента");
	
	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.НапоминанияПользователя") Тогда
		МодульНапоминанияПользователяСлужебный = ОбщегоНазначения.ОбщийМодуль("НапоминанияПользователяСлужебный");
		МодульНапоминанияПользователяСлужебный.ПриДобавленииПараметровРаботыКлиента(Параметры);
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"НапоминанияПользователяСлужебный.ПриДобавленииПараметровРаботыКлиента");
	
	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ОбщегоНазначения.ПодсистемаСуществует("ИнтеграцияС1СДокументооборотом") Тогда
		Параметры.Вставить("ВерсияБИД", ОбновлениеИнформационнойБазы.ВерсияИБ("БиблиотекаИнтеграцииС1СДокументооборотом"));
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"ИнтеграцияПодсистемБИД.ПриДобавленииПараметровРаботыКлиента");
	
	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ОбщегоНазначения.ПодсистемаСуществует("ЭлектронноеВзаимодействие") Тогда
		Параметры.Вставить("ЕстьМодульИнтеграцииПодсистемБЭДКлиент", 
			Метаданные.ОбщиеМодули.Найти("ИнтеграцияПодсистемБЭДКлиент") <> Неопределено);
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"ИнтеграцияПодсистемБЭД.ПриДобавленииПараметровРаботыКлиента");
	
	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриДобавленииПараметровРаботыКлиента Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриДобавленииПараметровРаботыКлиента(Параметры);
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"ИнтеграцияПодсистемПлюс.ПриДобавленииПараметровРаботыКлиента");
	
	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УчетОригиналовПервичныхДокументов") Тогда
		МодульУчетОригиналовПервичныхДокументов = ОбщегоНазначения.ОбщийМодуль("УчетОригиналовПервичныхДокументов");
		МодульУчетОригиналовПервичныхДокументов.ПриДобавленииПараметровРаботыКлиента(Параметры);
	КонецЕсли;
	СтандартныеПодсистемыСервер.ДобавитьПоказатель(Параметры, МоментНачала,
		"УчетОригиналовПервичныхДокументов.ПриДобавленииПараметровРаботыКлиента");
	
КонецПроцедуры

// См. ОбщегоНазначенияПереопределяемый.ПередЗапускомПрограммы
Процедура ПередЗапускомПрограммы() Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаВМоделиСервиса.ПользователиВМоделиСервиса") Тогда
		МодульПользователиСлужебныйВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("ПользователиСлужебныйВМоделиСервиса");
		МодульПользователиСлужебныйВМоделиСервиса.ПередЗапускомПрограммы();
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПередЗапускомПрограммы Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПередЗапускомПрограммы();
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПередЗапускомПрограммы Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПередЗапускомПрограммы();
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПередЗапускомПрограммы Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПередЗапускомПрограммы();
	КонецЕсли;
	
КонецПроцедуры

// Смотри также ОбновлениеИнформационнойБазыПереопределяемый.ПриОпределенииНастроек
//
// Параметры:
//  Объекты - Массив из ОбъектМетаданных
//
Процедура ПриОпределенииОбъектовСНачальнымЗаполнением(Объекты) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.БизнесПроцессыИЗадачи") Тогда
		МодульБизнесПроцессыИЗадачиСервер = ОбщегоНазначения.ОбщийМодуль("БизнесПроцессыИЗадачиСервер");
		МодульБизнесПроцессыИЗадачиСервер.ПриОпределенииОбъектовСНачальнымЗаполнением(Объекты);
	КонецЕсли;

	ПользователиСлужебный.ПриОпределенииОбъектовСНачальнымЗаполнением(Объекты);

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КонтактнаяИнформация") Тогда
		МодульУправлениеКонтактнойИнформациейСлужебный = ОбщегоНазначения.ОбщийМодуль(
			"УправлениеКонтактнойИнформациейСлужебный");
		МодульУправлениеКонтактнойИнформациейСлужебный.ПриОпределенииОбъектовСНачальнымЗаполнением(Объекты);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСПочтовымиСообщениями") Тогда
		МодульРаботаСПочтовымиСообщениямиСлужебный = ОбщегоНазначения.ОбщийМодуль(
			"РаботаСПочтовымиСообщениямиСлужебный");
		МодульРаботаСПочтовымиСообщениямиСлужебный.ПриОпределенииОбъектовСНачальнымЗаполнением(Объекты);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСФайлами") Тогда
		МодульРаботаСФайламиСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебный");
		МодульРаботаСФайламиСлужебный.ПриОпределенииОбъектовСНачальнымЗаполнением(Объекты);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РассылкаОтчетов") Тогда
		МодульРассылкаОтчетов = ОбщегоНазначения.ОбщийМодуль("РассылкаОтчетов");
		МодульРассылкаОтчетов.ПриОпределенииОбъектовСНачальнымЗаполнением(Объекты);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Свойства") Тогда
		МодульУправлениеСвойствамиСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеСвойствамиСлужебный");
		МодульУправлениеСвойствамиСлужебный.ПриОпределенииОбъектовСНачальнымЗаполнением(Объекты);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УправлениеДоступом") Тогда
		МодульУправлениеДоступомСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеДоступомСлужебный");
		МодульУправлениеДоступомСлужебный.ПриОпределенииОбъектовСНачальнымЗаполнением(Объекты);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УчетОригиналовПервичныхДокументов") Тогда
		МодульУчетОригиналовПервичныхДокументов = ОбщегоНазначения.ОбщийМодуль("УчетОригиналовПервичныхДокументов");
		МодульУчетОригиналовПервичныхДокументов.ПриОпределенииОбъектовСНачальнымЗаполнением(Объекты);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ШаблоныСообщений") Тогда
		МодульШаблоныСообщенийСлужебный = ОбщегоНазначения.ОбщийМодуль("ШаблоныСообщенийСлужебный");
		МодульШаблоныСообщенийСлужебный.ПриОпределенииОбъектовСНачальнымЗаполнением(Объекты);
	КонецЕсли;
КонецПроцедуры

// См. ОбщегоНазначенияПереопределяемый.ПриДобавленииСерверныхОповещений
Процедура ПриДобавленииСерверныхОповещений(Оповещения) Экспорт
	
	СтандартныеПодсистемыСервер.ПриДобавленииСерверныхОповещений(Оповещения);
	ПользователиСлужебный.ПриДобавленииСерверныхОповещений(Оповещения);
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВнешниеКомпоненты") Тогда
		МодульВнешниеКомпонентыСлужебный = ОбщегоНазначения.ОбщийМодуль("ВнешниеКомпонентыСлужебный");
		МодульВнешниеКомпонентыСлужебный.ПриДобавленииСерверныхОповещений(Оповещения);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЗавершениеРаботыПользователей") Тогда
		МодульСоединенияИБ = ОбщегоНазначения.ОбщийМодуль("СоединенияИБ");
		МодульСоединенияИБ.ПриДобавленииСерверныхОповещений(Оповещения);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.НапоминанияПользователя") Тогда
		МодульНапоминанияПользователяСлужебный = ОбщегоНазначения.ОбщийМодуль("НапоминанияПользователяСлужебный");
		МодульНапоминанияПользователяСлужебный.ПриДобавленииСерверныхОповещений(Оповещения);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.МашиночитаемыеДоверенности") Тогда
		МодульМашиночитаемыеДоверенностиФНССлужебный = ОбщегоНазначения.ОбщийМодуль("МашиночитаемыеДоверенностиФНССлужебный");
		МодульМашиночитаемыеДоверенностиФНССлужебный.ПриДобавленииСерверныхОповещений(Оповещения);
	КонецЕсли;
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриДобавленииСерверныхОповещений Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриДобавленииСерверныхОповещений(Оповещения);
	КонецЕсли;
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриДобавленииСерверныхОповещений Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриДобавленииСерверныхОповещений(Оповещения);
	КонецЕсли;
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриДобавленииСерверныхОповещений Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриДобавленииСерверныхОповещений(Оповещения);
	КонецЕсли;
		
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБЭД().ПриДобавленииСерверныхОповещений Тогда
		МодульИнтеграцияПодсистемБЭД = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБЭД");
		МодульИнтеграцияПодсистемБЭД.ПриДобавленииСерверныхОповещений(Оповещения);
	КонецЕсли;
	
КонецПроцедуры

// См. ОбщегоНазначенияПереопределяемый.ПриПериодическомПолученииДанныхКлиентаНаСервере
Процедура ПриПериодическомПолученииДанныхКлиентаНаСервере(Параметры, Результаты) Экспорт
	
	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Попытка
		СтандартныеПодсистемыСервер.ПриПериодическомПолученииДанныхКлиентаНаСервере(Параметры, Результаты);
	Исключение
		СерверныеОповещения.ОбработатьОшибку(ИнформацияОбОшибке());
	КонецПопытки;
	СерверныеОповещения.ДобавитьПоказатель(Результаты, МоментНачала,
		"СтандартныеПодсистемыСервер.ПриПериодическомПолученииДанныхКлиентаНаСервере");
	
	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Попытка
		Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ОценкаПроизводительности") Тогда
			МодульОценкаПроизводительностиСлужебный = ОбщегоНазначения.ОбщийМодуль("ОценкаПроизводительностиСлужебный");
			МодульОценкаПроизводительностиСлужебный.ПриПериодическомПолученииДанныхКлиентаНаСервере(Параметры, Результаты);
		КонецЕсли;
	Исключение
		СерверныеОповещения.ОбработатьОшибку(ИнформацияОбОшибке());
	КонецПопытки;
	СерверныеОповещения.ДобавитьПоказатель(Результаты, МоментНачала,
		"ОценкаПроизводительностиСлужебный.ПриПериодическомПолученииДанныхКлиентаНаСервере");
	
	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Попытка
		Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЦентрМониторинга") Тогда
			МодульЦентрМониторингаСлужебный = ОбщегоНазначения.ОбщийМодуль("ЦентрМониторингаСлужебный");
			МодульЦентрМониторингаСлужебный.ПриПериодическомПолученииДанныхКлиентаНаСервере(Параметры, Результаты);
		КонецЕсли;
	Исключение
		СерверныеОповещения.ОбработатьОшибку(ИнформацияОбОшибке());
	КонецПопытки;
	СерверныеОповещения.ДобавитьПоказатель(Результаты, МоментНачала,
		"ЦентрМониторингаСлужебный.ПриПериодическомПолученииДанныхКлиентаНаСервере");
	
	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриПериодическомПолученииДанныхКлиентаНаСервере Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриПериодическомПолученииДанныхКлиентаНаСервере(Параметры, Результаты);
	КонецЕсли;
	СерверныеОповещения.ДобавитьПоказатель(Результаты, МоментНачала,
		"ИнтеграцияПодсистемПлюс.ПриПериодическомПолученииДанныхКлиентаНаСервере");
	
	МоментНачала = ТекущаяУниверсальнаяДатаВМиллисекундах();
	Попытка
		Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБЭД().ПриПериодическомПолученииДанныхКлиентаНаСервере Тогда
			МодульИнтеграцияПодсистемБЭД = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБЭД");
			МодульИнтеграцияПодсистемБЭД.ПриПериодическомПолученииДанныхКлиентаНаСервере(Параметры, Результаты);
		КонецЕсли;
	Исключение
		СерверныеОповещения.ОбработатьОшибку(ИнформацияОбОшибке());
	КонецПопытки;
	СерверныеОповещения.ДобавитьПоказатель(Результаты, МоментНачала,
		"ИнтеграцияПодсистемБЭД.ПриПериодическомПолученииДанныхКлиентаНаСервере");
	
КонецПроцедуры

#КонецОбласти

#Область Банки

// См. РаботаСБанкамиПереопределяемый.ПриОпределенииНастроекЗагрузкиКлассификатораБанков
Процедура ПриОпределенииНастроекЗагрузкиКлассификатораБанков(Настройки) Экспорт
	
КонецПроцедуры

#КонецОбласти

#Область ВариантыОтчетов

// См. ВариантыОтчетовПереопределяемый.ПриОпределенииНастроек.
Процедура ПриОпределенииНастроекВариантовОтчетов(Настройки) Экспорт

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриОпределенииНастроекВариантовОтчетов Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриОпределенииНастроекВариантовОтчетов(Настройки);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриОпределенииНастроекВариантовОтчетов Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриОпределенииНастроекВариантовОтчетов(Настройки);
	КонецЕсли;

КонецПроцедуры

// См. ВариантыОтчетовПереопределяемый.ОпределитьРазделыСВариантамиОтчетов.
Процедура ПриОпределенииРазделовСВариантамиОтчетов(СписокРазделов) Экспорт

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриОпределенииРазделовСВариантамиОтчетов Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриОпределенииРазделовСВариантамиОтчетов(СписокРазделов);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриОпределенииРазделовСВариантамиОтчетов Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриОпределенииРазделовСВариантамиОтчетов(СписокРазделов);
	КонецЕсли;

КонецПроцедуры

// См. ВариантыОтчетовПереопределяемый.НастроитьВариантыОтчетов.
Процедура ПриНастройкеВариантовОтчетов(Настройки) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КонтрольРаботыПользователей") Тогда
		МодульКонтрольРаботыПользователейСлужебный = ОбщегоНазначения.ОбщийМодуль("КонтрольРаботыПользователейСлужебный");
		МодульКонтрольРаботыПользователейСлужебный.ПриНастройкеВариантовОтчетов(Настройки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Анкетирование") Тогда
		МодульАнкетирование = ОбщегоНазначения.ОбщийМодуль("Анкетирование");
		МодульАнкетирование.ПриНастройкеВариантовОтчетов(Настройки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.БизнесПроцессыИЗадачи") Тогда
		МодульБизнесПроцессыИЗадачиСервер = ОбщегоНазначения.ОбщийМодуль("БизнесПроцессыИЗадачиСервер");
		МодульБизнесПроцессыИЗадачиСервер.ПриНастройкеВариантовОтчетов(Настройки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ДатыЗапретаИзменения") Тогда
		МодульДатыЗапретаИзмененияСлужебный = ОбщегоНазначения.ОбщийМодуль("ДатыЗапретаИзмененияСлужебный");
		МодульДатыЗапретаИзмененияСлужебный.ПриНастройкеВариантовОтчетов(Настройки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЗащитаПерсональныхДанных") Тогда
		МодульЗащитаПерсональныхДанных = ОбщегоНазначения.ОбщийМодуль("ЗащитаПерсональныхДанных");
		МодульЗащитаПерсональныхДанных.ПриНастройкеВариантовОтчетов(Настройки);
	КонецЕсли;

	ОбновлениеИнформационнойБазыСлужебный.ПриНастройкеВариантовОтчетов(Настройки);

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ПоискИУдалениеДублей") Тогда
		МодульПоискИУдалениеДублей = ОбщегоНазначения.ОбщийМодуль("ПоискИУдалениеДублей");
		МодульПоискИУдалениеДублей.ПриНастройкеВариантовОтчетов(Настройки);
	КонецЕсли;

	ПользователиСлужебный.ПриНастройкеВариантовОтчетов(Настройки);

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ПрофилиБезопасности") Тогда
		МодульРаботаВБезопасномРежимеСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаВБезопасномРежимеСлужебный");
		МодульРаботаВБезопасномРежимеСлужебный.ПриНастройкеВариантовОтчетов(Настройки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСФайлами") Тогда
		МодульРаботаСФайламиСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебный");
		МодульРаботаСФайламиСлужебный.ПриНастройкеВариантовОтчетов(Настройки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УправлениеДоступом") Тогда
		МодульУправлениеДоступомСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеДоступомСлужебный");
		МодульУправлениеДоступомСлужебный.ПриНастройкеВариантовОтчетов(Настройки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ОтчетОДвиженияхДокумента") Тогда
		МодульДвиженияДокумента = ОбщегоНазначения.ОбщийМодуль("Отчеты.ДвиженияДокумента");
		МодульДвиженияДокумента.ПриНастройкеВариантовОтчетов(Настройки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ОценкаПроизводительности") Тогда
		МодульОценкаПроизводительностиСлужебный = ОбщегоНазначения.ОбщийМодуль("ОценкаПроизводительностиСлужебный");
		МодульОценкаПроизводительностиСлужебный.ПриНастройкеВариантовОтчетов(Настройки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КонтрольВеденияУчета") Тогда
		МодульРезультатыПроверкиУчета = ОбщегоНазначения.ОбщийМодуль("Отчеты.РезультатыПроверкиУчета");
		МодульРезультатыПроверкиУчета.ПриНастройкеВариантовОтчетов(Настройки);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РассылкаОтчетов") Тогда
		МодульКонтрольРассылкиОтчетов = ОбщегоНазначения.ОбщийМодуль("Отчеты.КонтрольРассылкиОтчетов");
		МодульКонтрольРассылкиОтчетов.ПриНастройкеВариантовОтчетов(Настройки);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриНастройкеВариантовОтчетов Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриНастройкеВариантовОтчетов(Настройки);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриНастройкеВариантовОтчетов Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриНастройкеВариантовОтчетов(Настройки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЭлектроннаяПодписьСервисаDSS") Тогда
		МодульСервисКриптографииDSSСлужебный = ОбщегоНазначения.ОбщийМодуль("СервисКриптографииDSSСлужебный");
		МодульСервисКриптографииDSSСлужебный.ПриНастройкеВариантовОтчетов(Настройки);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЭлектроннаяПодпись") Тогда
		МодульЭлектроннаяПодписьСлужебный = ОбщегоНазначения.ОбщийМодуль("ЭлектроннаяПодписьСлужебный");
		МодульЭлектроннаяПодписьСлужебный.ПриНастройкеВариантовОтчетов(Настройки);
	КонецЕсли;
	
КонецПроцедуры

// См. ВариантыОтчетовПереопределяемый.ЗарегистрироватьИзмененияКлючейВариантовОтчетов.
Процедура ПриИзмененииКлючейВариантовОтчетов(Изменения) Экспорт

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриИзмененииКлючейВариантовОтчетов Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриИзмененииКлючейВариантовОтчетов(Изменения);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриИзмененииКлючейВариантовОтчетов Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриИзмененииКлючейВариантовОтчетов(Изменения);
	КонецЕсли;

КонецПроцедуры

// См. ВариантыОтчетовПереопределяемый.ОпределитьОбъектыСКомандамиОтчетов.
Процедура ПриОпределенииОбъектовСКомандамиОтчетов(Объекты) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Анкетирование") Тогда
		МодульАнкетирование = ОбщегоНазначения.ОбщийМодуль("Анкетирование");
		МодульАнкетирование.ПриОпределенииОбъектовСКомандамиОтчетов(Объекты);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриОпределенииОбъектовСКомандамиОтчетов Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриОпределенииОбъектовСКомандамиОтчетов(Объекты);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриОпределенииОбъектовСКомандамиОтчетов Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриОпределенииОбъектовСКомандамиОтчетов(Объекты);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЭлектроннаяПодпись") Тогда
		МодульСертификатыЭлектроннойПодписи = ОбщегоНазначения.ОбщийМодуль("Отчеты.СертификатыЭлектроннойПодписи");
		МодульСертификатыЭлектроннойПодписи.ПриОпределенииОбъектовСКомандамиОтчетов(Объекты);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЭлектроннаяПодписьСервисаDSS") Тогда
		МодульСервисКриптографииDSSСлужебный = ОбщегоНазначения.ОбщийМодуль("СервисКриптографииDSSСлужебный");
		МодульСервисКриптографииDSSСлужебный.ПриОпределенииОбъектовСКомандамиОтчетов(Объекты);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСФайлами") Тогда
		МодульПроверкаЦелостностиТома = ОбщегоНазначения.ОбщийМодуль("Отчеты.ПроверкаЦелостностиТома");
		МодульПроверкаЦелостностиТома.ПриОпределенииОбъектовСКомандамиОтчетов(Объекты);
		
		МодульОбъемНенужныхФайлов = ОбщегоНазначения.ОбщийМодуль("Отчеты.ОбъемНенужныхФайлов");
		МодульОбъемНенужныхФайлов.ПриОпределенииОбъектовСКомандамиОтчетов(Объекты);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РассылкаОтчетов") Тогда
		МодульКонтрольРассылкиОтчетов = ОбщегоНазначения.ОбщийМодуль("Отчеты.КонтрольРассылкиОтчетов");
		МодульКонтрольРассылкиОтчетов.ПриОпределенииОбъектовСКомандамиОтчетов(Объекты);
	КонецЕсли;
	
КонецПроцедуры

// См. ВариантыОтчетовПереопределяемый.ПередДобавлениемКомандОтчетов.
Процедура ПередДобавлениемКомандОтчетов(КомандыОтчетов, Параметры, СтандартнаяОбработка) Экспорт

	Обработки.ЖурналРегистрации.ПередДобавлениемКомандОтчетов(КомандыОтчетов, Параметры, СтандартнаяОбработка);
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ОтчетОДвиженияхДокумента") Тогда
		МодульДвиженияДокумента = ОбщегоНазначения.ОбщийМодуль("Отчеты.ДвиженияДокумента");
		МодульДвиженияДокумента.ПередДобавлениемКомандОтчетов(КомандыОтчетов, Параметры, СтандартнаяОбработка);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КонтрольВеденияУчета") Тогда
		МодульРезультатыПроверкиУчета = ОбщегоНазначения.ОбщийМодуль("Отчеты.РезультатыПроверкиУчета");
		МодульРезультатыПроверкиУчета.ПередДобавлениемКомандОтчетов(КомандыОтчетов, Параметры,
			СтандартнаяОбработка);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КонтрольРаботыПользователей") Тогда
		МодульКонтрольРаботыПользователейСлужебный = ОбщегоНазначения.ОбщийМодуль("КонтрольРаботыПользователейСлужебный");
		МодульКонтрольРаботыПользователейСлужебный.ПередДобавлениемКомандОтчетов(КомандыОтчетов, Параметры,
			СтандартнаяОбработка);
	КонецЕсли;

	ПользователиСлужебный.ПередДобавлениемКомандОтчетов(КомандыОтчетов, Параметры, СтандартнаяОбработка);

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УправлениеДоступом") Тогда
		МодульУправлениеДоступомСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеДоступомСлужебный");
		МодульУправлениеДоступомСлужебный.ПередДобавлениемКомандОтчетов(КомандыОтчетов, Параметры,
			СтандартнаяОбработка);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПередДобавлениемКомандОтчетов Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПередДобавлениемКомандОтчетов(КомандыОтчетов, Параметры, СтандартнаяОбработка);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПередДобавлениемКомандОтчетов Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПередДобавлениемКомандОтчетов(КомандыОтчетов, Параметры, СтандартнаяОбработка);
	КонецЕсли; 
	
КонецПроцедуры

// См. ОтчетыПереопределяемый.ПриОпределенииПараметровВыбора.
Процедура ПриОпределенииПараметровВыбораВариантыОтчетов(Форма, СвойстваНастройки) Экспорт

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриОпределенииПараметровВыбораВариантыОтчетов Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриОпределенииПараметровВыбораВариантыОтчетов(Форма, СвойстваНастройки);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриОпределенииПараметровВыбораВариантыОтчетов Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриОпределенииПараметровВыбораВариантыОтчетов(Форма, СвойстваНастройки);
	КонецЕсли;

КонецПроцедуры

// См. ОтчетыПереопределяемый.ПриСозданииНаСервере.
Процедура ПриСозданииНаСервереВариантыОтчетов(Форма, Отказ, СтандартнаяОбработка) Экспорт

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриСозданииНаСервереВариантыОтчетов Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриСозданииНаСервереВариантыОтчетов(Форма, Отказ, СтандартнаяОбработка);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриСозданииНаСервереВариантыОтчетов Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриСозданииНаСервереВариантыОтчетов(Форма, Отказ, СтандартнаяОбработка);
	КонецЕсли;

КонецПроцедуры

// См. ОтчетыПереопределяемый.ПередЗагрузкойВариантаНаСервере.
Процедура ПередЗагрузкойВариантаНаСервере(Форма, НовыеНастройкиКД) Экспорт

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПередЗагрузкойВариантаНаСервере Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПередЗагрузкойВариантаНаСервере(Форма, НовыеНастройкиКД);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПередЗагрузкойВариантаНаСервере Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПередЗагрузкойВариантаНаСервере(Форма, НовыеНастройкиКД);
	КонецЕсли;

КонецПроцедуры

#КонецОбласти

#Область ВнешниеКомпоненты

// Параметры:
//  Компоненты - ТаблицаЗначений - список компонент, используемых в конфигурации:
//      * Идентификатор          - Строка - строка длиной 50 символов, идентификатор компоненты.
//      * ОбновлятьАвтоматически - Булево - обновлять из сервиса автоматически.
//
Процедура ПриОпределенииИспользуемыхВнешнихКомпонент(Компоненты) Экспорт
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБПО().ПриОпределенииИспользуемыхВнешнихКомпонент Тогда
		МодульИнтеграцияПодсистемБПО = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБПО");
		МодульИнтеграцияПодсистемБПО.ПриОпределенииИспользуемыхВнешнихКомпонент(Компоненты);
	КонецЕсли;
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБЭД().ПриОпределенииИспользуемыхВнешнихКомпонент Тогда
		МодульИнтеграцияПодсистемБЭД = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБЭД");
		МодульИнтеграцияПодсистемБЭД.ПриОпределенииИспользуемыхВнешнихКомпонент(Компоненты);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЭлектроннаяПодпись") Тогда
		МодульЭлектроннаяПодписьСлужебный = ОбщегоНазначения.ОбщийМодуль("ЭлектроннаяПодписьСлужебный");
		МодульЭлектроннаяПодписьСлужебный.ПриОпределенииИспользуемыхВнешнихКомпонент(Компоненты);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСФайлами") Тогда
		МодульРаботаСФайламиСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебный");
		МодульРаботаСФайламиСлужебный.ПриОпределенииИспользуемыхВнешнихКомпонент(Компоненты);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриОпределенииИспользуемыхВнешнихКомпонент Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриОпределенииИспользуемыхВнешнихКомпонент(Компоненты);
	КонецЕсли;
	
КонецПроцедуры

#КонецОбласти

#Область ГрупповоеИзменениеОбъектов

// См. ГрупповоеИзменениеОбъектовПереопределяемый.ПриОпределенииОбъектовСРедактируемымиРеквизитами.
Процедура ПриОпределенииОбъектовСРедактируемымиРеквизитами(Объекты) Экспорт

	СтандартныеПодсистемыСервер.ПриОпределенииОбъектовСРедактируемымиРеквизитами(Объекты);
	ПользователиСлужебный.ПриОпределенииОбъектовСРедактируемымиРеквизитами(Объекты);

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Анкетирование") Тогда
		МодульАнкетирование = ОбщегоНазначения.ОбщийМодуль("Анкетирование");
		МодульАнкетирование.ПриОпределенииОбъектовСРедактируемымиРеквизитами(Объекты);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Банки") Тогда
		МодульРаботаСБанками = ОбщегоНазначения.ОбщийМодуль("РаботаСБанками");
		МодульРаботаСБанками.ПриОпределенииОбъектовСРедактируемымиРеквизитами(Объекты);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.БизнесПроцессыИЗадачи") Тогда
		МодульБизнесПроцессыИЗадачиСервер = ОбщегоНазначения.ОбщийМодуль("БизнесПроцессыИЗадачиСервер");
		МодульБизнесПроцессыИЗадачиСервер.ПриОпределенииОбъектовСРедактируемымиРеквизитами(Объекты);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Взаимодействия") Тогда
		МодульВзаимодействия = ОбщегоНазначения.ОбщийМодуль("Взаимодействия");
		МодульВзаимодействия.ПриОпределенииОбъектовСРедактируемымиРеквизитами(Объекты);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Валюты") Тогда
		МодульРаботаСКурсамиВалют = ОбщегоНазначения.ОбщийМодуль("РаботаСКурсамиВалют");
		МодульРаботаСКурсамиВалют.ПриОпределенииОбъектовСРедактируемымиРеквизитами(Объекты);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВариантыОтчетов") Тогда
		МодульВариантыОтчетов = ОбщегоНазначения.ОбщийМодуль("ВариантыОтчетов");
		МодульВариантыОтчетов.ПриОпределенииОбъектовСРедактируемымиРеквизитами(Объекты);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВнешниеКомпоненты") Тогда
		МодульВнешниеКомпонентыСлужебный = ОбщегоНазначения.ОбщийМодуль("ВнешниеКомпонентыСлужебный");
		МодульВнешниеКомпонентыСлужебный.ПриОпределенииОбъектовСРедактируемымиРеквизитами(Объекты);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.ВнешниеКомпонентыВМоделиСервиса") Тогда
		МодульВнешниеКомпонентыВМоделиСервисаСлужебный = ОбщегоНазначения.ОбщийМодуль(
			"ВнешниеКомпонентыВМоделиСервисаСлужебный");
		МодульВнешниеКомпонентыВМоделиСервисаСлужебный.ПриОпределенииОбъектовСРедактируемымиРеквизитами(Объекты);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ДополнительныеОтчетыИОбработки") Тогда
		МодульДополнительныеОтчетыИОбработки = ОбщегоНазначения.ОбщийМодуль("ДополнительныеОтчетыИОбработки");
		МодульДополнительныеОтчетыИОбработки.ПриОпределенииОбъектовСРедактируемымиРеквизитами(Объекты);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЗаметкиПользователя") Тогда
		МодульЗаметкиПользователяСлужебный = ОбщегоНазначения.ОбщийМодуль("ЗаметкиПользователяСлужебный");
		МодульЗаметкиПользователяСлужебный.ПриОпределенииОбъектовСРедактируемымиРеквизитами(Объекты);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КонтактнаяИнформация") Тогда
		МодульУправлениеКонтактнойИнформациейСлужебный = ОбщегоНазначения.ОбщийМодуль(
			"УправлениеКонтактнойИнформациейСлужебный");
		МодульУправлениеКонтактнойИнформациейСлужебный.ПриОпределенииОбъектовСРедактируемымиРеквизитами(Объекты);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ОбменДанными") Тогда
		МодульОбменДаннымиСервер = ОбщегоНазначения.ОбщийМодуль("ОбменДаннымиСервер");
		МодульОбменДаннымиСервер.ПриОпределенииОбъектовСРедактируемымиРеквизитами(Объекты);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСФайлами") Тогда
		МодульРаботаСФайламиСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебный");
		МодульРаботаСФайламиСлужебный.ПриОпределенииОбъектовСРедактируемымиРеквизитами(Объекты);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РассылкаОтчетов") Тогда
		МодульРассылкаОтчетов = ОбщегоНазначения.ОбщийМодуль("РассылкаОтчетов");
		МодульРассылкаОтчетов.ПриОпределенииОбъектовСРедактируемымиРеквизитами(Объекты);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСПочтовымиСообщениями") Тогда
		МодульРаботаСПочтовымиСообщениямиСлужебный = ОбщегоНазначения.ОбщийМодуль(
			"РаботаСПочтовымиСообщениямиСлужебный");
		МодульРаботаСПочтовымиСообщениямиСлужебный.ПриОпределенииОбъектовСРедактируемымиРеквизитами(Объекты);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Свойства") Тогда
		МодульУправлениеСвойствамиСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеСвойствамиСлужебный");
		МодульУправлениеСвойствамиСлужебный.ПриОпределенииОбъектовСРедактируемымиРеквизитами(Объекты);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриОпределенииОбъектовСРедактируемымиРеквизитами Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриОпределенииОбъектовСРедактируемымиРеквизитами(Объекты);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УправлениеДоступом") Тогда
		МодульУправлениеДоступомСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеДоступомСлужебный");
		МодульУправлениеДоступомСлужебный.ПриОпределенииОбъектовСРедактируемымиРеквизитами(Объекты);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЭлектроннаяПодпись") Тогда
		МодульЭлектроннаяПодписьСлужебный = ОбщегоНазначения.ОбщийМодуль("ЭлектроннаяПодписьСлужебный");
		МодульЭлектроннаяПодписьСлужебный.ПриОпределенииОбъектовСРедактируемымиРеквизитами(Объекты);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриОпределенииОбъектовСРедактируемымиРеквизитами Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриОпределенииОбъектовСРедактируемымиРеквизитами(Объекты);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЭлектроннаяПодписьСервисаDSS") Тогда
		МодульСервисКриптографииDSSСлужебный = ОбщегоНазначения.ОбщийМодуль("СервисКриптографииDSSСлужебный");
		МодульСервисКриптографииDSSСлужебный.ПриОпределенииОбъектовСРедактируемымиРеквизитами(Объекты);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Печать") Тогда
		МодульУправлениеПечатью = ОбщегоНазначения.ОбщийМодуль("УправлениеПечатью");
		МодульУправлениеПечатью.ПриОпределенииОбъектовСРедактируемымиРеквизитами(Объекты);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриОпределенииОбъектовСРедактируемымиРеквизитами Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриОпределенииОбъектовСРедактируемымиРеквизитами(Объекты);
	КонецЕсли;
		
КонецПроцедуры

// См. ГрупповоеИзменениеОбъектовПереопределяемый.ПриОпределенииРедактируемыхРеквизитовОбъекта.
Процедура ПриОпределенииРедактируемыхРеквизитовОбъекта(Объект, РедактируемыеРеквизиты, НередактируемыеРеквизиты) Экспорт
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриОпределенииРедактируемыхРеквизитовОбъекта Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриОпределенииРедактируемыхРеквизитовОбъекта(Объект, РедактируемыеРеквизиты, НередактируемыеРеквизиты);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриОпределенииРедактируемыхРеквизитовОбъекта Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриОпределенииРедактируемыхРеквизитовОбъекта(Объект, РедактируемыеРеквизиты, НередактируемыеРеквизиты);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриОпределенииРедактируемыхРеквизитовОбъекта Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриОпределенииРедактируемыхРеквизитовОбъекта(Объект, РедактируемыеРеквизиты, НередактируемыеРеквизиты);
	КонецЕсли;
		
КонецПроцедуры

#КонецОбласти

#Область ДатыЗапретаИзменений

// См. ДатыЗапретаИзмененияПереопределяемый.ПриЗаполненииРазделовДатЗапретаИзменения.
Процедура ПриЗаполненииРазделовДатЗапретаИзменения(Разделы) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЗащитаПерсональныхДанных") Тогда
		МодульЗащитаПерсональныхДанных = ОбщегоНазначения.ОбщийМодуль("ЗащитаПерсональныхДанных");
		МодульЗащитаПерсональныхДанных.ПриЗаполненииРазделовДатЗапретаИзменения(Разделы);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриЗаполненииРазделовДатЗапретаИзменения Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриЗаполненииРазделовДатЗапретаИзменения(Разделы);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриЗаполненииРазделовДатЗапретаИзменения Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриЗаполненииРазделовДатЗапретаИзменения(Разделы);
	КонецЕсли;

КонецПроцедуры

// См. ДатыЗапретаИзмененияПереопределяемый.ЗаполнитьИсточникиДанныхДляПроверкиЗапретаИзменения.
Процедура ПриЗаполненииИсточниковДанныхДляПроверкиЗапретаИзменения(ИсточникиДанных) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЗащитаПерсональныхДанных") Тогда
		МодульЗащитаПерсональныхДанных = ОбщегоНазначения.ОбщийМодуль("ЗащитаПерсональныхДанных");
		МодульЗащитаПерсональныхДанных.ПриЗаполненииИсточниковДанныхДляПроверкиЗапретаИзменения(ИсточникиДанных);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриЗаполненииИсточниковДанныхДляПроверкиЗапретаИзменения Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриЗаполненииИсточниковДанныхДляПроверкиЗапретаИзменения(ИсточникиДанных);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриЗаполненииИсточниковДанныхДляПроверкиЗапретаИзменения Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриЗаполненииИсточниковДанныхДляПроверкиЗапретаИзменения(ИсточникиДанных);
	КонецЕсли;

КонецПроцедуры

#КонецОбласти

#Область ДополнительныеОтчетыИОбработки

// Устанавливает режим работы для доп. отчета или обработки.
//
// Параметры:
//   ПоставляемаяОбработка - СправочникСсылка.ПоставляемыеДополнительныеОтчетыИОбработки - доп отчет
//                         или обработка для которой необходимо установить режим работы.
//   РежимПодключения      - ОпределяемыйТип.БезопасныйРежим - режим работы доп. отчета или обработки.
//
Процедура ПриУстановкеРежимаПодключенияДополнительногоОтчетаИлиОбработкиВОбластиДанных(ПоставляемаяОбработка,
	РежимПодключения) Экспорт

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриУстановкеРежимаПодключенияДополнительногоОтчетаИлиОбработкиВОбластиДанных Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриУстановкеРежимаПодключенияДополнительногоОтчетаИлиОбработкиВОбластиДанных(
			ПоставляемаяОбработка, РежимПодключения);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриУстановкеРежимаПодключенияДополнительногоОтчетаИлиОбработкиВОбластиДанных Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриУстановкеРежимаПодключенияДополнительногоОтчетаИлиОбработкиВОбластиДанных(
			ПоставляемаяОбработка, РежимПодключения);
	КонецЕсли;
	
КонецПроцедуры

#Область ДополнительныеОтчетыИОбработки_ДляВнутреннегоИспользования

// Вызывается при определении наличия у текущего пользователя права на добавление дополнительного
// отчета или обработки в область данных.
//
// Параметры:
//  ДополнительнаяОбработка - СправочникОбъект.ДополнительныеОтчетыИОбработки - элемент справочника,
//                            который записывается пользователем.
//  Результат               - Булево - в этот параметр в данной процедуре устанавливается флаг наличия права,
//  СтандартнаяОбработка    - Булево - в этот параметр в данной процедуре устанавливается флаг выполнения
//                            стандартной обработки проверки права.
//
Процедура ПриПроверкеПраваДобавления(Знач ДополнительнаяОбработка, Результат, СтандартнаяОбработка) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.ДополнительныеОтчетыИОбработкиВМоделиСервиса") Тогда

		МодульДополнительныеОтчетыИОбработкиВАвтономномРежиме = ОбщегоНазначения.ОбщийМодуль(
			"ДополнительныеОтчетыИОбработкиВАвтономномРежиме");
		МодульДополнительныеОтчетыИОбработкиВАвтономномРежиме.ПриПроверкеПраваДобавления(ДополнительнаяОбработка,
			Результат, СтандартнаяОбработка);

		Если СтандартнаяОбработка Тогда
			МодульДополнительныеОтчетыИОбработкиВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль(
				"ДополнительныеОтчетыИОбработкиВМоделиСервиса");
			МодульДополнительныеОтчетыИОбработкиВМоделиСервиса.ПриПроверкеПраваДобавления(ДополнительнаяОбработка,
				Результат, СтандартнаяОбработка);
		КонецЕсли;

	КонецЕсли;

КонецПроцедуры

// Вызывается при проверке возможности загрузки дополнительного отчета или обработки из файла.
//
// Параметры:
//  ДополнительнаяОбработка - СправочникСсылка.ДополнительныеОтчетыИОбработки,
//  Результат - Булево - в этот параметр в данной процедуре устанавливается флаг наличия возможности
//    загрузки дополнительного отчета или обработки из файла,
//  СтандартнаяОбработка - Булево - в этот параметр в данной процедуре устанавливается флаг выполнения
//    стандартной обработки проверки возможности загрузки дополнительного отчета или обработки из файла.
//
Процедура ПриПроверкеВозможностиЗагрузкиОбработкиИзФайла(Знач ДополнительнаяОбработка, Результат, СтандартнаяОбработка) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.ДополнительныеОтчетыИОбработкиВМоделиСервиса") Тогда

		МодульДополнительныеОтчетыИОбработкиВАвтономномРежиме = ОбщегоНазначения.ОбщийМодуль(
			"ДополнительныеОтчетыИОбработкиВАвтономномРежиме");
		МодульДополнительныеОтчетыИОбработкиВАвтономномРежиме.ПриПроверкеВозможностиЗагрузкиОбработкиИзФайла(
			ДополнительнаяОбработка, Результат, СтандартнаяОбработка);

		Если СтандартнаяОбработка Тогда
			МодульДополнительныеОтчетыИОбработкиВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль(
				"ДополнительныеОтчетыИОбработкиВМоделиСервиса");
			МодульДополнительныеОтчетыИОбработкиВМоделиСервиса.ПриПроверкеВозможностиЗагрузкиОбработкиИзФайла(
				ДополнительнаяОбработка, Результат, СтандартнаяОбработка);
		КонецЕсли;

	КонецЕсли;

КонецПроцедуры

// Вызывается при проверке возможности выгрузки дополнительного отчета или обработки в файл.
//
// Параметры:
//  ДополнительнаяОбработка - СправочникСсылка.ДополнительныеОтчетыИОбработки,
//  Результат - Булево - в этот параметр в данной процедуре устанавливается флаг наличия возможности
//    выгрузки дополнительного отчета или обработки в файл,
//  СтандартнаяОбработка - Булево - в этот параметр в данной процедуре устанавливается флаг выполнения
//    стандартной обработки проверки возможности выгрузки дополнительного отчета или обработки в файл.
//
Процедура ПриПроверкеВозможностиВыгрузкиОбработкиВФайл(Знач ДополнительнаяОбработка, Результат, СтандартнаяОбработка) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.ДополнительныеОтчетыИОбработкиВМоделиСервиса") Тогда

		МодульДополнительныеОтчетыИОбработкиВАвтономномРежиме = ОбщегоНазначения.ОбщийМодуль(
			"ДополнительныеОтчетыИОбработкиВАвтономномРежиме");
		МодульДополнительныеОтчетыИОбработкиВАвтономномРежиме.ПриПроверкеВозможностиВыгрузкиОбработкиВФайл(
			ДополнительнаяОбработка, Результат, СтандартнаяОбработка);

		Если СтандартнаяОбработка Тогда
			МодульДополнительныеОтчетыИОбработкиВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль(
				"ДополнительныеОтчетыИОбработкиВМоделиСервиса");
			МодульДополнительныеОтчетыИОбработкиВМоделиСервиса.ПриПроверкеВозможностиВыгрузкиОбработкиВФайл(
				ДополнительнаяОбработка, Результат, СтандартнаяОбработка);
		КонецЕсли;

	КонецЕсли;

КонецПроцедуры

// Заполняет виды публикации дополнительных отчетов и обработок, недоступные для использования
// в текущей модели информационной базы.
//
// Параметры:
//  НедоступныеВидыПубликации - Массив из Строка
//
Процедура ПриЗаполненииНедоступныхВидовПубликации(Знач НедоступныеВидыПубликации) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.ДополнительныеОтчетыИОбработкиВМоделиСервиса") Тогда

		МодульДополнительныеОтчетыИОбработкиВАвтономномРежиме = ОбщегоНазначения.ОбщийМодуль(
			"ДополнительныеОтчетыИОбработкиВАвтономномРежиме");
		МодульДополнительныеОтчетыИОбработкиВАвтономномРежиме.ПриЗаполненииНедоступныхВидовПубликации(
			НедоступныеВидыПубликации);

		МодульДополнительныеОтчетыИОбработкиВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль(
			"ДополнительныеОтчетыИОбработкиВМоделиСервиса");
		МодульДополнительныеОтчетыИОбработкиВМоделиСервиса.ПриЗаполненииНедоступныхВидовПубликации(
			НедоступныеВидыПубликации);

	КонецЕсли;

КонецПроцедуры

// Вызывается из события ПередЗаписью справочника
//  ДополнительныеОтчетыИОбработки, выполняет проверку правомерности изменения реквизитов
//  элементов данного справочника для дополнительных обработок, полученных из
//  каталога дополнительных обработок менеджера сервиса.
//
// Параметры:
//  Источник - СправочникОбъект.ДополнительныеОтчетыИОбработки,
//  Отказ - Булево - флаг отказа от выполнения записи элемента справочника.
//
Процедура ПередЗаписьюДополнительнойОбработки(Источник, Отказ) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.ДополнительныеОтчетыИОбработкиВМоделиСервиса") Тогда

		МодульДополнительныеОтчетыИОбработкиВАвтономномРежиме = ОбщегоНазначения.ОбщийМодуль(
			"ДополнительныеОтчетыИОбработкиВАвтономномРежиме");
		МодульДополнительныеОтчетыИОбработкиВАвтономномРежиме.ПередЗаписьюДополнительнойОбработки(Источник, Отказ);

		МодульДополнительныеОтчетыИОбработкиВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль(
			"ДополнительныеОтчетыИОбработкиВМоделиСервиса");
		МодульДополнительныеОтчетыИОбработкиВМоделиСервиса.ПередЗаписьюДополнительнойОбработки(Источник, Отказ);

	КонецЕсли;

КонецПроцедуры

// Вызывается из события ПередУдалением справочника ДополнительныеОтчетыИОбработки.
//
// Параметры:
//  Источник - СправочникОбъект.ДополнительныеОтчетыИОбработки,
//  Отказ - Булево - флаг отказа от выполнения удаления элемента справочника из информационной базы.
//
Процедура ПередУдалениемДополнительнойОбработки(Источник, Отказ) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.ДополнительныеОтчетыИОбработкиВМоделиСервиса") Тогда
		МодульДополнительныеОтчетыИОбработкиВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль(
			"ДополнительныеОтчетыИОбработкиВМоделиСервиса");
		МодульДополнительныеОтчетыИОбработкиВМоделиСервиса.ПередУдалениемДополнительнойОбработки(Источник, Отказ);
	КонецЕсли;

КонецПроцедуры

// Вызывается при получении регистрационных данных для нового дополнительного отчета
// или обработки.
//
Процедура ПриПолученииРегистрационныхДанных(Объект, РегистрационныеДанные, СтандартнаяОбработка) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.ДополнительныеОтчетыИОбработкиВМоделиСервиса") Тогда
		МодульДополнительныеОтчетыИОбработкиВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль(
			"ДополнительныеОтчетыИОбработкиВМоделиСервиса");
		МодульДополнительныеОтчетыИОбработкиВМоделиСервиса.ПриПолученииРегистрационныхДанных(Объект,
			РегистрационныеДанные, СтандартнаяОбработка);
	КонецЕсли;

КонецПроцедуры

// Вызывается при подключении внешней обработки.
//
// Параметры:
//  Ссылка - СправочникСсылка.ДополнительныеОтчетыИОбработки,
//  СтандартнаяОбработка - Булево - флаг необходимости выполнения стандартной обработки подключения
//    внешней обработки,
//  Результат - Строка - имя подключенного внешнего отчета или обработки (в том случае, если в обработчике
//    для параметра СтандартнаяОбработка было установлено значение Ложь).
//
Процедура ПриПодключенииВнешнейОбработки(Знач Ссылка, СтандартнаяОбработка, Результат) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.ДополнительныеОтчетыИОбработкиВМоделиСервиса") Тогда
		МодульДополнительныеОтчетыИОбработкиВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль(
			"ДополнительныеОтчетыИОбработкиВМоделиСервиса");
		МодульДополнительныеОтчетыИОбработкиВМоделиСервиса.ПриПодключенииВнешнейОбработки(Ссылка, СтандартнаяОбработка,
			Результат);
	КонецЕсли;

КонецПроцедуры

// Вызывается при создании объекта внешней обработки.
//
// Параметры:
//  Ссылка - СправочникСсылка.ДополнительныеОтчетыИОбработки,
//  СтандартнаяОбработка - Булево - флаг необходимости выполнения стандартной обработки подключения
//    внешней обработки.
//  Результат - ВнешняяОбработка
//            - ВнешнийОтчет - объект подключенного внешнего отчета или
//    обработки (в том случае, если в обработчике для параметра СтандартнаяОбработка было установлено значение Ложь).
//
Процедура ПриСозданииВнешнейОбработки(Знач Ссылка, СтандартнаяОбработка, Результат) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.ДополнительныеОтчетыИОбработкиВМоделиСервиса") Тогда
		МодульДополнительныеОтчетыИОбработкиВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль(
			"ДополнительныеОтчетыИОбработкиВМоделиСервиса");
		МодульДополнительныеОтчетыИОбработкиВМоделиСервиса.ПриСозданииВнешнейОбработки(Ссылка, СтандартнаяОбработка,
			Результат);
	КонецЕсли;

КонецПроцедуры

// Вызывается перед записью изменений регламентного задания дополнительных отчетов и обработок в модели сервиса.
//
// Параметры:
//   Объект - СправочникОбъект.ДополнительныеОтчетыИОбработки - объект дополнительного отчета или обработки.
//   Команда - СправочникТабличнаяЧастьСтрока.ДополнительныеОтчетыИОбработки.Команды - описание команды.
//   Задание - РегламентноеЗадание
//           - СтрокаТаблицыЗначений - описание регламентного задания.
//       См. описание возвращаемого значения функции РегламентныеЗаданияСервер.Задание().
//   Изменения - Структура - значения реквизитов задания, которые необходимо изменить.
//       См. описание 2го параметра процедуры РегламентныеЗаданияСервер.ИзменитьЗадание().
//       Если установить Неопределено, то регламентное задание не будет изменено.
//
Процедура ПередОбновлениемЗадания(Объект, Команда, Задание, Изменения) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.ДополнительныеОтчетыИОбработкиВМоделиСервиса") Тогда
		МодульДополнительныеОтчетыИОбработкиВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль(
			"ДополнительныеОтчетыИОбработкиВМоделиСервиса");
		МодульДополнительныеОтчетыИОбработкиВМоделиСервиса.ПередОбновлениемЗадания(Объект, Команда, Задание, Изменения);
	КонецЕсли;

КонецПроцедуры

#КонецОбласти

#КонецОбласти

#Область ЗагрузкаДанныхИзФайла

// См. ЗагрузкаДанныхИзФайлаПереопределяемый.ПриОпределенииСправочниковДляЗагрузкиДанных.
Процедура ПриОпределенииСправочниковДляЗагрузкиДанных(ЗагружаемыеСправочники) Экспорт

	СтандартныеПодсистемыСервер.ПриОпределенииСправочниковДляЗагрузкиДанных(ЗагружаемыеСправочники);
	ПользователиСлужебный.ПриОпределенииСправочниковДляЗагрузкиДанных(ЗагружаемыеСправочники);

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КонтактнаяИнформация") Тогда
		МодульУправлениеКонтактнойИнформациейСлужебный = ОбщегоНазначения.ОбщийМодуль(
			"УправлениеКонтактнойИнформациейСлужебный");
		МодульУправлениеКонтактнойИнформациейСлужебный.ПриОпределенииСправочниковДляЗагрузкиДанных(
			ЗагружаемыеСправочники);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Валюты") Тогда
		МодульРаботаСКурсамиВалют = ОбщегоНазначения.ОбщийМодуль("РаботаСКурсамиВалют");
		МодульРаботаСКурсамиВалют.ПриОпределенииСправочниковДляЗагрузкиДанных(ЗагружаемыеСправочники);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.БизнесПроцессыИЗадачи") Тогда
		МодульБизнесПроцессыИЗадачиСервер = ОбщегоНазначения.ОбщийМодуль("БизнесПроцессыИЗадачиСервер");
		МодульБизнесПроцессыИЗадачиСервер.ПриОпределенииСправочниковДляЗагрузкиДанных(ЗагружаемыеСправочники);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Банки") Тогда
		МодульРаботаСБанками = ОбщегоНазначения.ОбщийМодуль("РаботаСБанками");
		МодульРаботаСБанками.ПриОпределенииСправочниковДляЗагрузкиДанных(ЗагружаемыеСправочники);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриОпределенииСправочниковДляЗагрузкиДанных Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриОпределенииСправочниковДляЗагрузкиДанных(ЗагружаемыеСправочники);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВариантыОтчетов") Тогда
		МодульВариантыОтчетов = ОбщегоНазначения.ОбщийМодуль("ВариантыОтчетов");
		МодульВариантыОтчетов.ПриОпределенииСправочниковДляЗагрузкиДанных(ЗагружаемыеСправочники);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЭлектроннаяПодпись") Тогда
		МодульЭлектроннаяПодписьСлужебный = ОбщегоНазначения.ОбщийМодуль("ЭлектроннаяПодписьСлужебный");
		МодульЭлектроннаяПодписьСлужебный.ПриОпределенииСправочниковДляЗагрузкиДанных(ЗагружаемыеСправочники);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Взаимодействия") Тогда
		МодульВзаимодействия = ОбщегоНазначения.ОбщийМодуль("Взаимодействия");
		МодульВзаимодействия.ПриОпределенииСправочниковДляЗагрузкиДанных(ЗагружаемыеСправочники);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УчетОригиналовПервичныхДокументов") Тогда
		МодульУчетОригиналовПервичныхДокументов = ОбщегоНазначения.ОбщийМодуль("УчетОригиналовПервичныхДокументов");
		МодульУчетОригиналовПервичныхДокументов.ПриОпределенииСправочниковДляЗагрузкиДанных(ЗагружаемыеСправочники);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСФайлами") Тогда
		МодульРаботаСФайламиСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебный");
		МодульРаботаСФайламиСлужебный.ПриОпределенииСправочниковДляЗагрузкиДанных(ЗагружаемыеСправочники);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриОпределенииСправочниковДляЗагрузкиДанных Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриОпределенииСправочниковДляЗагрузкиДанных(ЗагружаемыеСправочники);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЭлектроннаяПодписьСервисаDSS") Тогда
		МодульСервисКриптографииDSSСлужебный = ОбщегоНазначения.ОбщийМодуль("СервисКриптографииDSSСлужебный");
		МодульСервисКриптографииDSSСлужебный.ПриОпределенииСправочниковДляЗагрузкиДанных(ЗагружаемыеСправочники);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриОпределенииСправочниковДляЗагрузкиДанных Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриОпределенииСправочниковДляЗагрузкиДанных(ЗагружаемыеСправочники);
	КонецЕсли;
		
КонецПроцедуры

#КонецОбласти

#Область ЗапретРедактированияРеквизитовОбъектов

// См. ЗапретРедактированияРеквизитовОбъектовПереопределяемый.ПриОпределенииОбъектовСЗаблокированнымиРеквизитами.
Процедура ПриОпределенииОбъектовСЗаблокированнымиРеквизитами(Объекты) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КонтактнаяИнформация") Тогда
		МодульУправлениеКонтактнойИнформациейСлужебный = ОбщегоНазначения.ОбщийМодуль(
			"УправлениеКонтактнойИнформациейСлужебный");
		МодульУправлениеКонтактнойИнформациейСлужебный.ПриОпределенииОбъектовСЗаблокированнымиРеквизитами(Объекты);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСФайлами") Тогда
		МодульРаботаСФайламиСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебный");
		МодульРаботаСФайламиСлужебный.ПриОпределенииОбъектовСЗаблокированнымиРеквизитами(Объекты);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Свойства") Тогда
		МодульУправлениеСвойствамиСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеСвойствамиСлужебный");
		МодульУправлениеСвойствамиСлужебный.ПриОпределенииОбъектовСЗаблокированнымиРеквизитами(Объекты);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриОпределенииОбъектовСЗаблокированнымиРеквизитами Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриОпределенииОбъектовСЗаблокированнымиРеквизитами(Объекты);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриОпределенииОбъектовСЗаблокированнымиРеквизитами Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриОпределенииОбъектовСЗаблокированнымиРеквизитами(Объекты);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриОпределенииОбъектовСЗаблокированнымиРеквизитами Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриОпределенииОбъектовСЗаблокированнымиРеквизитами(Объекты);
	КонецЕсли;
	
КонецПроцедуры

#КонецОбласти

#Область ИнтерфейсOData

// См. ВыгрузкаЗагрузкаДанныхПереопределяемый.ПриЗаполненииТиповИсключаемыхИзВыгрузкиЗагрузки.
Процедура ПриЗаполненииТиповИсключаемыхИзВыгрузкиЗагрузкиOData(ИсключаемыеТипы) Экспорт

	ПриЗаполненииТиповИсключаемыхИзВыгрузкиЗагрузки(ИсключаемыеТипы);

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриЗаполненииТиповИсключаемыхИзВыгрузкиЗагрузкиOData Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриЗаполненииТиповИсключаемыхИзВыгрузкиЗагрузкиOData(ИсключаемыеТипы);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриЗаполненииТиповИсключаемыхИзВыгрузкиЗагрузкиOData Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриЗаполненииТиповИсключаемыхИзВыгрузкиЗагрузкиOData(ИсключаемыеТипы);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриЗаполненииТиповИсключаемыхИзВыгрузкиЗагрузкиOData Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриЗаполненииТиповИсключаемыхИзВыгрузкиЗагрузкиOData(ИсключаемыеТипы);
	КонецЕсли;
	
КонецПроцедуры

// См. ИнтерфейсODataПереопределяемый.ПриЗаполненииЗависимыхТаблицДляВыгрузкиЗагрузкиOData
Процедура ПриЗаполненииЗависимыхТаблицДляВыгрузкиЗагрузкиOData(Таблицы) Экспорт
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КонтрольВеденияУчета") Тогда
		МодульКонтрольВеденияУчетаСлужебный = ОбщегоНазначения.ОбщийМодуль("КонтрольВеденияУчетаСлужебный");
		МодульКонтрольВеденияУчетаСлужебный.ПриЗаполненииЗависимыхТаблицДляВыгрузкиЗагрузкиOData(Таблицы);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ОбменДанными") Тогда
		НовоеОписаниеПодсистемы = СтандартныеПодсистемыПовтИсп.НовоеОписаниеПодсистемы();
		МодульОбновлениеИнформационнойБазыБСД = ОбщегоНазначения.ОбщийМодуль("ОбновлениеИнформационнойБазыБСД");
		МодульОбновлениеИнформационнойБазыБСД.ПриДобавленииПодсистемы(НовоеОписаниеПодсистемы);
		Если ОбщегоНазначенияКлиентСервер.СравнитьВерсии(НовоеОписаниеПодсистемы.Версия, "1.0.4.226") >= 0
			И ОбщегоНазначенияКлиентСервер.СравнитьВерсии(НовоеОписаниеПодсистемы.Версия, "1.0.5.0") < 0
			Или ОбщегоНазначенияКлиентСервер.СравнитьВерсии(НовоеОписаниеПодсистемы.Версия, "1.0.5.58") >= 0 Тогда
			МодульОбменДаннымиСобытия = ОбщегоНазначения.ОбщийМодуль("ОбменДаннымиСобытия");
			МодульОбменДаннымиСобытия.ПриЗаполненииЗависимыхТаблицДляВыгрузкиЗагрузкиOData(Таблицы);
		КонецЕсли;
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаВМоделиСервиса.РаботаСФайламиВМоделиСервиса") Тогда
		МодульРаботаСФайламиСлужебныйВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебныйВМоделиСервиса");
		МодульРаботаСФайламиСлужебныйВМоделиСервиса.ПриЗаполненииЗависимыхТаблицДляВыгрузкиЗагрузкиOData(Таблицы);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УдалениеПомеченныхОбъектов") Тогда
		МодульУдалениеПомеченныхОбъектовСлужебный = ОбщегоНазначения.ОбщийМодуль("УдалениеПомеченныхОбъектовСлужебный");
		МодульУдалениеПомеченныхОбъектовСлужебный.ПриЗаполненииЗависимыхТаблицДляВыгрузкиЗагрузкиOData(Таблицы);
	КонецЕсли;
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриЗаполненииЗависимыхТаблицДляВыгрузкиЗагрузкиOData Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриЗаполненииЗависимыхТаблицДляВыгрузкиЗагрузкиOData(Таблицы);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриЗаполненииЗависимыхТаблицДляВыгрузкиЗагрузкиOData Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриЗаполненииЗависимыхТаблицДляВыгрузкиЗагрузкиOData(Таблицы);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриЗаполненииЗависимыхТаблицДляВыгрузкиЗагрузкиOData Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриЗаполненииЗависимыхТаблицДляВыгрузкиЗагрузкиOData(Таблицы);
	КонецЕсли;
		
КонецПроцедуры

#КонецОбласти

#Область КонтрольВеденияУчета

// См. КонтрольВеденияУчетаПереопределяемый.ПриОпределенииПроверок.
Процедура ПриОпределенииПроверок(ГруппыПроверок, Проверки) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСФайлами") Тогда
		МодульРаботаСФайламиСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебный");
		МодульРаботаСФайламиСлужебный.ПриОпределенииПроверок(ГруппыПроверок, Проверки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КонтактнаяИнформация") Тогда
		МодульУправлениеКонтактнойИнформациейСлужебный = ОбщегоНазначения.ОбщийМодуль(
			"УправлениеКонтактнойИнформациейСлужебный");
		МодульУправлениеКонтактнойИнформациейСлужебный.ПриОпределенииПроверок(ГруппыПроверок, Проверки);
	КонецЕсли;
	
	ОбновлениеИнформационнойБазыСлужебный.ПриОпределенииПроверок(ГруппыПроверок, Проверки);

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриОпределенииПроверок Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриОпределенииПроверок(ГруппыПроверок, Проверки);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриОпределенииПроверок Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриОпределенииПроверок(ГруппыПроверок, Проверки);
	КонецЕсли;
	

КонецПроцедуры

// Позволяет определить список объектов, которые нужно игнорировать при выполнении
// системных проверок.
//
// Параметры:
//  Объекты - Массив из ОбъектМетаданных - список объектов.
//
Процедура ПриОпределенииОбъектовИсключаемыхИзПроверки(Объекты) Экспорт
	
	СтандартныеПодсистемыСервер.ПриОпределенииОбъектовИсключаемыхИзПроверки(Объекты);
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УправлениеДоступом") Тогда
		МодульУправлениеДоступомСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеДоступомСлужебный");
		МодульУправлениеДоступомСлужебный.ПриОпределенииОбъектовИсключаемыхИзПроверки(Объекты);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ОбменДанными") Тогда
		МодульОбменДаннымиСервер = ОбщегоНазначения.ОбщийМодуль("ОбменДаннымиСервер");
		МодульОбменДаннымиСервер.ПриОпределенииОбъектовИсключаемыхИзПроверки(Объекты);
	КонецЕсли;

КонецПроцедуры

#КонецОбласти

#Область НапоминанияПользователя

// См. НапоминанияПользователяПереопределяемый.ПриЗаполненииСпискаРеквизитовИсточникаСДатамиДляНапоминания.
Процедура ПриЗаполненииСпискаРеквизитовИсточникаСДатамиДляНапоминания(Источник, РеквизитыСДатами) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.БизнесПроцессыИЗадачи") Тогда
		МодульБизнесПроцессыИЗадачиСервер = ОбщегоНазначения.ОбщийМодуль("БизнесПроцессыИЗадачиСервер");
		МодульБизнесПроцессыИЗадачиСервер.ПриЗаполненииСпискаРеквизитовИсточникаСДатамиДляНапоминания(Источник,
			РеквизитыСДатами);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЗаметкиПользователя") Тогда
		МодульЗаметкиПользователяСлужебный = ОбщегоНазначения.ОбщийМодуль("ЗаметкиПользователяСлужебный");
		МодульЗаметкиПользователяСлужебный.ПриЗаполненииСпискаРеквизитовИсточникаСДатамиДляНапоминания(Источник,
			РеквизитыСДатами);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриЗаполненииСпискаРеквизитовИсточникаСДатамиДляНапоминания Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриЗаполненииСпискаРеквизитовИсточникаСДатамиДляНапоминания(Источник,
			РеквизитыСДатами);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриЗаполненииСпискаРеквизитовИсточникаСДатамиДляНапоминания Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриЗаполненииСпискаРеквизитовИсточникаСДатамиДляНапоминания(Источник,
			РеквизитыСДатами);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриЗаполненииСпискаРеквизитовИсточникаСДатамиДляНапоминания Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриЗаполненииСпискаРеквизитовИсточникаСДатамиДляНапоминания(Источник,
			РеквизитыСДатами);
	КонецЕсли;
	
КонецПроцедуры

#КонецОбласти

#Область НастройкаПорядкаЭлементов

Процедура ПередПеремещениемЭлемента(ПеремещаемыйЭлемент, СоседнийЭлемент, Направление, ТекстОшибки, СтандартнаяОбработка) Экспорт
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УчетОригиналовПервичныхДокументов") Тогда
		МодульУчетОригиналовПервичныхДокументов = ОбщегоНазначения.ОбщийМодуль("УчетОригиналовПервичныхДокументов");
		МодульУчетОригиналовПервичныхДокументов.ПередПеремещениемЭлемента(
			ПеремещаемыйЭлемент, СоседнийЭлемент, Направление, ТекстОшибки, СтандартнаяОбработка);
	КонецЕсли;
	
КонецПроцедуры

#КонецОбласти

#Область ОбменДанными

// См. ОбменДаннымиПереопределяемый.ПриНастройкеПодчиненногоУзлаРИБ.
Процедура ПриНастройкеПодчиненногоУзлаРИБ() Экспорт

	ПользователиСлужебный.ПриНастройкеПодчиненногоУзлаРИБ();

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСПочтовымиСообщениями") Тогда
		МодульРаботаСПочтовымиСообщениямиСлужебный = ОбщегоНазначения.ОбщийМодуль(
			"РаботаСПочтовымиСообщениямиСлужебный");
		МодульРаботаСПочтовымиСообщениямиСлужебный.ПриНастройкеПодчиненногоУзлаРИБ();
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСФайлами") Тогда
		МодульРаботаСФайламиСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебный");
		МодульРаботаСФайламиСлужебный.ПриНастройкеПодчиненногоУзлаРИБ();
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РегламентныеЗадания") Тогда
		МодульРегламентныеЗаданияСлужебный = ОбщегоНазначения.ОбщийМодуль("РегламентныеЗаданияСлужебный");
		МодульРегламентныеЗаданияСлужебный.ПриНастройкеПодчиненногоУзлаРИБ();
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УправлениеДоступом") Тогда
		МодульУправлениеДоступомСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеДоступомСлужебный");
		МодульУправлениеДоступомСлужебный.ПриНастройкеПодчиненногоУзлаРИБ();
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриНастройкеПодчиненногоУзлаРИБ Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриНастройкеПодчиненногоУзлаРИБ();
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриНастройкеПодчиненногоУзлаРИБ Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриНастройкеПодчиненногоУзлаРИБ();
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриНастройкеПодчиненногоУзлаРИБ Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриНастройкеПодчиненногоУзлаРИБ();
	КонецЕсли;
	
КонецПроцедуры

#КонецОбласти

#Область ОбновлениеВерсииИБ

// См. ОбновлениеИнформационнойБазыБСП.ПриДобавленииОбработчиковОбновления.
Процедура ПриДобавленииОбработчиковОбновления(Обработчики) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.АдресныйКлассификатор") Тогда
		МодульАдресныйКлассификаторСлужебный = ОбщегоНазначения.ОбщийМодуль("АдресныйКлассификаторСлужебный");
		МодульАдресныйКлассификаторСлужебный.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Анкетирование") Тогда
		МодульАнкетирование = ОбщегоНазначения.ОбщийМодуль("Анкетирование");
		МодульАнкетирование.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Банки") Тогда
		МодульРаботаСБанкамиСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСБанкамиСлужебный");
		МодульРаботаСБанкамиСлужебный.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.БизнесПроцессыИЗадачи") Тогда
		МодульБизнесПроцессыИЗадачиСервер = ОбщегоНазначения.ОбщийМодуль("БизнесПроцессыИЗадачиСервер");
		МодульБизнесПроцессыИЗадачиСервер.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Валюты") Тогда
		МодульРаботаСКурсамиВалют = ОбщегоНазначения.ОбщийМодуль("РаботаСКурсамиВалют");
		МодульРаботаСКурсамиВалют.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВариантыОтчетов") Тогда
		МодульВариантыОтчетов = ОбщегоНазначения.ОбщийМодуль("ВариантыОтчетов");
		МодульВариантыОтчетов.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВерсионированиеОбъектов") Тогда
		МодульВерсионированиеОбъектов = ОбщегоНазначения.ОбщийМодуль("ВерсионированиеОбъектов");
		МодульВерсионированиеОбъектов.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Взаимодействия") Тогда
		МодульВзаимодействия = ОбщегоНазначения.ОбщийМодуль("Взаимодействия");
		МодульВзаимодействия.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВнешниеКомпоненты") Тогда
		МодульВнешниеКомпонентыСлужебный = ОбщегоНазначения.ОбщийМодуль("ВнешниеКомпонентыСлужебный");
		МодульВнешниеКомпонентыСлужебный.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ГрафикиРаботы") Тогда
		МодульГрафикиРаботы = ОбщегоНазначения.ОбщийМодуль("ГрафикиРаботы");
		МодульГрафикиРаботы.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ДатыЗапретаИзменения") Тогда
		МодульДатыЗапретаИзмененияСлужебный = ОбщегоНазначения.ОбщийМодуль("ДатыЗапретаИзмененияСлужебный");
		МодульДатыЗапретаИзмененияСлужебный.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЗащитаПерсональныхДанных") Тогда
		МодульЗащитаПерсональныхДанных = ОбщегоНазначения.ОбщийМодуль("ЗащитаПерсональныхДанных");
		МодульЗащитаПерсональныхДанных.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ИнформацияПриЗапуске") Тогда
		МодульИнформацияПриЗапуске = ОбщегоНазначения.ОбщийМодуль("ИнформацияПриЗапуске");
		МодульИнформацияПриЗапуске.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КалендарныеГрафики") Тогда
		МодульКалендарныеГрафики = ОбщегоНазначения.ОбщийМодуль("КалендарныеГрафики");
		МодульКалендарныеГрафики.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КонтактнаяИнформация") Тогда
		МодульУправлениеКонтактнойИнформациейСлужебный = ОбщегоНазначения.ОбщийМодуль(
			"УправлениеКонтактнойИнформациейСлужебный");
		МодульУправлениеКонтактнойИнформациейСлужебный.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КонтрольВеденияУчета") Тогда
		МодульКонтрольВеденияУчетаСлужебный = ОбщегоНазначения.ОбщийМодуль("КонтрольВеденияУчетаСлужебный");
		МодульКонтрольВеденияУчетаСлужебный.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.МашиночитаемыеДоверенности") Тогда
		МодульМашиночитаемыеДоверенностиФНССлужебный = ОбщегоНазначения.ОбщийМодуль("МашиночитаемыеДоверенностиФНССлужебный");
		МодульМашиночитаемыеДоверенностиФНССлужебный.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Мультиязычность") Тогда
		МодульМультиязычностьСервер = ОбщегоНазначения.ОбщийМодуль("МультиязычностьСервер");
		МодульМультиязычностьСервер.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ОбменДанными") Тогда
		МодульОбменДаннымиСервер = ОбщегоНазначения.ОбщийМодуль("ОбменДаннымиСервер");
		МодульОбменДаннымиСервер.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;

	ОбновлениеИнформационнойБазыСлужебный.ПриДобавленииОбработчиковОбновления(Обработчики);

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Обсуждения") Тогда
		МодульОбсужденияСлужебный =  ОбщегоНазначения.ОбщийМодуль("ОбсужденияСлужебный");
		МодульОбсужденияСлужебный.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ОценкаПроизводительности") Тогда
		МодульОценкаПроизводительностиСлужебный = ОбщегоНазначения.ОбщийМодуль("ОценкаПроизводительностиСлужебный");
		МодульОценкаПроизводительностиСлужебный.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Печать") Тогда
		МодульУправлениеПечатью = ОбщегоНазначения.ОбщийМодуль("УправлениеПечатью");
		МодульУправлениеПечатью.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ПодключаемыеКоманды") Тогда
		МодульПодключаемыеКоманды = ОбщегоНазначения.ОбщийМодуль("ПодключаемыеКоманды");
		МодульПодключаемыеКоманды.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ПолнотекстовыйПоиск") Тогда
		МодульПолнотекстовыйПоискСервер = ОбщегоНазначения.ОбщийМодуль("ПолнотекстовыйПоискСервер");
		МодульПолнотекстовыйПоискСервер.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;

	ПользователиСлужебный.ПриДобавленииОбработчиковОбновления(Обработчики);

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаВМоделиСервиса.ОбменДаннымиВМоделиСервиса") Тогда
		МодульОбменДаннымиВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("ОбменДаннымиВМоделиСервиса");
		МодульОбменДаннымиВМоделиСервиса.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаВМоделиСервиса.ВнешниеКомпонентыВМоделиСервиса") Тогда
		МодульВнешниеКомпонентыВМоделиСервисаСлужебный = ОбщегоНазначения.ОбщийМодуль("ВнешниеКомпонентыВМоделиСервисаСлужебный");
		МодульВнешниеКомпонентыВМоделиСервисаСлужебный.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСПочтовымиСообщениями") Тогда
		МодульРаботаСПочтовымиСообщениямиСлужебный = ОбщегоНазначения.ОбщийМодуль(
			"РаботаСПочтовымиСообщениямиСлужебный");
		МодульРаботаСПочтовымиСообщениямиСлужебный.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСФайлами") Тогда
		МодульРаботаСФайламиСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебный");
		МодульРаботаСФайламиСлужебный.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РассылкаОтчетов") Тогда
		МодульРассылкаОтчетов = ОбщегоНазначения.ОбщийМодуль("РассылкаОтчетов");
		МодульРассылкаОтчетов.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РегламентныеЗадания") Тогда
		МодульРегламентныеЗаданияСлужебный = ОбщегоНазначения.ОбщийМодуль("РегламентныеЗаданияСлужебный");
		МодульРегламентныеЗаданияСлужебный.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Свойства") Тогда
		МодульУправлениеСвойствамиСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеСвойствамиСлужебный");
		МодульУправлениеСвойствамиСлужебный.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;

	СтандартныеПодсистемыСервер.ПриДобавленииОбработчиковОбновления(Обработчики);

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УдалениеПомеченныхОбъектов") Тогда
		МодульУдалениеПомеченныхОбъектовСлужебный = ОбщегоНазначения.ОбщийМодуль("УдалениеПомеченныхОбъектовСлужебный");
		МодульУдалениеПомеченныхОбъектовСлужебный.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УправлениеДоступом") Тогда
		МодульУправлениеДоступомСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеДоступомСлужебный");
		МодульУправлениеДоступомСлужебный.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УправлениеИтогамиИАгрегатами") Тогда
		МодульУправлениеИтогамиИАгрегатамиСлужебный = ОбщегоНазначения.ОбщийМодуль(
			"УправлениеИтогамиИАгрегатамиСлужебный");
		МодульУправлениеИтогамиИАгрегатамиСлужебный.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УчетОригиналовПервичныхДокументов") Тогда
		МодульУчетОригиналовПервичныхДокументов = ОбщегоНазначения.ОбщийМодуль("УчетОригиналовПервичныхДокументов");
		МодульУчетОригиналовПервичныхДокументов.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЦентрМониторинга") Тогда
		МодульЦентрМониторингаСлужебный = ОбщегоНазначения.ОбщийМодуль("ЦентрМониторингаСлужебный");
		МодульЦентрМониторингаСлужебный.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ШаблоныСообщений") Тогда
		МодульШаблоныСообщенийСлужебный = ОбщегоНазначения.ОбщийМодуль("ШаблоныСообщенийСлужебный");
		МодульШаблоныСообщенийСлужебный.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЭлектроннаяПодпись") Тогда
		МодульЭлектроннаяПодписьСлужебный = ОбщегоНазначения.ОбщийМодуль("ЭлектроннаяПодписьСлужебный");
		МодульЭлектроннаяПодписьСлужебный.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриДобавленииОбработчиковОбновления Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаВМоделиСервиса.УправлениеДоступомВМоделиСервиса") Тогда
		МодульУправлениеДоступомСлужебныйВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль(
			"УправлениеДоступомСлужебныйВМоделиСервиса");
		МодульУправлениеДоступомСлужебныйВМоделиСервиса.ПриДобавленииОбработчиковОбновления(Обработчики);
	КонецЕсли;
	
КонецПроцедуры

// См. ОбновлениеИнформационнойБазыБСП.ПриДобавленииОбработчиковПереходаСДругойПрограммы.
Процедура ПриДобавленииОбработчиковПереходаСДругойПрограммы(Обработчики) Экспорт
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Свойства") Тогда
		МодульУправлениеСвойствамиСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеСвойствамиСлужебный");
		МодульУправлениеСвойствамиСлужебный.ПриДобавленииОбработчиковПереходаСДругойПрограммы(Обработчики);
	КонецЕсли;
	
КонецПроцедуры

// См. ОбновлениеИнформационнойБазыБСП.ПослеОбновленияИнформационнойБазы.
Процедура ПослеОбновленияИнформационнойБазы(Знач ПредыдущаяВерсия, Знач ТекущаяВерсия, Знач ВыполненныеОбработчики,
	ВыводитьОписаниеОбновлений, МонопольныйРежим) Экспорт
	
	ПользователиСлужебный.ПослеОбновленияИнформационнойБазы(ПредыдущаяВерсия, ТекущаяВерсия,
		ВыполненныеОбработчики, ВыводитьОписаниеОбновлений, МонопольныйРежим);
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ИнформацияПриЗапуске") Тогда
		МодульИнформацияПриЗапуске = ОбщегоНазначения.ОбщийМодуль("ИнформацияПриЗапуске");
		МодульИнформацияПриЗапуске.ПослеОбновленияИнформационнойБазы(ПредыдущаяВерсия, ТекущаяВерсия,
			ВыполненныеОбработчики, ВыводитьОписаниеОбновлений, МонопольныйРежим);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УправлениеИтогамиИАгрегатами") Тогда
		МодульУправлениеИтогамиИАгрегатамиСлужебный = ОбщегоНазначения.ОбщийМодуль(
			"УправлениеИтогамиИАгрегатамиСлужебный");
		МодульУправлениеИтогамиИАгрегатамиСлужебный.ПослеОбновленияИнформационнойБазы(ПредыдущаяВерсия, ТекущаяВерсия,
			ВыполненныеОбработчики, ВыводитьОписаниеОбновлений, МонопольныйРежим);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.ОбновлениеВерсииИБВМоделиСервиса") Тогда
		МодульОбновлениеИнформационнойБазыСлужебныйВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль(
			"ОбновлениеИнформационнойБазыСлужебныйВМоделиСервиса");
		МодульОбновлениеИнформационнойБазыСлужебныйВМоделиСервиса.ПослеОбновленияИнформационнойБазы(ПредыдущаяВерсия,
			ТекущаяВерсия, ВыполненныеОбработчики, ВыводитьОписаниеОбновлений, МонопольныйРежим);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УправлениеДоступом") Тогда
		МодульУправлениеДоступомСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеДоступомСлужебный");
		МодульУправлениеДоступомСлужебный.ПослеОбновленияИнформационнойБазы(ПредыдущаяВерсия, ТекущаяВерсия,
			ВыполненныеОбработчики, ВыводитьОписаниеОбновлений, МонопольныйРежим);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПослеОбновленияИнформационнойБазы Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПослеОбновленияИнформационнойБазы(ПредыдущаяВерсия, ТекущаяВерсия,
			ВыполненныеОбработчики, ВыводитьОписаниеОбновлений, МонопольныйРежим);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПослеОбновленияИнформационнойБазы Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПослеОбновленияИнформационнойБазы(ПредыдущаяВерсия, ТекущаяВерсия,
			ВыполненныеОбработчики, ВыводитьОписаниеОбновлений, МонопольныйРежим);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПослеОбновленияИнформационнойБазы Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПослеОбновленияИнформационнойБазы(ПредыдущаяВерсия, ТекущаяВерсия,
			ВыполненныеОбработчики, ВыводитьОписаниеОбновлений, МонопольныйРежим);
	КонецЕсли;
	
КонецПроцедуры

// Позволяет переопределить приоритет обновления, по умолчанию получаемый из константы СведенияОбОбновленииИБ.
// Например, БТС может переопределить приоритет обновления для каждой области данных в режиме сервиса.
//
// Параметры:
//  Приоритет - Строка - новое значение приоритета обновления (возвращаемое):
//              "РаботаПользователей" - приоритет на обработку пользователей (в один поток);
//              "ОбработкаДанных" - приоритет на обработку данных (в несколько потоков);
//              Любое другое - использовать приоритет из константы СведенияОбОбновленииИБ (не переопределять).
//
Процедура ПриПолученииПриоритетаОбновления(Приоритет) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.ОбновлениеВерсииИБВМоделиСервиса") Тогда
		МодульОбновлениеИнформационнойБазыСлужебныйВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль(
			"ОбновлениеИнформационнойБазыСлужебныйВМоделиСервиса");
		МодульОбновлениеИнформационнойБазыСлужебныйВМоделиСервиса.ПриПолученииПриоритетаОбновления(Приоритет);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриПолученииПриоритетаОбновления Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриПолученииПриоритетаОбновления(Приоритет);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриПолученииПриоритетаОбновления Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриПолученииПриоритетаОбновления(Приоритет);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриПолученииПриоритетаОбновления Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриПолученииПриоритетаОбновления(Приоритет);
	КонецЕсли;
	
КонецПроцедуры

// См. ОбновлениеИнформационнойБазыПереопределяемый.ПриЗаполненииОбъектовПланируемыхКУдалению.
Процедура ПриЗаполненииОбъектовПланируемыхКУдалению(Объекты) Экспорт
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УправлениеДоступом") Тогда
		МодульУправлениеДоступомСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеДоступомСлужебный");
		МодульУправлениеДоступомСлужебный.ПриЗаполненииОбъектовПланируемыхКУдалению(Объекты);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриЗаполненииОбъектовПланируемыхКУдалению Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриЗаполненииОбъектовПланируемыхКУдалению(Объекты);
	КонецЕсли;
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриЗаполненииОбъектовПланируемыхКУдалению Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриЗаполненииОбъектовПланируемыхКУдалению(Объекты);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриЗаполненииОбъектовПланируемыхКУдалению Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриЗаполненииОбъектовПланируемыхКУдалению(Объекты);
	КонецЕсли;
		
КонецПроцедуры

#КонецОбласти

#Область Печать

// См. УправлениеПечатьюПереопределяемый.ПриОпределенииНастроекПечати.
Процедура ПриОпределенииНастроекПечати(НастройкиПечати) Экспорт
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЗащитаПерсональныхДанных") Тогда
		МодульЗащитаПерсональныхДанных = ОбщегоНазначения.ОбщийМодуль("ЗащитаПерсональныхДанных");
		МодульЗащитаПерсональныхДанных.ПриОпределенииНастроекПечати(НастройкиПечати);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.МашиночитаемыеДоверенности") Тогда
		МодульМашиночитаемыеДоверенностиФНССлужебный = ОбщегоНазначения.ОбщийМодуль("МашиночитаемыеДоверенностиФНССлужебный");
		МодульМашиночитаемыеДоверенностиФНССлужебный.ПриОпределенииНастроекПечати(НастройкиПечати);
	КонецЕсли;
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриОпределенииНастроекПечати Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриОпределенииНастроекПечати(НастройкиПечати);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриОпределенииНастроекПечати Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриОпределенииНастроекПечати(НастройкиПечати);
	КонецЕсли;
	
КонецПроцедуры

// См. УправлениеПечатьюПереопределяемый.ПередДобавлениемКомандПечати.
Процедура ПередДобавлениемКомандПечати(ИмяФормы, КомандыПечати, СтандартнаяОбработка) Экспорт

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПередДобавлениемКомандПечати Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПередДобавлениемКомандПечати(ИмяФормы, КомандыПечати, СтандартнаяОбработка);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПередДобавлениемКомандПечати Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПередДобавлениемКомандПечати(ИмяФормы, КомандыПечати, СтандартнаяОбработка);
	КонецЕсли;

КонецПроцедуры

// См. УправлениеПечатьюПереопределяемый.ПриПолученииНастроекСпискаКомандПечати.
Процедура ПриПолученииНастроекСпискаКомандПечати(НастройкиСписка) Экспорт

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриПолученииНастроекСпискаКомандПечати Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриПолученииНастроекСпискаКомандПечати(НастройкиСписка);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриПолученииНастроекСпискаКомандПечати Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриПолученииНастроекСпискаКомандПечати(НастройкиСписка);
	КонецЕсли;

КонецПроцедуры

// См. УправлениеПечатьюПереопределяемый.ПриПечати.
Процедура ПриПечати(МассивОбъектов, ПараметрыПечати, КоллекцияПечатныхФорм, ОбъектыПечати, ПараметрыВывода) Экспорт

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриПечати Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриПечати(
			МассивОбъектов, ПараметрыПечати, КоллекцияПечатныхФорм, ОбъектыПечати, ПараметрыВывода);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриПечати Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриПечати(
			МассивОбъектов, ПараметрыПечати, КоллекцияПечатныхФорм, ОбъектыПечати, ПараметрыВывода);
	КонецЕсли;

КонецПроцедуры

// См. УправлениеПечатьюПереопределяемый.ПередОтправкойПоПочте.
Процедура ПередОтправкойПоПочте(ПараметрыОтправки, ПараметрыВывода, ОбъектыПечати, ПечатныеФормы) Экспорт

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПередОтправкойПоПочте Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПередОтправкойПоПочте(ПараметрыОтправки, ПараметрыВывода, ОбъектыПечати,
			ПечатныеФормы);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПередОтправкойПоПочте Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПередОтправкойПоПочте(ПараметрыОтправки, ПараметрыВывода, ОбъектыПечати,
			ПечатныеФормы);
	КонецЕсли;

КонецПроцедуры

// См. УправлениеПечатьюПереопределяемый.ПриПолученииПодписейИПечатей.
Процедура ПриПолученииПодписейИПечатей(Документы, ПодписиИПечати) Экспорт

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриПолученииПодписейИПечатей Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриПолученииПодписейИПечатей(Документы, ПодписиИПечати);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриПолученииПодписейИПечатей Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриПолученииПодписейИПечатей(Документы, ПодписиИПечати);
	КонецЕсли;

КонецПроцедуры

// См. УправлениеПечатьюПереопределяемый.ПечатьДокументовПриСозданииНаСервере.
Процедура ПечатьДокументовПриСозданииНаСервере(Форма, Отказ, СтандартнаяОбработка) Экспорт

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПечатьДокументовПриСозданииНаСервере Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПечатьДокументовПриСозданииНаСервере(Форма, Отказ, СтандартнаяОбработка);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПечатьДокументовПриСозданииНаСервере Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПечатьДокументовПриСозданииНаСервере(Форма, Отказ, СтандартнаяОбработка);
	КонецЕсли;
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБЭД().ПечатьДокументовПриСозданииНаСервере Тогда
		МодульИнтеграцияПодсистемБЭД = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБЭД");
		МодульИнтеграцияПодсистемБЭД.ПечатьДокументовПриСозданииНаСервере(Форма, Отказ, СтандартнаяОбработка);
	КонецЕсли;

КонецПроцедуры

// См. УправлениеПечатьюПереопределяемый.ПечатьДокументовПриЗагрузкеДанныхИзНастроекНаСервере.
Процедура ПечатьДокументовПриЗагрузкеДанныхИзНастроекНаСервере(Форма, Настройки) Экспорт

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПечатьДокументовПриЗагрузкеДанныхИзНастроекНаСервере Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПечатьДокументовПриЗагрузкеДанныхИзНастроекНаСервере(Форма, Настройки);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПечатьДокументовПриЗагрузкеДанныхИзНастроекНаСервере Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПечатьДокументовПриЗагрузкеДанныхИзНастроекНаСервере(Форма, Настройки);
	КонецЕсли;

КонецПроцедуры

// См. УправлениеПечатьюПереопределяемый.ПечатьДокументовПриСохраненииДанныхВНастройкахНаСервере.
Процедура ПечатьДокументовПриСохраненииДанныхВНастройкахНаСервере(Форма, Настройки) Экспорт

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПечатьДокументовПриСохраненииДанныхВНастройкахНаСервере Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПечатьДокументовПриСохраненииДанныхВНастройкахНаСервере(Форма, Настройки);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПечатьДокументовПриСохраненииДанныхВНастройкахНаСервере Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПечатьДокументовПриСохраненииДанныхВНастройкахНаСервере(Форма, Настройки);
	КонецЕсли;

КонецПроцедуры

// См. УправлениеПечатьюПереопределяемый.ПечатьДокументовПриВыполненииКоманды.
Процедура ПечатьДокументовПриВыполненииКоманды(Форма, ДополнительныеПараметры) Экспорт

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПечатьДокументовПриВыполненииКоманды Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПечатьДокументовПриВыполненииКоманды(Форма, ДополнительныеПараметры);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПечатьДокументовПриВыполненииКоманды Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПечатьДокументовПриВыполненииКоманды(Форма, ДополнительныеПараметры);
	КонецЕсли;
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБЭД().ПечатьДокументовПриВыполненииКоманды Тогда
		МодульИнтеграцияПодсистемБЭД = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБЭД");
		МодульИнтеграцияПодсистемБЭД.ПечатьДокументовПриВыполненииКоманды(Форма, ДополнительныеПараметры);
	КонецЕсли;

КонецПроцедуры

// См. УправлениеПечатьюПереопределяемый.ПриОпределенииИсточниковДанныхПечати
Процедура ПриОпределенииИсточниковДанныхПечати(Объект, ИсточникиДанныхПечати) Экспорт
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриОпределенииИсточниковДанныхПечати Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриОпределенииИсточниковДанныхПечати(Объект, ИсточникиДанныхПечати);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриОпределенииИсточниковДанныхПечати Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриОпределенииИсточниковДанныхПечати(Объект, ИсточникиДанныхПечати);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЗащитаПерсональныхДанных") Тогда
		МодульЗащитаПерсональныхДанных = ОбщегоНазначения.ОбщийМодуль("ЗащитаПерсональныхДанных");
		МодульЗащитаПерсональныхДанных.ПриОпределенииИсточниковДанныхПечати(Объект, ИсточникиДанныхПечати);
	КонецЕсли;
	
КонецПроцедуры

// См. УправлениеПечатьюПереопределяемый.ПриПодготовкеДанныхПечати
Процедура ПриПодготовкеДанныхПечати(ИсточникиДанных, ВнешниеНаборыДанных, ИдентификаторСхемыКомпоновкиДанных, КодЯзыка,
	ДополнительныеПараметры) Экспорт
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.СклонениеПредставленийОбъектов") Тогда
		МодульСклонениеПредставленийОбъектов = ОбщегоНазначения.ОбщийМодуль("СклонениеПредставленийОбъектов");
		МодульСклонениеПредставленийОбъектов.ПриПодготовкеДанныхПечати(ИсточникиДанных, ВнешниеНаборыДанных,
			ИдентификаторСхемыКомпоновкиДанных, КодЯзыка, ДополнительныеПараметры);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Валюты") Тогда
		МодульРаботаСКурсамиВалют = ОбщегоНазначения.ОбщийМодуль("РаботаСКурсамиВалют");
		МодульРаботаСКурсамиВалют.ПриПодготовкеДанныхПечати(ИсточникиДанных, ВнешниеНаборыДанных,
			ИдентификаторСхемыКомпоновкиДанных, КодЯзыка, ДополнительныеПараметры);
	КонецЕсли;	
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриПодготовкеДанныхПечати Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриПодготовкеДанныхПечати(ИсточникиДанных, ВнешниеНаборыДанных,
			ИдентификаторСхемыКомпоновкиДанных, КодЯзыка, ДополнительныеПараметры);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриПодготовкеДанныхПечати Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриПодготовкеДанныхПечати(ИсточникиДанных, ВнешниеНаборыДанных,
			 ИдентификаторСхемыКомпоновкиДанных, КодЯзыка, ДополнительныеПараметры);
	КонецЕсли;
	
КонецПроцедуры

#Область Печать_ДляВнутреннегоИспользования

Процедура ПриПодготовкеСпискаМакетовВФорматеОфисныхДокументовФормируемыхНаСервере(СписокМакетов) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЗащитаПерсональныхДанных") Тогда
		МодульЗащитаПерсональныхДанных = ОбщегоНазначения.ОбщийМодуль("ЗащитаПерсональныхДанных");
		МодульЗащитаПерсональныхДанных.ПриПодготовкеСпискаМакетовВФорматеОфисныхДокументовФормируемыхНаСервере(
			СписокМакетов);
	КонецЕсли;

КонецПроцедуры

#КонецОбласти

#КонецОбласти

#Область ПодключаемыеКоманды

// См. ПодключаемыеКомандыПереопределяемый.ПриОпределенииВидовПодключаемыхКоманд
Процедура ПриОпределенииВидовПодключаемыхКоманд(ВидыПодключаемыхКоманд) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Печать") Тогда
		МодульУправлениеПечатью = ОбщегоНазначения.ОбщийМодуль("УправлениеПечатью");
		МодульУправлениеПечатью.ПриОпределенииВидовПодключаемыхКоманд(ВидыПодключаемыхКоманд);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВариантыОтчетов") Тогда
		МодульВариантыОтчетов = ОбщегоНазначения.ОбщийМодуль("ВариантыОтчетов");
		МодульВариантыОтчетов.ПриОпределенииВидовПодключаемыхКоманд(ВидыПодключаемыхКоманд);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ДополнительныеОтчетыИОбработки") Тогда
		МодульДополнительныеОтчетыИОбработки = ОбщегоНазначения.ОбщийМодуль("ДополнительныеОтчетыИОбработки");
		МодульДополнительныеОтчетыИОбработки.ПриОпределенииВидовПодключаемыхКоманд(ВидыПодключаемыхКоманд);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.НастройкаПорядкаЭлементов") Тогда
		МодульНастройкаПорядкаЭлементов = ОбщегоНазначения.ОбщийМодуль("НастройкаПорядкаЭлементов");
		МодульНастройкаПорядкаЭлементов.ПриОпределенииВидовПодключаемыхКоманд(ВидыПодключаемыхКоманд);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ПоискИУдалениеДублей") Тогда
		МодульПоискИУдалениеДублей = ОбщегоНазначения.ОбщийМодуль("ПоискИУдалениеДублей");
		МодульПоискИУдалениеДублей.ПриОпределенииВидовПодключаемыхКоманд(ВидыПодключаемыхКоманд);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ГрупповоеИзменениеОбъектов") Тогда
		МодульГрупповоеИзменениеОбъектов = ОбщегоНазначения.ОбщийМодуль("ГрупповоеИзменениеОбъектов");
		МодульГрупповоеИзменениеОбъектов.ПриОпределенииВидовПодключаемыхКоманд(ВидыПодключаемыхКоманд);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриОпределенииВидовПодключаемыхКоманд Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриОпределенииВидовПодключаемыхКоманд(ВидыПодключаемыхКоманд);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриОпределенииВидовПодключаемыхКоманд Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриОпределенииВидовПодключаемыхКоманд(ВидыПодключаемыхКоманд);
	КонецЕсли;
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБЭД().ПриОпределенииВидовПодключаемыхКоманд Тогда
		МодульИнтеграцияПодсистемБЭД = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБЭД");
		МодульИнтеграцияПодсистемБЭД.ПриОпределенииВидовПодключаемыхКоманд(ВидыПодключаемыхКоманд);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УдалениеПомеченныхОбъектов") Тогда
		МодульУдалениеПомеченныхОбъектовСлужебный = ОбщегоНазначения.ОбщийМодуль("УдалениеПомеченныхОбъектовСлужебный");
		МодульУдалениеПомеченныхОбъектовСлужебный.ПриОпределенииВидовПодключаемыхКоманд(ВидыПодключаемыхКоманд);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.СтруктураПодчиненности") Тогда
		МодульСтруктураПодчиненностиСлужебный = ОбщегоНазначения.ОбщийМодуль("СтруктураПодчиненностиСлужебный");
		МодульСтруктураПодчиненностиСлужебный.ПриОпределенииВидовПодключаемыхКоманд(ВидыПодключаемыхКоманд);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УчетОригиналовПервичныхДокументов") Тогда
		МодульУчетОригиналовПервичныхДокументов = ОбщегоНазначения.ОбщийМодуль("УчетОригиналовПервичныхДокументов");
		МодульУчетОригиналовПервичныхДокументов.ПриОпределенииВидовПодключаемыхКоманд(ВидыПодключаемыхКоманд);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВыгрузкаОбъектовВФайлы") Тогда
		МодульВыгрузкаОбъектовВФайлы = ОбщегоНазначения.ОбщийМодуль("ВыгрузкаОбъектовВФайлы");
		МодульВыгрузкаОбъектовВФайлы.ПриОпределенииВидовПодключаемыхКоманд(ВидыПодключаемыхКоманд);
	КонецЕсли;
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриОпределенииВидовПодключаемыхКоманд Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриОпределенииВидовПодключаемыхКоманд(ВидыПодключаемыхКоманд);
	КонецЕсли;
	
	ОбновлениеИнформационнойБазыСлужебный.ПриОпределенииВидовПодключаемыхКоманд(ВидыПодключаемыхКоманд);

КонецПроцедуры

// См. ПодключаемыеКомандыПереопределяемый.ПриОпределенииСоставаНастроекПодключаемыхОбъектов
Процедура ПриОпределенииСоставаНастроекПодключаемыхОбъектов(НастройкиПрограммногоИнтерфейса) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Печать") Тогда
		МодульУправлениеПечатью = ОбщегоНазначения.ОбщийМодуль("УправлениеПечатью");
		МодульУправлениеПечатью.ПриОпределенииСоставаНастроекПодключаемыхОбъектов(НастройкиПрограммногоИнтерфейса);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВариантыОтчетов") Тогда
		МодульВариантыОтчетов = ОбщегоНазначения.ОбщийМодуль("ВариантыОтчетов");
		МодульВариантыОтчетов.ПриОпределенииСоставаНастроекПодключаемыхОбъектов(НастройкиПрограммногоИнтерфейса);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ШаблоныСообщений") Тогда
		МодульШаблоныСообщенийСлужебный = ОбщегоНазначения.ОбщийМодуль("ШаблоныСообщенийСлужебный");
		МодульШаблоныСообщенийСлужебный.ПриОпределенииСоставаНастроекПодключаемыхОбъектов(НастройкиПрограммногоИнтерфейса);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриОпределенииСоставаНастроекПодключаемыхОбъектов Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриОпределенииСоставаНастроекПодключаемыхОбъектов(НастройкиПрограммногоИнтерфейса);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриОпределенииСоставаНастроекПодключаемыхОбъектов Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриОпределенииСоставаНастроекПодключаемыхОбъектов(НастройкиПрограммногоИнтерфейса);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриОпределенииСоставаНастроекПодключаемыхОбъектов Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриОпределенииСоставаНастроекПодключаемыхОбъектов(НастройкиПрограммногоИнтерфейса);
	КонецЕсли;
	
КонецПроцедуры

// См. ПодключаемыеКомандыПереопределяемый.ПриОпределенииКомандПодключенныхКОбъекту
Процедура ПриОпределенииКомандПодключенныхКОбъекту(НастройкиФормы, Источники, ПодключенныеОтчетыИОбработки, Команды) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Печать") Тогда
		МодульУправлениеПечатью = ОбщегоНазначения.ОбщийМодуль("УправлениеПечатью");
		МодульУправлениеПечатью.ПриОпределенииКомандПодключенныхКОбъекту(НастройкиФормы, Источники,
			ПодключенныеОтчетыИОбработки, Команды);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВариантыОтчетов") Тогда
		МодульВариантыОтчетов = ОбщегоНазначения.ОбщийМодуль("ВариантыОтчетов");
		МодульВариантыОтчетов.ПриОпределенииКомандПодключенныхКОбъекту(НастройкиФормы, Источники,
			ПодключенныеОтчетыИОбработки, Команды);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ДополнительныеОтчетыИОбработки") Тогда
		МодульДополнительныеОтчетыИОбработки = ОбщегоНазначения.ОбщийМодуль("ДополнительныеОтчетыИОбработки");
		МодульДополнительныеОтчетыИОбработки.ПриОпределенииКомандПодключенныхКОбъекту(НастройкиФормы, Источники,
			ПодключенныеОтчетыИОбработки, Команды);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.НастройкаПорядкаЭлементов") Тогда
		МодульНастройкаПорядкаЭлементов = ОбщегоНазначения.ОбщийМодуль("НастройкаПорядкаЭлементов");
		МодульНастройкаПорядкаЭлементов.ПриОпределенииКомандПодключенныхКОбъекту(НастройкиФормы, Источники,
			ПодключенныеОтчетыИОбработки, Команды);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ПоискИУдалениеДублей") Тогда
		МодульПоискИУдалениеДублей = ОбщегоНазначения.ОбщийМодуль("ПоискИУдалениеДублей");
		МодульПоискИУдалениеДублей.ПриОпределенииКомандПодключенныхКОбъекту(НастройкиФормы, Источники,
			ПодключенныеОтчетыИОбработки, Команды);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ГрупповоеИзменениеОбъектов") Тогда
		МодульГрупповоеИзменениеОбъектов = ОбщегоНазначения.ОбщийМодуль("ГрупповоеИзменениеОбъектов");
		МодульГрупповоеИзменениеОбъектов.ПриОпределенииКомандПодключенныхКОбъекту(НастройкиФормы, Источники,
			ПодключенныеОтчетыИОбработки, Команды);
	КонецЕсли;
		
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ШаблоныСообщений") Тогда
		МодульШаблоныСообщенийСлужебный = ОбщегоНазначения.ОбщийМодуль("ШаблоныСообщенийСлужебный");
		МодульШаблоныСообщенийСлужебный.ПриОпределенииКомандПодключенныхКОбъекту(НастройкиФормы, Источники,
			ПодключенныеОтчетыИОбработки, Команды);
	КонецЕсли;
		
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЗаметкиПользователя") Тогда
		МодульЗаметкиПользователяСлужебный = ОбщегоНазначения.ОбщийМодуль("ЗаметкиПользователяСлужебный");
		МодульЗаметкиПользователяСлужебный.ПриОпределенииКомандПодключенныхКОбъекту(НастройкиФормы, Источники,
			ПодключенныеОтчетыИОбработки, Команды);
	КонецЕсли;
		
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.НапоминанияПользователя") Тогда
		МодульНапоминанияПользователяСлужебный = ОбщегоНазначения.ОбщийМодуль("НапоминанияПользователяСлужебный");
		МодульНапоминанияПользователяСлужебный.ПриОпределенииКомандПодключенныхКОбъекту(НастройкиФормы, Источники,
			ПодключенныеОтчетыИОбработки, Команды);
	КонецЕсли;
		
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриОпределенииКомандПодключенныхКОбъекту Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриОпределенииКомандПодключенныхКОбъекту(НастройкиФормы, Источники,
			ПодключенныеОтчетыИОбработки, Команды);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриОпределенииКомандПодключенныхКОбъекту Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриОпределенииКомандПодключенныхКОбъекту(НастройкиФормы, Источники,
			ПодключенныеОтчетыИОбработки, Команды);
	КонецЕсли;
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБЭД().ПриОпределенииКомандПодключенныхКОбъекту Тогда
		МодульИнтеграцияПодсистемБЭД = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБЭД");
		МодульИнтеграцияПодсистемБЭД.ПриОпределенииКомандПодключенныхКОбъекту(НастройкиФормы, Источники,
			ПодключенныеОтчетыИОбработки, Команды);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УдалениеПомеченныхОбъектов") Тогда
		МодульУдалениеПомеченныхОбъектовСлужебный = ОбщегоНазначения.ОбщийМодуль("УдалениеПомеченныхОбъектовСлужебный");
		МодульУдалениеПомеченныхОбъектовСлужебный.ПриОпределенииКомандПодключенныхКОбъекту(НастройкиФормы, Источники,
			ПодключенныеОтчетыИОбработки, Команды);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.СтруктураПодчиненности") Тогда
		МодульСтруктураПодчиненностиСлужебный = ОбщегоНазначения.ОбщийМодуль("СтруктураПодчиненностиСлужебный");
		МодульСтруктураПодчиненностиСлужебный.ПриОпределенииКомандПодключенныхКОбъекту(НастройкиФормы, Источники,
			ПодключенныеОтчетыИОбработки, Команды);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УчетОригиналовПервичныхДокументов") Тогда
		МодульУчетОригиналовПервичныхДокументов = ОбщегоНазначения.ОбщийМодуль("УчетОригиналовПервичныхДокументов");
		МодульУчетОригиналовПервичныхДокументов.ПриОпределенииКомандПодключенныхКОбъекту(НастройкиФормы, Источники,
			ПодключенныеОтчетыИОбработки, Команды);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВыгрузкаОбъектовВФайлы") Тогда
		МодульВыгрузкаОбъектовВФайлы = ОбщегоНазначения.ОбщийМодуль("ВыгрузкаОбъектовВФайлы");
		МодульВыгрузкаОбъектовВФайлы.ПриОпределенииКомандПодключенныхКОбъекту(НастройкиФормы, Источники,
			ПодключенныеОтчетыИОбработки, Команды);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриОпределенииКомандПодключенныхКОбъекту Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриОпределенииКомандПодключенныхКОбъекту(НастройкиФормы, Источники,
			ПодключенныеОтчетыИОбработки, Команды);
	КонецЕсли;
		
	ОбновлениеИнформационнойБазыСлужебный.ПриОпределенииКомандПодключенныхКОбъекту(НастройкиФормы, Источники,
		ПодключенныеОтчетыИОбработки, Команды);
	
КонецПроцедуры

// См. СозданиеНаОснованииПереопределяемый.ПриОпределенииОбъектовСКомандамиСозданияНаОсновании.
Процедура ПриОпределенииОбъектовСКомандамиСозданияНаОсновании(Объекты) Экспорт

	ПользователиСлужебный.ПриОпределенииОбъектовСКомандамиСозданияНаОсновании(Объекты);

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.БизнесПроцессыИЗадачи") Тогда
		МодульБизнесПроцессыИЗадачиСервер = ОбщегоНазначения.ОбщийМодуль("БизнесПроцессыИЗадачиСервер");
		МодульБизнесПроцессыИЗадачиСервер.ПриОпределенииОбъектовСКомандамиСозданияНаОсновании(Объекты);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Взаимодействия") Тогда
		МодульВзаимодействия = ОбщегоНазначения.ОбщийМодуль("Взаимодействия");
		МодульВзаимодействия.ПриОпределенииОбъектовСКомандамиСозданияНаОсновании(Объекты);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЗащитаПерсональныхДанных") Тогда
		МодульЗащитаПерсональныхДанных = ОбщегоНазначения.ОбщийМодуль("ЗащитаПерсональныхДанных");
		МодульЗащитаПерсональныхДанных.ПриОпределенииОбъектовСКомандамиСозданияНаОсновании(Объекты);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.МашиночитаемыеДоверенности") Тогда
		МодульМашиночитаемыеДоверенностиФНССлужебный = ОбщегоНазначения.ОбщийМодуль("МашиночитаемыеДоверенностиФНССлужебный");
		МодульМашиночитаемыеДоверенностиФНССлужебный.ПриОпределенииОбъектовСКомандамиСозданияНаОсновании(Объекты);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСФайлами") Тогда
		МодульРаботаСФайламиСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебный");
		МодульРаботаСФайламиСлужебный.ПриОпределенииОбъектовСКомандамиСозданияНаОсновании(Объекты);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ШаблоныСообщений") Тогда
		МодульШаблоныСообщений = ОбщегоНазначения.ОбщийМодуль("ШаблоныСообщений");
		МодульШаблоныСообщений.ПриОпределенииОбъектовСКомандамиСозданияНаОсновании(Объекты);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриОпределенииОбъектовСКомандамиСозданияНаОсновании Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриОпределенииОбъектовСКомандамиСозданияНаОсновании(Объекты);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриОпределенииОбъектовСКомандамиСозданияНаОсновании Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриОпределенииОбъектовСКомандамиСозданияНаОсновании(Объекты);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриОпределенииОбъектовСКомандамиСозданияНаОсновании Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриОпределенииОбъектовСКомандамиСозданияНаОсновании(Объекты);
	КонецЕсли;
	
КонецПроцедуры

// См. СозданиеНаОснованииПереопределяемый.ПередДобавлениемКомандСозданияНаОсновании.
Процедура ПередДобавлениемКомандСозданияНаОсновании(КомандыСозданияНаОсновании, Параметры, СтандартнаяОбработка) Экспорт

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПередДобавлениемКомандСозданияНаОсновании Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПередДобавлениемКомандСозданияНаОсновании(КомандыСозданияНаОсновании, Параметры,
			СтандартнаяОбработка);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПередДобавлениемКомандСозданияНаОсновании Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПередДобавлениемКомандСозданияНаОсновании(КомандыСозданияНаОсновании, Параметры,
			СтандартнаяОбработка);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПередДобавлениемКомандСозданияНаОсновании Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПередДобавлениемКомандСозданияНаОсновании(КомандыСозданияНаОсновании, Параметры,
			СтандартнаяОбработка);
	КонецЕсли;
	
КонецПроцедуры

// См. СозданиеНаОснованииПереопределяемый.ПриДобавленииКомандСозданияНаОсновании.
Процедура ПриДобавленииКомандСозданияНаОсновании(Объект, КомандыСозданияНаОсновании, Параметры, СтандартнаяОбработка) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.БизнесПроцессыИЗадачи") Тогда
		МодульБизнесПроцессыИЗадачиСервер = ОбщегоНазначения.ОбщийМодуль("БизнесПроцессыИЗадачиСервер");
		МодульБизнесПроцессыИЗадачиСервер.ПриДобавленииКомандСозданияНаОсновании(Объект, КомандыСозданияНаОсновании,
			Параметры, СтандартнаяОбработка);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ШаблоныСообщений") Тогда
		МодульШаблоныСообщений = ОбщегоНазначения.ОбщийМодуль("ШаблоныСообщений");
		МодульШаблоныСообщений.ПриДобавленииКомандСозданияНаОсновании(Объект, КомандыСозданияНаОсновании, Параметры,
			СтандартнаяОбработка);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриДобавленииКомандСозданияНаОсновании Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриДобавленииКомандСозданияНаОсновании(Объект, КомандыСозданияНаОсновании,
			Параметры, СтандартнаяОбработка);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриДобавленииКомандСозданияНаОсновании Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриДобавленииКомандСозданияНаОсновании(Объект, КомандыСозданияНаОсновании,
			Параметры, СтандартнаяОбработка);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриДобавленииКомандСозданияНаОсновании Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриДобавленииКомандСозданияНаОсновании(Объект, КомандыСозданияНаОсновании,
			Параметры, СтандартнаяОбработка);
	КонецЕсли;
	
КонецПроцедуры

#КонецОбласти

#Область ПоискИУдалениеДублей

// См. ПоискИУдалениеДублейПереопределяемый.ПриОпределенииОбъектовСПоискомДублей.
Процедура ПриОпределенииОбъектовСПоискомДублей(Объекты) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КонтактнаяИнформация") Тогда
		МодульУправлениеКонтактнойИнформациейСлужебный = ОбщегоНазначения.ОбщийМодуль(
			"УправлениеКонтактнойИнформациейСлужебный");
		МодульУправлениеКонтактнойИнформациейСлужебный.ПриОпределенииОбъектовСПоискомДублей(Объекты);
	КонецЕсли;

КонецПроцедуры

// См. ПоискИУдалениеДублейПереопределяемый.ПриОпределенииОбъектовСПоискомДублей
Процедура ПриДобавленииТиповИсключаемыхИзВозможныхДублей(ИсключаемыеТипы) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЗаметкиПользователя") Тогда
		МодульЗаметкиПользователяСлужебный = ОбщегоНазначения.ОбщийМодуль("ЗаметкиПользователяСлужебный");
		МодульЗаметкиПользователяСлужебный.ПриДобавленииТиповИсключаемыхИзВозможныхДублей(ИсключаемыеТипы);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСФайлами") Тогда
		МодульРаботаСФайламиСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебный");
		МодульРаботаСФайламиСлужебный.ПриДобавленииТиповИсключаемыхИзВозможныхДублей(ИсключаемыеТипы);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ГрафикиРаботы") Тогда
		МодульГрафикиРаботы = ОбщегоНазначения.ОбщийМодуль("ГрафикиРаботы");
		МодульГрафикиРаботы.ПриДобавленииТиповИсключаемыхИзВозможныхДублей(ИсключаемыеТипы);
	КонецЕсли;

КонецПроцедуры

#КонецОбласти

#Область ПолнотекстовыйПоискСервер

// Параметры:
//  МетаданныеОбъекта - ОбъектМетаданных
//  Значение - Произвольный
//  Представление - Строка
//
Процедура ПриПолученииРезультатовПолнотекстовогоПоиска(МетаданныеОбъекта, Значение, Представление) Экспорт
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Свойства") Тогда 
		МодульУправлениеСвойствамиСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеСвойствамиСлужебный");
		МодульУправлениеСвойствамиСлужебный.ПриПолученииРезультатовПолнотекстовогоПоиска(МетаданныеОбъекта, Значение, Представление);
	КонецЕсли;
	
КонецПроцедуры

#КонецОбласти

#Область Пользователи

// См. ПользователиПереопределяемый.ПриОпределенииНастроек.
Процедура ПриОпределенииНастроек(Настройки) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УправлениеДоступом") Тогда
		МодульУправлениеДоступомСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеДоступомСлужебный");
		МодульУправлениеДоступомСлужебный.ПриОпределенииНастроек(Настройки);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриОпределенииНастроек Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриОпределенииНастроек(Настройки);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриОпределенииНастроек Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриОпределенииНастроек(Настройки);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриОпределенииНастроек Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриОпределенииНастроек(Настройки);
	КонецЕсли;
	
КонецПроцедуры

// См. ПользователиПереопределяемый.ПриОпределенииНазначенияРолей.
Процедура ПриОпределенииНазначенияРолей(НазначениеРолей) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.АдресныйКлассификатор") Тогда
		МодульАдресныйКлассификаторСлужебный = ОбщегоНазначения.ОбщийМодуль("АдресныйКлассификаторСлужебный");
		МодульАдресныйКлассификаторСлужебный.ПриОпределенииНазначенияРолей(НазначениеРолей);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Анкетирование") Тогда
		МодульАнкетирование = ОбщегоНазначения.ОбщийМодуль("Анкетирование");
		МодульАнкетирование.ПриОпределенииНазначенияРолей(НазначениеРолей);
	КонецЕсли;

	СтандартныеПодсистемыСервер.ПриОпределенииНазначенияРолей(НазначениеРолей);

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Банки") Тогда
		МодульРаботаСБанками = ОбщегоНазначения.ОбщийМодуль("РаботаСБанками");
		МодульРаботаСБанками.ПриОпределенииНазначенияРолей(НазначениеРолей);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Валюты") Тогда
		МодульРаботаСКурсамиВалют = ОбщегоНазначения.ОбщийМодуль("РаботаСКурсамиВалют");
		МодульРаботаСКурсамиВалют.ПриОпределенииНазначенияРолей(НазначениеРолей);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВариантыОтчетов") Тогда
		МодульВариантыОтчетов = ОбщегоНазначения.ОбщийМодуль("ВариантыОтчетов");
		МодульВариантыОтчетов.ПриОпределенииНазначенияРолей(НазначениеРолей);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ГрафикиРаботы") Тогда
		МодульГрафикиРаботы = ОбщегоНазначения.ОбщийМодуль("ГрафикиРаботы");
		МодульГрафикиРаботы.ПриОпределенииНазначенияРолей(НазначениеРолей);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ДополнительныеОтчетыИОбработки") Тогда
		МодульДополнительныеОтчетыИОбработки = ОбщегоНазначения.ОбщийМодуль("ДополнительныеОтчетыИОбработки");
		МодульДополнительныеОтчетыИОбработки.ПриОпределенииНазначенияРолей(НазначениеРолей);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КалендарныеГрафики") Тогда
		МодульКалендарныеГрафики = ОбщегоНазначения.ОбщийМодуль("КалендарныеГрафики");
		МодульКалендарныеГрафики.ПриОпределенииНазначенияРолей(НазначениеРолей);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ОценкаПроизводительности") Тогда
		МодульОценкаПроизводительностиСлужебный = ОбщегоНазначения.ОбщийМодуль("ОценкаПроизводительностиСлужебный");
		МодульОценкаПроизводительностиСлужебный.ПриОпределенииНазначенияРолей(НазначениеРолей);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Печать") Тогда
		МодульУправлениеПечатью = ОбщегоНазначения.ОбщийМодуль("УправлениеПечатью");
		МодульУправлениеПечатью.ПриОпределенииНазначенияРолей(НазначениеРолей);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСФайлами") Тогда
		МодульРаботаСФайламиСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебный");
		МодульРаботаСФайламиСлужебный.ПриОпределенииНазначенияРолей(НазначениеРолей);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ТекущиеДела") Тогда
		МодульТекущиеДелаСлужебный = ОбщегоНазначения.ОбщийМодуль("ТекущиеДелаСлужебный");
		МодульТекущиеДелаСлужебный.ПриОпределенииНазначенияРолей(НазначениеРолей);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриОпределенииНазначенияРолей Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриОпределенииНазначенияРолей(НазначениеРолей);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриОпределенииНазначенияРолей Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриОпределенииНазначенияРолей(НазначениеРолей);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриОпределенииНазначенияРолей Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриОпределенииНазначенияРолей(НазначениеРолей);
	КонецЕсли;
	
КонецПроцедуры

// См. ПользователиПереопределяемый.ИзменитьДействияВФорме.
Процедура ПриОпределенииДействийВФорме(Знач ПользовательИлиГруппа, Знач ДействияВФорме) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УправлениеДоступом") Тогда
		МодульУправлениеДоступомСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеДоступомСлужебный");
		МодульУправлениеДоступомСлужебный.ПриОпределенииДействийВФорме(ПользовательИлиГруппа, ДействияВФорме);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриОпределенииДействийВФорме Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриОпределенииДействийВФорме(ПользовательИлиГруппа, ДействияВФорме);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриОпределенииДействийВФорме Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриОпределенииДействийВФорме(ПользовательИлиГруппа, ДействияВФорме);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриОпределенииДействийВФорме Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриОпределенииДействийВФорме(ПользовательИлиГруппа, ДействияВФорме);
	КонецЕсли;
	
КонецПроцедуры

// См. ПользователиПереопределяемый.ПриПолученииПрочихНастроек.
Процедура ПриПолученииПрочихНастроек(СведенияОПользователе, Настройки) Экспорт
	
	СтандартныеПодсистемыСервер.ПриПолученииПрочихНастроек(СведенияОПользователе, Настройки);
	
	// Добавление настроек дополнительных отчетов и обработок.
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ДополнительныеОтчетыИОбработки") Тогда
		МодульДополнительныеОтчетыИОбработки = ОбщегоНазначения.ОбщийМодуль("ДополнительныеОтчетыИОбработки");
		МодульДополнительныеОтчетыИОбработки.ПриПолученииПрочихНастроек(СведенияОПользователе, Настройки);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриПолученииПрочихНастроек Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриПолученииПрочихНастроек(СведенияОПользователе, Настройки);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриПолученииПрочихНастроек Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриПолученииПрочихНастроек(СведенияОПользователе, Настройки);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриПолученииПрочихНастроек Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриПолученииПрочихНастроек(СведенияОПользователе, Настройки);
	КонецЕсли;
	
КонецПроцедуры

// См. ПользователиПереопределяемый.ПриСохраненииПрочихНастроек.
Процедура ПриСохраненииПрочихНастроек(СведенияОПользователе, Настройки) Экспорт
	
	СтандартныеПодсистемыСервер.ПриСохраненииПрочихНастроек(СведенияОПользователе, Настройки);
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ДополнительныеОтчетыИОбработки") Тогда
		МодульДополнительныеОтчетыИОбработки = ОбщегоНазначения.ОбщийМодуль("ДополнительныеОтчетыИОбработки");
		МодульДополнительныеОтчетыИОбработки.ПриСохраненииПрочихНастроек(СведенияОПользователе, Настройки);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриСохраненииПрочихНастроек Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриСохраненииПрочихНастроек(СведенияОПользователе, Настройки);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриСохраненииПрочихНастроек Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриСохраненииПрочихНастроек(СведенияОПользователе, Настройки);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриСохраненииПрочихНастроек Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриСохраненииПрочихНастроек(СведенияОПользователе, Настройки);
	КонецЕсли;
	
КонецПроцедуры

// См. ПользователиПереопределяемый.ПриУдаленииПрочихНастроек.
Процедура ПриУдаленииПрочихНастроек(СведенияОПользователе, Настройки) Экспорт
	
	СтандартныеПодсистемыСервер.ПриУдаленииПрочихНастроек(СведенияОПользователе, Настройки);
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ДополнительныеОтчетыИОбработки") Тогда
		МодульДополнительныеОтчетыИОбработки = ОбщегоНазначения.ОбщийМодуль("ДополнительныеОтчетыИОбработки");
		МодульДополнительныеОтчетыИОбработки.ПриУдаленииПрочихНастроек(СведенияОПользователе, Настройки);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриУдаленииПрочихНастроек Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриУдаленииПрочихНастроек(СведенияОПользователе, Настройки);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриУдаленииПрочихНастроек Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриУдаленииПрочихНастроек(СведенияОПользователе, Настройки);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриУдаленииПрочихНастроек Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриУдаленииПрочихНастроек(СведенияОПользователе, Настройки);
	КонецЕсли;
	
КонецПроцедуры

// См. ПользователиПереопределяемый.ПриОпределенииНастроекРегистрацииСобытийДоступаКДанным
Процедура ПриОпределенииНастроекРегистрацииСобытийДоступаКДанным(Настройки) Экспорт
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЗащитаПерсональныхДанных") Тогда
		МодульЗащитаПерсональныхДанных = ОбщегоНазначения.ОбщийМодуль("ЗащитаПерсональныхДанных");
		МодульЗащитаПерсональныхДанных.ПриОпределенииНастроекРегистрацииСобытийДоступаКДанным(Настройки);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КонтрольРаботыПользователей") Тогда
		МодульКонтрольРаботыПользователейСлужебный = ОбщегоНазначения.ОбщийМодуль("КонтрольРаботыПользователейСлужебный");
		МодульКонтрольРаботыПользователейСлужебный.ПриОпределенииНастроекРегистрацииСобытийДоступаКДанным(Настройки);
	КонецЕсли;
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриОпределенииНастроекРегистрацииСобытийДоступаКДанным Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриОпределенииНастроекРегистрацииСобытийДоступаКДанным(Настройки);
	КонецЕсли;
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриОпределенииНастроекРегистрацииСобытийДоступаКДанным Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриОпределенииНастроекРегистрацииСобытийДоступаКДанным(Настройки);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриОпределенииНастроекРегистрацииСобытийДоступаКДанным Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриОпределенииНастроекРегистрацииСобытийДоступаКДанным(Настройки);
	КонецЕсли;
		
КонецПроцедуры

// См. ПользователиСлужебныйВМоделиСервиса.ПриЗавершенииОбработкиПользователяИБ
Процедура ПриЗавершенииОбработкиПользователяИБ(Пользователь) Экспорт

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриЗавершенииОбработкиПользователяИБ Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриЗавершенииОбработкиПользователяИБ(Пользователь);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриЗавершенииОбработкиПользователяИБ Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриЗавершенииОбработкиПользователяИБ(Пользователь);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриЗавершенииОбработкиПользователяИБ Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриЗавершенииОбработкиПользователяИБ(Пользователь);
	КонецЕсли;
	
КонецПроцедуры

#Область Пользователи_ДляВнутреннегоИспользования

// Вызывается, если не удалось найти пользователя в справочнике, который
// соответствует текущему пользователю ИБ. При этом можно включить автоматическое
// создание элемента справочника Пользователи для текущего пользователя.
//
// Параметры:
//  СоздатьПользователя - Булево - возвращаемое значение. Если указать Истина,
//       то автоматически будет создан пользователь в справочнике.
//       Переопределить свойства создаваемого пользователя можно перед его записью
//       в процедуре ПриАвтоматическомСозданииТекущегоПользователяВСправочнике.
//
Процедура ПриОтсутствииТекущегоПользователяВСправочнике(СоздатьПользователя) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаВМоделиСервиса.ПользователиВМоделиСервиса") Тогда
		МодульПользователиСлужебныйВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("ПользователиСлужебныйВМоделиСервиса");
		МодульПользователиСлужебныйВМоделиСервиса.ПриОтсутствииТекущегоПользователяВСправочнике(СоздатьПользователя);
	КонецЕсли;

КонецПроцедуры

// Вызывается при автоматическом создании элемента справочника Пользователи в момент
// интерактивного входа пользователя или при первом обращении из кода.
//
// Параметры:
//  НовыйПользователь - СправочникОбъект.Пользователи - новый пользователь перед записью.
//
Процедура ПриАвтоматическомСозданииТекущегоПользователяВСправочнике(НовыйПользователь) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаВМоделиСервиса.ПользователиВМоделиСервиса") Тогда
		МодульПользователиСлужебныйВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("ПользователиСлужебныйВМоделиСервиса");
		МодульПользователиСлужебныйВМоделиСервиса.ПриАвтоматическомСозданииТекущегоПользователяВСправочнике(
			НовыйПользователь);
	КонецЕсли;

КонецПроцедуры

// Вызывается при авторизации нового пользователя информационной базы.
//
// Параметры:
//  ПользовательИБ - ПользовательИнформационнойБазы - текущий пользователь информационной базы,
//  СтандартнаяОбработка - Булево - значение может быть установлено внутри обработчика, в этом случае
//    стандартная обработка авторизации нового пользователя ИБ выполняться не будет.
//
Процедура ПриАвторизацииНовогоПользователяИБ(ПользовательИБ, СтандартнаяОбработка) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаВМоделиСервиса.ПользователиВМоделиСервиса") Тогда
		МодульПользователиСлужебныйВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("ПользователиСлужебныйВМоделиСервиса");
		МодульПользователиСлужебныйВМоделиСервиса.ПриАвторизацииНовогоПользователяИБ(ПользовательИБ,
			СтандартнаяОбработка);
	КонецЕсли;

КонецПроцедуры

// Вызывается при начале обработки пользователя информационной базы.
//
// Параметры:
//  ПараметрыОбработки - см. ПользователиСлужебный.НачатьОбработкуПользователяИБ.ПараметрыОбработки.
//  ОписаниеПользователяИБ - Структура
//
Процедура ПриНачалеОбработкиПользователяИБ(ПараметрыОбработки, ОписаниеПользователяИБ) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаВМоделиСервиса.ПользователиВМоделиСервиса") Тогда
		МодульПользователиСлужебныйВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("ПользователиСлужебныйВМоделиСервиса");
		МодульПользователиСлужебныйВМоделиСервиса.ПриНачалеОбработкиПользователяИБ(ПараметрыОбработки,
			ОписаниеПользователяИБ);
	КонецЕсли;

КонецПроцедуры

// Вызывается перед записью пользователя информационной базы.
//
// Параметры:
//  ПользовательИБ - ПользовательИнформационнойБазы - пользователь, который будет записан.
//
Процедура ПередЗаписьюПользователяИБ(ПользовательИБ) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаВМоделиСервиса.ПользователиВМоделиСервиса") Тогда
		МодульПользователиСлужебныйВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("ПользователиСлужебныйВМоделиСервиса");
		МодульПользователиСлужебныйВМоделиСервиса.ПередЗаписьюПользователяИБ(ПользовательИБ);
	КонецЕсли;

КонецПроцедуры

// Вызывается перед удалением пользователя информационной базы.
//
// Параметры:
//  ПользовательИБ - ПользовательИнформационнойБазы - пользователь, который будет удален.
//
Процедура ПередУдалениемПользователяИБ(ПользовательИБ) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаВМоделиСервиса.ПользователиВМоделиСервиса") Тогда
		МодульПользователиСлужебныйВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("ПользователиСлужебныйВМоделиСервиса");
		МодульПользователиСлужебныйВМоделиСервиса.ПередЗаписьюПользователяИБ(ПользовательИБ);
	КонецЕсли;

КонецПроцедуры

// Переопределяет текст комментария при авторизации пользователя ИБ,
// созданного в конфигураторе с административными правами.
// Комментарий записывается в журнал регистрации.
// 
// Параметры:
//  Комментарий  - Строка
//
Процедура ПослеЗаписиАдминистратораПриАвторизации(Комментарий) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УправлениеДоступом") Тогда
		МодульУправлениеДоступомСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеДоступомСлужебный");
		МодульУправлениеДоступомСлужебный.ПослеЗаписиАдминистратораПриАвторизации(Комментарий);
	КонецЕсли;

КонецПроцедуры

// Доопределяет действия, необходимые после установки пользователя
// информационной базы у пользователя или внешнего пользователя,
// т.е. при изменении реквизита ИдентификаторПользователяИБ на не пустой.
//
// Например, можно обновить роли.
// 
// Параметры:
//  Ссылка - СправочникСсылка.Пользователи
//         - СправочникСсылка.ВнешниеПользователи - пользователь.
//
Процедура ПослеУстановкиПользователяИБ(Ссылка, ПарольПользователяСервиса) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УправлениеДоступом") Тогда
		МодульУправлениеДоступомСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеДоступомСлужебный");
		МодульУправлениеДоступомСлужебный.ПослеУстановкиПользователяИБ(Ссылка, ПарольПользователяСервиса);
	КонецЕсли;

КонецПроцедуры

// Позволяет переопределить текст вопроса перед записью первого администратора.
//  Вызывается из обработчика ПередЗаписью формы пользователя.
//  Вызов выполняется если установлен ЗапретРедактированияРолей() и
// количество пользователей информационной базы равно нулю.
// 
// Параметры:
//  ТекстВопроса - Строка - текст вопроса, который можно переопределить.
//
Процедура ПриОпределенииТекстаВопросаПередЗаписьюПервогоАдминистратора(ТекстВопроса) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УправлениеДоступом") Тогда
		МодульУправлениеДоступомСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеДоступомСлужебный");
		МодульУправлениеДоступомСлужебный.ПриОпределенииТекстаВопросаПередЗаписьюПервогоАдминистратора(ТекстВопроса);
	КонецЕсли;

КонецПроцедуры

// Доопределяет действия при создании администратора в подсистеме Пользователи.
//
// Параметры:
//  Администратор - СправочникСсылка.Пользователи
//  Уточнение     - Строка - поясняет, при каких условиях был создан администратор.
//
Процедура ПриСозданииАдминистратора(Администратор, Уточнение) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УправлениеДоступом") Тогда
		МодульУправлениеДоступомСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеДоступомСлужебный");
		МодульУправлениеДоступомСлужебный.ПриСозданииИлиАвторизацииАдминистратора(Администратор, Уточнение);
	КонецЕсли;

КонецПроцедуры

// Доопределяет действия, необходимые после добавления или изменения пользователя,
// группы пользователей, внешнего пользователя, группы внешних пользователей.
//
// Параметры:
//  Ссылка     - СправочникСсылка.Пользователи
//             - СправочникСсылка.ГруппыПользователей
//             - СправочникСсылка.ВнешниеПользователи
//             - СправочникСсылка.ГруппыВнешнихПользователей - измененный объект.
//
//  ЭтоНовый   - Булево - если Истина, объект был добавлен, иначе изменен.
//
Процедура ПослеДобавленияИзмененияПользователяИлиГруппы(Ссылка, ЭтоНовый) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСФайлами") Тогда
		МодульРаботаСФайламиСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебный");
		МодульРаботаСФайламиСлужебный.ПослеДобавленияИзмененияПользователяИлиГруппы(Ссылка, ЭтоНовый);
	КонецЕсли;

КонецПроцедуры

// Доопределяет действия, необходимые после завершения обновления
// связей в регистрах ИерархияГруппПользователей и СоставыГруппПользователей.
//
// Параметры:
//  УчастникиИзменений - Массив из СправочникСсылка.Пользователи
//                     - Массив из СправочникСсылка.ВнешниеПользователи -
//                       пользователи, которые участвовали в изменении состава групп.
//
//  ИзмененныеГруппы   - Массив из СправочникСсылка.ГруппыПользователей
//                     - Массив из СправочникСсылка.ГруппыВнешнихПользователей -
//                       группы, состав которых был изменен, а также группы у которых
//                       изменился состав родителей и новые группы.
//
Процедура ПослеОбновленияСоставовГруппПользователей(УчастникиИзменений, ИзмененныеГруппы) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УправлениеДоступом") Тогда
		МодульУправлениеДоступомСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеДоступомСлужебный");
		МодульУправлениеДоступомСлужебный.ПослеОбновленияСоставовГруппПользователей(УчастникиИзменений,
			ИзмененныеГруппы);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ДатыЗапретаИзменения") Тогда
		МодульДатыЗапретаИзмененияСлужебный = ОбщегоНазначения.ОбщийМодуль("ДатыЗапретаИзмененияСлужебный");
		МодульДатыЗапретаИзмененияСлужебный.ПослеОбновленияСоставовГруппПользователей(УчастникиИзменений,
			ИзмененныеГруппы);
	КонецЕсли;

КонецПроцедуры

// Получает варианты переданного отчета и их представления.
//
// Параметры:
//  ПолноеИмяОтчета                - Строка - отчет, для которого получаются варианты отчета.
//  ПользовательИнформационнойБазы - Строка - имя пользователя информационной базы.
//  СведенияОВариантахОтчетов      - ТаблицаЗначений - таблица, в которую сохраняется информация о варианте отчета:
//       * КлючОбъекта          - Строка - ключ отчета вида "Отчет.НазваниеОтчета".
//       * КлючВарианта         - Строка - ключ варианта отчета.
//       * Представление        - Строка - представление варианта отчета.
//       * СтандартнаяОбработка - Булево - если Истина - вариант отчета сохранен в стандартном хранилище.
//  СтандартнаяОбработка           - Булево - если Истина - вариант отчета сохранен в стандартном хранилище.
//
Процедура ПриПолученииПользовательскихВариантовОтчетов(ПолноеИмяОтчета, ПользовательИнформационнойБазы,
	СведенияОВариантахОтчетов, СтандартнаяОбработка) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВариантыОтчетов") Тогда
		МодульВариантыОтчетов = ОбщегоНазначения.ОбщийМодуль("ВариантыОтчетов");
		МодульВариантыОтчетов.ПользовательскиеВариантыОтчетов(ПолноеИмяОтчета, ПользовательИнформационнойБазы,
			СведенияОВариантахОтчетов, СтандартнаяОбработка);
	КонецЕсли;

КонецПроцедуры

// Удаляет переданный вариант отчета из хранилища вариантов отчетов.
//
// Параметры:
//  СведенияОВариантеОтчета   - ТаблицаЗначений - информация о варианте отчета:
//       * КлючОбъекта          - Строка - ключ отчета вида "Отчет.НазваниеОтчета".
//       * КлючВарианта         - Строка - ключ варианта отчета.
//       * Представление        - Строка - представление варианта отчета.
//       * СтандартнаяОбработка - Булево - если Истина - вариант отчета сохранен в стандартном хранилище.
//  ПользовательИнформационнойБазы - Строка - имя пользователя информационной базы, у которого удаляется вариант отчета.
//  СтандартнаяОбработка           - Булево - если Истина, то вариант отчета сохранен в стандартном хранилище.
//
Процедура ПриУдаленииПользовательскихВариантовОтчета(СведенияОВариантеОтчета, ПользовательИнформационнойБазы,
	СтандартнаяОбработка) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВариантыОтчетов") Тогда
		МодульВариантыОтчетов = ОбщегоНазначения.ОбщийМодуль("ВариантыОтчетов");
		МодульВариантыОтчетов.УдалитьПользовательскийВариантОтчета(СведенияОВариантеОтчета,
			ПользовательИнформационнойБазы, СтандартнаяОбработка);
	КонецЕсли;

КонецПроцедуры

// Формирует запрос на изменение адреса электронной почты пользователя сервиса.
//
// Параметры:
//  НоваяПочта                - Строка - новый адрес электронной почты пользователя.
//  Пользователь              - СправочникСсылка.Пользователи - пользователь, которому требуется изменить
//                                                              адрес электронной почты.
//  ПарольПользователяСервиса - Строка - пароль текущего пользователя для доступа к менеджеру сервиса.
//
Процедура ПриСозданииЗапросаНаСменуПочты(Знач НоваяПочта, Знач Пользователь, Знач ПарольПользователяСервиса) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаВМоделиСервиса.ПользователиВМоделиСервиса") Тогда
		МодульПользователиСлужебныйВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("ПользователиСлужебныйВМоделиСервиса");
		МодульПользователиСлужебныйВМоделиСервиса.СоздатьЗапросНаСменуПочты(НоваяПочта, Пользователь,
			ПарольПользователяСервиса);
	КонецЕсли;

КонецПроцедуры

#КонецОбласти

#КонецОбласти

#Область ПрофилиБезопасности

// См. РаботаВБезопасномРежимеПереопределяемый.ПриПроверкеВозможностиНастройкиПрофилейБезопасности.
Процедура ПриПроверкеВозможностиНастройкиПрофилейБезопасности(Отказ) Экспорт

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриПроверкеВозможностиНастройкиПрофилейБезопасности Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриПроверкеВозможностиНастройкиПрофилейБезопасности(Отказ);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриПроверкеВозможностиНастройкиПрофилейБезопасности Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриПроверкеВозможностиНастройкиПрофилейБезопасности(Отказ);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриПроверкеВозможностиНастройкиПрофилейБезопасности Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриПроверкеВозможностиНастройкиПрофилейБезопасности(Отказ);
	КонецЕсли;
	
КонецПроцедуры

// См. РаботаВБезопасномРежимеПереопределяемый.ПриЗапросеРазрешенийНаИспользованиеВнешнихРесурсов.
Процедура ПриЗапросеРазрешенийНаИспользованиеВнешнихРесурсов(Знач ПрограммныйМодуль, Знач Владелец,
	Знач РежимЗамещения, Знач ДобавляемыеРазрешения, Знач УдаляемыеРазрешения, СтандартнаяОбработка, Результат) Экспорт

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриЗапросеРазрешенийНаИспользованиеВнешнихРесурсов Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриЗапросеРазрешенийНаИспользованиеВнешнихРесурсов(ПрограммныйМодуль, Владелец,
			РежимЗамещения, ДобавляемыеРазрешения, УдаляемыеРазрешения, СтандартнаяОбработка, Результат);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриЗапросеРазрешенийНаИспользованиеВнешнихРесурсов Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриЗапросеРазрешенийНаИспользованиеВнешнихРесурсов(ПрограммныйМодуль, Владелец,
			РежимЗамещения, ДобавляемыеРазрешения, УдаляемыеРазрешения, СтандартнаяОбработка, Результат);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриЗапросеРазрешенийНаИспользованиеВнешнихРесурсов Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриЗапросеРазрешенийНаИспользованиеВнешнихРесурсов(ПрограммныйМодуль, Владелец,
			РежимЗамещения, ДобавляемыеРазрешения, УдаляемыеРазрешения, СтандартнаяОбработка, Результат);
	КонецЕсли;
	
КонецПроцедуры

// См. РаботаВБезопасномРежимеПереопределяемый.ПриЗапросеСозданияПрофиляБезопасности.
Процедура ПриЗапросеСозданияПрофиляБезопасности(Знач ПрограммныйМодуль, СтандартнаяОбработка, Результат) Экспорт

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриЗапросеСозданияПрофиляБезопасности Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриЗапросеСозданияПрофиляБезопасности(ПрограммныйМодуль, СтандартнаяОбработка,
			Результат);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриЗапросеСозданияПрофиляБезопасности Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриЗапросеСозданияПрофиляБезопасности(ПрограммныйМодуль, СтандартнаяОбработка,
			Результат);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриЗапросеСозданияПрофиляБезопасности Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриЗапросеСозданияПрофиляБезопасности(ПрограммныйМодуль, СтандартнаяОбработка,
			Результат);
	КонецЕсли;
	
КонецПроцедуры

// См. РаботаВБезопасномРежимеПереопределяемый.ПриЗапросеУдаленияПрофиляБезопасности.
Процедура ПриЗапросеУдаленияПрофиляБезопасности(Знач ПрограммныйМодуль, СтандартнаяОбработка, Результат) Экспорт

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриЗапросеУдаленияПрофиляБезопасности Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриЗапросеУдаленияПрофиляБезопасности(ПрограммныйМодуль, СтандартнаяОбработка,
			Результат);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриЗапросеУдаленияПрофиляБезопасности Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриЗапросеУдаленияПрофиляБезопасности(ПрограммныйМодуль, СтандартнаяОбработка,
			Результат);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриЗапросеУдаленияПрофиляБезопасности Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриЗапросеУдаленияПрофиляБезопасности(ПрограммныйМодуль, СтандартнаяОбработка,
			Результат);
	КонецЕсли;
	
КонецПроцедуры

// См. РаботаВБезопасномРежимеПереопределяемый.ПриПодключенииВнешнегоМодуля.
Процедура ПриПодключенииВнешнегоМодуля(Знач ВнешнийМодуль, БезопасныйРежим) Экспорт

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриПодключенииВнешнегоМодуля Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриПодключенииВнешнегоМодуля(ВнешнийМодуль, БезопасныйРежим);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриПодключенииВнешнегоМодуля Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриПодключенииВнешнегоМодуля(ВнешнийМодуль, БезопасныйРежим);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриПодключенииВнешнегоМодуля Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриПодключенииВнешнегоМодуля(ВнешнийМодуль, БезопасныйРежим);
	КонецЕсли;
	
КонецПроцедуры

// См. РаботаВБезопасномРежимеПереопределяемый.ПриВключенииИспользованияПрофилейБезопасности.
Процедура ПриВключенииИспользованияПрофилейБезопасности() Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ПолучениеФайловИзИнтернета") Тогда
		МодульПолучениеФайловИзИнтернетаСлужебный = ОбщегоНазначения.ОбщийМодуль("ПолучениеФайловИзИнтернетаСлужебный");
		МодульПолучениеФайловИзИнтернетаСлужебный.ПриВключенииИспользованияПрофилейБезопасности();
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РезервноеКопированиеИБ") Тогда
		МодульРезервноеКопированиеИБСервер = ОбщегоНазначения.ОбщийМодуль("РезервноеКопированиеИБСервер");
		МодульРезервноеКопированиеИБСервер.ПриВключенииИспользованияПрофилейБезопасности();
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриВключенииИспользованияПрофилейБезопасности Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриВключенииИспользованияПрофилейБезопасности();
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриВключенииИспользованияПрофилейБезопасности Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриВключенииИспользованияПрофилейБезопасности();
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриВключенииИспользованияПрофилейБезопасности Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриВключенииИспользованияПрофилейБезопасности();
	КонецЕсли;
	
КонецПроцедуры

// См. РаботаВБезопасномРежимеПереопределяемый.ПриЗаполненииРазрешенийНаДоступКВнешнимРесурсам.
Процедура ПриЗаполненииРазрешенийНаДоступКВнешнимРесурсам(ЗапросыРазрешений) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.АдресныйКлассификатор") Тогда
		МодульАдресныйКлассификаторСлужебный = ОбщегоНазначения.ОбщийМодуль("АдресныйКлассификаторСлужебный");
		МодульАдресныйКлассификаторСлужебный.ПриЗаполненииРазрешенийНаДоступКВнешнимРесурсам(ЗапросыРазрешений);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ДополнительныеОтчетыИОбработки") Тогда
		МодульДополнительныеОтчетыИОбработкиВБезопасномРежимеСлужебный = ОбщегоНазначения.ОбщийМодуль(
			"ДополнительныеОтчетыИОбработкиВБезопасномРежимеСлужебный");
		МодульДополнительныеОтчетыИОбработкиВБезопасномРежимеСлужебный.ПриЗаполненииРазрешенийНаДоступКВнешнимРесурсам(
			ЗапросыРазрешений);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ОбменДанными") Тогда
		МодульОбменДаннымиСервер = ОбщегоНазначения.ОбщийМодуль("ОбменДаннымиСервер");
		МодульОбменДаннымиСервер.ПриЗаполненииРазрешенийНаДоступКВнешнимРесурсам(ЗапросыРазрешений);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Обсуждения") Тогда
		МодульОбсужденияСлужебный = ОбщегоНазначения.ОбщийМодуль("ОбсужденияСлужебный");
		МодульОбсужденияСлужебный.ПриЗаполненииРазрешенийНаДоступКВнешнимРесурсам(ЗапросыРазрешений);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ОтправкаSMS") Тогда
		МодульОтправкаSMS = ОбщегоНазначения.ОбщийМодуль("ОтправкаSMS");
		МодульОтправкаSMS.ПриЗаполненииРазрешенийНаДоступКВнешнимРесурсам(ЗапросыРазрешений);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ОценкаПроизводительности") Тогда
		МодульОценкаПроизводительностиСлужебный = ОбщегоНазначения.ОбщийМодуль("ОценкаПроизводительностиСлужебный");
		МодульОценкаПроизводительностиСлужебный.ПриЗаполненииРазрешенийНаДоступКВнешнимРесурсам(ЗапросыРазрешений);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Валюты") Тогда
		МодульРаботаСКурсамиВалют = ОбщегоНазначения.ОбщийМодуль("РаботаСКурсамиВалют");
		МодульРаботаСКурсамиВалют.ПриЗаполненииРазрешенийНаДоступКВнешнимРесурсам(ЗапросыРазрешений);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ПолучениеФайловИзИнтернета") Тогда
		МодульПолучениеФайловИзИнтернетаСлужебный = ОбщегоНазначения.ОбщийМодуль("ПолучениеФайловИзИнтернетаСлужебный");
		МодульПолучениеФайловИзИнтернетаСлужебный.ПриЗаполненииРазрешенийНаДоступКВнешнимРесурсам(ЗапросыРазрешений);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСПочтовымиСообщениями") Тогда
		МодульРаботаСПочтовымиСообщениямиСлужебный = ОбщегоНазначения.ОбщийМодуль(
			"РаботаСПочтовымиСообщениямиСлужебный");
		МодульРаботаСПочтовымиСообщениямиСлужебный.ПриЗаполненииРазрешенийНаДоступКВнешнимРесурсам(ЗапросыРазрешений);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСФайлами") Тогда
		МодульРаботаСФайламиСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебный");
		МодульРаботаСФайламиСлужебный.ПриЗаполненииРазрешенийНаДоступКВнешнимРесурсам(ЗапросыРазрешений);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РассылкаОтчетов") Тогда
		МодульРассылкаОтчетов = ОбщегоНазначения.ОбщийМодуль("РассылкаОтчетов");
		МодульРассылкаОтчетов.ПриЗаполненииРазрешенийНаДоступКВнешнимРесурсам(ЗапросыРазрешений);
	КонецЕсли;

	СтандартныеПодсистемыСервер.ПриЗаполненииРазрешенийНаДоступКВнешнимРесурсам(ЗапросыРазрешений);
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Мультиязычность.ПереводТекста") Тогда
		МодульПереводТекстаНаДругиеЯзыки = ОбщегоНазначения.ОбщийМодуль("ПереводТекстаНаДругиеЯзыки");
		МодульПереводТекстаНаДругиеЯзыки.ПриЗаполненииРазрешенийНаДоступКВнешнимРесурсам(ЗапросыРазрешений);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Печать") Тогда
		МодульУправлениеПечатью = ОбщегоНазначения.ОбщийМодуль("УправлениеПечатью");
		МодульУправлениеПечатью.ПриЗаполненииРазрешенийНаДоступКВнешнимРесурсам(ЗапросыРазрешений);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриЗаполненииРазрешенийНаДоступКВнешнимРесурсам Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриЗаполненииРазрешенийНаДоступКВнешнимРесурсам(ЗапросыРазрешений);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриЗаполненииРазрешенийНаДоступКВнешнимРесурсам Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриЗаполненииРазрешенийНаДоступКВнешнимРесурсам(ЗапросыРазрешений);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриЗаполненииРазрешенийНаДоступКВнешнимРесурсам Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриЗаполненииРазрешенийНаДоступКВнешнимРесурсам(ЗапросыРазрешений);
	КонецЕсли;
	
КонецПроцедуры

#Область ПрофилиБезопасности_ДляВнутреннегоИспользования

// Вызывается при регистрации менеджеров внешних модулей.
//
// Параметры:
//  Менеджеры - Массив - ссылки на модули.
//
Процедура ПриРегистрацииМенеджеровВнешнихМодулей(Менеджеры) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ДополнительныеОтчетыИОбработки") Тогда
		МодульДополнительныеОтчетыИОбработкиВБезопасномРежимеСлужебный = ОбщегоНазначения.ОбщийМодуль(
			"ДополнительныеОтчетыИОбработкиВБезопасномРежимеСлужебный");
		МодульДополнительныеОтчетыИОбработкиВБезопасномРежимеСлужебный.ПриРегистрацииМенеджеровВнешнихМодулей(Менеджеры);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ОбменДанными") Тогда
		МодульОбменДаннымиСервер = ОбщегоНазначения.ОбщийМодуль("ОбменДаннымиСервер");
		МодульОбменДаннымиСервер.ПриРегистрацииМенеджеровВнешнихМодулей(Менеджеры);
	КонецЕсли;

КонецПроцедуры

#КонецОбласти

#КонецОбласти

#Область РассылкаОтчетов

// См. РассылкаОтчетовПереопределяемый.ОпределитьИсключаемыеОтчеты
Процедура ПриОпределенииИсключаемыхОтчетов(ИсключаемыеОтчеты) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УправлениеДоступом") Тогда
		МодульУправлениеДоступомСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеДоступомСлужебный");
		МодульУправлениеДоступомСлужебный.ПриОпределенииИсключаемыхОтчетов(ИсключаемыеОтчеты);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Анкетирование") Тогда
		МодульАнкетирование = ОбщегоНазначения.ОбщийМодуль("Анкетирование");
		МодульАнкетирование.ПриОпределенииИсключаемыхОтчетов(ИсключаемыеОтчеты);
	КонецЕсли;

КонецПроцедуры

#КонецОбласти

#Область РаботаСПочтовымиСообщениями

// См. РаботаСПочтовымиСообщениямиПереопределяемый.ПередПолучениемСтатусовПисем
Процедура ПередПолучениемСтатусовПисем(ИдентификаторыПисем) Экспорт
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РассылкаОтчетов") Тогда
		МодульРассылкаОтчетов = ОбщегоНазначения.ОбщийМодуль("РассылкаОтчетов");
		МодульРассылкаОтчетов.ПередПолучениемСтатусовПисем(ИдентификаторыПисем);
	КонецЕсли;
	
КонецПроцедуры    

// См. РаботаСПочтовымиСообщениямиПереопределяемый.ПослеПолученияСтатусовПисем
Процедура ПослеПолученияСтатусовПисем(СтатусыДоставки) Экспорт
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РассылкаОтчетов") Тогда
		МодульРассылкаОтчетов = ОбщегоНазначения.ОбщийМодуль("РассылкаОтчетов");
		МодульРассылкаОтчетов.ПослеПолученияСтатусовПисем(СтатусыДоставки);
	КонецЕсли;
	
КонецПроцедуры

#КонецОбласти

#Область РаботаСФайлами

// Параметры:
//   Объекты - Массив из ОбъектМетаданных
//
Процедура ПриОпределенииОбъектовИсключенияСинхронизацииФайлов(Объекты) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Взаимодействия") Тогда
		МодульВзаимодействия = ОбщегоНазначения.ОбщийМодуль("Взаимодействия");
		МодульВзаимодействия.ПриОпределенииОбъектовИсключенияСинхронизацииФайлов(Объекты);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриОпределенииОбъектовИсключенияСинхронизацииФайлов Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриОпределенииОбъектовИсключенияСинхронизацииФайлов(Объекты);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриОпределенииОбъектовИсключенияСинхронизацииФайлов Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриОпределенииОбъектовИсключенияСинхронизацииФайлов(Объекты);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриОпределенииОбъектовИсключенияСинхронизацииФайлов Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриОпределенииОбъектовИсключенияСинхронизацииФайлов(Объекты);
	КонецЕсли;
	
КонецПроцедуры

// См. РаботаСФайламиПереопределяемый.ПриСозданииФормыСпискаФайлов
Процедура ПриСозданииФормыСпискаФайлов(Форма) Экспорт

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриСозданииФормыСпискаФайлов Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриСозданииФормыСпискаФайлов(Форма);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриСозданииФормыСпискаФайлов Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриСозданииФормыСпискаФайлов(Форма);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриСозданииФормыСпискаФайлов Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриСозданииФормыСпискаФайлов(Форма);
	КонецЕсли;
	
КонецПроцедуры

// См. РаботаСФайламиПереопределяемый.ПриСозданииФормыЭлементаФайлов
Процедура ПриСозданииФормыЭлементаФайлов(Форма) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Взаимодействия") Тогда
		МодульВзаимодействия = ОбщегоНазначения.ОбщийМодуль("Взаимодействия");
		МодульВзаимодействия.ПриСозданииФормыЭлементаФайлов(Форма);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриСозданииФормыЭлементаФайлов Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриСозданииФормыЭлементаФайлов(Форма);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриСозданииФормыЭлементаФайлов Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриСозданииФормыЭлементаФайлов(Форма);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриСозданииФормыЭлементаФайлов Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриСозданииФормыЭлементаФайлов(Форма);
	КонецЕсли;
	
КонецПроцедуры

// См. РаботаСФайламиПереопределяемый.ПриОтправкеФайловПочтой.
Процедура ПриОтправкеФайловПочтой(ПараметрыОтправки, ФайлыДляОтправки, ВладелецФайлов, УникальныйИдентификатор) Экспорт
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриОтправкеФайловПочтой Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриОтправкеФайловПочтой(ПараметрыОтправки, ФайлыДляОтправки, ВладелецФайлов,
			УникальныйИдентификатор);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриОтправкеФайловПочтой Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриОтправкеФайловПочтой(ПараметрыОтправки, ФайлыДляОтправки, ВладелецФайлов,
			УникальныйИдентификатор);
	КонецЕсли;
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриОтправкеФайловПочтой Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриОтправкеФайловПочтой(ПараметрыОтправки, ФайлыДляОтправки, ВладелецФайлов,
			УникальныйИдентификатор);
	КонецЕсли;
	
КонецПроцедуры

#КонецОбласти

#Область РегламентныеЗадания

// См. РегламентныеЗаданияПереопределяемый.ПриОпределенииНастроекРегламентныхЗаданий.
Процедура ПриОпределенииНастроекРегламентныхЗаданий(Настройки) Экспорт
	
	СтандартныеПодсистемыСервер.ПриОпределенииНастроекРегламентныхЗаданий(Настройки);
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.БизнесПроцессыИЗадачи") Тогда
		МодульБизнесПроцессыИЗадачиСервер = ОбщегоНазначения.ОбщийМодуль("БизнесПроцессыИЗадачиСервер");
		МодульБизнесПроцессыИЗадачиСервер.ПриОпределенииНастроекРегламентныхЗаданий(Настройки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Валюты") Тогда
		МодульРаботаСКурсамиВалют = ОбщегоНазначения.ОбщийМодуль("РаботаСКурсамиВалют");
		МодульРаботаСКурсамиВалют.ПриОпределенииНастроекРегламентныхЗаданий(Настройки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВариантыОтчетов") Тогда
		МодульВариантыОтчетовСлужебный = ОбщегоНазначения.ОбщийМодуль("ВариантыОтчетовСлужебный");
		МодульВариантыОтчетовСлужебный.ПриОпределенииНастроекРегламентныхЗаданий(Настройки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВерсионированиеОбъектов") Тогда
		МодульВерсионированиеОбъектов = ОбщегоНазначения.ОбщийМодуль("ВерсионированиеОбъектов");
		МодульВерсионированиеОбъектов.ПриОпределенииНастроекРегламентныхЗаданий(Настройки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Взаимодействия") Тогда
		МодульВзаимодействия = ОбщегоНазначения.ОбщийМодуль("Взаимодействия");
		МодульВзаимодействия.ПриОпределенииНастроекРегламентныхЗаданий(Настройки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ДополнительныеОтчетыИОбработки") Тогда
		МодульДополнительныеОтчетыИОбработки = ОбщегоНазначения.ОбщийМодуль("ДополнительныеОтчетыИОбработки");
		МодульДополнительныеОтчетыИОбработки.ПриОпределенииНастроекРегламентныхЗаданий(Настройки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЗащитаПерсональныхДанных") Тогда
		МодульЗащитаПерсональныхДанных = ОбщегоНазначения.ОбщийМодуль("ЗащитаПерсональныхДанных");
		МодульЗащитаПерсональныхДанных.ПриОпределенииНастроекРегламентныхЗаданий(Настройки);
	КонецЕсли;

	ОбновлениеИнформационнойБазыСлужебный.ПриОпределенииНастроекРегламентныхЗаданий(Настройки);

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ОбменДанными") Тогда
		МодульОбменДаннымиСервер = ОбщегоНазначения.ОбщийМодуль("ОбменДаннымиСервер");
		МодульОбменДаннымиСервер.ПриОпределенииНастроекРегламентныхЗаданий(Настройки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаВМоделиСервиса.ОбменДаннымиВМоделиСервиса") Тогда
		МодульОбменДаннымиВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль("ОбменДаннымиВМоделиСервиса");
		МодульОбменДаннымиВМоделиСервиса.ПриОпределенииНастроекРегламентныхЗаданий(Настройки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ОценкаПроизводительности") Тогда
		МодульОценкаПроизводительностиСлужебный = ОбщегоНазначения.ОбщийМодуль("ОценкаПроизводительностиСлужебный");
		МодульОценкаПроизводительностиСлужебный.ПриОпределенииНастроекРегламентныхЗаданий(Настройки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ПолнотекстовыйПоиск") Тогда
		МодульПолнотекстовыйПоискСервер = ОбщегоНазначения.ОбщийМодуль("ПолнотекстовыйПоискСервер");
		МодульПолнотекстовыйПоискСервер.ПриОпределенииНастроекРегламентныхЗаданий(Настройки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСФайлами") Тогда
		МодульРаботаСФайламиСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебный");
		МодульРаботаСФайламиСлужебный.ПриОпределенииНастроекРегламентныхЗаданий(Настройки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РассылкаОтчетов") Тогда
		МодульРассылкаОтчетов = ОбщегоНазначения.ОбщийМодуль("РассылкаОтчетов");
		МодульРассылкаОтчетов.ПриОпределенииНастроекРегламентныхЗаданий(Настройки);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УправлениеДоступом") Тогда
		МодульУправлениеДоступомСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеДоступомСлужебный");
		МодульУправлениеДоступомСлужебный.ПриОпределенииНастроекРегламентныхЗаданий(Настройки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЦентрМониторинга") Тогда
		МодульЦентрМониторингаСлужебный = ОбщегоНазначения.ОбщийМодуль("ЦентрМониторингаСлужебный");
		МодульЦентрМониторингаСлужебный.ПриОпределенииНастроекРегламентныхЗаданий(Настройки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УдалениеПомеченныхОбъектов") Тогда
		МодульУдалениеПомеченныхОбъектовСлужебный = ОбщегоНазначения.ОбщийМодуль("УдалениеПомеченныхОбъектовСлужебный");
		МодульУдалениеПомеченныхОбъектовСлужебный.ПриОпределенииНастроекРегламентныхЗаданий(Настройки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЭлектроннаяПодпись") Тогда
		МодульЭлектроннаяПодписьСлужебный = ОбщегоНазначения.ОбщийМодуль("ЭлектроннаяПодписьСлужебный");
		МодульЭлектроннаяПодписьСлужебный.ПриОпределенииНастроекРегламентныхЗаданий(Настройки);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.МашиночитаемыеДоверенности") Тогда
		МодульМашиночитаемыеДоверенностиФНССлужебный = ОбщегоНазначения.ОбщийМодуль("МашиночитаемыеДоверенностиФНССлужебный");
		МодульМашиночитаемыеДоверенностиФНССлужебный.ПриОпределенииНастроекРегламентныхЗаданий(Настройки);
	КонецЕсли;
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриОпределенииНастроекРегламентныхЗаданий Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриОпределенииНастроекРегламентныхЗаданий(Настройки);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриОпределенииНастроекРегламентныхЗаданий Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриОпределенииНастроекРегламентныхЗаданий(Настройки);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриОпределенииНастроекРегламентныхЗаданий Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриОпределенииНастроекРегламентныхЗаданий(Настройки);
	КонецЕсли;
	
КонецПроцедуры

// См. БлокировкаРаботыСВнешнимиРесурсамиПереопределяемый.ПриЗапретеРаботыСВнешнимиРесурсами.
Процедура ПриЗапретеРаботыСВнешнимиРесурсами() Экспорт
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Обсуждения") Тогда
		МодульОбсужденияСлужебный = ОбщегоНазначения.ОбщийМодуль("ОбсужденияСлужебный");
		МодульОбсужденияСлужебный.Заблокировать();
	КонецЕсли;
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриЗапретеРаботыСВнешнимиРесурсами Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриЗапретеРаботыСВнешнимиРесурсами();
	КонецЕсли;
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриЗапретеРаботыСВнешнимиРесурсами Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриЗапретеРаботыСВнешнимиРесурсами();
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриЗапретеРаботыСВнешнимиРесурсами Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриЗапретеРаботыСВнешнимиРесурсами();
	КонецЕсли;
		
КонецПроцедуры

// См. БлокировкаРаботыСВнешнимиРесурсамиПереопределяемый.ПриРазрешенииРаботыСВнешнимиРесурсами.
Процедура ПриРазрешенииРаботыСВнешнимиРесурсами() Экспорт
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Обсуждения") Тогда
		МодульОбсужденияСлужебный = ОбщегоНазначения.ОбщийМодуль("ОбсужденияСлужебный");
		МодульОбсужденияСлужебный.Разблокировать();
	КонецЕсли;
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриРазрешенииРаботыСВнешнимиРесурсами Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриРазрешенииРаботыСВнешнимиРесурсами();
	КонецЕсли;
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриРазрешенииРаботыСВнешнимиРесурсами Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриРазрешенииРаботыСВнешнимиРесурсами();
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриРазрешенииРаботыСВнешнимиРесурсами Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриРазрешенииРаботыСВнешнимиРесурсами();
	КонецЕсли;
		
КонецПроцедуры

#КонецОбласти

#Область Свойства

// См. УправлениеСвойствамиПереопределяемый.ПриПолученииПредопределенныхНаборовСвойств.
Процедура ПриПолученииПредопределенныхНаборовСвойств(Наборы) Экспорт

	ПользователиСлужебный.ПриПолученииПредопределенныхНаборовСвойств(Наборы);

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Взаимодействия") Тогда
		МодульВзаимодействия = ОбщегоНазначения.ОбщийМодуль("Взаимодействия");
		МодульВзаимодействия.ПриПолученииПредопределенныхНаборовСвойств(Наборы);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЗащитаПерсональныхДанных") Тогда
		МодульЗащитаПерсональныхДанных = ОбщегоНазначения.ОбщийМодуль("ЗащитаПерсональныхДанных");
		МодульЗащитаПерсональныхДанных.ПриПолученииПредопределенныхНаборовСвойств(Наборы);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСФайлами") Тогда
		МодульРаботаСФайламиСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебный");
		МодульРаботаСФайламиСлужебный.ПриПолученииПредопределенныхНаборовСвойств(Наборы);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ДополнительныеОтчетыИОбработки") Тогда
		МодульДополнительныеОтчетыИОбработки = ОбщегоНазначения.ОбщийМодуль("ДополнительныеОтчетыИОбработки");
		МодульДополнительныеОтчетыИОбработки.ПриПолученииПредопределенныхНаборовСвойств(Наборы);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КонтактнаяИнформация") Тогда
		МодульУправлениеКонтактнойИнформацией = ОбщегоНазначения.ОбщийМодуль("УправлениеКонтактнойИнформацией");
		МодульУправлениеКонтактнойИнформацией.ПриПолученииПредопределенныхНаборовСвойств(Наборы);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриПолученииПредопределенныхНаборовСвойств Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриПолученииПредопределенныхНаборовСвойств(Наборы);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриПолученииПредопределенныхНаборовСвойств Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриПолученииПредопределенныхНаборовСвойств(Наборы);
	КонецЕсли;

КонецПроцедуры

#КонецОбласти

#Область ТекущиеДела

// См. ТекущиеДелаПереопределяемый.ПриОпределенииОбработчиковТекущихДел
Процедура ПриОпределенииОбработчиковТекущихДел(ТекущиеДела) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.АдресныйКлассификатор") Тогда
		ТекущиеДела.Добавить(ОбщегоНазначения.ОбщийМодуль("АдресныйКлассификаторСлужебный"));
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.БизнесПроцессыИЗадачи") Тогда
		ТекущиеДела.Добавить(ОбщегоНазначения.ОбщийМодуль("БизнесПроцессыИЗадачиСервер"));
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВерсионированиеОбъектов") Тогда
		ТекущиеДела.Добавить(ОбщегоНазначения.ОбщийМодуль("ВерсионированиеОбъектов"));
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Взаимодействия") Тогда
		ТекущиеДела.Добавить(ОбщегоНазначения.ОбщийМодуль("Взаимодействия"));
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВнешниеКомпоненты") Тогда
		ТекущиеДела.Добавить(ОбщегоНазначения.ОбщийМодуль("ВнешниеКомпонентыСлужебный"));
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ДополнительныеОтчетыИОбработки") Тогда
		ТекущиеДела.Добавить(ОбщегоНазначения.ОбщийМодуль("ДополнительныеОтчетыИОбработки"));
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЗаметкиПользователя") Тогда
		ТекущиеДела.Добавить(ОбщегоНазначения.ОбщийМодуль("ЗаметкиПользователяСлужебный"));
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЗащитаПерсональныхДанных") Тогда
		ТекущиеДела.Добавить(ОбщегоНазначения.ОбщийМодуль("ЗащитаПерсональныхДанных"));
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ОбменДанными") Тогда
		ТекущиеДела.Добавить(ОбщегоНазначения.ОбщийМодуль("ОбменДаннымиСервер"));
	КонецЕсли;

	ТекущиеДела.Добавить(ОбновлениеИнформационнойБазыСлужебный);

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ПолнотекстовыйПоиск") Тогда
		ТекущиеДела.Добавить(ОбщегоНазначения.ОбщийМодуль("ПолнотекстовыйПоискСервер"));
	КонецЕсли;

	ТекущиеДела.Добавить(ПользователиСлужебный);

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Банки") Тогда
		ТекущиеДела.Добавить(ОбщегоНазначения.ОбщийМодуль("РаботаСБанками"));
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Валюты") Тогда
		ТекущиеДела.Добавить(ОбщегоНазначения.ОбщийМодуль("РаботаСКурсамиВалют"));
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ОтправкаSMS") Тогда
		ТекущиеДела.Добавить(ОбщегоНазначения.ОбщийМодуль("ОтправкаSMS"));
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСФайлами") Тогда
		ТекущиеДела.Добавить(ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебный"));
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РассылкаОтчетов") Тогда
		ТекущиеДела.Добавить(ОбщегоНазначения.ОбщийМодуль("РассылкаОтчетов"));
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РезервноеКопированиеИБ") Тогда
		ТекущиеДела.Добавить(ОбщегоНазначения.ОбщийМодуль("РезервноеКопированиеИБСервер"));
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЗавершениеРаботыПользователей") Тогда
		ТекущиеДела.Добавить(ОбщегоНазначения.ОбщийМодуль("СоединенияИБ"));
	КонецЕсли;

	ТекущиеДела.Добавить(СтандартныеПодсистемыСервер);

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УправлениеИтогамиИАгрегатами") Тогда
		ТекущиеДела.Добавить(ОбщегоНазначения.ОбщийМодуль("УправлениеИтогамиИАгрегатамиСлужебный"));
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Печать") Тогда
		ТекущиеДела.Добавить(ОбщегоНазначения.ОбщийМодуль("УправлениеПечатью"));
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УправлениеДоступом") Тогда
		ТекущиеДела.Добавить(ОбщегоНазначения.ОбщийМодуль("Справочники.ПрофилиГруппДоступа"));
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КонтрольВеденияУчета") Тогда
		ТекущиеДела.Добавить(ОбщегоНазначения.ОбщийМодуль("КонтрольВеденияУчетаСлужебный"));
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЦентрМониторинга") Тогда
		ТекущиеДела.Добавить(ОбщегоНазначения.ОбщийМодуль("ЦентрМониторингаСлужебный"));
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЭлектроннаяПодпись") Тогда
		ТекущиеДела.Добавить(ОбщегоНазначения.ОбщийМодуль("ЭлектроннаяПодписьСлужебный"));
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.МашиночитаемыеДоверенности") Тогда
		ТекущиеДела.Добавить(ОбщегоНазначения.ОбщийМодуль("МашиночитаемыеДоверенностиФНССлужебный"));
	КонецЕсли;
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриОпределенииОбработчиковТекущихДел Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриОпределенииОбработчиковТекущихДел(ТекущиеДела);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриОпределенииОбработчиковТекущихДел Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриОпределенииОбработчиковТекущихДел(ТекущиеДела);
	КонецЕсли;

КонецПроцедуры

// Параметры:
//   ТекущиеДела - см. ТекущиеДелаСервер.ТекущиеДела.
//
Процедура ПриЗаполненииСпискаТекущихДел(ТекущиеДела) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КонтрольРаботыПользователей") Тогда
		МодульКонтрольРаботыПользователейСлужебный = ОбщегоНазначения.ОбщийМодуль("КонтрольРаботыПользователейСлужебный");
		МодульКонтрольРаботыПользователейСлужебный.ПриЗаполненииСпискаТекущихДел(ТекущиеДела);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УдалениеПомеченныхОбъектов") Тогда
		МодульУдалениеПомеченныхОбъектовСлужебный = ОбщегоНазначения.ОбщийМодуль("УдалениеПомеченныхОбъектовСлужебный");
		МодульУдалениеПомеченныхОбъектовСлужебный.ПриЗаполненииСпискаТекущихДел(ТекущиеДела);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриЗаполненииСпискаТекущихДел Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриЗаполненииСпискаТекущихДел(ТекущиеДела);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриЗаполненииСпискаТекущихДел Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриЗаполненииСпискаТекущихДел(ТекущиеДела);
	КонецЕсли;

КонецПроцедуры

// См. ТекущиеДелаПереопределяемый.ПриОпределенииПорядкаРазделовКомандногоИнтерфейса.
Процедура ПриОпределенииПорядкаРазделовКомандногоИнтерфейса(ПорядокРазделовКомандногоИнтерфейса) Экспорт

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриОпределенииПорядкаРазделовКомандногоИнтерфейса Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриОпределенииПорядкаРазделовКомандногоИнтерфейса(
			ПорядокРазделовКомандногоИнтерфейса);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриОпределенииПорядкаРазделовКомандногоИнтерфейса Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриОпределенииПорядкаРазделовКомандногоИнтерфейса(
			ПорядокРазделовКомандногоИнтерфейса);
	КонецЕсли;

КонецПроцедуры

// См. ТекущиеДелаПереопределяемый.ПриОтключенииТекущихДел.
Процедура ПриОтключенииТекущихДел(ОтключаемыеДела) Экспорт

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриОтключенииТекущихДел Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриОтключенииТекущихДел(ОтключаемыеДела);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриОтключенииТекущихДел Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриОтключенииТекущихДел(ОтключаемыеДела);
	КонецЕсли;

КонецПроцедуры

// См. ТекущиеДелаПереопределяемый.ПриОпределенииНастроек.
Процедура ПриОпределенииНастроекТекущихДел(Настройки) Экспорт

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриОпределенииНастроекТекущихДел Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриОпределенииНастроекТекущихДел(Настройки);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриОпределенииНастроекТекущихДел Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриОпределенииНастроекТекущихДел(Настройки);
	КонецЕсли;

КонецПроцедуры

// См. ТекущиеДелаПереопределяемый.УстановитьОбщиеПараметрыЗапросов.
Процедура ПриУстановкеОбщихПараметровЗапросов(Запрос, ОбщиеПараметрыЗапросов) Экспорт

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриУстановкеОбщихПараметровЗапросов Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриУстановкеОбщихПараметровЗапросов(Запрос, ОбщиеПараметрыЗапросов);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриУстановкеОбщихПараметровЗапросов Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриУстановкеОбщихПараметровЗапросов(Запрос, ОбщиеПараметрыЗапросов);
	КонецЕсли;

КонецПроцедуры

#КонецОбласти

#Область УправлениеДоступом

// См. УправлениеДоступомПереопределяемый.ПриЗаполненииВидовДоступа.
Процедура ПриЗаполненииВидовДоступа(ВидыДоступа) Экспорт
	
	// Вызов в подсистему Пользователи должен быть первым.
	ПользователиСлужебный.ПриЗаполненииВидовДоступа(ВидыДоступа);

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.БизнесПроцессыИЗадачи") Тогда
		МодульБизнесПроцессыИЗадачиСервер = ОбщегоНазначения.ОбщийМодуль("БизнесПроцессыИЗадачиСервер");
		МодульБизнесПроцессыИЗадачиСервер.ПриЗаполненииВидовДоступа(ВидыДоступа);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ДополнительныеОтчетыИОбработки") Тогда
		МодульДополнительныеОтчетыИОбработки = ОбщегоНазначения.ОбщийМодуль("ДополнительныеОтчетыИОбработки");
		МодульДополнительныеОтчетыИОбработки.ПриЗаполненииВидовДоступа(ВидыДоступа);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСПочтовымиСообщениями") Тогда
		МодульРаботаСПочтовымиСообщениямиСлужебный = ОбщегоНазначения.ОбщийМодуль(
			"РаботаСПочтовымиСообщениямиСлужебный");
		МодульРаботаСПочтовымиСообщениямиСлужебный.ПриЗаполненииВидовДоступа(ВидыДоступа);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Свойства") Тогда
		МодульУправлениеСвойствамиСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеСвойствамиСлужебный");
		МодульУправлениеСвойствамиСлужебный.ПриЗаполненииВидовДоступа(ВидыДоступа);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриЗаполненииВидовДоступа Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриЗаполненииВидовДоступа(ВидыДоступа);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриЗаполненииВидовДоступа Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриЗаполненииВидовДоступа(ВидыДоступа);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриЗаполненииВидовДоступа Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриЗаполненииВидовДоступа(ВидыДоступа);
	КонецЕсли;
	
КонецПроцедуры

// См. УправлениеДоступомПереопределяемый.ПриЗаполненииСписковСОграничениемДоступа.
Процедура ПриЗаполненииСписковСОграничениемДоступа(Списки) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Анкетирование") Тогда
		МодульАнкетирование = ОбщегоНазначения.ОбщийМодуль("Анкетирование");
		МодульАнкетирование.ПриЗаполненииСписковСОграничениемДоступа(Списки);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.БизнесПроцессыИЗадачи") Тогда
		МодульБизнесПроцессыИЗадачиСервер = ОбщегоНазначения.ОбщийМодуль("БизнесПроцессыИЗадачиСервер");
		МодульБизнесПроцессыИЗадачиСервер.ПриЗаполненииСписковСОграничениемДоступа(Списки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВариантыОтчетов") Тогда
		МодульВариантыОтчетов = ОбщегоНазначения.ОбщийМодуль("ВариантыОтчетов");
		МодульВариантыОтчетов.ПриЗаполненииСписковСОграничениемДоступа(Списки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Взаимодействия") Тогда
		МодульВзаимодействия = ОбщегоНазначения.ОбщийМодуль("Взаимодействия");
		МодульВзаимодействия.ПриЗаполненииСписковСОграничениемДоступа(Списки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ДатыЗапретаИзменения") Тогда
		МодульДатыЗапретаИзмененияСлужебный = ОбщегоНазначения.ОбщийМодуль("ДатыЗапретаИзмененияСлужебный");
		МодульДатыЗапретаИзмененияСлужебный.ПриЗаполненииСписковСОграничениемДоступа(Списки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ДополнительныеОтчетыИОбработки") Тогда
		МодульДополнительныеОтчетыИОбработки = ОбщегоНазначения.ОбщийМодуль("ДополнительныеОтчетыИОбработки");
		МодульДополнительныеОтчетыИОбработки.ПриЗаполненииСписковСОграничениемДоступа(Списки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЗаметкиПользователя") Тогда
		МодульЗаметкиПользователяСлужебный = ОбщегоНазначения.ОбщийМодуль("ЗаметкиПользователяСлужебный");
		МодульЗаметкиПользователяСлужебный.ПриЗаполненииСписковСОграничениемДоступа(Списки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.КонтрольВеденияУчета") Тогда
		МодульКонтрольВеденияУчетаСлужебный = ОбщегоНазначения.ОбщийМодуль("КонтрольВеденияУчетаСлужебный");
		МодульКонтрольВеденияУчетаСлужебный.ПриЗаполненииСписковСОграничениемДоступа(Списки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.НапоминанияПользователя") Тогда
		МодульНапоминанияПользователяСлужебный = ОбщегоНазначения.ОбщийМодуль("НапоминанияПользователяСлужебный");
		МодульНапоминанияПользователяСлужебный.ПриЗаполненииСписковСОграничениемДоступа(Списки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Пользователи") Тогда
		МодульПользователиСлужебный = ОбщегоНазначения.ОбщийМодуль("ПользователиСлужебный");
		МодульПользователиСлужебный.ПриЗаполненииСписковСОграничениемДоступа(Списки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСПочтовымиСообщениями") Тогда
		МодульРаботаСПочтовымиСообщениямиСлужебный = ОбщегоНазначения.ОбщийМодуль(
			"РаботаСПочтовымиСообщениямиСлужебный");
		МодульРаботаСПочтовымиСообщениямиСлужебный.ПриЗаполненииСписковСОграничениемДоступа(Списки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСФайлами") Тогда
		МодульРаботаСФайламиСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебный");
		МодульРаботаСФайламиСлужебный.ПриЗаполненииСписковСОграничениемДоступа(Списки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РассылкаОтчетов") Тогда
		МодульРассылкаОтчетов = ОбщегоНазначения.ОбщийМодуль("РассылкаОтчетов");
		МодульРассылкаОтчетов.ПриЗаполненииСписковСОграничениемДоступа(Списки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Свойства") Тогда
		МодульУправлениеСвойствамиСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеСвойствамиСлужебный");
		МодульУправлениеСвойствамиСлужебный.ПриЗаполненииСписковСОграничениемДоступа(Списки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.УправлениеДоступом") Тогда
		МодульУправлениеДоступомСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеДоступомСлужебный");
		МодульУправлениеДоступомСлужебный.ПриЗаполненииСписковСОграничениемДоступа(Списки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ШаблоныСообщений") Тогда
		МодульШаблоныСообщенийСлужебный = ОбщегоНазначения.ОбщийМодуль("ШаблоныСообщенийСлужебный");
		МодульШаблоныСообщенийСлужебный.ПриЗаполненииСписковСОграничениемДоступа(Списки);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриЗаполненииСписковСОграничениемДоступа Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриЗаполненииСписковСОграничениемДоступа(Списки);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриЗаполненииСписковСОграничениемДоступа Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриЗаполненииСписковСОграничениемДоступа(Списки);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЭлектроннаяПодписьСервисаDSS") Тогда
		МодульСервисКриптографииDSSСлужебный = ОбщегоНазначения.ОбщийМодуль("СервисКриптографииDSSСлужебный");
		МодульСервисКриптографииDSSСлужебный.ПриЗаполненииСписковСОграничениемДоступа(Списки);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриЗаполненииСписковСОграничениемДоступа Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриЗаполненииСписковСОграничениемДоступа(Списки);
	КонецЕсли;
		
КонецПроцедуры

// См. УправлениеДоступомПереопределяемый.ПриЗаполненииПоставляемыхПрофилейГруппДоступа.
Процедура ПриЗаполненииПоставляемыхПрофилейГруппДоступа(ОписанияПрофилей, ПараметрыОбновления) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ОбменДанными") Тогда
		МодульОбменДаннымиСервер = ОбщегоНазначения.ОбщийМодуль("ОбменДаннымиСервер");
		МодульОбменДаннымиСервер.ПриЗаполненииПоставляемыхПрофилейГруппДоступа(ОписанияПрофилей, ПараметрыОбновления);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриЗаполненииПоставляемыхПрофилейГруппДоступа Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриЗаполненииПоставляемыхПрофилейГруппДоступа(ОписанияПрофилей,
			ПараметрыОбновления);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриЗаполненииПоставляемыхПрофилейГруппДоступа Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриЗаполненииПоставляемыхПрофилейГруппДоступа(ОписанияПрофилей,
			ПараметрыОбновления);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриЗаполненииПоставляемыхПрофилейГруппДоступа Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриЗаполненииПоставляемыхПрофилейГруппДоступа(ОписанияПрофилей,
			ПараметрыОбновления);
	КонецЕсли;
		
КонецПроцедуры

// См. УправлениеДоступомПереопределяемый.ПриЗаполненииЗависимостейПравДоступа.
Процедура ПриЗаполненииЗависимостейПравДоступа(ЗависимостиПрав) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.БизнесПроцессыИЗадачи") Тогда
		МодульБизнесПроцессыИЗадачиСервер = ОбщегоНазначения.ОбщийМодуль("БизнесПроцессыИЗадачиСервер");
		МодульБизнесПроцессыИЗадачиСервер.ПриЗаполненииЗависимостейПравДоступа(ЗависимостиПрав);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриЗаполненииЗависимостейПравДоступа Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриЗаполненииЗависимостейПравДоступа(ЗависимостиПрав);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриЗаполненииЗависимостейПравДоступа Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриЗаполненииЗависимостейПравДоступа(ЗависимостиПрав);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриЗаполненииЗависимостейПравДоступа Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриЗаполненииЗависимостейПравДоступа(ЗависимостиПрав);
	КонецЕсли;
	
КонецПроцедуры

// См. УправлениеДоступомПереопределяемый.ПриЗаполненииВозможныхПравДляНастройкиПравОбъектов.
Процедура ПриЗаполненииВозможныхПравДляНастройкиПравОбъектов(ВозможныеПрава) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСФайлами") Тогда
		МодульРаботаСФайламиСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебный");
		МодульРаботаСФайламиСлужебный.ПриЗаполненииВозможныхПравДляНастройкиПравОбъектов(ВозможныеПрава);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриЗаполненииВозможныхПравДляНастройкиПравОбъектов Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриЗаполненииВозможныхПравДляНастройкиПравОбъектов(ВозможныеПрава);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриЗаполненииВозможныхПравДляНастройкиПравОбъектов Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриЗаполненииВозможныхПравДляНастройкиПравОбъектов(ВозможныеПрава);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриЗаполненииВозможныхПравДляНастройкиПравОбъектов Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриЗаполненииВозможныхПравДляНастройкиПравОбъектов(ВозможныеПрава);
	КонецЕсли;
	
КонецПроцедуры

// См. УправлениеДоступомПереопределяемый.ПриЗаполненииИспользованияВидаДоступа.
Процедура ПриЗаполненииИспользованияВидаДоступа(ВидДоступа, Использование) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ДополнительныеОтчетыИОбработки") Тогда
		МодульДополнительныеОтчетыИОбработки = ОбщегоНазначения.ОбщийМодуль("ДополнительныеОтчетыИОбработки");
		МодульДополнительныеОтчетыИОбработки.ПриЗаполненииИспользованияВидаДоступа(ВидДоступа, Использование);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Свойства") Тогда
		МодульУправлениеСвойствамиСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеСвойствамиСлужебный");
		МодульУправлениеСвойствамиСлужебный.ПриЗаполненииИспользованияВидаДоступа(ВидДоступа, Использование);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриЗаполненииИспользованияВидаДоступа Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриЗаполненииИспользованияВидаДоступа(ВидДоступа, Использование);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриЗаполненииИспользованияВидаДоступа Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриЗаполненииИспользованияВидаДоступа(ВидДоступа, Использование);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриЗаполненииИспользованияВидаДоступа Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриЗаполненииИспользованияВидаДоступа(ВидДоступа, Использование);
	КонецЕсли;
	
КонецПроцедуры

// См. УправлениеДоступомПереопределяемый.ПриЗаполненииВидовОграниченийПравОбъектовМетаданных.
Процедура ПриЗаполненииВидовОграниченийПравОбъектовМетаданных(Описание) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.БизнесПроцессыИЗадачи") Тогда
		МодульБизнесПроцессыИЗадачиСервер = ОбщегоНазначения.ОбщийМодуль("БизнесПроцессыИЗадачиСервер");
		МодульБизнесПроцессыИЗадачиСервер.ПриЗаполненииВидовОграниченийПравОбъектовМетаданных(Описание);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Взаимодействия") Тогда
		МодульВзаимодействия = ОбщегоНазначения.ОбщийМодуль("Взаимодействия");
		МодульВзаимодействия.ПриЗаполненииВидовОграниченийПравОбъектовМетаданных(Описание);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ДополнительныеОтчетыИОбработки") Тогда
		МодульДополнительныеОтчетыИОбработки = ОбщегоНазначения.ОбщийМодуль("ДополнительныеОтчетыИОбработки");
		МодульДополнительныеОтчетыИОбработки.ПриЗаполненииВидовОграниченийПравОбъектовМетаданных(Описание);
	КонецЕсли;

	ПользователиСлужебный.ПриЗаполненииВидовОграниченийПравОбъектовМетаданных(Описание);

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСПочтовымиСообщениями") Тогда
		МодульРаботаСПочтовымиСообщениямиСлужебный = ОбщегоНазначения.ОбщийМодуль(
			"РаботаСПочтовымиСообщениямиСлужебный");
		МодульРаботаСПочтовымиСообщениямиСлужебный.ПриЗаполненииВидовОграниченийПравОбъектовМетаданных(Описание);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСФайлами") Тогда
		МодульРаботаСФайламиСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебный");
		МодульРаботаСФайламиСлужебный.ПриЗаполненииВидовОграниченийПравОбъектовМетаданных(Описание);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.Свойства") Тогда
		МодульУправлениеСвойствамиСлужебный = ОбщегоНазначения.ОбщийМодуль("УправлениеСвойствамиСлужебный");
		МодульУправлениеСвойствамиСлужебный.ПриЗаполненииВидовОграниченийПравОбъектовМетаданных(Описание);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ШаблоныСообщений") Тогда
		МодульШаблоныСообщенийСлужебный = ОбщегоНазначения.ОбщийМодуль("ШаблоныСообщенийСлужебный");
		МодульШаблоныСообщенийСлужебный.ПриЗаполненииВидовОграниченийПравОбъектовМетаданных(Описание);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриЗаполненииВидовОграниченийПравОбъектовМетаданных Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриЗаполненииВидовОграниченийПравОбъектовМетаданных(Описание);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриЗаполненииВидовОграниченийПравОбъектовМетаданных Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриЗаполненииВидовОграниченийПравОбъектовМетаданных(Описание);
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ЭлектроннаяПодписьСервисаDSS") Тогда
		МодульСервисКриптографииDSSСлужебный = ОбщегоНазначения.ОбщийМодуль("СервисКриптографииDSSСлужебный");
		МодульСервисКриптографииDSSСлужебный.ПриЗаполненииВидовОграниченийПравОбъектовМетаданных(Описание);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриЗаполненииВидовОграниченийПравОбъектовМетаданных Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриЗаполненииВидовОграниченийПравОбъектовМетаданных(Описание);
	КонецЕсли;
		
КонецПроцедуры

#Область УправлениеДоступом_ДляВнутреннегоИспользования

// Возвращает менеджер временных таблиц, содержащий временную таблицу пользователей
// некоторых дополнительных групп пользователей, например, пользователей групп
// исполнителей задач, которые соответствуют ключам адресации
// (РольИсполнителя + ОсновнойОбъектАдресации + ДополнительныйОбъектАдресации).
//
// Параметры:
//  МенеджерВременныхТаблиц - МенеджерВременныхТаблиц - в который можно поместить таблицу
//                            ТаблицаГруппИсполнителей с полями:
//                              ГруппаИсполнителей - Например,
//                                                   СправочникСсылка.ГруппыИсполнителейЗадач.
//                              Пользователь       - СправочникСсылка.Пользователи
//                                                 - СправочникСсылка.ВнешниеПользователи.
//
//  СодержаниеПараметра     - Неопределено - параметр не указан, вернуть все данные.
//                            Строка, когда
//                              "ГруппыИсполнителей" требуется вернуть
//                               только составы указанных групп исполнителей.
//                              "Исполнители" требуется вернуть
//                               только составы групп исполнителей, которые
//                               в которые входят указанные исполнители.
//
//  ЗначениеПараметра       - Неопределено - когда СодержаниеПараметра = Неопределено,
//                          - СправочникСсылка.ГруппыИсполнителейЗадач - 
//                              когда СодержаниеПараметра = "ГруппыИсполнителей".
//                          - СправочникСсылка.Пользователи
//                          - СправочникСсылка.ВнешниеПользователи -
//                              когда СодержаниеПараметра = "Исполнители".
//                          - Массив - массив указанных выше типов.
//
//  НетГруппИсполнителей    - Булево - если Ложь, МенеджерВременныхТаблиц содержит временную таблицу, иначе нет.
//
Процедура ПриОпределенииГруппИсполнителей(МенеджерВременныхТаблиц, СодержаниеПараметра, ЗначениеПараметра,
	НетГруппИсполнителей) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.БизнесПроцессыИЗадачи") Тогда
		МодульБизнесПроцессыИЗадачиСервер = ОбщегоНазначения.ОбщийМодуль("БизнесПроцессыИЗадачиСервер");
		МодульБизнесПроцессыИЗадачиСервер.ПриОпределенииГруппИсполнителей(МенеджерВременныхТаблиц, СодержаниеПараметра,
			ЗначениеПараметра, НетГруппИсполнителей);
	КонецЕсли;

КонецПроцедуры

// Вызывается при обновлении ролей пользователя информационной базы.
//
// Параметры:
//  ИдентификаторПользователяИБ - УникальныйИдентификатор,
//  Отказ - Булево - при установке значения параметра в значение Ложь внутри обработчика события
//    обновление ролей для этого пользователя информационной базы будет пропущено.
//
Процедура ПриОбновленииРолейПользователяИБ(ИдентификаторПользователяИБ, Отказ) Экспорт

	Если ОбщегоНазначения.ПодсистемаСуществует(
		"СтандартныеПодсистемы.РаботаВМоделиСервиса.УправлениеДоступомВМоделиСервиса") Тогда
		МодульУправлениеДоступомСлужебныйВМоделиСервиса = ОбщегоНазначения.ОбщийМодуль(
			"УправлениеДоступомСлужебныйВМоделиСервиса");
		МодульУправлениеДоступомСлужебныйВМоделиСервиса.ПриОбновленииРолейПользователяИБ(ИдентификаторПользователяИБ,
			Отказ);
	КонецЕсли;

КонецПроцедуры

#КонецОбласти

#КонецОбласти

#Область УдалениеПомеченныхОбъектов

// См. УдалениеПомеченныхОбъектовПереопределяемый.ПередУдалениемГруппыОбъектов
Процедура ПередУдалениемГруппыОбъектов(Контекст, УдаляемыеОбъекты) Экспорт
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСФайлами") Тогда
		МодульРаботаСФайламиСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебный");
		МодульРаботаСФайламиСлужебный.ПередУдалениемГруппыОбъектов(Контекст, УдаляемыеОбъекты);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВерсионированиеОбъектов") Тогда
		МодульВерсионированиеОбъектов = ОбщегоНазначения.ОбщийМодуль("ВерсионированиеОбъектов");
		МодульВерсионированиеОбъектов.ПередУдалениемГруппыОбъектов(Контекст, УдаляемыеОбъекты);
	КонецЕсли;
		
КонецПроцедуры

// См. УдалениеПомеченныхОбъектовПереопределяемый.ПослеУдаленияГруппыОбъектов
Процедура ПослеУдаленияГруппыОбъектов(Контекст, Успешно) Экспорт
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСФайлами") Тогда
		МодульРаботаСФайламиСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебный");
		МодульРаботаСФайламиСлужебный.ПослеУдаленияГруппыОбъектов(Контекст, Успешно);
	КонецЕсли;
	
	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВерсионированиеОбъектов") Тогда
		МодульВерсионированиеОбъектов = ОбщегоНазначения.ОбщийМодуль("ВерсионированиеОбъектов");
		МодульВерсионированиеОбъектов.ПослеУдаленияГруппыОбъектов(Контекст, Успешно);
	КонецЕсли;
	
КонецПроцедуры

#КонецОбласти  

#Область УчетОригиналовПервичныхДокументов

// См. УчетОригиналовПервичныхДокументовПереопределяемый.ПриОпределенииНастроек
Процедура ПриОпределенииНастроекУчетаОригиналов(Настройки) Экспорт
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриОпределенииНастроекУчетаОригиналов Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриОпределенииНастроекУчетаОригиналов(Настройки);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриОпределенииНастроекУчетаОригиналов Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриОпределенииНастроекУчетаОригиналов(Настройки);
	КонецЕсли;
	
КонецПроцедуры

// См. УчетОригиналовПервичныхДокументовПереопределяемый.ПриИзмененииОбщегоСостоянияОригинала
Процедура ПриИзмененииОбщегоСостоянияОригинала(Документ, СостояниеОригинала) Экспорт
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриИзмененииОбщегоСостоянияОригинала Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриИзмененииОбщегоСостоянияОригинала(Документ, СостояниеОригинала);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриИзмененииОбщегоСостоянияОригинала Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриИзмененииОбщегоСостоянияОригинала(Документ, СостояниеОригинала);
	КонецЕсли;
		
КонецПроцедуры

// См. УчетОригиналовПервичныхДокументовПереопределяемый.ПередЗаписьюСостоянийОригиналовПослеПечати
Процедура ПередЗаписьюСостоянийОригиналовПослеПечати(ОбъектыПечати, СписокПечати) Экспорт
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПередЗаписьюСостоянийОригиналовПослеПечати Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПередЗаписьюСостоянийОригиналовПослеПечати(ОбъектыПечати, СписокПечати);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПередЗаписьюСостоянийОригиналовПослеПечати Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПередЗаписьюСостоянийОригиналовПослеПечати(ОбъектыПечати, СписокПечати);
	КонецЕсли;
	
КонецПроцедуры

// См. УчетОригиналовПервичныхДокументовПереопределяемый.ПриОпределенииОбъектовСКомандамиУчетаОригиналов
Процедура ПриОпределенииОбъектовСКомандамиУчетаОригиналов(СписокОбъектов) Экспорт
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриОпределенииОбъектовСКомандамиУчетаОригиналов Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриОпределенииОбъектовСКомандамиУчетаОригиналов(СписокОбъектов);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриОпределенииОбъектовСКомандамиУчетаОригиналов Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриОпределенииОбъектовСКомандамиУчетаОригиналов(СписокОбъектов);
	КонецЕсли;
	
КонецПроцедуры

// См. УчетОригиналовПервичныхДокументовПереопределяемый.ПриОпределенииМногосотрудниковыхДокументов
Процедура ПриОпределенииМногосотрудниковыхДокументов(СписокОбъектов) Экспорт

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриОпределенииМногосотрудниковыхДокументов Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриОпределенииМногосотрудниковыхДокументов(СписокОбъектов);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриОпределенииМногосотрудниковыхДокументов Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриОпределенииМногосотрудниковыхДокументов(СписокОбъектов);
	КонецЕсли;
	
КонецПроцедуры

// См. УчетОригиналовПервичныхДокументовПереопределяемый.ЗаполнитьТаблицуУчетаОригиналов
Процедура ПриЗаполненииТаблицыУчетаОригиналов(ТаблицаУчетаОригиналов) Экспорт	
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриЗаполненииТаблицыУчетаОригиналов Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриЗаполненииТаблицыУчетаОригиналов(ТаблицаУчетаОригиналов);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриЗаполненииТаблицыУчетаОригиналов Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриЗаполненииТаблицыУчетаОригиналов(ТаблицаУчетаОригиналов);
	КонецЕсли;
	
КонецПроцедуры

#КонецОбласти

#Область ЦентрМониторинга

// См. ЦентрМониторингаПереопределяемый.ПриСбореПоказателейСтатистикиКонфигурации.
Процедура ПриСбореПоказателейСтатистикиКонфигурации() Экспорт

	ОбновлениеИнформационнойБазыСлужебный.ПриСбореПоказателейСтатистикиКонфигурации();
	ПользователиСлужебный.ПриСбореПоказателейСтатистикиКонфигурации();

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВерсионированиеОбъектов") Тогда
		МодульВерсионированиеОбъектов = ОбщегоНазначения.ОбщийМодуль("ВерсионированиеОбъектов");
		МодульВерсионированиеОбъектов.ПриСбореПоказателейСтатистикиКонфигурации();
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ВариантыОтчетов") Тогда
		МодульВариантыОтчетов = ОбщегоНазначения.ОбщийМодуль("ВариантыОтчетов");
		МодульВариантыОтчетов.ПриСбореПоказателейСтатистикиКонфигурации();
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.ОтправкаSMS") Тогда
		МодульОтправкаSMS = ОбщегоНазначения.ОбщийМодуль("ОтправкаSMS");
		МодульОтправкаSMS.ПриСбореПоказателейСтатистикиКонфигурации();
	КонецЕсли;

	Если ОбщегоНазначения.ПодсистемаСуществует("СтандартныеПодсистемы.РаботаСФайлами") Тогда
		МодульРаботаСФайламиСлужебный = ОбщегоНазначения.ОбщийМодуль("РаботаСФайламиСлужебный");
		МодульРаботаСФайламиСлужебный.ПриСбореПоказателейСтатистикиКонфигурации();
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриСбореПоказателейСтатистикиКонфигурации Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриСбореПоказателейСтатистикиКонфигурации();
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриСбореПоказателейСтатистикиКонфигурации Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриСбореПоказателейСтатистикиКонфигурации();
	КонецЕсли;
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиПлюс().ПриСбореПоказателейСтатистикиКонфигурации Тогда
		МодульИнтеграцияПодсистемПлюс = МодульИнтеграцияПодсистемПлюс();
		МодульИнтеграцияПодсистемПлюс.ПриСбореПоказателейСтатистикиКонфигурации();
	КонецЕсли;
	
КонецПроцедуры

#КонецОбласти

#Область УстаревшиеПроцедурыИФункции

// Устарела. Следует использовать ИнтеграцияПодсистемБСП.ПриОпределенииНастроекПечати().
// См. УправлениеПечатьюПереопределяемый.ПриОпределенииОбъектовСКомандамиПечати.
//
Процедура ПриОпределенииОбъектовСКомандамиПечати(СписокОбъектов) Экспорт
	
	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБТС().ПриОпределенииОбъектовСКомандамиПечати Тогда
		МодульИнтеграцияПодсистемБТС = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБТС");
		МодульИнтеграцияПодсистемБТС.ПриОпределенииОбъектовСКомандамиПечати(СписокОбъектов);
	КонецЕсли;

	Если ИнтеграцияПодсистемБСППовтИсп.ПодпискиБИП().ПриОпределенииОбъектовСКомандамиПечати Тогда
		МодульИнтеграцияПодсистемБИП = ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемБИП");
		МодульИнтеграцияПодсистемБИП.ПриОпределенииОбъектовСКомандамиПечати(СписокОбъектов);
	КонецЕсли;
	
КонецПроцедуры

#КонецОбласти

#КонецОбласти

#Область СлужебныеПроцедурыИФункции

Функция МодульИнтеграцияПодсистемПлюс()
	Возврат ОбщегоНазначения.ОбщийМодуль("ИнтеграцияПодсистемПлюс");
КонецФункции

#КонецОбласти