///////////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2024, ООО 1С-Софт
// Все права защищены. Эта программа и сопроводительные материалы предоставляются 
// в соответствии с условиями лицензии Attribution 4.0 International (CC BY 4.0)
// Текст лицензии доступен по ссылке:
// https://creativecommons.org/licenses/by/4.0/legalcode
///////////////////////////////////////////////////////////////////////////////////////////////////////

#Область СлужебныйПрограммныйИнтерфейс

// Параметры:
//  Имя - Строка
//  НаправлениеПеревода - Строка - "ru" или "en"
// 
// Возвращаемое значение:
//  Строка
//
Функция ТранслироватьИмя(Имя, НаправлениеПеревода) Экспорт
	
	Если Метаданные.ВариантВстроенногоЯзыка = Метаданные.СвойстваОбъектов.ВариантВстроенногоЯзыка.Русский Тогда
		Возврат Имя;
	КонецЕсли;
	
	Если НаправлениеПеревода = "ru" Тогда
		Словарь = Словарь_en_ru();
	ИначеЕсли НаправлениеПеревода = "en" Тогда
		Словарь = Словарь_ru_en();
	КонецЕсли;
	
	НовоеИмя = Словарь.Получить(НРег(Имя));
	
	Если НовоеИмя = Неопределено Тогда
		Возврат Имя;
	Иначе
		Возврат НовоеИмя;
	КонецЕсли;
	
КонецФункции

#КонецОбласти

#Область СлужебныеПроцедурыИФункции

// Возвращаемое значение:
//  Соответствие из КлючИЗначение:
//   * Ключ - Строка
//   * Значение - Строка
//
Функция Словарь_ru_en()
	
	Словарь = Новый Соответствие;
	
	// АПК:1036-выкл не проверять текст на орфографию
	Словарь.Вставить("fileкаталогобменаинформацией", "FILEDataExchangeDirectory"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("fileсжиматьфайлисходящегосообщения", "FILECompressOutgoingMessageFile"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("skuконтрагента", "SKUCounterparty_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("wsпассивныйрежим", "WSPassiveMode"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("аванс", "Prepayment_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("авансовыйотчет", "ExpenseReport"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("авансовыйотчетссылка", "AdvanceReportLink"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("авансы", "Prepayments"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("автоматически", "Automatically"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("автор", "Author"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("агент", "Agent"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("агентские", "Agency"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("агентскоевознаграждение", "AgencyFee"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("адрес", "Address"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("адресдоставки", "DeliveryAddress"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("адресстрокой", "AddressAsString"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("адресэлектроннойпочты", "Email"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("аккредитив", "LetterOfCredit"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("актнапередачуправ", "DeedOfTransfer"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("акциз", "ExciseDuty"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("акцизныемарки", "ExciseStamps"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("алкогольная", "Alcoholic"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("алкогольнаяпродукция", "AlcoholContainingProducts"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("альтернативныйтабак", "AlternativeTobaccoProducts"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("амортизационнаягруппа", "DepreciationGroup"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("амортизация", "Depreciation"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("амортизациядо2009", "DepreciationBefore2009"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("амортизацияос", "FixedAssetsDepreciationCharge"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("аннулирован", "Canceled_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("аннулированиеподарочныхсертификатов", "GiftCertificateCancellation"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("антисептики", "Antiseptics"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("аренда", "Lease"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("артикул", "SKU"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("архив", "Archive"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("бады", "DietarySupplements"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("банк", "Bank"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("банкдлярасчетов", "TransferBank"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("банковскийордер", "BankPaymentOrder"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("банковскийплатежныйагент", "BankPayingAgent"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("банковскийплатежныйсубагент", "BankPayingSubagent"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("банковскийсчет", "BankAccount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("банковскийсчетконтрагента", "CounterpartyBankAccount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("банковскийсчеторганизации", "CompanyBankAccount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("банковскийсчетотправитель", "SenderBankAccount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("банковскийсчетсотрудника", "EmployeeSBankAccount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("безалкогольноепиво", "NonAlcoholicBeer"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("безналичная", "BankAccountPayment"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("безндс", "EXCLUDINGVAT"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("безучетапредоставленныхскидок", "ExcludingDiscountsProvided"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("бик", "BIC"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("бонус", "Bonus"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("бонуснаяпрограмма", "BonusProgram"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("бухгалтер", "Accountant"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("валюта", "Currency"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("валютавзаиморасчетов", "ARAPCurrency"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("валютаденежныхсредств", "CashCurrency"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("валютаконвертации", "CurrencyOfConversion"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("валютаконвертациибонусов", "BonusConversionCurrency"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("валютарегламентированногоучета", "LocalAccountingCurrency"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("валютацены", "PriceCurrency"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("вариантоплаты", "PaymentOption"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("вариантотражения", "PostingOption"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("вариантыоплаты", "PaymentOptions"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("вариантыотраженияизлишковприпоступлении", "OptionsForReflectingSurplusesUponReceipt"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("вариантыотражениянедостачиприпоступлении", "OptionsForReflectingShortageUponReceipt"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("вводвэксплуатацию", "Commissioning"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("вебстраница", "WebPage"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ведомость", "Statement"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("велосипеды", "Bicycles"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("версияформатафайланастроекобменаданными", "ExchangeDataSettingsFileFormatVersion"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("вес", "Weight"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("веснеттокг", "NetWeightKg"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("весовой", "SoldByWeight"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("взносналичными", "CashContribution"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видагентскогодоговора", "AgencyAgreementKind"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видалкогольнойпродукции", "KindOfAlcoholContainingProducts"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видбанковскогосчета", "TypeOfBankAccount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("виддеятельностидляналоговогоучетазатрат", "ActivityTypeForTaxAccountingOfCosts"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("виддеятельностираздельногоучетандс", "TypeOfActivityOfSeparateVATAccounting"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("виддоговора", "TypeOfAgreement"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("виддокумента", "DocumentKind"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("виддокументаизклассификатора", "DocumentViewFromClassifier"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("виддокументаотбор", "DocumentTypeSelection"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("виддокументаправоподписи", "TypeOfDocumentRightToSign"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видзапасов", "InventoryOwnerAttribute"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видкарты", "CardKind"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видконтактнойинформации", "ContactInformationKind"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видноменклатуры", "ProductKind"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видобъектаучета", "KindOfAccountingObject"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видоперации", "OperationKind"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видоперацииотчетакоммисионера", "TypeOfOperationOfCommissionaireSReport"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видоплаты", "PaymentKind_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видответственноголица", "ResponsiblePersonKind"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видответственноголицаотбор", "TypeOfResponsiblePersonSelection"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видответственноголицастрокой", "TypeOfResponsiblePersonByLine"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видотчета", "ReportKind"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видплатежа", "PaymentKind"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видподарочногосертификата", "GiftCertificateKind"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видпродукцииис", "ProductTypeIS"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видработ", "WorkKind"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видрасходовпонеосновнойдеятельности", "TypeOfExpensesForNonCoreActivities"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видрасходовпоосновнойдеятельности", "TypeOfExpensesForCoreActivities"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видрасчетов", "ARAPType"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видрасчетоврасширенный", "TypeOfCalculationsAdvanced"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видрезерва", "TypeOfReserve"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видскидки", "TypeOfDiscount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видсобытия", "EventKind"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видсобытияос", "EventKindWithFixedAssets"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видсчета", "AccountType"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видсчетафактуры", "InvoiceType"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видтранспортасообщенийобмена", "ExchangeMessagesTransportKind"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видыдоговоров", "TypesOfContracts"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видыки", "CIKinds"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видылицензийалкогольнойпродукции", "LicenseKindsOfAlcoholContainingProducts"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видыноменклатуры", "ItemKinds"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видыобъектовучетанма", "IntangibleAssetsAccountingItemKinds"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видыоперацийвозвратотпокупателя", "TypesOfOperationsReturnFromBuyer"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видыоперацийвозвратпоставщику", "TypesOfOperationsRefundToSupplier"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видыоперацийвыпускапродукции", "TypesOfProductionOperations"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видыоперацийпоплатежнойкарте", "TypesOfPaymentCardOperations"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видыоперацийпоступлениятоваров", "TypesOfOperationsOfReceiptOfGoods"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видыоперацийреализациятоваровуслуг", "TypesOfOperationsSaleOfGoodsServices"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видыоперацийрконабанковскийсчет", "TypesOfACWOperationsToBankAccount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видыоперацийсбдспрочее", "TypesOfSBDsOperationsOther"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видыответственныхлиц", "TypesOfResponsiblePersons"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видыподарочныхсертификатов", "GiftCertificateKinds"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видыпродукцииис", "TypesOfIPProducts"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видырасчетовсконтрагентами", "TypesOfSettlementsWithCounterparties"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видырасчетовссотрудниками", "TypesOfEmployeeCompensations"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видысобытийос", "EventKindsWithFixedAssets"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видытранспортасообщенийобмена", "ExchangeMessagesTransportTypes"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видыэд", "TypesOfED"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("видэд", "EdView"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("включениеврасходыприпринятиикучету", "DeductionInExpensesOnRecognition"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("включитьвсоставамортизируемогоимущества", "IncludeInDepreciableProperty"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("владелец", "Owner"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("владелецдополнительныхзначений", "AdditionalValuesOwner"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("владелецкарты", "Cardholder"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("владелецфайла", "FileOwner"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("владелецхарактеристики", "TechnicalCharacteristics"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("внереализационныйдоход", "NonOperatingIncome"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("внешняясистема", "ExternalSystem"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("внутреннееперемещение", "InternalMovement"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("внутренняяпередача", "InternalTransfer"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("водительскоеудостоверение", "DriverLicense"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("возврат", "Return"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("возвратденежныхдокументовпоставщику", "ReturnOfCashEquivalentsToVendor"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("возвраткомитенту", "RefundToCommittee"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("возвратматериаловизпроизводства", "ReturnOfMaterialsFromProduction"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("возвратнаятара", "ReturnContainers"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("возвратныеотходы", "RecyclableWaste"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("возвратоплатыклиентунаплатежнуюкарту", "RefundToCustomerSPaymentCard"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("возвратотклиента", "ReturnFromCustomer"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("возвратотклиентачерезплатежнуюсистему", "RefundFromCustomerViaPaymentSystem"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("возвратоткомиссионера", "ReturnFromCommissionAgent"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("возвратотрозничногопокупателя", "ReturnFromRetailCustomer"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("возвратподарочныхсертификатов", "ReturnOfGiftCards"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("возвратподдеятельность", "ReturnUnderOperation"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("возвратпоставщику", "ReturnToVendor"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("возвратсырьядавальцу", "ReturnOfRawMaterialsToMaterialProvider"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("возвратсырьяотпереработчика", "ReturnOfRawMaterialsFromToller"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("возвраттоваровпоставщику", "ReturnOfGoodsToVendor"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("возвраты", "Returns"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("возвратыпокупателей", "CustomerRefunds"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("восстановитьндс", "RestoreVAT"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("впользупоставщика", "InFavorOfSupplier"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("всевыполнено", "AllExecuted"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("встречноепредставление", "CounterRepresentation"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("втомчислендс", "IncludingVAT"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("выбраннаяформа", "SelectedForm"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("выбытиебутылки", "BottleRetirement"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("выводитьмесяцпрописью", "DisplayMonthInWords"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("выводитьсуммубезкопеек", "OutputAmountWithoutFractionalPart"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("выданныеавансы", "PrepaymentsToVendor_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("выдано", "Issued"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("выдать", "Issue"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("выдачаденежныхдокументовподотчетнику", "CashEquivalentsIssueToAdvanceHolder"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("выдачаденежныхсредств", "DisbursementOfFunds"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("выигрышазартнойигры", "GamblingPrize"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("выигрышлотереи", "LotteryPrize"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("выплата", "Repayment"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("выплатасамозанятому", "PaymentToSelfEmployed"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("выполнен", "Completed"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("выполненныеработы", "CompletedWorks"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("выпускпродукции", "ProductsRelease"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("выпускпродукциивподразделение", "ProductsReleaseToBusinessUnit"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("выпускпродукциинасклад", "ProductsReleaseToWarehouse"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("выработкасотрудников", "WorkOutput"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("высота", "Height"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("выставлен", "Issued"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("выставленсф", "SetSF"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("вышестоящееподразделение", "SuperiorDepartment"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("вэксплуатации", "InOperation"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("вэлектронномвиде", "InElectronicForm"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("главныйбухгалтер", "ChiefAccountant"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("глубина", "Depth"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("год", "Year"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("годендо", "ValidUntil_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("головнаяорганизация", "ParentCompany"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("головнойконтрагент", "MainCounterparty"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("город", "City"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("готоваяпродукция", "FinishedProducts"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("готовквыдаче", "ReadyForIssuance"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("гражданство", "Citizenship"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("грузоотправитель", "Shipper"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("грузополучатель", "GoodsRecipient"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("группа", "Group"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("группааналитическогоучета", "AnalyticalGroup"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("группааналитическогоучетаноменклатуры", "AnalyticalProductGroup"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("группанастроекфинансовогоучетарасчетов", "GroupOfFinancialAccountingSettingsForSettlements"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("группаос", "OSGroup"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("группыос", "FAGroups"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("да", "Yes"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("давальческиесырьеиматериалы", "GiverRawMaterialsAndSupplies"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("данныевзаиморасчетов", "SettlementData"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("данныевходящегодокумента", "IncomingDocumentData"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("данныегтд", "CCDData"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("данныеклассификатора", "ClassifierData"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("данныеноменклатуры", "ProductData_1"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("данныеотчета", "ReportData"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("данныепосф", "SFData"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("данныерасчетов", "CalculationData"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("данныесертификата", "CertificateData"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("данныефио", "FullNameData"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("дата", "Date"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датаведомости", "StatementDate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датаведомостинавыплатузарплаты", "PaysheetDate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датавходящегодокумента", "IncomingDocumentDate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датавыдачи", "DateOfIssue1"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датавыписки", "DateOfDischarge"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датавыполнения", "ExecutionDate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датавыпуска", "DateOfProduction"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датавыставления", "IssueDate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датадоговора", "ContractDate_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датадокумента", "DocumentDate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датадокументаправаподписи", "DateOfDocumentSignatureRight"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датазакрытия", "ClosingDate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датаинвентаризации", "InventoryDate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датаисправления", "CorrectionDate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датаначала", "StartDate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датаначаладействия", "ValidityStartDate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датаначалаинвентаризации", "StartDateOfInventory"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датаначисления", "AccrualDate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датаокончания", "EndDate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датаокончаниядействия", "ValidityEndDate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датаокончанияинвентаризации", "EndDateOfInventory"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датаотправки", "DateSent"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датаотправления", "PostingDate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датапереходаправасобственности", "DateOfTransferOfTitleToGoods"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датаплатежа", "PaymentDate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датаплатежногодокумента", "DateOfPaymentDocument"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датаплатежнорасчетногодокумента", "DateOfDocumentInARAPAccounting"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датаподключения", "DateOfActivation"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датаподписи", "SignatureDate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датаполучения", "DateReceived"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датапринятиякучету", "DateOfRecognition"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датапринятиянаучет", "AccountingRecordDate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датаприобретения", "PurchaseDate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датапродажи", "DateOfSale"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датапроизводства", "ProductionDate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датареализации", "SaleDate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датарегистрации", "RegistrationDate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датарождения", "BirthDate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датасобытия", "EventDate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датасостояния", "StateDate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датаспецификации", "SpecificationDate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датасписания", "DateOfDeduction"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датасф", "InvoiceDate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датасчетафактуры", "TaxInvoiceDate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("дататсд", "SupportingDocumentDate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("датаутверждения", "ConfirmationDate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("дебиторскаязадолженность", "AccountsReceivable"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("действийнетребуется", "NoActionsNeeded"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("действителендо", "ValidBefore"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("декада", "TenDays"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("денежныедокументы", "CashEquivalents"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("денежныесредства", "Cash"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("денежныйдокумент", "MonetaryDocument"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("день", "Day"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("депозит", "Deposit"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("депозитный", "Deposit_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("депозиты", "Deposits"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("депонированиезарплаты", "SalaryDepositing"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("десятая", "Tenth"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("дисконтная", "Discounted"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("дисконтнаякарта", "DiscountCard"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("длинамагнитногокода", "MagneticCodeLength"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("длинаштрихкода", "BarcodeLength"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("доверенность", "LetterOfAuthority"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("доверенностьдата", "PowerOfAttorneyDate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("доверенностькемвыдана", "PowerOfAttorneyIssuedByWhom"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("доверенностькомувыдана", "PowerOfAttorneyIssuedTo"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("доверенностьномер", "PowerOfAttorneyNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("договор", "Contract"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("договорконтрагента", "CounterpartyContract"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("договорскомиссионером", "ContractWithCommissionAgent"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("договорссылка", "ContractLink"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("договорэквайрера", "AcquirerSContract"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("доклиента", "ToCustomer"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("документ", "Document"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("документоснование", "DocumentBasis"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("документоснованиевид", "DocumentBasisKind"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("документоснованиедата", "DocumentReferenceDocumentDateForPrintForms"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("документоснованиеномер", "DocumentBaseDocumentNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("документпередачи", "DocumentTransfers_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("документпоступления", "DocumentInflow"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("документпродажи", "DocumentSales"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("документрасчетов", "DocumentOfARAPAccounting"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("документреализации", "DocumentSalesOfGoodsAndServices"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("документустановкицен", "PriceSettingDocument"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("документыоснования", "BasisDocuments"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("долг", "Debt"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("долгосрочныезаймы", "LongTermLoans"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("долгосрочныекредиты", "LongTermLoans_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("долгосрочный", "LongTerm"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("должность", "JobTitle"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("долястоимости", "CostShare"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("дооборудование", "FurtherEquipping"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("доплата", "ExtraPay"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("дополнительнаяинформация", "AdditionalInformation"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("дополнительныезначенияиспользуются", "AdditionalValuesUsed"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("дополнительныезначениясвесом", "AdditionalValuesWithWeight"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("дополнительныереквизиты", "AdditionalAttributes"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("дополнительныйкодфсс", "SSFAdditionalCode"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("дополнительныйреквизит", "AdditionalAttribute"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("достройка", "Completion"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("духи", "PerfumesAndToiletWaters"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("единицаизмерения", "UnitOfMeasure"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("единицаизмеренияпрослеживаемости", "UnitOfTraceability"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("единицаизмерениярнпт", "UnitOfProductBatchID"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("единицаизмерениясрокагодности", "ShelfLifeUnitOfMeasure"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("енвд", "UTII"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("естьвдокументепоступленияреализации", "ThereIsImplementationReceiptInDocument"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("желательнаяформаоплатыбезналичные", "DesirableFormOfPaymentNonCash"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("желательнаяформаоплатыналичные", "DesirableFormOfPaymentCash"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("желательнаяформаоплатыплатежнаякарта", "DesiredFormOfPaymentPaymentCard"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("женский", "Feminine"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("заводскойномер", "ManufaturerNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("заголовок", "Title"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("заголовокформывыборазначения", "ValueChoiceFormTitle"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("заголовокформызначения", "ValueFormTitle"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("загружаетсяизинтернета", "ImportingFromInternet"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("займконтрагенту", "LoanToCounterparty"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("займы", "Loans_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("займыполученные", "LoansReceived"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("заказ", "OrderDocument"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("заказклиента", "SalesOrder"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("заказнаперемещение", "TransferOrder"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("заказпоставщику", "PurchaseOrder"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("заказчик", "Customer_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("закрыта", "Closed_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("закрытпринудительно", "ClosedForcefully"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("закрытсотклонением", "ClosedWithDeviation"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("закрытсотклонениемприглашения", "ClosedWithRejectionOfInvitation"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("закрытсошибкойпередачи", "ClosedWithTransmissionError"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("закупкаподдеятельность", "PurchaseForActivity"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("закупкапоимпорту", "PurchaseByImport"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("залог", "SecurityDeposit"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("заметки", "Notes"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("записи", "Records"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("заполнятьобязательно", "RequiredToFill"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("зарплата", "Salary"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("засчетпоставщика", "AtExpenseOfSupplier"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("засчетстороннейкомпании", "AtExpenseOfThirdPartyCompany"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("заявканарасходденежныхсредств", "RequestForSpendingFunds"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("заявлениеоввозетоваров", "ApplicationForImportationOfGoods"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("зерно", "Grain"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("зерноветис", "GrainUnderVetISControl"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("значениедополнительногореквизита", "ValueOfAdditionalProps"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("значениесвойства", "PropertyValue"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("значенияполей", "FieldValues"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("идентификатор", "Id"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("идентификаторгосконтракта", "StateContactID"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("идентификаторкорзины", "CartID"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("идентификаторноменклатурысервиса1сноменклатура", "IDOf1CProductsProductCategory"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("идентификатороплатысбп", "FPSPaymentID"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("идентификаторотчета", "ReportID"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("идентификаторплатежа", "PaymentID"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("идентификаторсервиса1сноменклатура", "IDOf1CProductsService"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("идентификаторстроки", "RowID"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("идентификаторупаковки", "PackageID"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("идентификаторхарактеристикисервиса1сноменклатура", "IDOf1CProductsServiceCharacteristic"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("изготовитель", "Manufacturer_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("излишки", "Surpluses"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("импортнаяалкогольнаяпродукция", "ImportedAlcoholContainingProducts"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("имущественноеправо", "PropertyRight"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("имя", "Name"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("имяпланаобмена", "ExchangePlanName"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("инвентаризация", "Inventory_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("инвентарныйномер", "AssetID"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("индивидуальныйпредприниматель", "IndividualEntrepreneur"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("инкассация", "Collection_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("инкассовоепоручение", "CollectionOrder_2"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("инн", "TIN"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("иннконтрагента", "TINOfCounterparty"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("иннплательщика", "TINOfPayer"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("иннполучателя", "RecipientTIN"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("иннпродавца", "SellerTIN"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("иное", "OtherReasons"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("инойпредметрасчета", "OtherSettlementSubject"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("иностранныйбанк", "ForeignBank"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("исполнитель", "Performer"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("использоватьакцизы", "UseExcises"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("использоватьоплатуплатежнымикартами", "UsePaymentByCards"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("использоватьпараметрытранспортаemail", "UseTransportParametersEMAIL"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("использоватьпараметрытранспортаfile", "UseTransportParametersFILE"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("использоватьпараметрытранспортаftp", "UseTransportParametersFTP"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("использоватьсерии", "KeepAccountingByBatch"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("использоватьскидкинаценки", "UseDiscountsMarkups"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("использоватьсрокгодностисерии", "UseShelfLifeOnBatchRegistration"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("использоватьхарактеристики", "UseCharacteristics"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("исправление", "Patch"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("исправлениеошибки", "CorrectionOfErrors"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("исправляемыйдокумент", "CorrectedDocument"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("исправляемыйдокументпоступления", "CorrectedReceiptDocument"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("исправляемыйдокументреализации", "CorrectedImplementationDocument"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("историякпп", "CRTRHistory"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("историянаименований", "NameHistory"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("исходныйдокумент", "SourceDocument_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("капитальныйремонт", "Overhaul"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("карталояльности", "LoyaltyCard"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кассаккм", "CashRegister"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кассаотправитель", "CashAccountIssuer"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кассаполучатель", "CashAccountRecipient"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кассир", "Cashier"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кассоваясмена", "CashRegisterShift"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кассы", "CashAccounts"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кассыккм", "CashRegisters"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("квартал", "Quarter"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кемвыдан", "IssuedBy"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ключевыесвойства", "KeyProperties"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ключстроки", "Composite"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("код", "Code"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кодавторизации", "AuthorizationCode"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кодадресафиас", "FIASAddressCode"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кодалкогольнойпродукции", "CodeOfAlcoholicProducts"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кодальфа2", "CodeAlpha2"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кодальфа3", "CodeAlpha3"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кодвидадохода", "IncomeKindCode"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кодвиданоменклатурнойклассификации", "ProductClassificationTypeCode"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кодвидаоперации", "TransactionKindCode"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кодвидатранспорта", "TransportKindCode"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кодвпрограмме", "CodeInApp"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кодмвд", "FTSCode"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кодналоговогооргана", "TaxAuthorityCode"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кодновогоузла", "NewNodeCode"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кодновогоузлавторойбазы", "SecondInfobaseNewNodeCode"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кодоквэд", "BusinessActivityClassifierCode"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кодокп", "RNCPCode"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кодокпд2", "RNCTEAPS2Code"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кодподразделения", "BusinessUnitCode"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кодподчиненностифсс", "FTSSubordinationCode"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кодпоокоф", "CodeByRNCFA"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кодпредопределенногоузла", "PredefinedNodeCode"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кодпфр", "PensionFundCode"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кодтнвэд", "FEACNCode"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кодтру", "TRUCode"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("количество", "Count"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("количествобонусныхбаллов", "NumberOfBonusPoints"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("количестводнейотсрочки", "NumberOfDaysOfDeferral"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("количестводоизменения", "QuantityBeforeChange_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("количестводокорректировки", "QuantityBeforeAdjustment"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("количестводокументов", "DocumentsCount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("количестволистов", "SheetQuantity"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("количествонаскладе", "QuantityInStock_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("количествопериодовдействия", "NumberOfValidityPeriods"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("количествопослеизменения", "QuantityAfterChange"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("количествопотнвэд", "QuantityByFEACN"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("количестворнпт", "NumberOfRNPT"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("количестворнптдоизменения", "NumberOfRNPTBeforeChange"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("количестворнптдокорректировки", "NumberOfRNPTBeforeAdjustment"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("количествоупаковок", "NumberOfPackages"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("количествоупаковокдоизменения", "NumberOfPackagesBeforeChange_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("количествоупаковокдокорректировки", "NumberOfPackagesBeforeAdjustment"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("количествоупаковокучет", "NumberOfPackagesAccounting"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("количествоупаковокфакт", "NumberOfPackagesReal"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("количествоучет", "NumberOfDays_1"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("количествофакт", "CountReal"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("комиссионер", "Consignee"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("комиссионныетовары", "CommissionGoods"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("комиссия", "Fee"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("комитент", "Consignor"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("комментарий", "Comment"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("комплект", "Kit"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("комплектуется", "Replenished"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("конецдиапазонамагнитногокода", "EndOfMagneticCodeRange"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("конецдиапазонаштрихкода", "EndOfBarcodeRange"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("конецпериода", "EndOfPeriod"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("контактнаяинформация", "ContactInformation"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("контактноелицо", "ContactPerson"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("контактноелицоконтрагента", "CounterpartySContactPerson"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("контактныелица", "ContactPersons"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("контрагент", "Counterparty"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("контрагентдебитор", "CounterpartyDebtor"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("контрагенткредитор", "Creditor"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("контрагенты", "Counterparties"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("коплате", "AmountDue"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("корректировкапоступлениятоваров", "AdjustmentOfGoodsReceipts"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("корректировочный", "Corrective"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("коррсчет", "CorrAccount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("коэффициент", "ZoomRatio"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("коэффициент1", "ZoomRatio1"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("коэффициент10", "ZoomRatio10"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("коэффициент11", "ZoomRatio11"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("коэффициент12", "ZoomRatio12"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("коэффициент2", "ZoomRatio2"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("коэффициент3", "ZoomRatio3"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("коэффициент4", "ZoomRatio4"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("коэффициент5", "ZoomRatio5"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("коэффициент6", "ZoomRatio6"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("коэффициент7", "ZoomRatio7"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("коэффициент8", "ZoomRatio8"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("коэффициент9", "ZoomRatio9"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("коэффициентамортизациибу", "AnnualDepreciationRate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("коэффициентбу", "DepreciationAccrualFactor"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("коэффициентускорениябу", "AccelerationFactorAccounting"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кполучателюопределяетслужбадоставки", "ToCustomerIsDefinedByTransportationCompany"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кпп", "CRTR"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кппконтрагента", "CounterpartyCRTR"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кппплательщика", "PayerCRTR"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кппполучателя", "RecipientCRTR"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кпппродавца", "SellerCRTR"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("крайнийсрокплатежа", "PaymentDeadline"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("краткосрочныезаймы", "ShortTermLoans"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("краткосрочныекредиты", "ShortTermLoans_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("краткосрочный", "ShortTerm"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кратностьвзаиморасчетов", "Multiplier_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кратностьдокумента", "DocumentMultiplicity"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кратностьконвертации", "ConversionMultiplicity"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кредит", "Credit"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кредитбанка", "BankCredit"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кредитконтрагента", "CounterpartyCredit"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кредиторскаязадолженность", "AccountsPayable"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кредитыизаймы", "LoansAndBorrowings"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кредитыполученные", "LoansReceived_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("крепость", "Strength"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("креслаколяски", "Wheelchairs"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ктозаявил", "WhoStated"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("кторешил", "WhoDecided"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("курортныйсбор", "ResortFee"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("курсвзаиморасчетов", "TransactionRate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("курсдокумента", "DocumentCourse"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("курсконвертации", "ConversionRate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("курсконвертациибонусовввалюту", "ConversionRateOfBonusesIntoCurrency"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("курсцбнадатуконвертации", "ExchangeRateOfCentralBankOnDateOfConversion"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("курьер", "Courier"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("курьером", "ByCourier"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("легкаяпромышленность", "LightIndustryGoodsAndClothes"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("линейный", "Linear"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("лотерейныйбилет", "LotteryTicket"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("магазин", "Store"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("магнитныйкод", "MagneticCode"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("максимальныйпроцентоплатыбонусами", "MaximumSharePayableByPoints"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("марка", "Brand"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("маркированныйтовар", "MarkedGoods"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("маркировка", "Marking"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("маркировкаупаковки", "PackageMarking"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("маркировкиупаковок", "PackageMarkings"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("маркируемый", "Labelled"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("маршрут", "Route"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("материалы", "UsedMaterials"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("материалызаказчика", "CustomerMaterials"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("менеджер", "Manager"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("месторождения", "Birthplace"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("месяц", "Month"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("месяцналоговогопериода", "MonthOfTaxPeriod"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("многооборотнаятара", "ReusablePackage"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("многострочноеполеввода", "MultilineInputField"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("модернизация", "Modernization"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("модернизацияос", "FixedAssetsCostAdditions"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("мол", "FinanciallyLiablePerson"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("молочнаяпродукция", "MilkAndMilkProducts"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("молочнаяпродукциябезветис", "MilkAndDairyProductsWithoutVetIS"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("молочнаяпродукцияветис", "VETISDairyProducts"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("монотоварнаяупаковка", "SingleProductPackage"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("морепродуктыподконтрольныеветис", "SeafoodControlledByVETIS"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("мужской", "Masculine"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("мультитоварнаяупаковка", "MultiproductPackaging"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("нааванс", "AdvancePayment"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("набор", "Set"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("набумажномносителе", "OnPaper"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("названиедокументамодернизации", "ModernizationDocumentName"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("названиедокументапринятиякучету", "NameOfRecognitionDocument"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("назначениеаванса", "AdvancePurpose"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("назначениеплатежа", "PaymentPurposes"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("наименование", "Description"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("наименованиевторойбазы", "SecondInfobaseDescription"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("наименованиевходящегодокумента", "ExternalDocumentName"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("наименованиеконтактнойинформации", "NameOfContactInformation"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("наименованиемеждународное", "DescriptionInternational"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("наименованиеназначенияиспользования", "NameOfPurposeOfUse"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("наименованиенастройкивыполненияобмена", "DataExchangeExecutionSettingsDescription"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("наименованиеоквэд", "ActivityType"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("наименованиеоквэд2", "ActivityType2"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("наименованиеокопф", "LegalForm"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("наименованиеокп", "NameOfTheOKP"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("наименованиеокфс", "OwnershipForm"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("наименованиеотчета", "ReportDescription1"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("наименованиеполное", "DescriptionFull"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("наименованиесокращенное", "AbbreviatedDescription"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("наименованиеспособаотражениярасходов", "NameOfMethodForReflectingExpenses"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("наименованиетерриториальногоорганапфр", "PensionFundLocalAuthorityName"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("наименованиетерриториальногоорганафсс", "SSFLocalAuthorityName"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("наименованиетовара", "ProductName"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("наименованиеэтойбазы", "ThisInfobaseDescription"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("накопленнаяамортизациябу", "AccumulatedDepreciationAccounting"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("накопленнаяамортизациявр", "AccumulatedDepreciationTD"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("накопленнаяамортизацияну", "AccumulatedDepreciationTaxAccounting"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("накопленнаяамортизацияпр", "PermanentDifferenceInEvaluationOfAccumulatedDepreciation"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("наличная", "CashAccountPayment_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("наличные", "CashPayment"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("налоговаябазаакцизы", "TaxBaseExcises"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("налоговаябазандс", "VATTaxBase"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("налоговыйагентпондс", "VATTaxAgent"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("налоговыйномернерезидента", "NonResidentTaxNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("налогообложение", "Taxation"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("налогообложениендс", "VATTaxation"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("налогообложениендспродавца", "VATTaxationOfSeller"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("напрочиедоходы", "OnOtherIncome"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("напрочиерасходы", "ForOtherExpenses"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("настройкирасчета", "CalculationSettings"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("натовар", "OnItem"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("наутверждении", "AwaitingConfirmation"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("наценка", "Markup"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("началодиапазонамагнитногокода", "StartOfMagneticCodeRange"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("началодиапазонаштрихкода", "StartOfBarcodeRange"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("началопериода", "BeginOfPeriod"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("началопериодаотчета", "BeginningOfReportPeriod"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("начислениеамортизации", "DepreciationAccrual"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("начислениебонусныхбаллов", "BonusPointAccrual"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("начислениеизноса", "WearAccrual"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("начислениеизносапоенаоф", "AccrueWearAsPerUFADR"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("начислениеоценочныхобязательствпоотпускам", "AccrualOfEstimatedVacationLiabilities"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("начисления", "Accruals"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("начисленныебонусы", "Accrued_Bonuses"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("начислятьамортизациюбу", "DepreciationAccrualAccounting"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("начислятьамортизациюну", "DepreciationAccrualTaxAccounting"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("нашимисиламисадресаотправителя", "OurOwnDeliveryFromSenderAddress"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ндс", "VAT"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ндс0", "VAT0"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ндс10", "VAT10"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ндс10_110", "VAT10_110"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ндс18", "VAT18"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ндс18_118", "VAT18_118"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ндс20", "VAT20"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ндс20_120", "VAT20_120"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ндсисчисляетсяналоговымагентом", "PersonalIncomeTaxIsCalculatedByTheTaxAgent"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ндсисчисляетсяпокупателем", "VATIsCalculatedByBuyer"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ндфл", "PersonalIncomeTax"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("неавтоматизированнаяторговаяточка", "NonAutomatedPointOfSale"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("неделя", "Week"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("недостачи", "Shortages"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("нематериальныеактивы", "IntangibleAssets"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("нематериальныйактив", "IntangibleAsset"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("неначислятьбаллыприоплатебонусами", "DoNotAccruePointsWhenPayingWithBonuses"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("необлагаетсяндс", "NotSubjectToVAT"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("неоплачен", "NotPaid"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("неотгружен", "NotShipped_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("неполучен", "NotReceived"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("нерассчитывается", "NotCalculating"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("несогласована", "NotAgreedUpon"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("несформирован", "NotGenerated1"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("нет", "None"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("никотиносодержащаяпродукция", "NicotineContainingProducts"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номенклатура", "Products"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номенклатураотбор", "NomenclatureSelection"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номер", "Number"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номеракцизноймарки", "ExciseStampNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номербилета", "TicketNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номерведомости", "StatementNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номерведомостинавыплатузарплаты", "PaysheetNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номервпрограмме", "NumberInProgram"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номервходящегодокумента", "IncomingDocumentNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номергтд", "CCDNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номергтддоизменения", "CCDNumberBeforeChange"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номердекларации", "DeclarationNo"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номердоговора", "ContractNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номердокумента", "DocumentNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номердокументамодернизации", "ModernizationDocumentNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номердокументаправаподписи", "NumberOfSignatureRightDocument"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номердокументапринятиякучету", "DocumentOfRecognitionNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номерисправления", "CorrectionNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номеркарты", "CardNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номеркассовойсмены", "CashShiftNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номерлицевогосчета", "PersonalAccountNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номерпаспорта", "PassportNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номерплатежногодокумента", "NumberOfPaymentDocument"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номерплатежнорасчетногодокумента", "SettlementDocumentNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номерраздела", "SectionNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номеррасширенный", "ExtendedNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номерспецификации", "SpecificationNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номерстроки", "LineNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номерстрокидокумента", "DocumentRowNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номерсф", "InvoiceNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номерсчета", "AccountNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номерсчетафактуры", "TaxInvoiceNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номерсчетафактурыкомиссионера", "CommissionAgentSTaxInvoiceNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номерчекаккм", "CashRegisterReceiptNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номерчекаккмпродажи", "CashRegisterSalesReceiptNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номерчекаэт", "POSTerminalReceiptNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("номинал", "Nominal"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("облагаетсяенвд", "SubjectToENVD"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("облагаетсяндс", "SubjectToVAT"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("облагаетсяндсупокупателя", "SubjectToVATAtCustomer"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("обмензавершен", "ExchangeCompleted"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("обмензавершенсисправлением", "ExchangeCompletedWithAdjustments"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("обособленноеподразделение", "BranchOffice"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("обувь", "ShoesProducts"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("общая", "Shared3"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("общиеданные", "SharedData"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("объект", "Object"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("объем", "VolumeM3"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("объемдал", "VolumeInDecaliters"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("объемпродукцииработдлявычисленияамортизации", "VolumeOfProductsWorksForCalculatingDepreciationInPhysicalUnits"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("обязательноемедицинскоестрахование", "ContributionsForCMI"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("обязательноемедицинскоестрахованиеип", "ContributionsForCMIIE"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("обязательноепенсионноестрахование", "ContributionsForMPI"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("обязательноепенсионноестрахованиеип", "ContributionsForMPIIE"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("обязательноесоциальноестрахование", "ContributionsForCSI"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("огрн", "OGRN"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ожидаемаядатапоставки", "ExpectedDeliveryDate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ожидаемаядатапоступления", "ExpectedDateOfReceipt"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ожидаетсяизвещениеополучении", "PendingReceiptNotification"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ожидаетсяизвещениепоотклонению", "NotificationOfRejectionIsExpected"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ожидаетсяисправление", "PendingCorrection"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ожидаетсяответнаприглашение", "WaitingForResponseToInvitation"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ожидаетсяпередачаоператору", "PendingTransferToProvider"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ожидаетсяподтверждение", "PendingConfirmation"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ожидаетсяподтверждениеаннулирования", "WaitingForConfirmationOfCancellation"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ожидаетсяподтверждениеоператора", "PendingConfirmationOfProvider"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("окато", "RNCPS"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("оквэд", "RNCEA"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("оквэд2", "RNCEA2"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("окончаниепериода", "PeriodEnding"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("окончаниепериодаотчета", "EndOfReportPeriod_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("окопф", "RNCFI"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("окпо", "OKPO"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("округлятьвбольшуюсторону", "RoundUp"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("октмо", "MunicipalTerritoriesClassifier"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("окфс", "OKFS"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("операцияпоплатежнойкарте", "PaymentCardTransaction"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("описание", "LongDesc"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("оплатабонуснымибаллами", "PaymentWithBonusPoints"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("оплатаконтрагентам", "PaymentToCounterparties"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("оплатакредита", "PaymentForLoan"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("оплатаотклиентаплатежнойкартой", "PaymentFromClientByPaymentCard"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("оплатаотклиентачерезплатежнуюсистему", "PaymentFromClientThroughPaymentSystem"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("оплатаплатежнымикартами", "PaymentWithPaymentCards"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("оплатаплатежнымикартамиподарочныхсертификатов", "PaymentByCreditCardsForGiftCertificates"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("оплатапоставщику", "PaymentToVendor"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("оплатасертификатами", "PaymentByCertificates"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("оплаты", "Payments"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("оплатыккм", "CashRegisterPayments"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("оплачен", "Paid"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("оплачено", "Paid"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("оплаченчастично", "PartiallyPaid"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("определяетсяраспределением", "DeterminedByAllocation"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("оприходованиеподдеятельность", "ActivityRegistration"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("оприходованиетоваров", "GoodsRecordingAsReceived"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("оптовый", "Wholesale_1"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("организация", "Organization"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("организацияотбор", "CompanyFilter"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("организацияотправитель", "SenderOrganization"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("организацияполучатель", "CompanyRecipient"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("организацияпродавец", "CompanyCustomer"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("органпфр", "FIUAuthority"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("основание", "Basis"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("основнаявалюта", "MainCurrency"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("основнаякартинка", "MainPicture"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("основнаясистеманалогообложения", "MainSystem"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("основноесредство", "FixedAsset"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("основнойбанковскийсчет", "MainBankAccount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("основныесредства", "FixedAssets"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("особыйпорядокналогообложения", "SpecialTaxationProcedure"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ответственноелицо", "EmployeeInCharge_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ответственный", "EmployeeResponsible"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ответственныйзабухгалтерскиерегистры", "AssigneeForMaintainingOfAccountingRegisters"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ответственныйзаналоговыерегистры", "AssigneeForMaintainingOfTaxRegisters"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("отгружатьзаказцеликом", "ShipEntireOrder"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("отгружен", "Shipped_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("отгруженчастично", "PartiallyShipped"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("отгрузкабезпереходаправсобственности_впути", "ShipmentWithoutTransferOfOwnership_inPath"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("отгрузкабезпереходаправсобственности_реализовано", "ShipmentWithoutTransferOfOwnership_Implemented"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("отгрузкаклиенту", "ShipmentToCustomer"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("отгрузкаповозвратупоставщику", "ShipmentUnderReturnToVendor"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("отгрузкапоперемещению", "ShipmentByTransfer"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("отклонен", "Rejected"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("отклонена", "IsRejected"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("отменен", "RolledBack_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("отменено", "Canceled"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ототправителяопределяетслужбадоставки", "FromSenderDeterminedByDeliveryService"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("отпускпроизвел", "VacationProduced"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("отражениевозвратаоплатычерезкомиссионера", "RecordOfRefundThroughTheCommissionAgent"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("отражениезарплатывфинансовомучете", "PostingPayrollExpensesInFinancialAccounting"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("отражениеоплатычерезкомиссионера", "RecordOfPaymentThroughTheCommissionAgent"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("отсрочкаплатежа", "DeferredPayment"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("отчество", "MiddleName"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("отчетбанкапооперациямэквайринга", "BankReportOnAcquiringTransactions"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("отчетдавальцу", "ReportToMaterialProvider"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("отчеткомиссионера", "ConsignmentReportFromCustomer"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("отчеткомитенту", "ConsignmentReportToVendor"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("отчеторозничныхпродажах", "RetailSalesReport"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("отчетпереработчика", "SubcontractorReport"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("оценочныеобязательства", "Provisions"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("очередность", "RankingInPriority"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("параметрыпрописи", "AmountInWordsParameters"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("парольархивасообщенияобмена", "ArchivePasswordExchangeMessages"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("патент", "Patent"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("патентнаясистема", "PatentSystem"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("первая", "First"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("первоначальнаястоимостьбу", "InitialCostLocalAccounting"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("первоначальнаястоимостьну", "InitialCostTA"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("перевозчик", "Carrier"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("передача", "Transfer_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("передачабезоплаты", "TransferWithoutPayment"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("передачадавальцу", "TransferToMaterialProvider"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("передачаматериаловвпроизводство", "MaterialTransferToProduction"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("передачанакомиссию", "TransferToCommissionAgent"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("передачапереработчику", "TransferToToller"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("передачасполнойоплатой", "TransferWithFullPayment"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("передачасчастичнойоплатой", "TransferWithPartialPayment"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("перемещениеденежныхдокументов", "CashEquivalentsTransfer"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("перемещениеподдеятельность", "TransferForActivity"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("перемещениетоваров", "InventoryTransfer"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("переносзадолженности", "DebtTransfer_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("переоценка", "Revaluation"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("переоценкатоваровврознице", "GoodsRevaluationInRetail"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("пересчеттоваров", "InventoryRecount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("перечислениевбюджет", "TransferOfTaxesAndContributions"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("период", "Period"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("периодотбор", "PeriodFilter"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("периодрегистрации", "RegistrationPeriod"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("периодстрокой", "PeriodAsString"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("пиво", "BeerOrBeerDrink"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("платеж", "Payment_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("платежвыплата", "PaymentDisbursement"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("платежказино", "PaymentCasino"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("платежнаякарта", "PaymentCard"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("платежнаяссылка", "PaymentURL"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("платежноепоручение", "PaymentOrder"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("платежноетребование", "PaymentDemand"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("платежнорасчетныедокументы", "PaymentAndSettlementDocuments"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("платежныйагент", "PayingAgent"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("платежныйордер", "PaymentWarrant"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("платежныйсубагент", "PayingSubagent"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("поверенный", "Attorney"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("погашениезадолженности", "RepaymentOfDebt"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("подакцизныйтовар", "ExcisableGoods"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("подакцизныйтовармаркируемыйсиимеющийкм", "ExcisableGoodsMarkedByIdentificationToolWithMarkingCode"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("подакцизныйтовармаркируемыйсинеимеющийкм", "ExcisableGoodsMarkedByIdentificationToolWithoutMarkingCode"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("подарок", "Gift"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("подарочныесертификаты", "GiftCertificates"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("подготовкакпередаче", "PreparingForSale"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("поддерживаетоплатуэсфсс", "SupportsESFSSPayment"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("подконтрольнаяпродукцияветис", "ProductsUnderVetISControl"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("подконтрольнаяпродукциясатурн", "ProductsUnderSaturnFSISControl"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("подоговорулизинга", "UnderLeaseAgreement"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("подокументу", "ByDocument"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("подотчет", "Subreport"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("подотчетноелицо", "AdvanceHolder"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("подпись", "Signature"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("подразделение", "Department"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("подразделениезатрат", "CostDivision"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("подразделениеорганизации", "Department_Company"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("подразделениеотправитель", "SendingDepartment"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("подразделениеполучатель", "ReceivingBusinessUnit"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("подсказка", "ToolTip"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("подтвержден", "Confirmed_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("поенаоф", "ByUniformDepreciationRates"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("поенаофна1000кмпробега", "ByUniformDepreciationRatesPer1000KmOfMileage"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("показатели", "Indicators"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("показательдаты", "DateIndicator"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("показателькбк", "IndicatorBCC"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("показательнаработки", "RunningTimeValue"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("показательномера", "NumberIndicator"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("показательоснования", "BasisIndicator"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("показательпериода", "PeriodIndicator"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("показательтипа", "TypeIndicator"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("покупателемвыставляетсясчетфактуранавозврат", "BuyerIssuesInvoiceForReturn"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("покупатели", "Buyers"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("покупатель", "Customer"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("покупателькомиссионноготовара", "ConsignedGoodsCustomer"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("покупка", "Purchase"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("покупкаупоставщика", "PurchaseFromSupplier_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("покупки", "Purchases"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("пол", "Gender"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("полугодье", "HalfYear_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("получениеналичных", "ReceivingCash"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("пользователь", "User"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("пользовательскаякиskype", "UserCISkype"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("пользовательскаякиадрес", "UserCIAddress"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("пользовательскаякиадресэлектроннойпочты", "UserCIEmail"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("пользовательскаякивебстраница", "UserCIWebPage"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("пользовательскаякидругое", "UserCIOther"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("пользовательскаякителефон", "UserCIPhone"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("пользовательскаякифакс", "UserCIFax"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("помещение", "Premise"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("понаработке", "ByAssetActivity"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("поручениеэкспедиторувпункте", "InstructionForShippingAgentAtPoint"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("поручениеэкспедиторунасклад", "InstructionForShippingAgentToWarehouse"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("поручениеэкспедиторусосклада", "InstructionForShippingAgentFromWarehouse"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("порядковыйномер", "SequenceNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("порядок", "Order"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("порядоквключениястоимостиосвсоставрасходовну", "ProcedureOfIncludingFixedAssetCostInExpensesTA"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("порядокпогашениястоимостиос", "FARepaymentProcedure"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("посроку", "ByDate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("поставщик", "Vendor"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("постоплата", "Postpayment"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("поступлениеденежныхдокументовотподотчетника", "ReceiptOfFinancialDocumentsFromAdvanceHolder"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("поступлениеденежныхдокументовотпоставщика", "ReceiptOfFinancialDocumentsFromVendor"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("поступлениеотпереработчика", "ReceiptFromToller"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("поступлениеподдеятельность", "IncomeForActivities"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("поступлениесырьяотдавальца", "SupplyFromMaterialProvider"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("поступлениетоваровуслуг", "ReceiptOfGoodsServices"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("посуммечиселлетиспользования", "BySumOfUsefulLifeYearNumbers"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("пофактическомуиспользованию", "ByActualUsage"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("почтовыйадрес", "MailAddress"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("прайслист", "PriceList"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("предоплата", "Prepayment"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("предоплатаполная", "FullPrepayment"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("предоплатачастичная", "PartialPrepayment"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("представление", "Presentation"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("представлениевида", "KindPresentaion"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("представлениедокументаправаподписи", "PresentationOfSignatureRightsDocument"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("представлениепериода", "PeriodPresentation"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("предъявленсф", "InvIsSubmitted"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("префикс", "Prefix"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("префиксинформационнойбазыисточника", "SourceInfobasePrefix"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("приемкаотпоставщика", "ReceiptFromVendor"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("приемкаповозвратуотклиента", "ReceivingByReturnFromACustomer"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("приемкапоперемещению", "ReceivingByTransfer"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("приемнакомиссию", "ConsignmentProcurement"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("признакагента", "AgentAttribute"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("признакиагента", "AgentCharacteristics"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("признакипредметарасчета", "SettlementSubjectFlags"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("признакиспособарасчета", "CalculationMethodFlags"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("признакпредметарасчета", "SettlementSubjectFlag"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("признакспособарасчета", "ShowsCalculationMethod"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("приложение", "Package"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("принципал", "Principal"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("принят", "Accepted"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("принятиекучету", "Recognition"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("принятиекучетусвводомвэксплуатацию", "RecognitionWithCommissioning"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("принятоот", "ReceivedFrom"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("припередаче", "OnCommissioning"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("причинапроведенияинвентаризации", "PhysicalInventoryCountReason"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("проведениевзаимозачета", "CarryingOutNetting"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("программалояльности", "LoyaltyProgram_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("продавец", "Seller"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("продавцы", "Sellers"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("продажанаэкспорт", "ExportSale"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("продажанеоблагаетсяндс", "SaleIsNotSubjectToVAT"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("продажаоблагаетсяенвд", "SaleIsSubjectToUTII"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("продажаоблагаетсяндс", "SaleIsSubjectToVAT"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("продажапопатенту", "SalesByPatent"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("продажатоваровнакомиссии", "SaleOfGoodsOnCommission"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("продуктыпереработкизерна", "GrainProcessingProducts"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("продуктыпереработкизернаветис", "GrainProcessingProductsUnderVetISControl"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("продукция", "ManufacturedProduct"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("продукцияизнатуральногомеха", "FurSkinProducts"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("производитель", "Manufacturer"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("производительимпортер", "ManufacturerImporter"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("произвольнаясумма", "ArbitraryAmount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("промокод", "PromoCode"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("промокоды", "PromoCodes"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("пропорциональнообъемупродукции", "ByUnitsOfProduction"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("прослеживаемыйтовар", "TracedGoods"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("проценткомиссионноговознаграждения", "PercentageOfCommission"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("процентотразницысуммпродажиипоступления", "PercentageOfDifferenceBetweenSalesAndReceipts"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("процентотсуммыпродажи", "SaleShare"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("процентплатежа", "PaymentPercentage"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("процентскидки", "DiscountPercentage"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("проценты", "Interests"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("процентыподолгосрочнымзаймам", "InterestOnLongTermLoans_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("процентыподолгосрочнымкредитам", "InterestOnLongTermLoans"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("процентыпократкосрочнымзаймам", "InterestOnShortTermLoans_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("процентыпократкосрочнымкредитам", "InterestOnShortTermLoans"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("прочее", "Other"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("прочеесписание", "OtherWriteOffs"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("прочиерасходы", "OtherExpenses"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("прочиерасчетысконтрагентами", "OtherSettlementsWithCounterparties"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("прочиесведения", "OtherInformation"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("пфрдопредельнойвеличины", "PensionFundFromBaseToLimitValue"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("пфрзазанятыхнаподземныхивредныхработах", "PFEmployedOnUndergroundAndHarmfulJobs"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("пфрзазанятыхнатяжелыхипрочихработах", "PFForEmployedOnHeavyAndOtherJobs"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("пфрпосуммарномутарифу", "PensionFundByOverallTariff"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("пфрспревышения", "PensionFundFromBaseInExcessOfLimitValue"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("работа", "Work_5"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("работы", "Works"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("разборка", "Disassembly"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("разделы", "Sections"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("разрешитьчастичнуюоплату", "AllowPartialPayment"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("распоряжениенаотгрузку", "ShipmentReferenceOrder"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("распоряжениенаприемку", "OrderForAcceptance"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("распределяемыезатраты", "ExpensesForAllocation"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("расход", "Expense"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("расходынаниокр", "RDExpenses"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("расценка", "Rate_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("расчетнаяставка", "CalculatedRate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("расчетный", "Estimated_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("расчеты", "Calculations"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("расчетыввалюте", "ARAPInCurrency"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("расчетывусловныхединицах", "CalculationsInConventionalUnits"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("расчетыпокредитамизаймам", "SettlementsOnLoansAndBorrowings"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("расчетысдебиторами", "DebtorsARAPAccounting"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("расчетысклиентами", "CustomersARAPAccounting"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("расчетыскомиссионерами", "CommissionAgentsARAPAccounting"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("расчетыскомитентами", "ConsignorsARAPAccounting"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("расчетыскомитентамипозакупке", "PurchaseSettlementsWithConsignors"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("расчетыскредиторами", "CreditorsARAPAccounting"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("расчетыслизингодателями", "SettlementsWithLessors"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("расчетыспоставщиками", "VendorsARAPAccounting"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("расширение", "Extension"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("расшифровкадопрасходов", "TranscriptOfAdditionalExpenses"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("расшифровкаплатежа", "ARAPDetails"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("реализацияклиенту", "SaleToCustomer"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("реализацияподарочныхсертификатов", "GiftCertificateSale"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("реализациятоваров", "GoodsSales"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("реализациятоваровуслуг", "CustomerInvoice"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("реализациячерезкомиссионера", "SalesViaCommissionAgent"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("реализациячерезкомиссионерабезпереходаправасобственности", "SalesViaCommissionAgentGoodsInTransit"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("регистрационныйномер", "RegistrationNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("регистрационныйномернерезидента", "NonResidentRegistrationNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("регистрационныйномерпфр", "PensionFundRegistrationNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("регистрационныйномерфсс", "SSFRegistrationNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("регистрациявналоговоморгане", "RegistrationWithTaxAuthority"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("регламентированнаяотчетность", "RegulatedReporting"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("резерв", "Reserve"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("резервбу", "ACReserve"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("резервну", "TAReserve"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("резервы", "Reserves"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("резервыпооплатетруда", "WageReserves"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("реквизитыплатежа", "PaymentDetails"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("реконструкция", "Reconstruction"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("рнпт", "ProductBatchID"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("родитель", "Parent"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("розничный", "Retail_2"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("рольпокупателя", "CustomerRole"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("рольпродавца", "SellerRole"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("руководитель", "Director"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("руководителькадровойслужбы", "HRDirector"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("самовывоз", "SelfPickup"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("сборка", "Assembly"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("сборкатоваров", "AssemblyFromComponents"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("сведенияодокументах", "DocumentsInformation"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("сведениярнпт", "ProductBatchIDInformation"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("свидетельстводатавыдачи", "SertificateDateOfIssue"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("свидетельствосерияномер", "SeriesAndNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("свифтбик", "SWIFTBIC"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("сводныйкомиссионный", "ConsolidatedCommission"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("свойство", "Property"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("себестоимость", "Cost_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("серииноменклатуры", "ItemsBatches"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("серийныйномер", "SerialNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("серия", "Series"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("серияномертсд", "SupportingDocumentSeriesNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("серияпродукции", "ProductionSeries_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("сертификат", "Certificate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("сертификатнспк", "NSPKCertificate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("сертификатышифрования", "EncryptionCertificates"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("силамиперевозчика", "ByCarrier"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("силамиперевозчикадонашегосклада", "ByCarrierToOurWarehouse"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("силамиперевозчикадопунктапередачи", "ByCarrierToTransferPoint"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("силамиперевозчикапоадресу", "ByCarrierToAddress"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("силамипоставщикадонашегосклада", "ByVendorToOurWarehouse"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("синхронизацияданныхчерезуниверсальныйформат", "DataSynchronizationViaUniversalFormat"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("системабыстрыхплатежей", "InstantPayments"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("системаналогообложения", "TaxationSystem"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("системыналогообложения", "TaxationSystems"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("скидкинаценки", "DiscountsMarkups"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("склад", "Warehouse"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("складгруппа", "WarehouseGroup_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("складотправитель", "SourceWarehouse"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("складполучатель", "DestinationWarehouse"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("скомиссионером", "WithConsignee"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("скомиссионеромназакупку", "WithCommissionAgentForPurchase"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("скомитентом", "WithConsignor"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("скомитентомназакупку", "CustomerInvoiceOutsourcedSale"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("собственные", "Own"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("собственныетовары", "OwnProducts"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("событиеос", "FixedAssetsEvent"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("согласована", "AgreedUpon"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("согласованноеизменение", "AgreedChange"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("содержание", "Content"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("содержаниедоизменения", "ContentBeforeChange"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("соковаяпродукция", "JuiceProducts"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("составнойпредметрасчета", "CompoundSettlementSubject"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("состояниезаказа", "OrderState"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("состояниезаказастрокой", "OrderStateByLine"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("состояниеоплаты", "StateOfPayment"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("состояниеотгрузки", "ShipmentStatus"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("сотрудник", "Employee"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("сотрудники", "Employees_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("специальныйкоэффициентну", "SpecialFactorTaxAccounting"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("спецификации", "Specifications"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("спирт", "Alcohol"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("спиртосодержащаянепищеваяпродукция", "AlcoholContainingNonFoodProducts"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("спиртосодержащаяпищеваяпродукция", "AlcoholContainingFoodProducts"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("списание", "WriteOff"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("списаниеденежныхдокументов", "WriteOffFinancialDocuments"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("списаниезадолженности", "DebtCancellation"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("списаниеприпринятиикучету", "IncludingInExpensesOnRecognition"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("списаниетоваровнакомиссии", "WriteOffOfGoodsForCommissions"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("спокупателем", "WithCustomer"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("способвыставления", "BillingMethod"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("способдоставки", "DeliveryMethod"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("способпогашениязадолженности", "MethodOfDebtRepayment"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("способпогашениястоимоститмц", "MethodOfRepaymentOfCostOfInventory"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("способпоступления", "ReceiptMethod"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("способрасчетакомиссионноговознаграждения", "MethodOfCalculationOfCommission"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("способрасчетов", "CalculationMethod"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("способыдоставки", "TransportMethods"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("способыначисленияамортизациинмабу", "MethodsOfCalculatingDepreciationOfNMABU"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("способыначисленияамортизацииос", "AccrualMethodOfFixedAssetsDepreciation"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("способыпогашениястоимоститмц", "WaysToRepayCostOfInventory"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("способырасчетакомиссионноговознаграждения", "CommissionFeeCalculationMethods"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("споставщиком", "WithVendor"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("среднийремонт", "AssetRepair"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("срокгодности", "ExpirationDate_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("срокдействия", "ValidityPeriod"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("срокиспользованиянудо2009", "UsefulLifeBefore2009"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("срокполезногоиспользованиябу", "UsefulLifeMonthsAC"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("срокполезногоиспользованияну", "UsefulLifeMonthsTA"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("срокэксплуатации", "ServiceLife"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("срочностькредитазайма", "UrgencyOfLoanLoan"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ссылка", "Ref"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ссылканаобъект", "ObjectReference"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ставка", "Rate1"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ставкаазартнойигры", "GamblingStake"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ставкандс", "VATRate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ставкандсвознаграждения", "VATRateOfRemuneration"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ставкандсврознице", "RetailNDSRate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ставкандсдоизменения", "VATRateBeforeChange"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ставкапошлины", "DutyRate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ставкиндс", "VATRates"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ставкиндсноменклатуры", "ProductsVATRates"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("статус", "Status"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("статуссоставителя", "AuthorStatus"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("статусуказаниясерий", "BatchesIndicationStatus"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("статусызаявокнарасходдс", "StatusesOfRequestsForSpendingCash"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("статьяддс", "CFItem"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("статьядоходов", "IncomeItem"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("статьязатрат", "CostItem"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("статьярасходов", "ExpenseItem"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("стоимость", "Cost"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("стоимостьневключаетсяврасходы", "CostIsNotIncludedInExpenses"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("стоимостьнепогашается", "CostIsNotRedeemable"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("стоимостьос", "FACost"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("стоимостьтоваров", "GoodsCost"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("сторнируемыйдокумент", "ReversedDocument"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("страна", "Country"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("странаввозанерф", "ImportingCountryIsNotRF"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("странамира", "WorldCountry"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("странапроисхождения", "OriginCountry"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("странапроисхождениядоизменения", "CountryOfOriginBeforeChange"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("странарегистрации", "RegistrationCountry"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("страховойномерпфр", "InsuranceNumberOfTheFIU"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("страховыевзносы", "InsuranceContributions"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("строка", "String"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("субъект", "Subject"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("сумма", "Sum"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммабезндс", "AmountExcludingVAT"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммабонусныхбаллов", "AmountOfBonusPoints"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммавал", "SumCurr"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммавзаиморасчетов", "AmountARAP"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммавключаетндс", "AmountIncludesVAT"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммавозврата", "ReturnAmount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммавознаграждения", "CommissionAmount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммаврознице", "RetailAmount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммавсехплатежей", "TotalOfAllPayments"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммадебиторскойзадолженности", "AmountOfAccountsReceivable"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммадоизменения", "AmountBeforeChange"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммадокорректировки", "AmountBeforeAdjustment"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммадокумента", "DocumentAmount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммакомиссии", "FeeAmount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммакомиссиябанка", "AmountBankCommission"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммакредиторскойзадолженности", "AmountOfAccountsPayable"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммандс", "VATAmount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммандс10", "VATAmount10"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммандс20", "VATAmount20"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммандсвознаграждения", "AmountVATRemuneration"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммандсдоизменения", "VATAmountBeforeChange"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммандсдокорректировки", "AmountOfVATBeforeAdjustment"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("сумманеоблагаемаяндс", "AmountNotSubjectToVAT"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммаоплаты", "PayAmount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммапередачи", "TransferAmount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммаплатежа", "PaymentAmount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммапоступления", "OrderReceiptAmount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммапошлины", "DutyAmount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммарегл", "SumCompl"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммарезерва", "ReserveAmount_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммарнпт", "AmountOfProductBatchID"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммаскидки", "DiscountAmount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммасучетомскидки", "AmountIncludingDiscount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммауслуг", "AmountOfServices"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммаучет", "AmountAccounting_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("суммафакт", "SumReal"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетафактурывыданныепокупателям", "InvoicesIssuedToCustomers"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетдоходов", "AccountOfIncome"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетдт", "AccountDr"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетзатрат", "CostAccount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счеткт", "AccountCr"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетпередачи", "TransferAccount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетрасходов", "ExpensesAccount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетрасчетов", "SettlementAccount_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетучета", "GLAccount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетучетаавансоввыданных", "AccountForAdvancesIssued"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетучетаавансовполученных", "AccountForAdvancesReceived"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетучетавпути", "TrackingAccountInTransit"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетучетавыручкиотпродаж", "SalesRevenueAccount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетучетанаскладе", "WarehouseInvoice"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетучетандсвпути", "NdsvPathAccountingAccount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетучетандспризакупке", "VATInvoiceForPurchases"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетучетандсприпродаже", "VATInvoiceForSales"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетучетанеотфактурованныепоставки", "InvoiceForUnfacturedDeliveries"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетучетапередачинакомиссию", "AccountForTransferToCommission"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетучетарасчетов", "Account_Settlement"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетучетарасчетовповознаграждению", "RemunerationSettlementAccount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетучетарасчетовпопретензиям", "ClaimsSettlementAccount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетучетарасчетовсдебиторамикомиссия", "AccountForSettlementsWithDebtorsCommission"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетучетарасчетовсдебиторамиосновнойдолг", "AccountForSettlementsWithDebtorsPrincipalDebt"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетучетарасчетовсдебиторамипроценты", "AccountForSettlementsWithDebtorsInterest"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетучетарасчетовсклиентами", "AccountForSettlementsWithCustomers"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетучетарасчетовсклиентамитара", "AccountForSettlementsWithCustomersTare"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетучетарасчетовсконтрагентом", "AccountForSettlementsWithCounterparty"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетучетарасчетовскредиторамикомиссия", "AccountForSettlementsWithCreditorsCommission"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетучетарасчетовскредиторамиосновнойдолг", "AccountForSettlementsWithCreditorsPrincipalDebt"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетучетарасчетовскредиторамипроценты", "AccountForSettlementsWithCreditorsInterest"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетучетарасчетовслизингодателемарендныеобязательства", "AccountForSettlementsWithLessorLeaseObligations"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетучетарасчетовслизингодателемвыкуппредметализинга", "AccountForSettlementsWithLessorRepurchaseOfLeasedItem"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетучетарасчетовслизингодателемлизинговыеуслуги", "AccountForSettlementsWithLessorLeasingServices"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетучетарасчетовслизингодателемобеспечительныйплатеж", "AccountForSettlementsWithLessorSecurityPayment"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетучетарасчетовспоставщиками", "AccountForSettlementsWithSuppliers"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетучетарасчетовспоставщикамитара", "AccountForSettlementsWithSuppliersTare"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетучетасебестоимостипродаж", "CostOfSalesAccount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетфактура", "TaxInvoice"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетфактуравыданный", "InvoiceIssued"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетфактуравыданныйпокупателю", "InvoiceIssuedToBuyer"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("счетфактураполученный", "VendorInvoiceReceived"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("сырьевойтовар", "Commodity"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("табак", "Tobacco"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("таможеннаядекларация", "CustomsDeclaration"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("таможеннаядекларацияссылка", "CustomsDeclarationLink"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("таможеннаястоимость", "CustomsValue"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("таможенныйсбор", "CustomsFee"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("таможенныйштраф", "CustomsPenalty"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("тара", "Tara"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("твердаяставкаакциза", "FixedExciseDuty"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("тексткорреспондента", "CorrespondentText"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("текстназначения", "PurposeText"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("текстплательщика", "PayerSName"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("текстполучателя", "RecipientText"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("текущаяноменклатура", "CurrentProducts"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("текущаястоимостьбу", "CurrentcCostFinAcc"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("текущаястоимостьвр", "CurrentCostTD"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("текущаястоимостьну", "CurrentCostTaxAccounting"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("текущаястоимостьпр", "CurrentcCostPD"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("текущийремонт", "AssetMaintenance"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("телефон", "Phone"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("телефондомашний", "HomePhoneNumber"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("телефонрабочий", "WorkingPhone"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("телефоны", "Phones"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("типакцизноймарки", "TypeOfExciseStamp"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("типзапасов", "InventoryType"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("типколичество", "TypeQuantity"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("типноменклатуры", "ItemsType"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("типоплаты", "TypeOfPayment"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("типпериодадействия", "TypeOfValidityPeriod"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("типплатежногодокумента", "PaymentDocumentType"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("типсклада", "WarehouseStore"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("типсумма", "TypeAmount"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("типсуммыграфика", "ScheduleAmountType"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("типуникальныйидентификатор", "UUIDType"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("типупаковки", "PackageType"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("типуслуги", "ServiceType"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("типцен", "PriceType_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("типценрозничнойторговли", "TypeOfRetailPrices"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("типцены", "PriceType"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("типштрихкода", "BarcodeType"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("типызапасов", "InventoryTypes"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("типыноменклатуры", "ItemsTypes"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("типыпериодов", "TypesOfPeriods"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("типыплатежнойсистемыккт", "TypesOfCashRegisterPaymentSystem"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("типыплатежныхдокументов", "TypesOfPaymentDocuments"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("типыскладов", "TypesOfWarehouses"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("типытипыоплатчековккм", "TypesOfPaymentTypesOfCashRegisterChecks"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("типыупаковокноменклатуры", "TypesOfItemsPackages"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("типыуслуг", "ServicesTypes"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("типыштрихкодов", "BarcodeTypes"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("тмц", "Inventory"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("товар", "OwnGoods"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("товармаркируемыйсиимеющийкм", "GoodsMarkedByIdentificationToolWithMarkingCode"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("товармаркируемыйсинеимеющийкм", "GoodsMarkedByIdentificationToolWithoutMarkingCode"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("товары", "Goods"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("товарывозвратпродажи", "GoodsReturnSales"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("товарыпродажа", "GoodsSale"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("торг12", "Auction12"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("торговыйсбор", "SalesCharge"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("точностьединицыизмерения", "AccuracyOfUnitOfMeasure"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("точностьокругления", "RoundingPrecision"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("транспортныесредства", "Vehicles"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("требуетсяизвещениеополучении", "NotificationOfReceiptIsRequired"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("требуетсяизвещениепоотклонению", "NotificationOfRejectionIsRequired"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("требуетсяисправлениеошибкипередачи", "TransmissionErrorCorrectionIsRequired"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("требуетсяотправка", "SendingRequired"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("требуетсяотправкааннулирования", "SendingCancellationIsRequired"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("требуетсяотправкаизвещения", "SendingNotificationIsRequired"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("требуетсяотправкаизвещенияпоотклонению", "SendingNotificationOfRejectionIsRequired"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("требуетсяотправкаотклонения", "SendingRejectionIsRequired"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("требуетсяотправкаприглашения", "SendingInvitationIsRequired"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("требуетсяповторнаяотправка", "ResendingRequired"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("требуетсяподготовкакотправке", "PreparationForSendingIsRequired"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("требуетсяподготовкакотправкеаннулирования", "PreparationForSendingCancellationIsRequired"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("требуетсяподготовкакотправкеизвещения", "PreparationForSendingNotificationIsRequired"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("требуетсяподготовкакотправкеизвещенияпоотклонению", "PreparationIsRequiredForSendingNotificationOfRejection"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("требуетсяподготовкакотправкеотклонения", "PreparationForSendingRejectionIsRequired"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("требуетсяподписание", "SigningRequired"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("требуетсяподписаниеаннулирования", "SigningOfCancellationIsRequired"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("требуетсяподписаниеизвещения", "SigningOfNotificationIsRequired"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("требуетсяподписаниеизвещенияпоотклонению", "SigningNotificationOfRejectionIsRequired"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("требуетсяподписаниеотклонения", "RejectionSignatureIsRequired"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("требуетсяподтверждениеаннулирования", "ConfirmationOfCancellationIsRequired"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("требуетсяутверждение", "ApprovalRequired"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("требуетсяуточнение", "ClarificationIsRequired"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("требуютсядействия", "ActionsAreRequired"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("тфомс", "TCMIF"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("уведомлениеобостаткахпрослеживаемыхтоваров", "NotificationOfBalancesOfTraceableGoods"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("уведомлениеоввозепрослеживаемыхтоваров", "NotificationOfImportOfTraceableGoods"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("уведомлениеоперемещениипрослеживаемыхтоваров", "NotificationOfMovementOfTraceableGoods"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("удалитьожидаетсявыписка", "DeleteAwaitingStatement"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("удалитьожидаетсяизвещение", "DeleteAwaitingNotification"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("удалитьожидаетсяисполнение", "DeleteFulfillmentIsExpected"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("удалитьожидаетсяотзыв", "DeleteRevokeIsExpected"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("удалитьожидаетсяотправкаполучателю", "DeleteItIsExpectedToBeSentToRecipient"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("удалитьотклоненоператором", "DeleteRejectedByOperator"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("удалитьплатежисполнен", "DeletePaymentIsExecuted"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("удалитьтребуетсяподтверждение", "DeleteConfirmationIsRequired"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("удержатькомиссионноевознаграждение", "WithholdCommission"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("уменьшаемогоостатка", "ReducedBalance"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("упакованнаявода", "PackagedWater"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("упаковка", "Package"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("упаковканоменклатуры", "ProductPackaging"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("упаковкаотбор", "PackagingSelection"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("уполномоченноелицо", "AuthorizedPerson"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("уполномоченноелицоотбор", "AuthorizedPersonSelection"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("уполномоченныйпредставитель", "AuthorizedRepresentativeInTaxAuthority"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("упрощеннаядоход", "SimplifiedRevenue"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("упрощеннаядоходминусрасход", "SimplifiedRevenueMinusExpense"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("услуга", "OperationService"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("услугаповознаграждению", "RewardService"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("услуги", "Services"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("установкаценноменклатуры", "PriceSetup"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("устаревший", "Obsolete1"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("утверждена", "Upholded_"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("утвержденнаядатаплатежа", "ApprovedPaymentDate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("утвержденнаяформаоплаты", "ApprovedFormOfPayment"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("уточнениенаименования", "NameClarification"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("участникисделки", "TransactionParties"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("учетагентскогондс", "CompanyActsAsAVATTaxAgent"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("учетвыручкивоперационнойкассе", "AccountingForRevenueInOperatingCashRegister"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("файлы", "Files"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("факс", "Fax"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("фактическийадрес", "ActualAddress"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("фактурнаястоимость", "TaxInvoicedPrice"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("фамилия", "LastName"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("физическиелица", "Persons"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("физическоелицо", "Individual"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("физическоелицоотбор", "IndividualSelection"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("фио", "LastFirstName"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("формаоплаты", "PaymentMethod"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("форматвыгрузки", "UploadFormat"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("форматсвойства", "FormatProperties"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("формыоплаты", "PaymentForms"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("фотоаппараты", "CamerasAndFlashbulbs"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("фсс", "InsuranceContributionsToSSF"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ффомс", "InsuranceContributionsToFCMIF"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("характеристика", "Characteristic"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("характеристиканоменклатуры", "ProductCharacteristic"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("характеристикаотбор", "FeatureSelection"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("характеристикапродукции", "ItemVariant"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("хранимыйфайл", "StoredFile"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("цена", "Price"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ценавключаетндс", "PriceIncludesVAT"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ценаврознице", "RetailPrice"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ценаврозницестарая", "RetailPriceIsOld"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ценадоизменения", "PriceBeforeChange"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ценадокорректировки", "PriceBeforeAdjustment"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ценазаупаковку", "PricePerPackaging"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ценапередачи", "TransferPrice"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ценапоступления", "ReceiptPrice"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ценныебумаги", "Securities"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ценоваягруппа", "PriceGroup"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ценовыегруппы", "PriceGroups"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("цифровойиндексобособленногоподразделения", "NumericCodeForTaxInvoices"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("частичнаяликвидация", "PartialDisposal"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("частичноевыбытиевариантучета", "PartialDisposalAccountingOption"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("частичноевыбытиеколичество", "PartialDisposalQuantity"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("чек", "Receipt"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("чекккм", "CashRegisterReceipt"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("черновик", "Draft"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("шаблонмагнитнойкарты", "MagneticStripeCardTemplate"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("шаблоныкодов", "CodeTemplates"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("шины", "Tires"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ширина", "Width"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("шифрпоенаоф", "CodeByUFADR"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("штраф", "Penalty"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("штрихкод", "Barcode"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("штрихкодотбор", "BarcodeSelection"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("эквайер", "Acquirer"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("эквайрер", "Acquirer"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("эквайринговыетерминалы", "POSTerminals"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("эквайринговыйтерминал", "POSTerminal"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("экспортнесырьевыхтоваров", "ExportOfNonResourceGoods"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("экспортсырьевыхтоваров", "CommodityExports"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("электронно", "Electronically"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("электронныеподписи", "DigitalSignatures"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("электронныеуслуги", "DigitalServices"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("эмитент", "Issuer"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("этапгосконтрактаеис", "UISStateContractStep"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("этапыоплаты", "PaymentSteps"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("этовозврат", "ThisIsReturn"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("этодоговорэквайринга", "ThisIsAcquiringContract"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("этодополнительноесведение", "IsAdditionalInfo"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("этодопрасходы", "ThisIsAdditionalExpense"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("этонабор", "IsRecordsSet"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("юкасса", "YooKassa"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("юридическийадрес", "LegalAddress"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("юридическоелицо", "BusinessEntity"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("юридическоефизическоелицо", "CompanyIndividual"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("являетсярнпт", "IsRNPT"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("являетсяудостоверяющимличность", "IsIdentityDocument"); // @NON-NLS-1 @NON-NLS-2

	// АПК:1036-вкл не проверять текст на орфографию
	
	Возврат Словарь;
	
КонецФункции
    
// Возвращаемое значение:
//  Соответствие из КлючИЗначение:
//   * Ключ - Строка
//   * Значение - Строка
//
Функция Словарь_en_ru()
	
	Словарь = Новый Соответствие;
	
	// АПК:1036-выкл не проверять текст на орфографию
	Словарь.Вставить("abbreviateddescription", "НаименованиеСокращенное"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accelerationfactoraccounting", "КоэффициентУскоренияБУ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accepted", "Принят"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("account_settlement", "СчетУчетаРасчетов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accountant", "Бухгалтер"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accountcr", "СчетКт"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accountdr", "СчетДт"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accountforadvancesissued", "СчетУчетаАвансовВыданных"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accountforadvancesreceived", "СчетУчетаАвансовПолученных"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accountforsettlementswithcounterparty", "СчетУчетаРасчетовСКонтрагентом"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accountforsettlementswithcreditorscommission", "СчетУчетаРасчетовСКредиторамиКомиссия"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accountforsettlementswithcreditorsinterest", "СчетУчетаРасчетовСКредиторамиПроценты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accountforsettlementswithcreditorsprincipaldebt", "СчетУчетаРасчетовСКредиторамиОсновнойДолг"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accountforsettlementswithcustomers", "СчетУчетаРасчетовСКлиентами"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accountforsettlementswithcustomerstare", "СчетУчетаРасчетовСКлиентамиТара"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accountforsettlementswithdebtorscommission", "СчетУчетаРасчетовСДебиторамиКомиссия"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accountforsettlementswithdebtorsinterest", "СчетУчетаРасчетовСДебиторамиПроценты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accountforsettlementswithdebtorsprincipaldebt", "СчетУчетаРасчетовСДебиторамиОсновнойДолг"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accountforsettlementswithlessorleaseobligations", "СчетУчетаРасчетовСЛизингодателемАрендныеОбязательства"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accountforsettlementswithlessorleasingservices", "СчетУчетаРасчетовСЛизингодателемЛизинговыеУслуги"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accountforsettlementswithlessorrepurchaseofleaseditem", "СчетУчетаРасчетовСЛизингодателемВыкупПредметаЛизинга"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accountforsettlementswithlessorsecuritypayment", "СчетУчетаРасчетовСЛизингодателемОбеспечительныйПлатеж"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accountforsettlementswithsuppliers", "СчетУчетаРасчетовСПоставщиками"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accountforsettlementswithsupplierstare", "СчетУчетаРасчетовСПоставщикамиТара"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accountfortransfertocommission", "СчетУчетаПередачиНаКомиссию"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accountingforrevenueinoperatingcashregister", "УчетВыручкиВОперационнойКассе"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accountingrecorddate", "ДатаПринятияНаУчет"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accountnumber", "НомерСчета"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accountofincome", "СчетДоходов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accountspayable", "КредиторскаяЗадолженность"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accountsreceivable", "ДебиторскаяЗадолженность"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accounttype", "ВидСчета"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accrualdate", "ДатаНачисления"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accrualmethodoffixedassetsdepreciation", "СпособыНачисленияАмортизацииОС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accrualofestimatedvacationliabilities", "НачислениеОценочныхОбязательствПоОтпускам"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accruals", "Начисления"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accrued_bonuses", "НачисленныеБонусы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accruewearasperufadr", "НачислениеИзносаПоЕНАОФ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accumulateddepreciationaccounting", "НакопленнаяАмортизацияБУ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accumulateddepreciationtaxaccounting", "НакопленнаяАмортизацияНУ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accumulateddepreciationtd", "НакопленнаяАмортизацияВР"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("accuracyofunitofmeasure", "ТочностьЕдиницыИзмерения"); // @NON-NLS-1 @NON-NLS-2

	Массив = Новый Массив;
	Массив.Добавить("Эквайер"); // @NON-NLS-1
	Массив.Добавить("Эквайрер"); // @NON-NLS-1
	Словарь.Вставить("acquirer", Массив);

	Словарь.Вставить("acquirerscontract", "ДоговорЭквайрера"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("acreserve", "РезервБУ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("actionsarerequired", "ТребуютсяДействия"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("activityregistration", "ОприходованиеПодДеятельность"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("activitytype", "НаименованиеОКВЭД"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("activitytype2", "НаименованиеОКВЭД2"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("activitytypefortaxaccountingofcosts", "ВидДеятельностиДляНалоговогоУчетаЗатрат"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("actualaddress", "ФактическийАдрес"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("additionalattribute", "ДополнительныйРеквизит"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("additionalattributes", "ДополнительныеРеквизиты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("additionalinformation", "ДополнительнаяИнформация"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("additionalvaluesowner", "ВладелецДополнительныхЗначений"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("additionalvaluesused", "ДополнительныеЗначенияИспользуются"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("additionalvalueswithweight", "ДополнительныеЗначенияСВесом"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("address", "Адрес"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("addressasstring", "АдресСтрокой"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("adjustmentofgoodsreceipts", "КорректировкаПоступленияТоваров"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("advanceholder", "ПодотчетноеЛицо"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("advancepayment", "НаАванс"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("advancepurpose", "НазначениеАванса"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("advancereportlink", "АвансовыйОтчетСсылка"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("agency", "Агентские"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("agencyagreementkind", "ВидАгентскогоДоговора"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("agencyfee", "АгентскоеВознаграждение"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("agent", "Агент"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("agentattribute", "ПризнакАгента"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("agentcharacteristics", "ПризнакиАгента"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("agreedchange", "СогласованноеИзменение"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("agreedupon", "Согласована"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("alcohol", "Спирт"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("alcoholcontainingfoodproducts", "СпиртосодержащаяПищеваяПродукция"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("alcoholcontainingnonfoodproducts", "СпиртосодержащаяНеПищеваяПродукция"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("alcoholcontainingproducts", "АлкогольнаяПродукция"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("alcoholic", "Алкогольная"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("allexecuted", "ВсеВыполнено"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("allowpartialpayment", "РазрешитьЧастичнуюОплату"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("alternativetobaccoproducts", "АльтернативныйТабак"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("amountaccounting_", "СуммаУчет"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("amountarap", "СуммаВзаиморасчетов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("amountbankcommission", "СуммаКомиссияБанка"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("amountbeforeadjustment", "СуммаДоКорректировки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("amountbeforechange", "СуммаДоИзменения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("amountdue", "КОплате"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("amountexcludingvat", "СуммаБезНДС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("amountincludesvat", "СуммаВключаетНДС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("amountincludingdiscount", "СуммаСУчетомСкидки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("amountinwordsparameters", "ПараметрыПрописи"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("amountnotsubjecttovat", "СуммаНеОблагаемаяНДС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("amountofaccountspayable", "СуммаКредиторскойЗадолженности"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("amountofaccountsreceivable", "СуммаДебиторскойЗадолженности"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("amountofbonuspoints", "СуммаБонусныхБаллов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("amountofproductbatchid", "СуммаРНПТ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("amountofservices", "СуммаУслуг"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("amountofvatbeforeadjustment", "СуммаНДСДоКорректировки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("amountvatremuneration", "СуммаНДСВознаграждения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("analyticalgroup", "ГруппаАналитическогоУчета"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("analyticalproductgroup", "ГруппаАналитическогоУчетаНоменклатуры"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("annualdepreciationrate", "КоэффициентАмортизацииБУ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("antiseptics", "Антисептики"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("applicationforimportationofgoods", "ЗаявлениеОВвозеТоваров"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("approvalrequired", "ТребуетсяУтверждение"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("approvedformofpayment", "УтвержденнаяФормаОплаты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("approvedpaymentdate", "УтвержденнаяДатаПлатежа"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("arapcurrency", "ВалютаВзаиморасчетов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("arapdetails", "РасшифровкаПлатежа"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("arapincurrency", "РасчетыВВалюте"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("araptype", "ВидРасчетов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("arbitraryamount", "ПроизвольнаяСумма"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("archive", "Архив"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("archivepasswordexchangemessages", "ПарольАрхиваСообщенияОбмена"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("assembly", "Сборка"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("assemblyfromcomponents", "СборкаТоваров"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("assetid", "ИнвентарныйНомер"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("assetmaintenance", "ТекущийРемонт"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("assetrepair", "СреднийРемонт"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("assigneeformaintainingofaccountingregisters", "ОтветственныйЗаБухгалтерскиеРегистры"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("assigneeformaintainingoftaxregisters", "ОтветственныйЗаНалоговыеРегистры"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("atexpenseofsupplier", "ЗаСчетПоставщика"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("atexpenseofthirdpartycompany", "ЗаСчетСтороннейКомпании"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("attorney", "Поверенный"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("auction12", "ТОРГ12"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("author", "Автор"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("authorizationcode", "КодАвторизации"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("authorizedperson", "УполномоченноеЛицо"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("authorizedpersonselection", "УполномоченноеЛицоОтбор"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("authorizedrepresentativeintaxauthority", "УполномоченныйПредставитель"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("authorstatus", "СтатусСоставителя"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("automatically", "Автоматически"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("awaitingconfirmation", "НаУтверждении"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("bank", "Банк"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("bankaccount", "БанковскийСчет"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("bankaccountpayment", "Безналичная"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("bankcredit", "КредитБанка"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("bankpayingagent", "БанковскийПлатежныйАгент"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("bankpayingsubagent", "БанковскийПлатежныйСубагент"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("bankpaymentorder", "БанковскийОрдер"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("bankreportonacquiringtransactions", "ОтчетБанкаПоОперациямЭквайринга"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("barcode", "Штрихкод"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("barcodelength", "ДлинаШтрихкода"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("barcodeselection", "ШтрихкодОтбор"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("barcodetype", "ТипШтрихкода"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("barcodetypes", "ТипыШтрихкодов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("basis", "Основание"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("basisdocuments", "ДокументыОснования"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("basisindicator", "ПоказательОснования"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("batchesindicationstatus", "СтатусУказанияСерий"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("beerorbeerdrink", "Пиво"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("beginningofreportperiod", "НачалоПериодаОтчета"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("beginofperiod", "НачалоПериода"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("bic", "БИК"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("bicycles", "Велосипеды"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("billingmethod", "СпособВыставления"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("birthdate", "ДатаРождения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("birthplace", "МестоРождения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("bonus", "Бонус"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("bonusconversioncurrency", "ВалютаКонвертацииБонусов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("bonuspointaccrual", "НачислениеБонусныхБаллов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("bonusprogram", "БонуснаяПрограмма"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("bottleretirement", "ВыбытиеБутылки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("branchoffice", "ОбособленноеПодразделение"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("brand", "Марка"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("businessactivityclassifiercode", "КодОКВЭД"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("businessentity", "ЮридическоеЛицо"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("businessunitcode", "КодПодразделения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("buyerissuesinvoiceforreturn", "ПокупателемВыставляетсяСчетФактураНаВозврат"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("buyers", "Покупатели"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("byactualusage", "ПоФактическомуИспользованию"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("byassetactivity", "ПоНаработке"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("bycarrier", "СиламиПеревозчика"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("bycarriertoaddress", "СиламиПеревозчикаПоАдресу"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("bycarriertoourwarehouse", "СиламиПеревозчикаДоНашегоСклада"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("bycarriertotransferpoint", "СиламиПеревозчикаДоПунктаПередачи"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("bycourier", "Курьером"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("bydate", "ПоСроку"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("bydocument", "ПоДокументу"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("bysumofusefullifeyearnumbers", "ПоСуммеЧиселЛетИспользования"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("byuniformdepreciationrates", "ПоЕНАОФ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("byuniformdepreciationratesper1000kmofmileage", "ПоЕНАОФНа1000кмПробега"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("byunitsofproduction", "ПропорциональноОбъемуПродукции"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("byvendortoourwarehouse", "СиламиПоставщикаДоНашегоСклада"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("calculatedrate", "РасчетнаяСтавка"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("calculationdata", "ДанныеРасчетов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("calculationmethod", "СпособРасчетов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("calculationmethodflags", "ПризнакиСпособаРасчета"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("calculations", "Расчеты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("calculationsettings", "НастройкиРасчета"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("calculationsinconventionalunits", "РасчетыВУсловныхЕдиницах"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("camerasandflashbulbs", "Фотоаппараты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("canceled", "Отменено"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("canceled_", "Аннулирован"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("cardholder", "ВладелецКарты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("cardkind", "ВидКарты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("cardnumber", "НомерКарты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("carrier", "Перевозчик"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("carryingoutnetting", "ПроведениеВзаимозачета"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("cartid", "ИдентификаторКорзины"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("cash", "ДенежныеСредства"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("cashaccountissuer", "КассаОтправитель"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("cashaccountpayment_", "Наличная"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("cashaccountrecipient", "КассаПолучатель"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("cashaccounts", "Кассы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("cashcontribution", "ВзносНаличными"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("cashcurrency", "ВалютаДенежныхСредств"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("cashequivalents", "ДенежныеДокументы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("cashequivalentsissuetoadvanceholder", "ВыдачаДенежныхДокументовПодотчетнику"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("cashequivalentstransfer", "ПеремещениеДенежныхДокументов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("cashier", "Кассир"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("cashpayment", "Наличные"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("cashregister", "КассаККМ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("cashregisterpayments", "ОплатыККМ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("cashregisterreceipt", "ЧекККМ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("cashregisterreceiptnumber", "НомерЧекаККМ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("cashregisters", "КассыККМ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("cashregistersalesreceiptnumber", "НомерЧекаККМПродажи"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("cashregistershift", "КассоваяСмена"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("cashshiftnumber", "НомерКассовойСмены"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ccddata", "ДанныеГТД"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ccdnumber", "НомерГТД"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ccdnumberbeforechange", "НомерГТДДоИзменения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("certificate", "Сертификат"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("certificatedata", "ДанныеСертификата"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("cfitem", "СтатьяДДС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("characteristic", "Характеристика"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("chiefaccountant", "ГлавныйБухгалтер"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("cikinds", "ВидыКИ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("citizenship", "Гражданство"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("city", "Город"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("claimssettlementaccount", "СчетУчетаРасчетовПоПретензиям"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("clarificationisrequired", "ТребуетсяУточнение"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("classifierdata", "ДанныеКлассификатора"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("closed_", "Закрыта"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("closedforcefully", "ЗакрытПринудительно"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("closedwithdeviation", "ЗакрытСОтклонением"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("closedwithrejectionofinvitation", "ЗакрытСОтклонениемПриглашения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("closedwithtransmissionerror", "ЗакрытСОшибкойПередачи"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("closingdate", "ДатаЗакрытия"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("code", "Код"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("codealpha2", "КодАльфа2"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("codealpha3", "КодАльфа3"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("codebyrncfa", "КодПоОКОФ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("codebyufadr", "ШифрПоЕНАОФ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("codeinapp", "КодВПрограмме"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("codeofalcoholicproducts", "КодАлкогольнойПродукции"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("codetemplates", "ШаблоныКодов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("collection_", "Инкассация"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("collectionorder_2", "ИнкассовоеПоручение"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("comment", "Комментарий"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("commissionagentsarapaccounting", "РасчетыСКомиссионерами"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("commissionagentstaxinvoicenumber", "НомерСчетаФактурыКомиссионера"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("commissionamount", "СуммаВознаграждения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("commissionfeecalculationmethods", "СпособыРасчетаКомиссионногоВознаграждения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("commissiongoods", "КомиссионныеТовары"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("commissioning", "ВводВЭксплуатацию"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("commodity", "СырьевойТовар"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("commodityexports", "ЭкспортСырьевыхТоваров"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("companyactsasavattaxagent", "УчетАгентскогоНДС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("companybankaccount", "БанковскийСчетОрганизации"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("companycustomer", "ОрганизацияПродавец"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("companyfilter", "ОрганизацияОтбор"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("companyindividual", "ЮридическоеФизическоеЛицо"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("companyrecipient", "ОрганизацияПолучатель"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("completed", "Выполнен"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("completedworks", "ВыполненныеРаботы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("completion", "Достройка"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("composite", "КлючСтроки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("compoundsettlementsubject", "СоставнойПредметРасчета"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("confirmationdate", "ДатаУтверждения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("confirmationofcancellationisrequired", "ТребуетсяПодтверждениеАннулирования"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("confirmed_", "Подтвержден"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("consignedgoodscustomer", "ПокупательКомиссионногоТовара"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("consignee", "Комиссионер"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("consignmentprocurement", "ПриемНаКомиссию"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("consignmentreportfromcustomer", "ОтчетКомиссионера"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("consignmentreporttovendor", "ОтчетКомитенту"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("consignor", "Комитент"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("consignorsarapaccounting", "РасчетыСКомитентами"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("consolidatedcommission", "СводныйКомиссионный"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("contactinformation", "КонтактнаяИнформация"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("contactinformationkind", "ВидКонтактнойИнформации"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("contactperson", "КонтактноеЛицо"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("contactpersons", "КонтактныеЛица"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("content", "Содержание"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("contentbeforechange", "СодержаниеДоИзменения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("contract", "Договор"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("contractdate_", "ДатаДоговора"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("contractlink", "ДоговорСсылка"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("contractnumber", "НомерДоговора"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("contractwithcommissionagent", "ДоговорСКомиссионером"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("contributionsforcmi", "ОбязательноеМедицинскоеСтрахование"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("contributionsforcmiie", "ОбязательноеМедицинскоеСтрахованиеИП"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("contributionsforcsi", "ОбязательноеСоциальноеСтрахование"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("contributionsformpi", "ОбязательноеПенсионноеСтрахование"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("contributionsformpiie", "ОбязательноеПенсионноеСтрахованиеИП"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("conversionmultiplicity", "КратностьКонвертации"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("conversionrate", "КурсКонвертации"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("conversionrateofbonusesintocurrency", "КурсКонвертацииБонусовВВалюту"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("corraccount", "КоррСчет"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("correcteddocument", "ИсправляемыйДокумент"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("correctedimplementationdocument", "ИсправляемыйДокументРеализации"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("correctedreceiptdocument", "ИсправляемыйДокументПоступления"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("correctiondate", "ДатаИсправления"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("correctionnumber", "НомерИсправления"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("correctionoferrors", "ИсправлениеОшибки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("corrective", "Корректировочный"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("correspondenttext", "ТекстКорреспондента"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("cost", "Стоимость"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("cost_", "Себестоимость"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("costaccount", "СчетЗатрат"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("costdivision", "ПодразделениеЗатрат"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("costisnotincludedinexpenses", "СтоимостьНеВключаетсяВРасходы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("costisnotredeemable", "СтоимостьНеПогашается"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("costitem", "СтатьяЗатрат"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("costofsalesaccount", "СчетУчетаСебестоимостиПродаж"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("costshare", "ДоляСтоимости"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("count", "Количество"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("counterparties", "Контрагенты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("counterparty", "Контрагент"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("counterpartybankaccount", "БанковскийСчетКонтрагента"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("counterpartycontract", "ДоговорКонтрагента"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("counterpartycredit", "КредитКонтрагента"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("counterpartycrtr", "КППКонтрагента"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("counterpartydebtor", "КонтрагентДебитор"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("counterpartyscontactperson", "КонтактноеЛицоКонтрагента"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("counterrepresentation", "ВстречноеПредставление"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("countreal", "КоличествоФакт"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("country", "Страна"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("countryoforiginbeforechange", "СтранаПроисхожденияДоИзменения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("courier", "Курьер"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("credit", "Кредит"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("creditor", "КонтрагентКредитор"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("creditorsarapaccounting", "РасчетыСКредиторами"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("crtr", "КПП"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("crtrhistory", "ИсторияКПП"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("currency", "Валюта"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("currencyofconversion", "ВалютаКонвертации"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("currentccostfinacc", "ТекущаяСтоимостьБУ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("currentccostpd", "ТекущаяСтоимостьПР"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("currentcosttaxaccounting", "ТекущаяСтоимостьНУ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("currentcosttd", "ТекущаяСтоимостьВР"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("currentproducts", "ТекущаяНоменклатура"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("customer", "Покупатель"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("customer_", "Заказчик"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("customerinvoice", "РеализацияТоваровУслуг"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("customerinvoiceoutsourcedsale", "СКомитентомНаЗакупку"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("customermaterials", "МатериалыЗаказчика"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("customerrefunds", "ВозвратыПокупателей"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("customerrole", "РольПокупателя"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("customersarapaccounting", "РасчетыСКлиентами"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("customsdeclaration", "ТаможеннаяДекларация"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("customsdeclarationlink", "ТаможеннаяДекларацияСсылка"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("customsfee", "ТаможенныйСбор"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("customspenalty", "ТаможенныйШтраф"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("customsvalue", "ТаможеннаяСтоимость"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("dataexchangeexecutionsettingsdescription", "НаименованиеНастройкиВыполненияОбмена"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("datasynchronizationviauniversalformat", "СинхронизацияДанныхЧерезУниверсальныйФормат"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("date", "Дата"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("dateindicator", "ПоказательДаты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("dateofactivation", "ДатаПодключения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("dateofdeduction", "ДатаСписания"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("dateofdischarge", "ДатаВыписки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("dateofdocumentinarapaccounting", "ДатаПлатежноРасчетногоДокумента"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("dateofdocumentsignatureright", "ДатаДокументаПраваПодписи"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("dateofissue1", "ДатаВыдачи"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("dateofpaymentdocument", "ДатаПлатежногоДокумента"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("dateofproduction", "ДатаВыпуска"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("dateofrecognition", "ДатаПринятияКУчету"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("dateofsale", "ДатаПродажи"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("dateoftransferoftitletogoods", "ДатаПереходаПраваСобственности"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("datereceived", "ДатаПолучения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("datesent", "ДатаОтправки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("day", "День"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("debt", "Долг"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("debtcancellation", "СписаниеЗадолженности"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("debtorsarapaccounting", "РасчетыСДебиторами"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("debttransfer_", "ПереносЗадолженности"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("declarationno", "НомерДекларации"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("deductioninexpensesonrecognition", "ВключениеВРасходыПриПринятииКУчету"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("deedoftransfer", "АктНаПередачуПрав"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("deferredpayment", "ОтсрочкаПлатежа"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("deleteawaitingnotification", "УдалитьОжидаетсяИзвещение"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("deleteawaitingstatement", "УдалитьОжидаетсяВыписка"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("deleteconfirmationisrequired", "УдалитьТребуетсяПодтверждение"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("deletefulfillmentisexpected", "УдалитьОжидаетсяИсполнение"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("deleteitisexpectedtobesenttorecipient", "УдалитьОжидаетсяОтправкаПолучателю"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("deletepaymentisexecuted", "УдалитьПлатежИсполнен"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("deleterejectedbyoperator", "УдалитьОтклоненОператором"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("deleterevokeisexpected", "УдалитьОжидаетсяОтзыв"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("deliveryaddress", "АдресДоставки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("deliverymethod", "СпособДоставки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("department", "Подразделение"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("department_company", "ПодразделениеОрганизации"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("deposit", "Депозит"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("deposit_", "Депозитный"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("deposits", "Депозиты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("depreciation", "Амортизация"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("depreciationaccrual", "НачислениеАмортизации"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("depreciationaccrualaccounting", "НачислятьАмортизациюБУ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("depreciationaccrualfactor", "КоэффициентБУ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("depreciationaccrualtaxaccounting", "НачислятьАмортизациюНУ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("depreciationbefore2009", "АмортизацияДо2009"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("depreciationgroup", "АмортизационнаяГруппа"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("depth", "Глубина"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("description", "Наименование"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("descriptionfull", "НаименованиеПолное"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("descriptioninternational", "НаименованиеМеждународное"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("desirableformofpaymentcash", "ЖелательнаяФормаОплатыНаличные"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("desirableformofpaymentnoncash", "ЖелательнаяФормаОплатыБезналичные"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("desiredformofpaymentpaymentcard", "ЖелательнаяФормаОплатыПлатежнаяКарта"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("destinationwarehouse", "СкладПолучатель"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("determinedbyallocation", "ОпределяетсяРаспределением"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("dietarysupplements", "БАДы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("digitalservices", "ЭлектронныеУслуги"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("digitalsignatures", "ЭлектронныеПодписи"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("director", "Руководитель"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("disassembly", "Разборка"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("disbursementoffunds", "ВыдачаДенежныхСредств"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("discountamount", "СуммаСкидки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("discountcard", "ДисконтнаяКарта"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("discounted", "Дисконтная"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("discountpercentage", "ПроцентСкидки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("discountsmarkups", "СкидкиНаценки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("displaymonthinwords", "ВыводитьМесяцПрописью"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("document", "Документ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("documentamount", "СуммаДокумента"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("documentbasedocumentnumber", "ДокументОснованиеНомер"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("documentbasis", "ДокументОснование"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("documentbasiskind", "ДокументОснованиеВид"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("documentcourse", "КурсДокумента"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("documentdate", "ДатаДокумента"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("documentinflow", "ДокументПоступления"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("documentkind", "ВидДокумента"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("documentmultiplicity", "КратностьДокумента"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("documentnumber", "НомерДокумента"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("documentofarapaccounting", "ДокументРасчетов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("documentofrecognitionnumber", "НомерДокументаПринятияКУчету"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("documentreferencedocumentdateforprintforms", "ДокументОснованиеДата"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("documentrownumber", "НомерСтрокиДокумента"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("documentsales", "ДокументПродажи"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("documentsalesofgoodsandservices", "ДокументРеализации"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("documentscount", "КоличествоДокументов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("documentsinformation", "СведенияОДокументах"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("documenttransfers_", "ДокументПередачи"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("documenttypeselection", "ВидДокументаОтбор"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("documentviewfromclassifier", "ВидДокументаИзКлассификатора"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("donotaccruepointswhenpayingwithbonuses", "НеНачислятьБаллыПриОплатеБонусами"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("draft", "Черновик"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("driverlicense", "ВодительскоеУдостоверение"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("dutyamount", "СуммаПошлины"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("dutyrate", "СтавкаПошлины"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("edview", "ВидЭД"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("electronically", "Электронно"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("email", "АдресЭлектроннойПочты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("employee", "Сотрудник"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("employeeincharge_", "ОтветственноеЛицо"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("employeeresponsible", "Ответственный"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("employees_", "Сотрудники"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("employeesbankaccount", "БанковскийСчетСотрудника"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("encryptioncertificates", "СертификатыШифрования"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("enddate", "ДатаОкончания"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("enddateofinventory", "ДатаОкончанияИнвентаризации"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("endofbarcoderange", "КонецДиапазонаШтрихкода"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("endofmagneticcoderange", "КонецДиапазонаМагнитногоКода"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("endofperiod", "КонецПериода"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("endofreportperiod_", "ОкончаниеПериодаОтчета"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("estimated_", "Расчетный"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("eventdate", "ДатаСобытия"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("eventkind", "ВидСобытия"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("eventkindswithfixedassets", "ВидыСобытийОС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("eventkindwithfixedassets", "ВидСобытияОС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("exchangecompleted", "ОбменЗавершен"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("exchangecompletedwithadjustments", "ОбменЗавершенСИсправлением"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("exchangedatasettingsfileformatversion", "ВерсияФорматаФайлаНастроекОбменаДанными"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("exchangemessagestransportkind", "ВидТранспортаСообщенийОбмена"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("exchangemessagestransporttypes", "ВидыТранспортаСообщенийОбмена"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("exchangeplanname", "ИмяПланаОбмена"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("exchangerateofcentralbankondateofconversion", "КурсЦБНаДатуКонвертации"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("excisablegoods", "ПодакцизныйТовар"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("excisablegoodsmarkedbyidentificationtoolwithmarkingcode", "ПодакцизныйТоварМаркируемыйСИИмеющийКМ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("excisablegoodsmarkedbyidentificationtoolwithoutmarkingcode", "ПодакцизныйТоварМаркируемыйСИНеИмеющийКМ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("exciseduty", "Акциз"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("excisestampnumber", "НомерАкцизнойМарки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("excisestamps", "АкцизныеМарки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("excludingdiscountsprovided", "БезУчетаПредоставленныхСкидок"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("excludingvat", "БезНДС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("executiondate", "ДатаВыполнения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("expecteddateofreceipt", "ОжидаемаяДатаПоступления"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("expecteddeliverydate", "ОжидаемаяДатаПоставки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("expense", "Расход"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("expenseitem", "СтатьяРасходов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("expensereport", "АвансовыйОтчет"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("expensesaccount", "СчетРасходов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("expensesforallocation", "РаспределяемыеЗатраты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("expirationdate_", "СрокГодности"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("exportofnonresourcegoods", "ЭкспортНесырьевыхТоваров"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("exportsale", "ПродажаНаЭкспорт"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("extendednumber", "НомерРасширенный"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("extension", "Расширение"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("externaldocumentname", "НаименованиеВходящегоДокумента"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("externalsystem", "ВнешняяСистема"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("extrapay", "Доплата"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("facost", "СтоимостьОС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("fagroups", "ГруппыОС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("farepaymentprocedure", "ПорядокПогашенияСтоимостиОС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("fax", "Факс"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("feacncode", "КодТНВЭД"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("featureselection", "ХарактеристикаОтбор"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("fee", "Комиссия"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("feeamount", "СуммаКомиссии"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("feminine", "Женский"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("fiasaddresscode", "КодАдресаФИАС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("fieldvalues", "ЗначенияПолей"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("filecompressoutgoingmessagefile", "FILEСжиматьФайлИсходящегоСообщения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("filedataexchangedirectory", "FILEКаталогОбменаИнформацией"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("fileowner", "ВладелецФайла"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("files", "Файлы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("financiallyliableperson", "МОЛ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("finishedproducts", "ГотоваяПродукция"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("first", "Первая"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("fiuauthority", "ОрганПФР"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("fixedasset", "ОсновноеСредство"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("fixedassets", "ОсновныеСредства"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("fixedassetscostadditions", "МодернизацияОС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("fixedassetsdepreciationcharge", "АмортизацияОС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("fixedassetsevent", "СобытиеОС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("fixedexciseduty", "ТвердаяСтавкаАкциза"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("foreignbank", "ИностранныйБанк"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("formatproperties", "ФорматСвойства"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("forotherexpenses", "НаПрочиеРасходы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("fpspaymentid", "ИдентификаторОплатыСБП"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("fromsenderdeterminedbydeliveryservice", "ОтОтправителяОпределяетСлужбаДоставки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ftscode", "КодМВД"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ftssubordinationcode", "КодПодчиненностиФСС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("fullnamedata", "ДанныеФИО"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("fullprepayment", "ПредоплатаПолная"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("furskinproducts", "ПродукцияИзНатуральногоМеха"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("furtherequipping", "Дооборудование"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("gamblingprize", "ВыигрышАзартнойИгры"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("gamblingstake", "СтавкаАзартнойИгры"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("gender", "Пол"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("gift", "Подарок"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("giftcertificatecancellation", "АннулированиеПодарочныхСертификатов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("giftcertificatekind", "ВидПодарочногоСертификата"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("giftcertificatekinds", "ВидыПодарочныхСертификатов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("giftcertificates", "ПодарочныеСертификаты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("giftcertificatesale", "РеализацияПодарочныхСертификатов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("giverrawmaterialsandsupplies", "ДавальческиеСырьеИМатериалы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("glaccount", "СчетУчета"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("goods", "Товары"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("goodscost", "СтоимостьТоваров"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("goodsmarkedbyidentificationtoolwithmarkingcode", "ТоварМаркируемыйСИИмеющийКМ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("goodsmarkedbyidentificationtoolwithoutmarkingcode", "ТоварМаркируемыйСИНеИмеющийКМ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("goodsrecipient", "Грузополучатель"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("goodsrecordingasreceived", "ОприходованиеТоваров"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("goodsreturnsales", "ТоварыВозвратПродажи"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("goodsrevaluationinretail", "ПереоценкаТоваровВРознице"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("goodssale", "ТоварыПродажа"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("goodssales", "РеализацияТоваров"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("grain", "Зерно"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("grainprocessingproducts", "ПродуктыПереработкиЗерна"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("grainprocessingproductsundervetiscontrol", "ПродуктыПереработкиЗернаВЕТИС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("grainundervetiscontrol", "ЗерноВЕТИС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("group", "Группа"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("groupoffinancialaccountingsettingsforsettlements", "ГруппаНастроекФинансовогоУчетаРасчетов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("halfyear_", "Полугодье"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("height", "Высота"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("homephonenumber", "ТелефонДомашний"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("hrdirector", "РуководительКадровойСлужбы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("id", "Идентификатор"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("idof1cproductsproductcategory", "ИдентификаторНоменклатурыСервиса1СНоменклатура"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("idof1cproductsservice", "ИдентификаторСервиса1СНоменклатура"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("idof1cproductsservicecharacteristic", "ИдентификаторХарактеристикиСервиса1СНоменклатура"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("importedalcoholcontainingproducts", "ИмпортнаяАлкогольнаяПродукция"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("importingcountryisnotrf", "СтранаВвозаНеРФ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("importingfrominternet", "ЗагружаетсяИзИнтернета"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("includeindepreciableproperty", "ВключитьВСоставАмортизируемогоИмущества"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("includinginexpensesonrecognition", "СписаниеПриПринятииКУчету"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("includingvat", "ВТомЧислеНДС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("incomeforactivities", "ПоступлениеПодДеятельность"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("incomeitem", "СтатьяДоходов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("incomekindcode", "КодВидаДохода"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("incomingdocumentdata", "ДанныеВходящегоДокумента"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("incomingdocumentdate", "ДатаВходящегоДокумента"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("incomingdocumentnumber", "НомерВходящегоДокумента"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("indicatorbcc", "ПоказательКБК"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("indicators", "Показатели"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("individual", "ФизическоеЛицо"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("individualentrepreneur", "ИндивидуальныйПредприниматель"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("individualselection", "ФизическоеЛицоОтбор"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("inelectronicform", "ВЭлектронномВиде"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("infavorofsupplier", "ВПользуПоставщика"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("initialcostlocalaccounting", "ПервоначальнаяСтоимостьБУ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("initialcostta", "ПервоначальнаяСтоимостьНУ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("inoperation", "ВЭксплуатации"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("instantpayments", "СистемаБыстрыхПлатежей"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("instructionforshippingagentatpoint", "ПоручениеЭкспедиторуВПункте"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("instructionforshippingagentfromwarehouse", "ПоручениеЭкспедиторуСоСклада"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("instructionforshippingagenttowarehouse", "ПоручениеЭкспедиторуНаСклад"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("insurancecontributions", "СтраховыеВзносы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("insurancecontributionstofcmif", "ФФОМС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("insurancecontributionstossf", "ФСС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("insurancenumberofthefiu", "СтраховойНомерПФР"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("intangibleasset", "НематериальныйАктив"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("intangibleassets", "НематериальныеАктивы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("intangibleassetsaccountingitemkinds", "ВидыОбъектовУчетаНМА"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("interestonlongtermloans", "ПроцентыПоДолгосрочнымКредитам"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("interestonlongtermloans_", "ПроцентыПоДолгосрочнымЗаймам"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("interestonshorttermloans", "ПроцентыПоКраткосрочнымКредитам"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("interestonshorttermloans_", "ПроцентыПоКраткосрочнымЗаймам"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("interests", "Проценты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("internalmovement", "ВнутреннееПеремещение"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("internaltransfer", "ВнутренняяПередача"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("inventory", "ТМЦ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("inventory_", "Инвентаризация"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("inventorydate", "ДатаИнвентаризации"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("inventoryownerattribute", "ВидЗапасов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("inventoryrecount", "ПересчетТоваров"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("inventorytransfer", "ПеремещениеТоваров"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("inventorytype", "ТипЗапасов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("inventorytypes", "ТипыЗапасов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("invissubmitted", "ПредъявленСФ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("invoicedate", "ДатаСФ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("invoiceforunfactureddeliveries", "СчетУчетаНеотфактурованныеПоставки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("invoiceissued", "СчетФактураВыданный"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("invoiceissuedtobuyer", "СчетФактураВыданныйПокупателю"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("invoicenumber", "НомерСФ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("invoicesissuedtocustomers", "СчетаФактурыВыданныеПокупателям"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("invoicetype", "ВидСчетаФактуры"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("isadditionalinfo", "ЭтоДополнительноеСведение"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("isidentitydocument", "ЯвляетсяУдостоверяющимЛичность"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("isrecordsset", "ЭтоНабор"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("isrejected", "Отклонена"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("isrnpt", "ЯвляетсяРНПТ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("issue", "Выдать"); // @NON-NLS-1 @NON-NLS-2

	Массив = Новый Массив;
	Массив.Добавить("Выдано"); // @NON-NLS-1
	Массив.Добавить("Выставлен"); // @NON-NLS-1
	Словарь.Вставить("issued", Массив);

	Словарь.Вставить("issuedate", "ДатаВыставления"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("issuedby", "КемВыдан"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("issuer", "Эмитент"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("itemkinds", "ВидыНоменклатуры"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("itemsbatches", "СерииНоменклатуры"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("itemstype", "ТипНоменклатуры"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("itemstypes", "ТипыНоменклатуры"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("itemvariant", "ХарактеристикаПродукции"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("jobtitle", "Должность"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("juiceproducts", "СоковаяПродукция"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("keepaccountingbybatch", "ИспользоватьСерии"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("keyproperties", "КлючевыеСвойства"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("kindofaccountingobject", "ВидОбъектаУчета"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("kindofalcoholcontainingproducts", "ВидАлкогольнойПродукции"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("kindpresentaion", "ПредставлениеВида"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("kit", "Комплект"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("labelled", "Маркируемый"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("lastfirstname", "ФИО"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("lastname", "Фамилия"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("lease", "Аренда"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("legaladdress", "ЮридическийАдрес"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("legalform", "НаименованиеОКОПФ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("letterofauthority", "Доверенность"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("letterofcredit", "Аккредитив"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("licensekindsofalcoholcontainingproducts", "ВидыЛицензийАлкогольнойПродукции"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("lightindustrygoodsandclothes", "ЛегкаяПромышленность"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("linear", "Линейный"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("linenumber", "НомерСтроки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("loans_", "Займы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("loansandborrowings", "КредитыИЗаймы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("loansreceived", "ЗаймыПолученные"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("loansreceived_", "КредитыПолученные"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("loantocounterparty", "ЗаймКонтрагенту"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("localaccountingcurrency", "ВалютаРегламентированногоУчета"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("longdesc", "Описание"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("longterm", "Долгосрочный"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("longtermloans", "ДолгосрочныеЗаймы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("longtermloans_", "ДолгосрочныеКредиты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("lotteryprize", "ВыигрышЛотереи"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("lotteryticket", "ЛотерейныйБилет"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("loyaltycard", "КартаЛояльности"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("loyaltyprogram_", "ПрограммаЛояльности"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("magneticcode", "МагнитныйКод"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("magneticcodelength", "ДлинаМагнитногоКода"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("magneticstripecardtemplate", "ШаблонМагнитнойКарты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("mailaddress", "ПочтовыйАдрес"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("mainbankaccount", "ОсновнойБанковскийСчет"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("maincounterparty", "ГоловнойКонтрагент"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("maincurrency", "ОсновнаяВалюта"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("mainpicture", "ОсновнаяКартинка"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("mainsystem", "ОсновнаяСистемаНалогообложения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("manager", "Менеджер"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("manufacturedproduct", "Продукция"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("manufacturer", "Производитель"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("manufacturer_", "Изготовитель"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("manufacturerimporter", "ПроизводительИмпортер"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("manufaturernumber", "ЗаводскойНомер"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("markedgoods", "МаркированныйТовар"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("marking", "Маркировка"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("markup", "Наценка"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("masculine", "Мужской"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("materialtransfertoproduction", "ПередачаМатериаловВПроизводство"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("maximumsharepayablebypoints", "МаксимальныйПроцентОплатыБонусами"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("methodofcalculationofcommission", "СпособРасчетаКомиссионногоВознаграждения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("methodofdebtrepayment", "СпособПогашенияЗадолженности"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("methodofrepaymentofcostofinventory", "СпособПогашенияСтоимостиТМЦ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("methodsofcalculatingdepreciationofnmabu", "СпособыНачисленияАмортизацииНМАБУ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("middlename", "Отчество"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("milkanddairyproductswithoutvetis", "МолочнаяПродукцияБезВЕТИС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("milkandmilkproducts", "МолочнаяПродукция"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("modernization", "Модернизация"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("modernizationdocumentname", "НазваниеДокументаМодернизации"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("modernizationdocumentnumber", "НомерДокументаМодернизации"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("monetarydocument", "ДенежныйДокумент"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("month", "Месяц"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("monthoftaxperiod", "МесяцНалоговогоПериода"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("multilineinputfield", "МногострочноеПолеВвода"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("multiplier_", "КратностьВзаиморасчетов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("multiproductpackaging", "МультитоварнаяУпаковка"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("municipalterritoriesclassifier", "ОКТМО"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("name", "Имя"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("nameclarification", "УточнениеНаименования"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("namehistory", "ИсторияНаименований"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("nameofcontactinformation", "НаименованиеКонтактнойИнформации"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("nameofmethodforreflectingexpenses", "НаименованиеСпособаОтраженияРасходов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("nameofpurposeofuse", "НаименованиеНазначенияИспользования"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("nameofrecognitiondocument", "НазваниеДокументаПринятияКУчету"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("nameoftheokp", "НаименованиеОКП"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ndsvpathaccountingaccount", "СчетУчетаНДСВПути"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("netweightkg", "ВесНеттоКг"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("newnodecode", "КодНовогоУзла"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("nicotinecontainingproducts", "НикотиносодержащаяПродукция"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("noactionsneeded", "ДействийНеТребуется"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("nomenclatureselection", "НоменклатураОтбор"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("nominal", "Номинал"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("nonalcoholicbeer", "БезалкогольноеПиво"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("nonautomatedpointofsale", "НеавтоматизированнаяТорговаяТочка"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("none", "Нет"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("nonoperatingincome", "ВнереализационныйДоход"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("nonresidentregistrationnumber", "РегистрационныйНомерНерезидента"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("nonresidenttaxnumber", "НалоговыйНомерНерезидента"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("notagreedupon", "НеСогласована"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("notcalculating", "НеРассчитывается"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("notes", "Заметки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("notgenerated1", "НеСформирован"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("notificationofbalancesoftraceablegoods", "УведомлениеОбОстаткахПрослеживаемыхТоваров"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("notificationofimportoftraceablegoods", "УведомлениеОВвозеПрослеживаемыхТоваров"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("notificationofmovementoftraceablegoods", "УведомлениеОПеремещенииПрослеживаемыхТоваров"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("notificationofreceiptisrequired", "ТребуетсяИзвещениеОПолучении"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("notificationofrejectionisexpected", "ОжидаетсяИзвещениеПоОтклонению"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("notificationofrejectionisrequired", "ТребуетсяИзвещениеПоОтклонению"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("notpaid", "НеОплачен"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("notreceived", "НеПолучен"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("notshipped_", "НеОтгружен"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("notsubjecttovat", "НеОблагаетсяНДС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("nspkcertificate", "СертификатНСПК"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("number", "Номер"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("numberindicator", "ПоказательНомера"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("numberinprogram", "НомерВПрограмме"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("numberofbonuspoints", "КоличествоБонусныхБаллов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("numberofdays_1", "КоличествоУчет"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("numberofdaysofdeferral", "КоличествоДнейОтсрочки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("numberofpackages", "КоличествоУпаковок"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("numberofpackagesaccounting", "КоличествоУпаковокУчет"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("numberofpackagesbeforeadjustment", "КоличествоУпаковокДоКорректировки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("numberofpackagesbeforechange_", "КоличествоУпаковокДоИзменения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("numberofpackagesreal", "КоличествоУпаковокФакт"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("numberofpaymentdocument", "НомерПлатежногоДокумента"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("numberofrnpt", "КоличествоРНПТ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("numberofrnptbeforeadjustment", "КоличествоРНПТДоКорректировки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("numberofrnptbeforechange", "КоличествоРНПТДоИзменения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("numberofsignaturerightdocument", "НомерДокументаПраваПодписи"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("numberofvalidityperiods", "КоличествоПериодовДействия"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("numericcodefortaxinvoices", "ЦифровойИндексОбособленногоПодразделения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("object", "Объект"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("objectreference", "СсылкаНаОбъект"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("obsolete1", "Устаревший"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ogrn", "ОГРН"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("okfs", "ОКФС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("okpo", "ОКПО"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("oncommissioning", "ПриПередаче"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("onitem", "НаТовар"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("onotherincome", "НаПрочиеДоходы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("onpaper", "НаБумажномНосителе"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("operationkind", "ВидОперации"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("operationservice", "Услуга"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("optionsforreflectingshortageuponreceipt", "ВариантыОтраженияНедостачиПриПоступлении"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("optionsforreflectingsurplusesuponreceipt", "ВариантыОтраженияИзлишковПриПоступлении"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("order", "Порядок"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("orderdocument", "Заказ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("orderforacceptance", "РаспоряжениеНаПриемку"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("orderreceiptamount", "СуммаПоступления"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("orderstate", "СостояниеЗаказа"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("orderstatebyline", "СостояниеЗаказаСтрокой"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("organization", "Организация"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("origincountry", "СтранаПроисхождения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("osgroup", "ГруппаОС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("other", "Прочее"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("otherexpenses", "ПрочиеРасходы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("otherinformation", "ПрочиеСведения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("otherreasons", "Иное"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("othersettlementsubject", "ИнойПредметРасчета"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("othersettlementswithcounterparties", "ПрочиеРасчетыСКонтрагентами"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("otherwriteoffs", "ПрочееСписание"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ourowndeliveryfromsenderaddress", "НашимиСиламиСАдресаОтправителя"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("outputamountwithoutfractionalpart", "ВыводитьСуммуБезКопеек"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("overhaul", "КапитальныйРемонт"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("own", "Собственные"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("owner", "Владелец"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ownershipform", "НаименованиеОКФС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("owngoods", "Товар"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ownproducts", "СобственныеТовары"); // @NON-NLS-1 @NON-NLS-2

	Массив = Новый Массив;
	Массив.Добавить("Приложение"); // @NON-NLS-1
	Массив.Добавить("Упаковка"); // @NON-NLS-1
	Словарь.Вставить("package", Массив);

	Словарь.Вставить("packagedwater", "УпакованнаяВода"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("packageid", "ИдентификаторУпаковки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("packagemarking", "МаркировкаУпаковки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("packagemarkings", "МаркировкиУпаковок"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("packagetype", "ТипУпаковки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("packagingselection", "УпаковкаОтбор"); // @NON-NLS-1 @NON-NLS-2

	Массив = Новый Массив;
	Массив.Добавить("Оплачен"); // @NON-NLS-1
	Массив.Добавить("Оплачено"); // @NON-NLS-1
	Словарь.Вставить("paid", Массив);

	Словарь.Вставить("parent", "Родитель"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("parentcompany", "ГоловнаяОрганизация"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("partialdisposal", "ЧастичнаяЛиквидация"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("partialdisposalaccountingoption", "ЧастичноеВыбытиеВариантУчета"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("partialdisposalquantity", "ЧастичноеВыбытиеКоличество"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("partiallypaid", "ОплаченЧастично"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("partiallyshipped", "ОтгруженЧастично"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("partialprepayment", "ПредоплатаЧастичная"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("passportnumber", "НомерПаспорта"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("patch", "Исправление"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("patent", "Патент"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("patentsystem", "ПатентнаяСистема"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("payamount", "СуммаОплаты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("payercrtr", "КПППлательщика"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("payersname", "ТекстПлательщика"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("payingagent", "ПлатежныйАгент"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("payingsubagent", "ПлатежныйСубагент"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("payment_", "Платеж"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paymentamount", "СуммаПлатежа"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paymentandsettlementdocuments", "ПлатежноРасчетныеДокументы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paymentbycertificates", "ОплатаСертификатами"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paymentbycreditcardsforgiftcertificates", "ОплатаПлатежнымиКартамиПодарочныхСертификатов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paymentcard", "ПлатежнаяКарта"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paymentcardtransaction", "ОперацияПоПлатежнойКарте"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paymentcasino", "ПлатежКазино"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paymentdate", "ДатаПлатежа"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paymentdeadline", "КрайнийСрокПлатежа"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paymentdemand", "ПлатежноеТребование"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paymentdetails", "РеквизитыПлатежа"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paymentdisbursement", "ПлатежВыплата"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paymentdocumenttype", "ТипПлатежногоДокумента"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paymentforloan", "ОплатаКредита"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paymentforms", "ФормыОплаты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paymentfromclientbypaymentcard", "ОплатаОтКлиентаПлатежнойКартой"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paymentfromclientthroughpaymentsystem", "ОплатаОтКлиентаЧерезПлатежнуюСистему"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paymentid", "ИдентификаторПлатежа"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paymentkind", "ВидПлатежа"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paymentkind_", "ВидОплаты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paymentmethod", "ФормаОплаты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paymentoption", "ВариантОплаты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paymentoptions", "ВариантыОплаты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paymentorder", "ПлатежноеПоручение"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paymentpercentage", "ПроцентПлатежа"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paymentpurposes", "НазначениеПлатежа"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("payments", "Оплаты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paymentsteps", "ЭтапыОплаты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paymenttocounterparties", "ОплатаКонтрагентам"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paymenttoselfemployed", "ВыплатаСамозанятому"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paymenttovendor", "ОплатаПоставщику"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paymenturl", "ПлатежнаяСсылка"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paymentwarrant", "ПлатежныйОрдер"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paymentwithbonuspoints", "ОплатаБонуснымиБаллами"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paymentwithpaymentcards", "ОплатаПлатежнымиКартами"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paysheetdate", "ДатаВедомостиНаВыплатуЗарплаты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("paysheetnumber", "НомерВедомостиНаВыплатуЗарплаты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("penalty", "Штраф"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("pendingconfirmation", "ОжидаетсяПодтверждение"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("pendingconfirmationofprovider", "ОжидаетсяПодтверждениеОператора"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("pendingcorrection", "ОжидаетсяИсправление"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("pendingreceiptnotification", "ОжидаетсяИзвещениеОПолучении"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("pendingtransfertoprovider", "ОжидаетсяПередачаОператору"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("pensionfundbyoveralltariff", "ПФРПоСуммарномуТарифу"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("pensionfundcode", "КодПФР"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("pensionfundfrombaseinexcessoflimitvalue", "ПФРСПревышения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("pensionfundfrombasetolimitvalue", "ПФРДоПредельнойВеличины"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("pensionfundlocalauthorityname", "НаименованиеТерриториальногоОрганаПФР"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("pensionfundregistrationnumber", "РегистрационныйНомерПФР"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("percentageofcommission", "ПроцентКомиссионногоВознаграждения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("percentageofdifferencebetweensalesandreceipts", "ПроцентОтРазницыСуммПродажиИПоступления"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("performer", "Исполнитель"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("perfumesandtoiletwaters", "Духи"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("period", "Период"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("periodasstring", "ПериодСтрокой"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("periodending", "ОкончаниеПериода"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("periodfilter", "ПериодОтбор"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("periodindicator", "ПоказательПериода"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("periodpresentation", "ПредставлениеПериода"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("permanentdifferenceinevaluationofaccumulateddepreciation", "НакопленнаяАмортизацияПР"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("personalaccountnumber", "НомерЛицевогоСчета"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("personalincometax", "НДФЛ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("personalincometaxiscalculatedbythetaxagent", "НДСИсчисляетсяНалоговымАгентом"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("persons", "ФизическиеЛица"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("pfemployedonundergroundandharmfuljobs", "ПФРЗаЗанятыхНаПодземныхИВредныхРаботах"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("pfforemployedonheavyandotherjobs", "ПФРЗаЗанятыхНаТяжелыхИПрочихРаботах"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("phone", "Телефон"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("phones", "Телефоны"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("physicalinventorycountreason", "ПричинаПроведенияИнвентаризации"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("posterminal", "ЭквайринговыйТерминал"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("posterminalreceiptnumber", "НомерЧекаЭТ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("posterminals", "ЭквайринговыеТерминалы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("postingdate", "ДатаОтправления"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("postingoption", "ВариантОтражения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("postingpayrollexpensesinfinancialaccounting", "ОтражениеЗарплатыВФинансовомУчете"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("postpayment", "Постоплата"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("powerofattorneydate", "ДоверенностьДата"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("powerofattorneyissuedbywhom", "ДоверенностьКемВыдана"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("powerofattorneyissuedto", "ДоверенностьКомуВыдана"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("powerofattorneynumber", "ДоверенностьНомер"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("predefinednodecode", "КодПредопределенногоУзла"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("prefix", "Префикс"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("premise", "Помещение"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("preparationforsendingcancellationisrequired", "ТребуетсяПодготовкаКОтправкеАннулирования"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("preparationforsendingisrequired", "ТребуетсяПодготовкаКОтправке"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("preparationforsendingnotificationisrequired", "ТребуетсяПодготовкаКОтправкеИзвещения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("preparationforsendingrejectionisrequired", "ТребуетсяПодготовкаКОтправкеОтклонения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("preparationisrequiredforsendingnotificationofrejection", "ТребуетсяПодготовкаКОтправкеИзвещенияПоОтклонению"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("preparingforsale", "ПодготовкаКПередаче"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("prepayment", "Предоплата"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("prepayment_", "Аванс"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("prepayments", "Авансы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("prepaymentstovendor_", "ВыданныеАвансы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("presentation", "Представление"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("presentationofsignaturerightsdocument", "ПредставлениеДокументаПраваПодписи"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("price", "Цена"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("pricebeforeadjustment", "ЦенаДоКорректировки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("pricebeforechange", "ЦенаДоИзменения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("pricecurrency", "ВалютаЦены"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("pricegroup", "ЦеноваяГруппа"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("pricegroups", "ЦеновыеГруппы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("priceincludesvat", "ЦенаВключаетНДС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("pricelist", "ПрайсЛист"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("priceperpackaging", "ЦенаЗаУпаковку"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("pricesettingdocument", "ДокументУстановкиЦен"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("pricesetup", "УстановкаЦенНоменклатуры"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("pricetype", "ТипЦены"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("pricetype_", "ТипЦен"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("principal", "Принципал"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("procedureofincludingfixedassetcostinexpensesta", "ПорядокВключенияСтоимостиОСВСоставРасходовНУ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("productbatchid", "РНПТ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("productbatchidinformation", "СведенияРНПТ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("productcharacteristic", "ХарактеристикаНоменклатуры"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("productclassificationtypecode", "КодВидаНоменклатурнойКлассификации"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("productdata_1", "ДанныеНоменклатуры"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("productiondate", "ДатаПроизводства"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("productionseries_", "СерияПродукции"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("productkind", "ВидНоменклатуры"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("productname", "НаименованиеТовара"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("productpackaging", "УпаковкаНоменклатуры"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("products", "Номенклатура"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("productsrelease", "ВыпускПродукции"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("productsreleasetobusinessunit", "ВыпускПродукцииВПодразделение"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("productsreleasetowarehouse", "ВыпускПродукцииНаСклад"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("productsundersaturnfsiscontrol", "ПодконтрольнаяПродукцияСАТУРН"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("productsundervetiscontrol", "ПодконтрольнаяПродукцияВЕТИС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("productsvatrates", "СтавкиНДСНоменклатуры"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("producttypeis", "ВидПродукцииИС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("promocode", "Промокод"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("promocodes", "Промокоды"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("property", "Свойство"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("propertyright", "ИмущественноеПраво"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("propertyvalue", "ЗначениеСвойства"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("provisions", "ОценочныеОбязательства"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("purchase", "Покупка"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("purchasebyimport", "ЗакупкаПоИмпорту"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("purchasedate", "ДатаПриобретения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("purchaseforactivity", "ЗакупкаПодДеятельность"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("purchasefromsupplier_", "ПокупкаУПоставщика"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("purchaseorder", "ЗаказПоставщику"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("purchases", "Покупки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("purchasesettlementswithconsignors", "РасчетыСКомитентамиПоЗакупке"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("purposetext", "ТекстНазначения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("quantityafterchange", "КоличествоПослеИзменения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("quantitybeforeadjustment", "КоличествоДоКорректировки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("quantitybeforechange_", "КоличествоДоИзменения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("quantitybyfeacn", "КоличествоПоТНВЭД"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("quantityinstock_", "КоличествоНаСкладе"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("quarter", "Квартал"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("rankinginpriority", "Очередность"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("rate1", "Ставка"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("rate_", "Расценка"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("rdexpenses", "РасходыНаНИОКР"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("readyforissuance", "ГотовКВыдаче"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("receipt", "Чек"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("receiptfromtoller", "ПоступлениеОтПереработчика"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("receiptfromvendor", "ПриемкаОтПоставщика"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("receiptmethod", "СпособПоступления"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("receiptoffinancialdocumentsfromadvanceholder", "ПоступлениеДенежныхДокументовОтПодотчетника"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("receiptoffinancialdocumentsfromvendor", "ПоступлениеДенежныхДокументовОтПоставщика"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("receiptofgoodsservices", "ПоступлениеТоваровУслуг"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("receiptprice", "ЦенаПоступления"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("receivedfrom", "ПринятоОт"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("receivingbusinessunit", "ПодразделениеПолучатель"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("receivingbyreturnfromacustomer", "ПриемкаПоВозвратуОтКлиента"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("receivingbytransfer", "ПриемкаПоПеремещению"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("receivingcash", "ПолучениеНаличных"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("recipientcrtr", "КПППолучателя"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("recipienttext", "ТекстПолучателя"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("recipienttin", "ИННПолучателя"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("recognition", "ПринятиеКУчету"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("recognitionwithcommissioning", "ПринятиеКУчетуСВводомВЭксплуатацию"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("reconstruction", "Реконструкция"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("recordofpaymentthroughthecommissionagent", "ОтражениеОплатыЧерезКомиссионера"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("recordofrefundthroughthecommissionagent", "ОтражениеВозвратаОплатыЧерезКомиссионера"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("records", "Записи"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("recyclablewaste", "ВозвратныеОтходы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("reducedbalance", "УменьшаемогоОстатка"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ref", "Ссылка"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("refundfromcustomerviapaymentsystem", "ВозвратОтКлиентаЧерезПлатежнуюСистему"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("refundtocommittee", "ВозвратКомитенту"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("refundtocustomerspaymentcard", "ВозвратОплатыКлиентуНаПлатежнуюКарту"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("registrationcountry", "СтранаРегистрации"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("registrationdate", "ДатаРегистрации"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("registrationnumber", "РегистрационныйНомер"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("registrationperiod", "ПериодРегистрации"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("registrationwithtaxauthority", "РегистрацияВНалоговомОргане"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("regulatedreporting", "РегламентированнаяОтчетность"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("rejected", "Отклонен"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("rejectionsignatureisrequired", "ТребуетсяПодписаниеОтклонения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("remunerationsettlementaccount", "СчетУчетаРасчетовПоВознаграждению"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("repayment", "Выплата"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("repaymentofdebt", "ПогашениеЗадолженности"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("replenished", "Комплектуется"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("reportdata", "ДанныеОтчета"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("reportdescription1", "НаименованиеОтчета"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("reportid", "ИдентификаторОтчета"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("reportkind", "ВидОтчета"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("reporttomaterialprovider", "ОтчетДавальцу"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("requestforspendingfunds", "ЗаявкаНаРасходДенежныхСредств"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("requiredtofill", "ЗаполнятьОбязательно"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("resendingrequired", "ТребуетсяПовторнаяОтправка"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("reserve", "Резерв"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("reserveamount_", "СуммаРезерва"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("reserves", "Резервы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("resortfee", "КурортныйСбор"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("responsiblepersonkind", "ВидОтветственногоЛица"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("restorevat", "ВосстановитьНДС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("retail_2", "Розничный"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("retailamount", "СуммаВРознице"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("retailndsrate", "СтавкаНДСВРознице"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("retailprice", "ЦенаВРознице"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("retailpriceisold", "ЦенаВРозницеСтарая"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("retailsalesreport", "ОтчетОРозничныхПродажах"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("return", "Возврат"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("returnamount", "СуммаВозврата"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("returncontainers", "ВозвратнаяТара"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("returnfromcommissionagent", "ВозвратОтКомиссионера"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("returnfromcustomer", "ВозвратОтКлиента"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("returnfromretailcustomer", "ВозвратОтРозничногоПокупателя"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("returnofcashequivalentstovendor", "ВозвратДенежныхДокументовПоставщику"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("returnofgiftcards", "ВозвратПодарочныхСертификатов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("returnofgoodstovendor", "ВозвратТоваровПоставщику"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("returnofmaterialsfromproduction", "ВозвратМатериаловИзПроизводства"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("returnofrawmaterialsfromtoller", "ВозвратСырьяОтПереработчика"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("returnofrawmaterialstomaterialprovider", "ВозвратСырьяДавальцу"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("returns", "Возвраты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("returntovendor", "ВозвратПоставщику"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("returnunderoperation", "ВозвратПодДеятельность"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("reusablepackage", "МногооборотнаяТара"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("revaluation", "Переоценка"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("reverseddocument", "СторнируемыйДокумент"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("rewardservice", "УслугаПоВознаграждению"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("rncea", "ОКВЭД"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("rncea2", "ОКВЭД2"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("rncfi", "ОКОПФ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("rncpcode", "КодОКП"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("rncps", "ОКАТО"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("rncteaps2code", "КодОКПД2"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("rolledback_", "Отменен"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("roundingprecision", "ТочностьОкругления"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("roundup", "ОкруглятьВБольшуюСторону"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("route", "Маршрут"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("rowid", "ИдентификаторСтроки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("runningtimevalue", "ПоказательНаработки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("salary", "Зарплата"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("salarydepositing", "ДепонированиеЗарплаты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("saledate", "ДатаРеализации"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("saleisnotsubjecttovat", "ПродажаНеОблагаетсяНДС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("saleissubjecttoutii", "ПродажаОблагаетсяЕНВД"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("saleissubjecttovat", "ПродажаОблагаетсяНДС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("saleofgoodsoncommission", "ПродажаТоваровНаКомиссии"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("salesbypatent", "ПродажаПоПатенту"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("salescharge", "ТорговыйСбор"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("saleshare", "ПроцентОтСуммыПродажи"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("salesorder", "ЗаказКлиента"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("salesrevenueaccount", "СчетУчетаВыручкиОтПродаж"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("salesviacommissionagent", "РеализацияЧерезКомиссионера"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("salesviacommissionagentgoodsintransit", "РеализацияЧерезКомиссионераБезПереходаПраваСобственности"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("saletocustomer", "РеализацияКлиенту"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("scheduleamounttype", "ТипСуммыГрафика"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("seafoodcontrolledbyvetis", "МорепродуктыПодконтрольныеВЕТИС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("secondinfobasedescription", "НаименованиеВторойБазы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("secondinfobasenewnodecode", "КодНовогоУзлаВторойБазы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("sectionnumber", "НомерРаздела"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("sections", "Разделы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("securities", "ЦенныеБумаги"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("securitydeposit", "Залог"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("selectedform", "ВыбраннаяФорма"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("selfpickup", "Самовывоз"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("seller", "Продавец"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("sellercrtr", "КПППродавца"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("sellerrole", "РольПродавца"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("sellers", "Продавцы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("sellertin", "ИННПродавца"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("senderbankaccount", "БанковскийСчетОтправитель"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("senderorganization", "ОрганизацияОтправитель"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("sendingcancellationisrequired", "ТребуетсяОтправкаАннулирования"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("sendingdepartment", "ПодразделениеОтправитель"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("sendinginvitationisrequired", "ТребуетсяОтправкаПриглашения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("sendingnotificationisrequired", "ТребуетсяОтправкаИзвещения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("sendingnotificationofrejectionisrequired", "ТребуетсяОтправкаИзвещенияПоОтклонению"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("sendingrejectionisrequired", "ТребуетсяОтправкаОтклонения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("sendingrequired", "ТребуетсяОтправка"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("sequencenumber", "ПорядковыйНомер"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("serialnumber", "СерийныйНомер"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("series", "Серия"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("seriesandnumber", "СвидетельствоСерияНомер"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("sertificatedateofissue", "СвидетельствоДатаВыдачи"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("servicelife", "СрокЭксплуатации"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("services", "Услуги"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("servicestypes", "ТипыУслуг"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("servicetype", "ТипУслуги"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("set", "Набор"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("setsf", "ВыставленСФ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("settlementaccount_", "СчетРасчетов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("settlementdata", "ДанныеВзаиморасчетов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("settlementdocumentnumber", "НомерПлатежноРасчетногоДокумента"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("settlementsonloansandborrowings", "РасчетыПоКредитамИЗаймам"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("settlementsubjectflag", "ПризнакПредметаРасчета"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("settlementsubjectflags", "ПризнакиПредметаРасчета"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("settlementswithlessors", "РасчетыСЛизингодателями"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("sfdata", "ДанныеПоСФ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("shared3", "Общая"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("shareddata", "ОбщиеДанные"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("sheetquantity", "КоличествоЛистов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("shelflifeunitofmeasure", "ЕдиницаИзмеренияСрокаГодности"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("shipentireorder", "ОтгружатьЗаказЦеликом"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("shipmentbytransfer", "ОтгрузкаПоПеремещению"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("shipmentreferenceorder", "РаспоряжениеНаОтгрузку"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("shipmentstatus", "СостояниеОтгрузки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("shipmenttocustomer", "ОтгрузкаКлиенту"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("shipmentunderreturntovendor", "ОтгрузкаПоВозвратуПоставщику"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("shipmentwithouttransferofownership_implemented", "ОтгрузкаБезПереходаПравСобственности_Реализовано"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("shipmentwithouttransferofownership_inpath", "ОтгрузкаБезПереходаПравСобственности_ВПути"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("shipped_", "Отгружен"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("shipper", "Грузоотправитель"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("shoesproducts", "Обувь"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("shortages", "Недостачи"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("shortterm", "Краткосрочный"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("shorttermloans", "КраткосрочныеЗаймы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("shorttermloans_", "КраткосрочныеКредиты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("showscalculationmethod", "ПризнакСпособаРасчета"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("signature", "Подпись"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("signaturedate", "ДатаПодписи"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("signingnotificationofrejectionisrequired", "ТребуетсяПодписаниеИзвещенияПоОтклонению"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("signingofcancellationisrequired", "ТребуетсяПодписаниеАннулирования"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("signingofnotificationisrequired", "ТребуетсяПодписаниеИзвещения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("signingrequired", "ТребуетсяПодписание"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("simplifiedrevenue", "УпрощеннаяДоход"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("simplifiedrevenueminusexpense", "УпрощеннаяДоходМинусРасход"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("singleproductpackage", "МонотоварнаяУпаковка"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("sku", "Артикул"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("skucounterparty_", "SKUКонтрагента"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("soldbyweight", "Весовой"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("sourcedocument_", "ИсходныйДокумент"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("sourceinfobaseprefix", "ПрефиксИнформационнойБазыИсточника"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("sourcewarehouse", "СкладОтправитель"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("specialfactortaxaccounting", "СпециальныйКоэффициентНУ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("specialtaxationprocedure", "ОсобыйПорядокНалогообложения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("specificationdate", "ДатаСпецификации"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("specificationnumber", "НомерСпецификации"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("specifications", "Спецификации"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ssfadditionalcode", "ДополнительныйКодФСС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ssflocalauthorityname", "НаименованиеТерриториальногоОрганаФСС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ssfregistrationnumber", "РегистрационныйНомерФСС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("startdate", "ДатаНачала"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("startdateofinventory", "ДатаНачалаИнвентаризации"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("startofbarcoderange", "НачалоДиапазонаШтрихкода"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("startofmagneticcoderange", "НачалоДиапазонаМагнитногоКода"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("statecontactid", "ИдентификаторГосконтракта"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("statedate", "ДатаСостояния"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("statement", "Ведомость"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("statementdate", "ДатаВедомости"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("statementnumber", "НомерВедомости"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("stateofpayment", "СостояниеОплаты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("status", "Статус"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("statusesofrequestsforspendingcash", "СтатусыЗаявокНаРасходДС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("store", "Магазин"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("storedfile", "ХранимыйФайл"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("strength", "Крепость"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("string", "Строка"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("subcontractorreport", "ОтчетПереработчика"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("subject", "Субъект"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("subjecttoenvd", "ОблагаетсяЕНВД"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("subjecttovat", "ОблагаетсяНДС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("subjecttovatatcustomer", "ОблагаетсяНДСУПокупателя"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("subreport", "Подотчет"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("sum", "Сумма"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("sumcompl", "СуммаРегл"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("sumcurr", "СуммаВал"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("sumreal", "СуммаФакт"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("superiordepartment", "ВышестоящееПодразделение"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("supplyfrommaterialprovider", "ПоступлениеСырьяОтДавальца"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("supportingdocumentdate", "ДатаТСД"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("supportingdocumentseriesnumber", "СерияНомерТСД"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("supportsesfsspayment", "ПоддерживаетОплатуЭСФСС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("surpluses", "Излишки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("swiftbic", "СВИФТБИК"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("tara", "Тара"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("tareserve", "РезервНУ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("taxation", "Налогообложение"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("taxationsystem", "СистемаНалогообложения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("taxationsystems", "СистемыНалогообложения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("taxauthoritycode", "КодНалоговогоОргана"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("taxbaseexcises", "НалоговаяБазаАкцизы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("taxinvoice", "СчетФактура"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("taxinvoicedate", "ДатаСчетаФактуры"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("taxinvoicedprice", "ФактурнаяСтоимость"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("taxinvoicenumber", "НомерСчетаФактуры"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("tcmif", "ТФОМС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("technicalcharacteristics", "ВладелецХарактеристики"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("tendays", "Декада"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("tenth", "десятая"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("thereisimplementationreceiptindocument", "ЕстьВДокументеПоступленияРеализации"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("thisinfobasedescription", "НаименованиеЭтойБазы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("thisisacquiringcontract", "ЭтоДоговорЭквайринга"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("thisisadditionalexpense", "ЭтоДопРасходы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("thisisreturn", "ЭтоВозврат"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("ticketnumber", "НомерБилета"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("tin", "ИНН"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("tinofcounterparty", "ИННКонтрагента"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("tinofpayer", "ИННПлательщика"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("tires", "Шины"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("title", "Заголовок"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("tobacco", "Табак"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("tocustomer", "ДоКлиента"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("tocustomerisdefinedbytransportationcompany", "КПолучателюОпределяетСлужбаДоставки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("tooltip", "Подсказка"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("totalofallpayments", "СуммаВсехПлатежей"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("tracedgoods", "ПрослеживаемыйТовар"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("trackingaccountintransit", "СчетУчетаВПути"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("transactionkindcode", "КодВидаОперации"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("transactionparties", "УчастникиСделки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("transactionrate", "КурсВзаиморасчетов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("transcriptofadditionalexpenses", "РасшифровкаДопРасходов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("transfer_", "Передача"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("transferaccount", "СчетПередачи"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("transferamount", "СуммаПередачи"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("transferbank", "БанкДляРасчетов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("transferforactivity", "ПеремещениеПодДеятельность"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("transferoftaxesandcontributions", "ПеречислениеВБюджет"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("transferorder", "ЗаказНаПеремещение"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("transferprice", "ЦенаПередачи"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("transfertocommissionagent", "ПередачаНаКомиссию"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("transfertomaterialprovider", "ПередачаДавальцу"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("transfertotoller", "ПередачаПереработчику"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("transferwithfullpayment", "ПередачаСПолнойОплатой"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("transferwithoutpayment", "ПередачаБезОплаты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("transferwithpartialpayment", "ПередачаСЧастичнойОплатой"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("transmissionerrorcorrectionisrequired", "ТребуетсяИсправлениеОшибкиПередачи"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("transportkindcode", "КодВидаТранспорта"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("transportmethods", "СпособыДоставки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("trucode", "КодТРУ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typeamount", "ТипСумма"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typeindicator", "ПоказательТипа"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typeofactivityofseparatevataccounting", "ВидДеятельностиРаздельногоУчетаНДС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typeofagreement", "ВидДоговора"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typeofbankaccount", "ВидБанковскогоСчета"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typeofcalculationsadvanced", "ВидРасчетовРасширенный"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typeofdiscount", "ВидСкидки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typeofdocumentrighttosign", "ВидДокументаПравоПодписи"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typeofexcisestamp", "ТипАкцизнойМарки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typeofexpensesforcoreactivities", "ВидРасходовПоОсновнойДеятельности"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typeofexpensesfornoncoreactivities", "ВидРасходовПоНеосновнойДеятельности"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typeofoperationofcommissionairesreport", "ВидОперацииОтчетаКоммисионера"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typeofpayment", "ТипОплаты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typeofreserve", "ВидРезерва"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typeofresponsiblepersonbyline", "ВидОтветственногоЛицаСтрокой"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typeofresponsiblepersonselection", "ВидОтветственногоЛицаОтбор"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typeofretailprices", "ТипЦенРозничнойТорговли"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typeofvalidityperiod", "ТипПериодаДействия"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typequantity", "ТипКоличество"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typesofacwoperationstobankaccount", "ВидыОперацийРКОНаБанковскийСчет"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typesofcashregisterpaymentsystem", "ТипыПлатежнойСистемыККТ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typesofcontracts", "ВидыДоговоров"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typesofed", "ВидыЭД"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typesofemployeecompensations", "ВидыРасчетовССотрудниками"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typesofipproducts", "ВидыПродукцииИС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typesofitemspackages", "ТипыУпаковокНоменклатуры"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typesofoperationsofreceiptofgoods", "ВидыОперацийПоступленияТоваров"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typesofoperationsrefundtosupplier", "ВидыОперацийВозвратПоставщику"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typesofoperationsreturnfrombuyer", "ВидыОперацийВозвратОтПокупателя"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typesofoperationssaleofgoodsservices", "ВидыОперацийРеализацияТоваровУслуг"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typesofpaymentcardoperations", "ВидыОперацийПоПлатежнойКарте"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typesofpaymentdocuments", "ТипыПлатежныхДокументов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typesofpaymenttypesofcashregisterchecks", "ТипыТипыОплатЧековККМ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typesofperiods", "ТипыПериодов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typesofproductionoperations", "ВидыОперацийВыпускаПродукции"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typesofresponsiblepersons", "ВидыОтветственныхЛиц"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typesofsbdsoperationsother", "ВидыОперацийСБДСПрочее"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typesofsettlementswithcounterparties", "ВидыРасчетовСКонтрагентами"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("typesofwarehouses", "ТипыСкладов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("uisstatecontractstep", "ЭтапГосконтрактаЕИС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("underleaseagreement", "ПоДоговоруЛизинга"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("unitofmeasure", "ЕдиницаИзмерения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("unitofproductbatchid", "ЕдиницаИзмеренияРНПТ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("unitoftraceability", "ЕдиницаИзмеренияПрослеживаемости"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("upholded_", "Утверждена"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("uploadformat", "ФорматВыгрузки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("urgencyofloanloan", "СрочностьКредитаЗайма"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("usecharacteristics", "ИспользоватьХарактеристики"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("usediscountsmarkups", "ИспользоватьСкидкиНаценки"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("usedmaterials", "Материалы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("useexcises", "ИспользоватьАкцизы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("usefullifebefore2009", "СрокИспользованияНУДо2009"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("usefullifemonthsac", "СрокПолезногоИспользованияБУ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("usefullifemonthsta", "СрокПолезногоИспользованияНУ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("usepaymentbycards", "ИспользоватьОплатуПлатежнымиКартами"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("user", "Пользователь"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("userciaddress", "ПользовательскаяКИАдрес"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("userciemail", "ПользовательскаяКИАдресЭлектроннойПочты"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("usercifax", "ПользовательскаяКИФакс"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("userciother", "ПользовательскаяКИДругое"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("userciphone", "ПользовательскаяКИТелефон"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("userciskype", "ПользовательскаяКИSkype"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("userciwebpage", "ПользовательскаяКИВебСтраница"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("useshelflifeonbatchregistration", "ИспользоватьСрокГодностиСерии"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("usetransportparametersemail", "ИспользоватьПараметрыТранспортаEMAIL"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("usetransportparametersfile", "ИспользоватьПараметрыТранспортаFILE"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("usetransportparametersftp", "ИспользоватьПараметрыТранспортаFTP"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("utii", "ЕНВД"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("uuidtype", "ТипУникальныйИдентификатор"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("vacationproduced", "ОтпускПроизвел"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("validbefore", "ДействителенДо"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("validityenddate", "ДатаОкончанияДействия"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("validityperiod", "СрокДействия"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("validitystartdate", "ДатаНачалаДействия"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("validuntil_", "ГоденДо"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("valuechoiceformtitle", "ЗаголовокФормыВыбораЗначения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("valueformtitle", "ЗаголовокФормыЗначения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("valueofadditionalprops", "ЗначениеДополнительногоРеквизита"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("vat", "НДС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("vat0", "НДС0"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("vat10", "НДС10"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("vat10_110", "НДС10_110"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("vat18", "НДС18"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("vat18_118", "НДС18_118"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("vat20", "НДС20"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("vat20_120", "НДС20_120"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("vatamount", "СуммаНДС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("vatamount10", "СуммаНДС10"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("vatamount20", "СуммаНДС20"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("vatamountbeforechange", "СуммаНДСДоИзменения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("vatinvoiceforpurchases", "СчетУчетаНДСПриЗакупке"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("vatinvoiceforsales", "СчетУчетаНДСПриПродаже"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("vatiscalculatedbybuyer", "НДСИсчисляетсяПокупателем"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("vatrate", "СтавкаНДС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("vatratebeforechange", "СтавкаНДСДоИзменения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("vatrateofremuneration", "СтавкаНДСВознаграждения"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("vatrates", "СтавкиНДС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("vattaxagent", "НалоговыйАгентПоНДС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("vattaxation", "НалогообложениеНДС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("vattaxationofseller", "НалогообложениеНДСПродавца"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("vattaxbase", "НалоговаяБазаНДС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("vehicles", "ТранспортныеСредства"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("vendor", "Поставщик"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("vendorinvoicereceived", "СчетФактураПолученный"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("vendorsarapaccounting", "РасчетыСПоставщиками"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("vetisdairyproducts", "МолочнаяПродукцияВЕТИС"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("volumeindecaliters", "ОбъемДАЛ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("volumem3", "Объем"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("volumeofproductsworksforcalculatingdepreciationinphysicalunits", "ОбъемПродукцииРаботДляВычисленияАмортизации"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("wagereserves", "РезервыПоОплатеТруда"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("waitingforconfirmationofcancellation", "ОжидаетсяПодтверждениеАннулирования"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("waitingforresponsetoinvitation", "ОжидаетсяОтветНаПриглашение"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("warehouse", "Склад"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("warehousegroup_", "СкладГруппа"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("warehouseinvoice", "СчетУчетаНаСкладе"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("warehousestore", "ТипСклада"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("waystorepaycostofinventory", "СпособыПогашенияСтоимостиТМЦ"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("wearaccrual", "НачислениеИзноса"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("webpage", "ВебСтраница"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("week", "Неделя"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("weight", "Вес"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("wheelchairs", "КреслаКоляски"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("whodecided", "КтоРешил"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("wholesale_1", "Оптовый"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("whostated", "КтоЗаявил"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("width", "Ширина"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("withcommissionagentforpurchase", "СКомиссионеромНаЗакупку"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("withconsignee", "СКомиссионером"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("withconsignor", "СКомитентом"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("withcustomer", "СПокупателем"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("withholdcommission", "УдержатьКомиссионноеВознаграждение"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("withvendor", "СПоставщиком"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("work_5", "Работа"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("workingphone", "ТелефонРабочий"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("workkind", "ВидРабот"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("workoutput", "ВыработкаСотрудников"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("works", "Работы"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("worldcountry", "СтранаМира"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("writeoff", "Списание"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("writeofffinancialdocuments", "СписаниеДенежныхДокументов"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("writeoffofgoodsforcommissions", "СписаниеТоваровНаКомиссии"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("wspassivemode", "WSПассивныйРежим"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("year", "Год"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("yes", "Да"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("yookassa", "ЮКасса"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("zoomratio", "Коэффициент"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("zoomratio1", "Коэффициент1"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("zoomratio10", "Коэффициент10"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("zoomratio11", "Коэффициент11"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("zoomratio12", "Коэффициент12"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("zoomratio2", "Коэффициент2"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("zoomratio3", "Коэффициент3"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("zoomratio4", "Коэффициент4"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("zoomratio5", "Коэффициент5"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("zoomratio6", "Коэффициент6"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("zoomratio7", "Коэффициент7"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("zoomratio8", "Коэффициент8"); // @NON-NLS-1 @NON-NLS-2
	Словарь.Вставить("zoomratio9", "Коэффициент9"); // @NON-NLS-1 @NON-NLS-2

	// АПК:1036-вкл не проверять текст на орфографию
	
	Возврат Словарь;
	
КонецФункции
    
#КонецОбласти